<?php
class ZATCA implements iTransQR
{
	protected $data = [];

	function __construct(array $trans = [])
	{
		$this->set_data($trans);
	}

	public function set_data(array $trans = [])
	{
		if (empty($trans))
		{
			return $this;
		}

		require_once("Tag.php");

		$this->data = array(
			new Tag(1, $trans["company"]["compName"]), // Seller
			new Tag(2, $trans["company"]["gstin"]), // TaxNumber
			new Tag(3, $trans["_tDate"]), // InvoiceDate
			new Tag(4, $trans["totAmount"]), // InvoiceTotalAmount
			new Tag(5, $trans["totTax"]) // InvoiceTaxAmount
        );

        return $this;
	}

	public function toTLV()
	{
		return implode('', array_map(function ($tag) {
			return (string) $tag;
		}, $this->data));
	}

	public function toBase64()
	{
		return base64_encode($this->toTLV());
	}

	public function get_content(array $trans = [])
	{
		return $this->set_data($trans)->toBase64();
	}

	public function __toString()
	{
		return $this->get_content();
	}
}
