-- Adminer 4.8.1 MySQL 5.5.5-10.4.21-MariaDB dump

SET NAMES utf8;
SET time_zone = '+00:00';
SET foreign_key_checks = 0;
SET sql_mode = 'NO_AUTO_VALUE_ON_ZERO';

SET NAMES utf8mb4;

DELIMITER ;;

DROP FUNCTION IF EXISTS `obfnCharDiff`;;
CREATE FUNCTION `obfnCharDiff`(`s1` VARCHAR(255), `s2` VARCHAR(255)) RETURNS int(11)
    NO SQL
    DETERMINISTIC
    SQL SECURITY INVOKER
BEGIN
    DECLARE s1_len, s2_len, i, j, c, c_temp, cost INT;
    DECLARE s1_char CHAR;
    
    DECLARE cv0, cv1 VARBINARY(256);
    
	SET s1=LEFT(obREGEXP_REPLACE(s1, "[^a-zA-Z]", ""), 20);
    SET s2=LEFT(obREGEXP_REPLACE(s2, "[^a-zA-Z]", ""), 20);

    SET s1_len = CHAR_LENGTH(s1), s2_len = CHAR_LENGTH(s2), cv1 = 0x00, j = 1, i = 1, c = 0;

    IF s1 = s2 THEN
        RETURN 0;
    ELSEIF s1_len = 0 THEN
        RETURN s2_len;
    ELSEIF s2_len = 0 THEN
        RETURN s1_len;
    ELSE
        WHILE j <= s2_len DO
            SET cv1 = CONCAT(cv1, UNHEX(HEX(j))), j = j + 1;
        END WHILE;
        cntloop: WHILE i <= s1_len DO
            SET s1_char = SUBSTRING(s1, i, 1), c = i, cv0 = UNHEX(HEX(i)), j = 1;
            WHILE j <= s2_len DO
                SET c = c + 1;
                IF s1_char = SUBSTRING(s2, j, 1) THEN
                    SET cost = 0; ELSE SET cost = 1;
                END IF;
                SET c_temp = CONV(HEX(SUBSTRING(cv1, j, 1)), 16, 10) + cost;
                IF c > c_temp THEN SET c = c_temp; END IF;
                SET c_temp = CONV(HEX(SUBSTRING(cv1, j+1, 1)), 16, 10) + 1;
                IF c > c_temp THEN
                    SET c = c_temp;
                END IF;
                SET cv0 = CONCAT(cv0, UNHEX(HEX(c))), j = j + 1;
            END WHILE;
            SET cv1 = cv0, i = i + 1;
        END WHILE cntloop;
    END IF;
    RETURN c;
END;;

DROP FUNCTION IF EXISTS `obREGEXP_REPLACE`;;
CREATE FUNCTION `obREGEXP_REPLACE`(original VARCHAR(1000),pattern VARCHAR(1000),replacement VARCHAR(1000)) RETURNS varchar(1000) CHARSET utf8mb4
    DETERMINISTIC
BEGIN 
	DECLARE temp VARCHAR(1000); 
	DECLARE ch VARCHAR(1); 
	DECLARE i INT;
	SET i = 1;
	SET temp = '';
	IF original REGEXP pattern THEN 
		loop_label: LOOP 
			IF i>CHAR_LENGTH(original) THEN
				LEAVE loop_label;  
			END IF;
			SET ch = SUBSTRING(original,i,1);
			IF NOT ch REGEXP pattern THEN
				SET temp = CONCAT(temp,ch);
			ELSE
				SET temp = CONCAT(temp,replacement);
			END IF;
			SET i=i+1;
		END LOOP;
	ELSE
		SET temp = original;
	END IF;
	RETURN temp;
END;;

DROP PROCEDURE IF EXISTS `obsptree`;;
CREATE PROCEDURE `obsptree`(IN tCode char(1))
    MODIFIES SQL DATA
BEGIN

    DECLARE currentId, currentParentId  CHAR(36);
    DECLARE currentLeft                 INT;
    DECLARE startId                     INT DEFAULT 1;

    # Determines the max size for MEMORY tables.
    SET max_heap_table_size = 1024 * 1024 * 512;

    START TRANSACTION;
DROP TABLE IF EXISTS `tmp_tree`;
    # Temporary MEMORY table to do all the heavy lifting in,
    # otherwise performance is simply abysmal.

IF tCode='C' THEN
    UPDATE ob_category set pid=0 where pid not in (select id from (select * from ob_category) c) and pid > 0;
    CREATE TABLE `tmp_tree` (
        `id` char(36) NOT NULL DEFAULT '',
        `pid` char(36) DEFAULT NULL,
        `name` varchar(100),
        `sortNo` INT DEFAULT 0,
        `lft` int(11) unsigned DEFAULT NULL,
        `rgt` int(11) unsigned DEFAULT NULL,
        PRIMARY KEY (`id`), INDEX USING HASH (`pId`), INDEX USING HASH (`lft`), INDEX USING HASH (`rgt`)
    ) ENGINE = MEMORY
    SELECT `id`, `pId`, `name`, `sortNo`, `lft`, `rgt` FROM `ob_category` WHERE pId != -1 AND type='C' ORDER BY cid,sortNo,lft,name;
ELSE  
    UPDATE ob_accountgroup set parentGroupId=0 where parentGroupId not in (select id from (select * from ob_accountgroup) ag) and parentGroupId > 0;
    CREATE TABLE `tmp_tree` (
        `id` char(36) NOT NULL DEFAULT '',
        `pid` char(36) DEFAULT NULL,
        `name` varchar(100),
        `sortNo` INT DEFAULT 0,
        `lft` int(11) unsigned DEFAULT NULL,
        `rgt` int(11) unsigned DEFAULT NULL,
        PRIMARY KEY (`id`), INDEX USING HASH (`pId`), INDEX USING HASH (`lft`), INDEX USING HASH (`rgt`)
    ) ENGINE = MEMORY
    SELECT `id`, `parentGroupId` as pid, `name`, `sortOrd` as sortNo, `lft`, `rgt` FROM `ob_accountgroup` ORDER BY cid,sortOrd,lft,name;
END IF;
    # Leveling the playing field.
    UPDATE `tmp_tree` SET `lft`=NULL, `rgt`=NULL;

    # Establishing starting numbers for all root elements.
    WHILE EXISTS (SELECT * FROM `tmp_tree` WHERE (`pId` IS NULL or `pId` = 0) AND `lft` IS NULL AND `rgt` IS NULL LIMIT 1) DO
        UPDATE `tmp_tree` SET `lft` = startId, `rgt` = startId + 1 WHERE  (`pId` IS NULL or `pId` = 0) AND  `lft` IS NULL AND  `rgt` IS NULL ORDER BY sortNo, name LIMIT 1;
        SET startId = startId + 2;
    END WHILE;

    # Switching the indexes for the lft/rgt columns to B-Trees to speed up the next section, which uses range queries.
    DROP INDEX `lft`  ON `tmp_tree`;
    DROP INDEX `rgt` ON `tmp_tree`;
    CREATE INDEX `lft`  USING BTREE ON `tmp_tree` (`lft`);
    CREATE INDEX `rgt` USING BTREE ON `tmp_tree` (`rgt`);

    # Numbering all child elements
    WHILE EXISTS (SELECT * FROM `tmp_tree` WHERE `lft` IS NULL LIMIT 1) DO

        # Picking an unprocessed element which has a processed parent.
        SELECT `tmp_tree`.`id` INTO currentId FROM `tmp_tree` INNER JOIN `tmp_tree` AS `parents` ON `tmp_tree`.`pId` = `parents`.`id` WHERE `tmp_tree`.`lft` IS NULL AND `parents`.`lft`  IS NOT NULL order by `tmp_tree`.sortNo desc, `tmp_tree`.name desc LIMIT 1;

        # Finding the element's parent.
        SELECT `pId` INTO currentParentId FROM `tmp_tree` WHERE `id` = currentId;

        # Finding the parent's lft value.
        SELECT `lft` INTO  currentLeft FROM `tmp_tree` WHERE `id` = currentParentId;

        # Shifting all elements to the right of the current element 2 to the right.
        UPDATE `tmp_tree` SET `rgt` = `rgt` + 2 WHERE `rgt` > currentLeft;

        UPDATE `tmp_tree` SET `lft` = `lft` + 2 WHERE `lft` > currentLeft;

        # Setting lft and rgt values for current element.
        UPDATE `tmp_tree` SET `lft` = currentLeft + 1, `rgt` = currentLeft + 2 WHERE `id`=currentId;

    END WHILE;

	IF tCode='C' THEN
		# Writing calculated values back to physical table.
		UPDATE `ob_category`, `tmp_tree` SET `ob_category`.`lft`  = `tmp_tree`.`lft`, `ob_category`.`rgt` = `tmp_tree`.`rgt` WHERE `ob_category`.`id` = `tmp_tree`.`id`;
	ELSE
		UPDATE `ob_accountgroup`, `tmp_tree` SET `ob_accountgroup`.`lft`  = `tmp_tree`.`lft`, `ob_accountgroup`.`rgt` = `tmp_tree`.`rgt` WHERE `ob_accountgroup`.`id`=`tmp_tree`.`id`;
	END IF;

    COMMIT;

    DROP TABLE `tmp_tree`;

END;;

DELIMITER ;

DROP TABLE IF EXISTS `ob_account`;
CREATE TABLE `ob_account` (
  `id` mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
  `cId` mediumint(8) unsigned NOT NULL,
  `name` varchar(100) NOT NULL,
  `groupId` int(11) DEFAULT NULL,
  `groupCode` char(2) NOT NULL,
  `accCode` varchar(16) NOT NULL,
  `accCustomCode` varchar(20) DEFAULT NULL,
  `descr` varchar(500) NOT NULL,
  `taxId` int(10) unsigned NOT NULL,
  `HS` varchar(8) NOT NULL,
  `itc` tinyint(1) NOT NULL DEFAULT 0,
  `taxTypeCode` varchar(7) NOT NULL,
  `isActive` tinyint(1) NOT NULL,
  `systemRec` tinyint(1) NOT NULL,
  `balance` decimal(11,2) NOT NULL,
  `drank` smallint(5) NOT NULL DEFAULT 0,
  `crank` smallint(5) NOT NULL DEFAULT 0,
  `updatedOn` timestamp NOT NULL DEFAULT current_timestamp() ON UPDATE current_timestamp(),
  `bId` int(11) NOT NULL DEFAULT -1,
  `sortNo` int(11) DEFAULT 0,
  PRIMARY KEY (`id`),
  KEY `IX_cId_accCode` (`cId`,`accCode`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

INSERT INTO `ob_account` (`id`, `cId`, `name`, `groupId`, `groupCode`, `accCode`, `accCustomCode`, `descr`, `taxId`, `HS`, `itc`, `taxTypeCode`, `isActive`, `systemRec`, `balance`, `drank`, `crank`, `updatedOn`, `bId`, `sortNo`) VALUES
(1,	0,	'Advertising & Promotion',	15,	'EI',	'',	NULL,	'Advertising and promotion expenses for Product A, B, C',	0,	'',	0,	'',	1,	1,	0.00,	0,	0,	'2020-12-28 14:55:11',	-1,	0),
(2,	0,	'Bad Debts Written Off',	15,	'EI',	'BD',	NULL,	'',	0,	'',	0,	'',	1,	1,	0.00,	0,	0,	'2020-12-28 14:55:11',	-1,	0),
(3,	0,	'Housekeeping Charges',	15,	'EI',	'',	NULL,	'',	0,	'',	0,	'',	1,	1,	0.00,	0,	0,	'2020-12-28 14:55:11',	-1,	0),
(4,	0,	'Charity & Donations',	15,	'EI',	'',	NULL,	'',	0,	'',	0,	'',	1,	1,	0.00,	0,	0,	'2020-12-28 14:55:11',	-1,	0),
(5,	0,	'Travel Expense',	15,	'EI',	'',	NULL,	'',	0,	'',	0,	'',	1,	1,	0.00,	0,	0,	'2020-12-28 14:55:11',	-1,	0),
(6,	0,	'IT and Internet Expenses',	15,	'EI',	'',	NULL,	'',	0,	'',	0,	'',	1,	1,	0.00,	0,	0,	'2020-12-28 14:55:11',	-1,	0),
(7,	0,	'Depreciation Expenses',	15,	'EI',	'',	NULL,	'',	0,	'',	0,	'',	1,	1,	0.00,	0,	0,	'2020-12-28 14:55:11',	-1,	0),
(8,	0,	'Insurance Expenses',	15,	'EI',	'',	NULL,	'',	0,	'',	0,	'',	1,	1,	0.00,	0,	0,	'2020-12-28 14:55:11',	-1,	0),
(9,	0,	'Consultant Expenses',	15,	'EI',	'',	NULL,	'',	0,	'',	0,	'',	1,	1,	0.00,	0,	0,	'2020-12-28 14:55:11',	-1,	0),
(10,	0,	'Miscellaneous Expenses',	15,	'EI',	'',	NULL,	'',	0,	'',	0,	'',	1,	1,	0.00,	0,	0,	'2020-12-28 14:55:11',	-1,	0),
(11,	0,	'Repairs and Maintenance',	15,	'EI',	'',	NULL,	'',	0,	'',	0,	'',	1,	1,	0.00,	0,	0,	'2020-12-28 14:55:11',	-1,	0),
(12,	0,	'Rent Expenses',	15,	'EI',	'',	NULL,	'',	0,	'',	0,	'',	1,	1,	0.00,	0,	0,	'2020-12-28 14:55:11',	-1,	0),
(13,	0,	'Postal Expenses',	15,	'EI',	'',	NULL,	'',	0,	'',	0,	'',	1,	1,	0.00,	0,	0,	'2020-12-28 14:55:11',	-1,	0),
(14,	0,	'Printing & Stationery',	15,	'EI',	'',	NULL,	'',	0,	'',	0,	'',	1,	1,	0.00,	0,	0,	'2020-12-28 14:55:11',	-1,	0),
(15,	0,	'Fuel Expenses',	15,	'EI',	'',	NULL,	'',	0,	'',	0,	'',	1,	1,	0.00,	0,	0,	'2020-12-28 14:55:11',	-1,	0),
(16,	0,	'Salary',	15,	'EI',	'',	NULL,	'',	0,	'',	0,	'',	1,	1,	0.00,	0,	0,	'2020-12-28 14:55:11',	-1,	0),
(17,	0,	'Interest on loan',	15,	'EI',	'',	NULL,	'',	0,	'',	0,	'',	1,	1,	0.00,	0,	0,	'2020-12-28 14:55:11',	-1,	0),
(18,	0,	'Staff Welfare Expenses',	15,	'EI',	'',	NULL,	'',	0,	'',	0,	'',	1,	1,	0.00,	0,	0,	'2020-12-28 14:55:11',	-1,	0),
(19,	0,	'Telephone Expenses',	15,	'EI',	'',	NULL,	'',	0,	'',	0,	'',	1,	1,	0.00,	0,	0,	'2020-12-28 14:55:11',	-1,	0),
(20,	0,	'General Expenses',	15,	'EI',	'',	NULL,	'',	0,	'',	0,	'',	1,	1,	0.00,	0,	0,	'2020-12-28 14:55:11',	-1,	0),
(21,	0,	'Water & Electricity Expenses',	15,	'EI',	'',	NULL,	'',	0,	'',	0,	'',	1,	1,	0.00,	0,	0,	'2020-12-28 14:55:11',	-1,	0),
(22,	0,	'Cash',	5,	'CH',	'CA',	NULL,	'',	0,	'',	0,	'',	1,	1,	0.00,	0,	0,	'2020-12-28 14:55:11',	-1,	0),
(23,	0,	'Sales',	25,	'SA',	'SA',	NULL,	'',	0,	'',	0,	'',	1,	1,	0.00,	0,	0,	'2020-12-28 14:55:11',	-1,	0),
(24,	0,	'Purchase',	24,	'PU',	'PU',	NULL,	'',	0,	'',	0,	'',	1,	1,	0.00,	0,	0,	'2020-12-28 14:55:11',	-1,	0),
(25,	0,	'Land',	16,	'FA',	'',	NULL,	'',	0,	'',	0,	'',	1,	1,	0.00,	0,	0,	'2020-12-28 14:55:11',	-1,	0),
(26,	0,	'Vehicle',	16,	'FA',	'',	NULL,	'',	0,	'',	0,	'',	1,	1,	0.00,	0,	0,	'2020-12-28 14:55:11',	-1,	0),
(27,	0,	'Furniture and Fittings',	16,	'FA',	'FF',	NULL,	'',	0,	'',	0,	'',	1,	1,	0.00,	0,	0,	'2020-12-28 14:55:11',	-1,	0),
(28,	0,	'Building',	16,	'FA',	'',	NULL,	'',	0,	'',	0,	'',	1,	1,	0.00,	0,	0,	'2020-12-28 14:55:11',	-1,	0),
(29,	0,	'Computer',	16,	'FA',	'',	NULL,	'',	0,	'',	0,	'',	1,	1,	0.00,	0,	0,	'2020-12-28 14:55:11',	-1,	0),
(30,	0,	'Machinery',	16,	'FA',	'',	NULL,	'',	0,	'',	0,	'',	1,	1,	0.00,	0,	0,	'2020-12-28 14:55:11',	-1,	0),
(31,	0,	'Bills Receivable',	3,	'CA',	'BR',	NULL,	'',	0,	'',	0,	'',	1,	1,	0.00,	0,	0,	'2020-12-28 14:55:11',	-1,	0),
(32,	0,	'Prepaid Expense',	3,	'CA',	'PE',	NULL,	'',	0,	'',	0,	'',	1,	1,	0.00,	0,	0,	'2020-12-28 14:55:11',	-1,	0),
(33,	0,	'TDS Receivable',	3,	'CA',	'TDSR',	NULL,	'',	0,	'',	0,	'',	1,	1,	0.00,	0,	0,	'2020-12-28 14:55:11',	-1,	0),
(34,	0,	'Undeposited Funds',	3,	'CA',	'',	NULL,	'',	0,	'',	0,	'',	1,	1,	0.00,	0,	0,	'2020-12-28 14:55:11',	-1,	0),
(35,	0,	'Advance Tax',	3,	'CA',	'',	NULL,	'',	0,	'',	0,	'',	1,	1,	0.00,	0,	0,	'2020-12-28 14:55:11',	-1,	0),
(36,	0,	'Employee Advance',	3,	'CA',	'',	NULL,	'',	0,	'',	0,	'',	1,	1,	0.00,	0,	0,	'2020-12-28 14:55:11',	-1,	0),
(37,	0,	'Sundry Debtors',	9,	'SD',	'AR',	NULL,	'',	0,	'',	0,	'',	1,	1,	0.00,	0,	0,	'2020-12-28 14:55:11',	-1,	0),
(38,	0,	'Sundry Creditors',	13,	'SC',	'AP',	NULL,	'',	0,	'',	0,	'',	1,	1,	0.00,	0,	0,	'2020-12-28 14:55:11',	-1,	0),
(39,	0,	'Wages',	14,	'ED',	'',	NULL,	'',	0,	'',	0,	'',	1,	1,	0.00,	0,	0,	'2020-12-28 14:55:11',	-1,	0),
(40,	0,	'TDS Payable',	10,	'CL',	'TDSPAY',	NULL,	'',	0,	'',	0,	'',	1,	1,	0.00,	0,	0,	'2020-12-28 14:55:11',	-1,	0),
(41,	0,	'Freight Charges',	17,	'ID',	'FC',	NULL,	'',	0,	'',	0,	'',	1,	1,	0.00,	0,	0,	'2020-12-28 14:55:11',	-1,	0),
(42,	0,	'Packing and Forwarding Charges',	17,	'ID',	'PC',	NULL,	'',	0,	'',	0,	'',	1,	1,	0.00,	0,	0,	'2020-12-28 14:55:11',	-1,	0),
(43,	0,	'Insurance Charges',	17,	'ID',	'IC',	NULL,	'',	0,	'',	0,	'',	1,	1,	0.00,	0,	0,	'2020-12-28 14:55:11',	-1,	0),
(44,	0,	'Round Off',	15,	'EI',	'RO',	NULL,	'',	0,	'',	0,	'',	1,	1,	0.00,	0,	0,	'2020-12-28 14:55:11',	-1,	0),
(45,	0,	'Forex Gain/Loss',	15,	'EI',	'FX',	NULL,	'',	0,	'',	0,	'',	1,	1,	0.00,	0,	0,	'2020-12-28 14:55:11',	-1,	0),
(46,	0,	'Sales Return',	25,	'SA',	'SR',	NULL,	'',	0,	'',	0,	'',	1,	1,	0.00,	0,	0,	'2020-12-28 14:55:11',	-1,	0),
(47,	0,	'Purchase Return',	24,	'PU',	'PR',	NULL,	'',	0,	'',	0,	'',	1,	1,	0.00,	0,	0,	'2020-12-28 14:55:11',	-1,	0),
(48,	0,	'Profit and Loss',	485,	'CP',	'PL',	NULL,	'',	0,	'',	0,	'',	1,	1,	0.00,	0,	0,	'2020-12-28 14:55:11',	-1,	0),
(49,	0,	'Bank Charges',	15,	'EI',	'BC',	NULL,	'',	0,	'',	0,	'',	1,	1,	0.00,	0,	0,	'2020-12-28 14:55:11',	-1,	0),
(50,	0,	'Balance Written Off',	18,	'II',	'BW',	NULL,	'',	0,	'',	0,	'',	1,	1,	0.00,	0,	0,	'2020-12-28 14:55:11',	-1,	0),
(51,	0,	'Customs Duty Payable',	24,	'PU',	'CD',	NULL,	'',	0,	'',	0,	'',	0,	1,	0.00,	0,	0,	'2020-12-28 14:55:11',	-1,	0),
(52,	0,	'TCS Payable',	10,	'CL',	'TCSPAY',	NULL,	'',	0,	'',	0,	'',	1,	1,	0.00,	0,	0,	'2020-12-28 14:55:11',	-1,	0),
(53,	0,	'TCS Receivable',	3,	'CA',	'TCSR',	NULL,	'',	0,	'',	0,	'',	1,	1,	0.00,	0,	0,	'2020-12-28 14:55:11',	-1,	0),
(54,	0,	'Branch',	3,	'CA',	'BH',	NULL,	'',	0,	'',	0,	'',	1,	1,	0.00,	0,	0,	'2021-11-17 05:40:56',	-1,	0),
(55,	0,	'Loyalty Discount',	14,	'ED',	'LD',	'',	'',	0,	'',	0,	'',	1,	1,	0.00,	0,	0,	'2023-03-18 06:18:22',	-1,	0),
(56,	0,	'Stock-in-hand',	8,	'SH',	'SH',	'',	'',	0,	'',	0,	'',	1,	1,	0.00,	0,	0,	'2023-03-18 06:18:23',	0,	0);

DROP TABLE IF EXISTS `ob_accountgroup`;
CREATE TABLE `ob_accountgroup` (
  `id` mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
  `cId` mediumint(8) unsigned NOT NULL,
  `name` varchar(100) NOT NULL,
  `groupCode` char(2) NOT NULL DEFAULT '',
  `grpCustomCode` varchar(16) DEFAULT NULL,
  `parentGroupCode` char(2) NOT NULL,
  `parentGroupId` mediumint(8) unsigned NOT NULL DEFAULT 0,
  `acType` char(1) NOT NULL COMMENT 'I/E/A/L',
  `rptType` char(1) NOT NULL COMMENT 'B - Balancesheet / P - P&L',
  `systemRec` tinyint(1) NOT NULL,
  `sortOrd` char(1) DEFAULT NULL,
  `lft` int(11) DEFAULT NULL,
  `rgt` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

INSERT INTO `ob_accountgroup` (`id`, `cId`, `name`, `groupCode`, `grpCustomCode`, `parentGroupCode`, `parentGroupId`, `acType`, `rptType`, `systemRec`, `sortOrd`, `lft`, `rgt`) VALUES
(1,	0,	'Capital Account',	'CP',	NULL,	'',	28,	'L',	'B',	1,	'F',	30,	33),
(2,	0,	'Reserves & Surplus',	'RS',	NULL,	'CP',	1,	'L',	'B',	1,	NULL,	31,	32),
(3,	0,	'Current Assets',	'CA',	NULL,	'',	29,	'A',	'B',	1,	'H',	2,	15),
(4,	0,	'Bank Accounts',	'BA',	NULL,	'CA',	3,	'A',	'B',	1,	NULL,	3,	4),
(5,	0,	'Cash-in-hand',	'CH',	NULL,	'CA',	3,	'A',	'B',	1,	NULL,	5,	6),
(6,	0,	'Deposits (Asset)',	'DA',	NULL,	'CA',	3,	'A',	'B',	1,	NULL,	7,	8),
(7,	0,	'Loans & Advances (Asset)',	'LA',	NULL,	'CA',	3,	'A',	'B',	1,	NULL,	9,	10),
(8,	0,	'Stock-in-hand',	'SH',	NULL,	'CA',	3,	'A',	'B',	1,	NULL,	11,	12),
(9,	0,	'Sundry Debtors',	'SD',	NULL,	'CA',	3,	'A',	'B',	1,	NULL,	13,	14),
(10,	0,	'Current Liabilities',	'CL',	NULL,	'',	28,	'L',	'B',	1,	'H',	34,	41),
(11,	0,	'Duties & Taxes',	'TX',	NULL,	'CL',	10,	'L',	'B',	1,	NULL,	35,	36),
(12,	0,	'Provisions/Expenses Payable',	'EP',	NULL,	'CL',	10,	'L',	'B',	1,	NULL,	37,	38),
(13,	0,	'Sundry Creditors',	'SC',	NULL,	'CL',	10,	'L',	'B',	1,	NULL,	39,	40),
(14,	0,	'Direct Expenses',	'ED',	NULL,	'',	0,	'E',	'T',	1,	'I',	21,	22),
(15,	0,	'Indirect Expenses',	'EI',	NULL,	'',	0,	'E',	'L',	1,	'K',	25,	26),
(16,	0,	'Fixed Assets',	'FA',	NULL,	'',	29,	'A',	'B',	1,	'F',	16,	17),
(17,	0,	'Direct Income',	'ID',	NULL,	'',	0,	'I',	'T',	1,	'G',	23,	24),
(18,	0,	'Indirect Income',	'II',	NULL,	'',	0,	'I',	'P',	1,	'J',	27,	28),
(19,	0,	'Investments',	'IN',	NULL,	'',	29,	'A',	'B',	1,	'G',	18,	19),
(20,	0,	'Loans (Liability)',	'LO',	NULL,	'',	28,	'L',	'B',	1,	'G',	42,	51),
(21,	0,	'Bank O/D Account',	'BO',	NULL,	'LO',	20,	'L',	'B',	1,	NULL,	43,	44),
(22,	0,	'Secured Loans',	'SL',	NULL,	'LO',	20,	'L',	'B',	1,	NULL,	47,	48),
(23,	0,	'Unsecured Loans',	'UL',	NULL,	'LO',	20,	'L',	'B',	1,	NULL,	49,	50),
(24,	0,	'Purchase',	'PU',	NULL,	'',	0,	'E',	'T',	1,	'H',	55,	56),
(25,	0,	'Sales',	'SA',	NULL,	'',	0,	'I',	'T',	1,	'F',	57,	58),
(26,	0,	'Suspense Account',	'SU',	NULL,	'',	28,	'L',	'B',	1,	'I',	52,	53),
(27,	0,	'Credit Cards',	'CC',	NULL,	'LO',	20,	'L',	'B',	1,	NULL,	45,	46),
(28,	0,	'Liabilities',	'',	NULL,	'',	0,	'L',	'B',	1,	'A',	29,	54),
(29,	0,	'Assets',	'',	NULL,	'',	0,	'A',	'B',	1,	'B',	1,	20);

DROP TABLE IF EXISTS `ob_account_loc`;
CREATE TABLE `ob_account_loc` (
  `accId` mediumint(8) unsigned NOT NULL,
  `locId` mediumint(8) unsigned NOT NULL,
  `cId` mediumint(8) unsigned NOT NULL,
  `alType` char(1) NOT NULL COMMENT 'R-ReceiptOnly, P-Payment, B-Both, N - None',
  UNIQUE KEY `alc` (`accId`,`locId`,`cId`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ob_activationkey`;
CREATE TABLE `ob_activationkey` (
  `id` mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
  `uId` mediumint(8) unsigned NOT NULL,
  `actKey` varchar(32) NOT NULL,
  `uuid` varchar(50) NOT NULL,
  `info` text NOT NULL,
  `activateOn` timestamp NOT NULL DEFAULT current_timestamp(),
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ob_activetrial`;
CREATE TABLE `ob_activetrial` (
  `id` mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
  `uId` mediumint(8) unsigned NOT NULL,
  `actKey` varchar(32) NOT NULL,
  `uuid` varchar(50) NOT NULL,
  `info` text NOT NULL,
  `activateOn` timestamp NOT NULL DEFAULT current_timestamp(),
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ob_api_keys`;
CREATE TABLE `ob_api_keys` (
  `id` mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
  `cId` mediumint(8) unsigned NOT NULL,
  `description` varchar(200) NOT NULL,
  `permissions` varchar(10) NOT NULL,
  `consumer_key` varchar(64) NOT NULL,
  `consumer_secret` varchar(43) NOT NULL,
  `last_access` datetime DEFAULT NULL,
  `bId` int(11) NOT NULL DEFAULT 0,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ob_attachment`;
CREATE TABLE `ob_attachment` (
  `id` mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
  `cId` mediumint(8) unsigned NOT NULL,
  `bId` mediumint(8) NOT NULL DEFAULT 0,
  `mType` char(4) NOT NULL DEFAULT 'C' COMMENT 'C - Customer / S - Supplier / L - Warehouse / B - Branches',
  `mId` mediumint(8) unsigned NOT NULL,
  `fileName` varchar(100) NOT NULL,
  `filePath` varchar(200) NOT NULL,
  `fileType` varchar(200) NOT NULL,
  `fileSize` varchar(200) NOT NULL,
  `crdBy` mediumint(8) unsigned DEFAULT NULL,
  `crdDate` timestamp NOT NULL DEFAULT current_timestamp(),
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ob_attributes`;
CREATE TABLE `ob_attributes` (
  `attrId` mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
  `attrGrpId` mediumint(8) unsigned NOT NULL,
  `name` varchar(60) NOT NULL,
  `cId` mediumint(8) unsigned NOT NULL,
  `isActive` tinyint(1) NOT NULL DEFAULT 1,
  PRIMARY KEY (`attrId`),
  KEY `IX_agId_cId` (`attrGrpId`,`cId`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ob_attributes_group`;
CREATE TABLE `ob_attributes_group` (
  `attrGrpId` mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(60) NOT NULL,
  `grpCode` varchar(2) NOT NULL COMMENT '(BA-Batch/MD-M.Date/ED-Ex.Date/BD-Brand/MF-Manufacturer)',
  `fldType` varchar(1) NOT NULL COMMENT '(S-Select (default), T-Text, D-Date, N - Number)',
  `format` varchar(16) NOT NULL,
  `isRequired` tinyint(1) NOT NULL,
  `isPrint` tinyint(1) NOT NULL,
  `cId` mediumint(8) unsigned NOT NULL,
  `isActive` tinyint(1) NOT NULL DEFAULT 1,
  `sortNo` smallint(2) NOT NULL,
  PRIMARY KEY (`attrGrpId`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ob_bank`;
CREATE TABLE `ob_bank` (
  `id` mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
  `cid` mediumint(8) unsigned NOT NULL,
  `accId` mediumint(8) unsigned NOT NULL,
  `bankName` varchar(100) NOT NULL,
  `accName` varchar(100) NOT NULL,
  `accNumber` varchar(20) NOT NULL,
  `accType` char(1) NOT NULL COMMENT 'C-Current/S-Saving/H-Cash Credit/L-Loan Account/O-Over Draft/R-Credit Card',
  `branchName` varchar(30) DEFAULT NULL,
  `ifscRouteCode` varchar(30) DEFAULT NULL,
  `bsrCode` varchar(20) DEFAULT NULL,
  `swiftCode` varchar(16) DEFAULT NULL,
  `adCode` varchar(20) DEFAULT NULL,
  `corrBank` varchar(500) NOT NULL,
  `upiId` varchar(50) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ob_banktrans`;
CREATE TABLE `ob_banktrans` (
  `btrId` mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
  `bankAccId` mediumint(8) unsigned NOT NULL,
  `btrDate` date DEFAULT NULL,
  `btrDesc` varchar(255) NOT NULL,
  `chqno` varchar(255) NOT NULL,
  `debit` decimal(11,2) NOT NULL,
  `credit` decimal(11,2) NOT NULL,
  `cId` mediumint(8) unsigned NOT NULL,
  PRIMARY KEY (`btrId`),
  KEY `IX_bankaccid_btrdate` (`bankAccId`,`btrDate`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ob_banktrans_map`;
CREATE TABLE `ob_banktrans_map` (
  `btrId` mediumint(8) unsigned NOT NULL,
  `transId` mediumint(8) unsigned NOT NULL,
  `cId` mediumint(8) unsigned NOT NULL,
  UNIQUE KEY `btrId` (`btrId`,`transId`,`cId`),
  KEY `transId_cId` (`transId`,`cId`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ob_barcode_settings`;
CREATE TABLE `ob_barcode_settings` (
  `id` mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
  `cId` mediumint(8) unsigned NOT NULL,
  `name` varchar(255) NOT NULL,
  `lines` text NOT NULL,
  `paper` varchar(10) NOT NULL,
  `qty` tinyint(3) NOT NULL DEFAULT 1,
  `width` float(4,2) NOT NULL,
  `height` float(4,2) NOT NULL,
  `cols` mediumint(8) unsigned NOT NULL,
  `rows` mediumint(8) unsigned NOT NULL,
  `topMargin` float(4,2) NOT NULL,
  `rightMargin` float(4,2) NOT NULL,
  `bottomMargin` float(4,2) NOT NULL,
  `leftMargin` float(4,2) NOT NULL,
  `lableWidth` float(4,2) NOT NULL DEFAULT 0.00,
  `lableHeight` float(4,2) NOT NULL DEFAULT 0.00,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ob_bom`;
CREATE TABLE `ob_bom` (
  `id` mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
  `cId` mediumint(8) unsigned NOT NULL,
  `bomName` varchar(128) NOT NULL,
  `itemId` mediumint(8) unsigned NOT NULL,
  `itemAttrId` mediumint(8) unsigned NOT NULL,
  `hideRate` tinyint(1) NOT NULL,
  `lockEdit` tinyint(1) NOT NULL,
  `isBundle` tinyint(1) NOT NULL,
  `isActive` tinyint(1) NOT NULL,
  `bomType` char(1) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ob_bom_items`;
CREATE TABLE `ob_bom_items` (
  `id` mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
  `bomId` mediumint(8) unsigned NOT NULL,
  `cId` mediumint(8) unsigned NOT NULL,
  `itemId` mediumint(8) unsigned NOT NULL,
  `description` text NOT NULL,
  `itemAttrId` mediumint(8) unsigned NOT NULL,
  `locId` mediumint(8) unsigned NOT NULL,
  `qty` decimal(9,3) NOT NULL,
  `unit` varchar(10) NOT NULL,
  `rate` decimal(11,3) NOT NULL DEFAULT 0.000,
  `pType` varchar(1) NOT NULL COMMENT 'C-Consumption / P-Production / E - Additional Cost',
  PRIMARY KEY (`id`),
  KEY `bomId` (`bomId`,`itemId`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ob_budget`;
CREATE TABLE `ob_budget` (
  `id` mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
  `cId` mediumint(8) unsigned NOT NULL,
  `fYear` smallint(5) NOT NULL,
  `bId` mediumint(8) unsigned NOT NULL DEFAULT 0,
  PRIMARY KEY (`id`),
  KEY `IX_cId` (`cId`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ob_budgetval`;
CREATE TABLE `ob_budgetval` (
  `budgetId` mediumint(8) unsigned NOT NULL,
  `accId` mediumint(8) unsigned NOT NULL,
  `monval1` decimal(9,2) NOT NULL,
  `monval2` decimal(9,2) NOT NULL,
  `monval3` decimal(9,2) NOT NULL,
  `monval4` decimal(9,2) NOT NULL,
  `monval5` decimal(9,2) NOT NULL,
  `monval6` decimal(9,2) NOT NULL,
  `monval7` decimal(9,2) NOT NULL,
  `monval8` decimal(9,2) NOT NULL,
  `monval9` decimal(9,2) NOT NULL,
  `monval10` decimal(9,2) NOT NULL,
  `monval11` decimal(9,2) NOT NULL,
  `monval12` decimal(9,2) NOT NULL,
  UNIQUE KEY `IX_bud_acc_id` (`budgetId`,`accId`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ob_captcha`;
CREATE TABLE `ob_captcha` (
  `captcha_id` bigint(13) unsigned NOT NULL AUTO_INCREMENT,
  `captcha_time` int(10) unsigned NOT NULL,
  `ip_address` varchar(45) NOT NULL,
  `word` varchar(20) NOT NULL,
  PRIMARY KEY (`captcha_id`),
  KEY `word` (`word`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ob_category`;
CREATE TABLE `ob_category` (
  `id` mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
  `cId` mediumint(8) unsigned NOT NULL,
  `code` varchar(8) NOT NULL,
  `name` varchar(64) NOT NULL,
  `pId` mediumint(8) unsigned NOT NULL DEFAULT 0,
  `filePath` varchar(250) NOT NULL,
  `updatedOn` timestamp NOT NULL DEFAULT current_timestamp() ON UPDATE current_timestamp(),
  `sortNo` int(11) NOT NULL DEFAULT 0,
  `imgFileExt` varchar(5) NOT NULL,
  `type` char(1) NOT NULL DEFAULT 'C',
  `lft` int(11) DEFAULT NULL,
  `rgt` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ob_category_attrgrp`;
CREATE TABLE `ob_category_attrgrp` (
  `catId` mediumint(8) unsigned NOT NULL,
  `attrGrpId` mediumint(8) unsigned NOT NULL,
  `cId` mediumint(8) unsigned NOT NULL,
  KEY `IX_catId` (`catId`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ob_chqprint`;
CREATE TABLE `ob_chqprint` (
  `accId` mediumint(8) unsigned NOT NULL,
  `cId` mediumint(8) unsigned NOT NULL,
  `tmplCode` varchar(40) NOT NULL,
  `isCustom` tinyint(1) NOT NULL,
  `content` text NOT NULL,
  PRIMARY KEY (`accId`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ob_cities`;
CREATE TABLE `ob_cities` (
  `id` mediumint(9) NOT NULL AUTO_INCREMENT,
  `name` varchar(60) NOT NULL,
  `stateCode` varchar(3) NOT NULL,
  `location` varchar(50) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `idx_name` (`name`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

INSERT INTO `ob_cities` (`id`, `name`, `stateCode`, `location`) VALUES
(1,	'Andaman & Nicobar',	'AN',	'11.74008670,92.65864010'),
(2,	'Dhinoj',	'GJ',	'23.661324,72.279541'),
(3,	'Chitalwana',	'RJ',	'24.924999,71.659721'),
(4,	'Pugal',	'RJ',	'28.5,72.800003'),
(5,	'Doom Dooma',	'AS',	'27.57,95.57'),
(6,	'Usar',	'MH',	'18.291109,73.131744'),
(7,	'Perinad',	'KL',	'8.95628,76.640022'),
(8,	'New Terhi',	'UT',	'30.379999,78.480003'),
(9,	'Cheekode',	'KL',	'11.23043,75.989342'),
(10,	'Palani',	'TN',	'10.45,77.519997'),
(11,	'Bhawani Mandi',	'RJ',	'24.42,75.82972'),
(12,	'Beldanga',	'WB',	'23.93,88.25'),
(13,	'Vedasandur',	'TN',	'10.530206,77.922646'),
(14,	'Paniyara',	'UP',	'26.997454,83.463402'),
(15,	'Nagarbera',	'AS',	'26.11179,91.003578'),
(16,	'Atgaon',	'MH',	'19.502623,73.330368'),
(17,	'Malur',	'KA',	'12.99,77.937111'),
(18,	'Munnar',	'KL',	'10.089167,77.059723'),
(19,	'Demjok',	'JK',	'32.699909,79.449516'),
(20,	'Umerkote',	'OR',	'19.665001,82.211998'),
(21,	'Mohone',	'MH',	'19.265133,73.172371'),
(22,	'Shiroor',	'KA',	'13.916197,74.599342'),
(23,	'Kuwerpur',	'UP',	'27.217766,78.118172'),
(24,	'Holnanthe',	'MH',	'21.204906,74.900551'),
(25,	'Asopur',	'BH',	'25.58942,85.043251'),
(26,	'Sagardighi',	'WB',	'24.292355,88.086357'),
(27,	'Siolim',	'GA',	'15.62009,73.777222'),
(28,	'Rahika',	'BH',	'26.378592,86.020332'),
(29,	'Veerabhadrapeta',	'APN',	'18.038063,83.194374'),
(30,	'Bagseen',	'RJ',	'25.035452,72.927742'),
(31,	'Laikera',	'OR',	'21.884956,84.212807'),
(32,	'Piliv',	'MH',	'17.682156,74.966156'),
(33,	'Patnitop',	'JK',	'33.077778,75.326912'),
(34,	'Peer Muchalla',	'PB',	'30.661608,76.863342'),
(35,	'Rambha',	'OR',	'19.520241,85.090126'),
(36,	'Lasadiya',	'RJ',	'24.257906,74.24073'),
(37,	'Pimpalgaon Baswant',	'MH',	'20.165369,73.987991'),
(38,	'Maganpur',	'JH',	'23.565374,85.781036'),
(39,	'Banki',	'OR',	'20.377754,85.530029'),
(40,	'Goilkera',	'JH',	'22.507088,85.37664'),
(41,	'Amethi',	'UP',	'26.153912,81.813087'),
(42,	'Belda',	'WB',	'22.070757,87.338417'),
(43,	'Mohania',	'BH',	'25.166819,83.617294'),
(44,	'Bichhiya',	'MP',	'22.451139,80.709236'),
(45,	'Nasrala',	'PB',	'31.489271,75.82431'),
(46,	'Amritpur',	'UP',	'27.540354,79.597565'),
(47,	'Basari',	'MP',	'24.823471,79.717812'),
(48,	'Pothencode',	'KL',	'8.620447,76.89843'),
(49,	'Kalaghatagi',	'KA',	'15.192222,74.967094'),
(50,	'Natepute',	'MH',	'17.898615,74.754189'),
(51,	'Nainpur',	'MP',	'22.426605,80.109558'),
(52,	'Asotra',	'RJ',	'25.764273,72.294334'),
(53,	'Nasirabad',	'RJ',	'26.297997,74.734558'),
(54,	'Chandrakona Road',	'WB',	'22.733934,87.339088'),
(55,	'VeeraKLmpudur',	'TN',	'8.937609,77.449501'),
(56,	'Rajpipila',	'GJ ',	'21.87171,73.502701'),
(57,	'Chowannur',	'KL',	'10.65054,76.078346'),
(58,	'Aatarsumba',	'GJ',	'23.052139,72.966629'),
(59,	'Puthalam',	'TN',	'8.106106,77.466888'),
(60,	'Simri',	'BH',	'26.005791,86.349442'),
(61,	'Maipit',	'WB',	'21.919558,88.544647'),
(62,	'Naranda',	'MH',	'19.781528,79.058151'),
(63,	'Gawan',	'UP',	'28.421179,78.351059'),
(64,	'Rahatgaon',	'MP',	'22.24675,77.228226'),
(65,	'Fatehpur Sikri',	'UP',	'27.095018,77.668846'),
(66,	'Ghumansar Khurd',	'RJ',	'28.24391,75.483482'),
(67,	'Panwaria',	'UP',	'28.760918,79.056107'),
(68,	'Shirala',	'MH',	'16.985617,74.129868'),
(69,	'Jakhinwadi',	'MH',	'17.238325,74.168594'),
(70,	'Galleborgaon',	'MH',	'20.090658,75.123199'),
(71,	'Patharkandi',	'AS',	'24.607124,92.317726'),
(72,	'Chopta',	'UT',	'30.346434,79.048386'),
(73,	'Lipti',	'CT',	'22.636292,83.402977'),
(74,	'Hatkanangale',	'MH',	'16.74456,74.446701'),
(75,	'Mothkur',	'TS',	'17.472683,79.25946'),
(76,	'Dharampur',	'GJ',	'20.54014,73.179214'),
(77,	'Bawal',	'HR',	'28.095589,76.592751'),
(78,	'Thasra',	'GJ',	'22.802561,73.220505'),
(79,	'Lohagad',	'MH',	'18.694317,73.487259'),
(80,	'Parwaha',	'BH',	'26.233364,87.226997'),
(81,	'Jamtala',	'WB',	'22.108612,88.572548'),
(82,	'Kayalpatnam',	'TN',	'8.568315,78.123833'),
(83,	'Bhatgaon',	'CT',	'21.655977,82.803757'),
(84,	'Angul',	'OR',	'20.844402,85.151085'),
(85,	'Deogarh',	'OR',	'21.538315,84.728943'),
(86,	'Sanwer',	'MP',	'22.976303,75.827553'),
(87,	'Dalsingh Sarai',	'BH',	'25.668974,85.834892'),
(88,	'Jalalabad',	'PB',	'30.60573,74.256111'),
(89,	'Takarwan',	'MH',	'19.25038,76.012505'),
(90,	'Purena',	'CT',	'21.238678,81.704781'),
(91,	'Kailash',	'HR',	'29.728127,77.010422'),
(92,	'Nimta',	'WB',	'22.668962,88.408844'),
(93,	'Pathapatnam',	'APN',	'18.750523,84.091576'),
(94,	'Ganeshgarh',	'RJ',	'29.746632,73.903648'),
(95,	'Brahamanwada Thadi',	'MH',	'21.324831,77.732201'),
(96,	'Ghasipura',	'OR',	'21.216875,86.112129'),
(97,	'Pallikkara',	'KL',	'11.503067,75.635963'),
(98,	'Kevadia',	'GJ',	'21.882874,73.697624'),
(99,	'Patarajpur',	'OR',	'20.608757,86.243416'),
(100,	'Kulei',	'OR',	'21.09145,85.136497'),
(101,	'Dalhousie',	'HP',	'32.539555,75.970955'),
(102,	'Khandokata',	'OR',	'21.793653,84.326042'),
(103,	'Rangpo',	'SK',	'27.176147,88.528732'),
(104,	'Candolim',	'GA',	'15.515447,73.768402'),
(105,	'Khandaghosh',	'WB',	'23.214766,87.689949'),
(106,	'Jyotiba Nagar',	'MH',	'18.686785,73.790443'),
(107,	'Rudri',	'CT',	'20.665974,81.552872'),
(108,	'Muddebihal',	'KA',	'16.339136,76.130211'),
(109,	'Vatadara',	'GJ',	'22.3407,72.752487'),
(110,	'Dhondalgaon',	'MH',	'19.982878,74.938416'),
(111,	'Hulagabali',	'KA',	'16.662367,74.993935'),
(112,	'Thekkady',	'KL',	'9.606325,77.169701'),
(113,	'Uchgaon',	'MH',	'16.696154,74.274345'),
(114,	'Etmadpur',	'UP',	'27.233313,78.199188'),
(115,	'Hungund',	'KA',	'16.057627,76.060951'),
(116,	'Chargaon',	'MH',	'21.264942,78.750099'),
(117,	'Huzurabad',	'TS',	'18.201895,79.396706'),
(118,	'Yedathore',	'KA',	'12.470855,76.386024'),
(119,	'Poovattoor',	'KL',	'9.05604,76.752411'),
(120,	'Bhojpura',	'RJ',	'26.62359,75.614037'),
(121,	'Imphal West',	'MN',	'24.782784,93.885895'),
(122,	'Raoti',	'MP',	'23.225624,74.840477'),
(123,	'Eyyal',	'TN',	'12.406525,79.326134'),
(124,	'Mussoorie',	'UT',	'30.459909,78.066399'),
(125,	'Dattapur Dhamangaon',	'MH',	'20.795732,78.138779'),
(126,	'Panewadi',	'MH',	'20.271851,74.507507'),
(127,	'Awadhan',	'MH',	'20.845247,74.760902'),
(128,	'Kanturka',	'WB',	'24.998625,88.321503'),
(129,	'Ghulewadi',	'MH',	'19.611471,74.193527'),
(130,	'Phalodi',	'RJ',	'27.131235,72.358925'),
(131,	'Aruvankadu',	'TN',	'11.368327,76.771164'),
(132,	'Karmala',	'MH',	'18.40724,75.195221'),
(133,	'Adgaon',	'MH',	'20.039238,73.856606'),
(134,	'Devalapura',	'KA',	'12.817242,76.868309'),
(135,	'Rai Durg',	'TS',	'17.416315,78.389847'),
(136,	'Kakiriguma',	'OR',	'18.924225,83.01062'),
(137,	'Allowal',	'PB',	'31.144585,75.478325'),
(138,	'Lonand',	'MH',	'18.041706,74.18618'),
(139,	'Sangavi',	'MH',	'18.059986,74.486023'),
(140,	'Mandvi',	'GJ',	'22.833334,69.355476'),
(141,	'Pariyawan',	'UP',	'25.806955,81.378456'),
(142,	'Keelara',	'KA',	'12.599972,76.941917'),
(143,	'Bamangachi',	'WB',	'22.75692,88.507256'),
(144,	'Kondumal',	'MH',	'20.022755,79.285271'),
(145,	'Jui Khurd',	'HR',	'28.633448,75.943291'),
(146,	'Akkalkuva',	'MH',	'21.554268,74.016029'),
(147,	'Nilaji',	'KA',	'16.548655,74.891647'),
(148,	'Bayana',	'RJ',	'26.91581,77.28936'),
(149,	'Kuhi',	'MH',	'21.017248,79.367676'),
(150,	'Budhma',	'BH',	'25.913647,86.873276'),
(151,	'Chainpur',	'JH',	'23.133387,84.240814'),
(152,	'Ramgadh',	'GJ',	'21.508837,71.993614'),
(153,	'Awankhed',	'MH',	'20.246393,73.849625'),
(154,	'Shadnagar',	'TS',	'17.07123,78.204887'),
(155,	'Jadcherla',	'TS',	'16.763159,78.143585'),
(156,	'Puluru',	'TS',	'15.875523,77.997025'),
(157,	'Ieeja',	'TS',	'16.019527,77.667908'),
(158,	'Kalwakurthy',	'TS',	'16.668499,78.490639'),
(159,	'Maddur',	'TS',	'16.860228,77.612083'),
(160,	'Kodangal',	'TS',	'17.1103,77.623543'),
(161,	'Arsena',	'UP',	'27.237696,77.838142'),
(162,	'Nethaur',	'UP',	'29.323637,78.38707'),
(163,	'Tukada',	'GJ',	'21.526697,69.724129'),
(164,	'Chamta',	'WB',	'26.292059,89.655754'),
(165,	'Bandardewa',	'AR',	'27.095158,93.82737'),
(166,	'Vasind',	'MH',	'19.408226,73.264618'),
(167,	'Borgaon',	'KA',	'16.600021,74.50531'),
(168,	'Gejjalagere',	'KA',	'12.564031,76.995621'),
(169,	'Syaldey',	'UT',	'29.823778,79.209511'),
(170,	'Champa Nagar',	'UT',	'29.830875,79.202194'),
(171,	'Vikarabad',	'TS',	'17.33643,77.904846'),
(172,	'Nandavara',	'KA',	'12.867657,75.038834'),
(173,	'Lalgarh Jattan',	'RJ',	'29.84203,74.025513'),
(174,	'Haloli',	'MH',	'19.667858,72.906143'),
(175,	'Urga',	'CT',	'22.276445,82.7267'),
(176,	'Gajendragad',	'KA',	'15.736078,75.971001'),
(177,	'Poicha',	'GJ',	'21.970097,73.462425'),
(178,	'Jhalod',	'GJ',	'23.098167,74.164352'),
(179,	'Rudhauli',	'UP',	'27.032515,82.804024'),
(180,	'Varkala',	'KL',	'8.737868,76.716339'),
(181,	'Valasna',	'GJ',	'23.827955,72.78212'),
(182,	'Majhgawa',	'MP',	'24.91367,80.807327'),
(183,	'Kagarol',	'UP',	'27.022673,77.846916'),
(184,	'Asind',	'RJ',	'25.740776,74.338089'),
(185,	'Katraul',	'BH',	'26.351614,85.683624'),
(186,	'Fedara',	'GJ',	'22.452955,72.157906'),
(187,	'Malpura',	'RJ',	'26.300568,75.369659'),
(188,	'Thanakalan',	'TS',	'18.672577,78.007408'),
(189,	'Desari',	'BH',	'25.6647,85.404022'),
(190,	'Honnavar',	'KA',	'14.27975,74.443924'),
(191,	'Iglas',	'UP',	'27.710951,77.937683'),
(192,	'Laling',	'MH',	'20.824259,74.748177'),
(193,	'Sampla',	'HR',	'28.776157,76.773109'),
(194,	'Bamiyal',	'PB',	'32.286846,75.374741'),
(195,	'Gopiballabpur',	'WB',	'22.205948,86.894775'),
(196,	'Kapadne',	'MH',	'21.037188,74.809868'),
(197,	'Rameswar',	'MH',	'9.397255,78.626305'),
(198,	'Charadva',	'GJ',	'22.926941,71.024521'),
(199,	'Tungidighi',	'WB',	'25.755753,87.95771'),
(200,	'Aravatagi',	'KA',	'15.449764,74.819016'),
(201,	'Pure Dadhu',	'UP',	'26.941858,82.150963'),
(202,	'Mayannur',	'KL',	'10.750743,76.381088'),
(203,	'Vemulawada',	'TS',	'18.481934,78.867226'),
(204,	'Maliwada',	'MH',	'19.928707,75.221649'),
(205,	'Bhadrajun',	'RJ',	'25.603775,72.889946'),
(206,	'Ahan',	'UP',	'25.677322,82.840553'),
(207,	'Koradi',	'MH',	'21.237804,79.112511'),
(208,	'Vita',	'MH',	'17.273096,74.538826'),
(209,	'Lulhara',	'RJ',	'27.168571,77.313271'),
(210,	'Gadchandur',	'MH',	'19.729097,79.173195'),
(211,	'Reru',	'PB',	'31.359907,75.590981'),
(212,	'Malshiras',	'MH',	'17.863255,74.905479'),
(213,	'Kursela',	'BH',	'25.450579,87.252647'),
(214,	'Kullanchavadi',	'TN',	'11.629657,79.67128'),
(215,	'Shirud',	'MH',	'20.740564,74.895302'),
(216,	'Silhati',	'CT',	'21.783251,81.126526'),
(217,	'Dupadu',	'APN',	'15.916674,79.367073'),
(218,	'Gangolihat',	'UT',	'29.657042,80.039345'),
(219,	'Kedar Nagar',	'UP',	'26.540569,82.547791'),
(220,	'Gopalapur',	'UP',	'25.946089,82.555107'),
(221,	'Jetalpur',	'GJ',	'22.890657,72.595573'),
(222,	'Jawala Pathak',	'MH',	'19.199507,77.404213'),
(223,	'Chohtan',	'RJ',	'25.49448,71.08223'),
(224,	'Kaithwar',	'BH',	'26.167292,86.259033'),
(225,	'Urun Islampur',	'MH',	'17.051073,74.261742'),
(226,	'Changodar',	'GJ',	'22.918116,72.440613'),
(227,	'Morgram',	'WB',	'24.30258,88.016388'),
(228,	'Sarila',	'UP',	'25.773968,79.678276'),
(229,	'Rajesultanpur',	'UP',	'26.303431,83.078415'),
(230,	'Badrinath',	'UT',	'30.743309,79.493767'),
(231,	'Mirajgaon',	'MH',	'18.732149,75.025169'),
(232,	'Dera Baba Nanak',	'PB',	'32.032185,75.030449'),
(233,	'Mehgam',	'GJ',	'21.673908,72.757729'),
(234,	'Hannur',	'MH',	'17.668001,76.190018'),
(235,	'Bamane',	'MH',	'19.451019,73.346626'),
(236,	'Manguli',	'OR',	'20.327068,86.063324'),
(237,	'Malihabad',	'UP',	'26.923906,80.709'),
(238,	'Sarava',	'UP',	'26.935722,80.70591'),
(239,	'Borsia',	'UP',	'25.628294,83.622696'),
(240,	'Bhopalgarh',	'RJ',	'26.649759,73.495621'),
(241,	'Dehu Road',	'MH',	'18.684626,73.723068'),
(242,	'Habibpur',	'WB',	'23.199638,88.536224'),
(243,	'Debagram',	'WB',	'23.696093,88.301239'),
(244,	'Mul',	'MH',	'20.072056,79.673538'),
(245,	'Chautham',	'BH',	'25.540274,86.659813'),
(246,	'Pokharan',	'RJ',	'26.920542,71.91655'),
(247,	'Manali',	'HP',	'32.239632,77.188713'),
(248,	'Shelu Bazar',	'MH',	'20.371378,77.249855'),
(249,	'Chorma',	'BH',	'26.510519,85.091171'),
(250,	'Dramman',	'HP',	'32.227249,76.165207'),
(251,	'Brahmapuri',	'MH',	'20.608042,79.861336'),
(252,	'Nagbhir',	'MH',	'20.582853,79.680359'),
(253,	'Aunta',	'UP',	'26.076483,79.478058'),
(254,	'Genguvarpatti',	'TN',	'10.170677,77.69799'),
(255,	'Dalmau',	'UP',	'26.078371,81.056442'),
(256,	'Jahangir Ganj',	'UP',	'26.415346,82.979729'),
(257,	'Eksara',	'WB',	'22.632233,88.29248'),
(258,	'Mankapur',	'UP',	'27.043215,82.212143'),
(259,	'Talod',	'GJ',	'23.351227,72.950493'),
(260,	'Idar',	'GJ',	'23.843393,73.003059'),
(261,	'Kyara',	'UP',	'28.252136,79.420456'),
(262,	'Sumbal',	'JK',	'34.230705,74.647308'),
(263,	'Kumbharia Balipokhari',	'OR',	'20.897675,86.313591'),
(264,	'Behbalpur',	'HR',	'29.621187,75.341263'),
(265,	'Bilgram',	'UP',	'27.183037,80.041679'),
(266,	'Jaisinagar',	'MP',	'23.618185,78.572563'),
(267,	'Nidhasan',	'UP',	'27.144415,80.868881'),
(268,	'Pimpri Gawali',	'MH',	'18.920607,74.575623'),
(269,	'Jansath',	'UP',	'29.322609,77.848465'),
(270,	'Morna',	'UP',	'29.467882,77.938171'),
(271,	'Bhokarhedi',	'UP',	'29.506514,77.936554'),
(272,	'Adul',	'MH',	'19.713587,75.534225'),
(273,	'Betawad',	'MH',	'21.16613,74.908508'),
(274,	'Dingore',	'MH',	'19.274303,73.929688'),
(275,	'Harsul',	'MH',	'19.92942,75.353233'),
(276,	'Satana',	'MH',	'20.597382,74.200294'),
(277,	'Bhatewar',	'RJ',	'24.616369,74.00798'),
(278,	'Jukehi',	'MP',	'24.020605,80.438904'),
(279,	'Parli',	'MH',	'18.845318,76.519844'),
(280,	'Amloh',	'PB',	'30.6143,76.233429'),
(281,	'Haridevpur',	'WB',	'22.480124,88.335312'),
(282,	'Thakur Pukur',	'WB',	'22.462139,88.307137'),
(283,	'Sathanur',	'TN',	'12.205727,78.888962'),
(284,	'Rajoha',	'UP',	'28.780937,78.347496'),
(285,	'Okkiyam Thuraipakkam',	'TN',	'12.939266,80.234695'),
(286,	'Pulicherla',	'APN',	'13.60047,79.04332'),
(287,	'Karicode',	'KL',	'8.915342,76.632607'),
(288,	'Fattepur',	'MH',	'20.647081,75.882736'),
(289,	'Molgi',	'MH',	'21.768196,74.00724'),
(290,	'Bangarapet',	'KA',	'12.991491,78.178757'),
(291,	'Titilagarh',	'OR',	'20.28709,83.146606'),
(292,	'Sukher',	'RJ',	'24.643896,73.714828'),
(293,	'Chirner',	'MH',	'18.872904,73.050858'),
(294,	'Wadgaon Road',	'MH',	'20.373089,78.107864'),
(295,	'Gaighata',	'WB',	'22.931065,88.7314'),
(296,	'Kakapalayam',	'TN',	'11.557062,78.010826'),
(297,	'Jakranpally',	'TS',	'18.718285,78.277512'),
(298,	'Damra',	'AS',	'25.93767,90.775223'),
(299,	'Adirampattinam',	'TN',	'10.341318,79.379646'),
(300,	'Sankarankovil',	'TN',	'9.181414,77.535324'),
(301,	'Kalugumalai',	'TN',	'9.150718,77.705147'),
(302,	'Derdi Kumbhaji',	'GJ',	'21.750252,70.992622'),
(303,	'Jonhi',	'BH',	'25.186972,84.27626'),
(304,	'Arimalam',	'TN',	'10.256141,78.894882'),
(305,	'Arsikere',	'KA',	'13.310455,76.253708'),
(306,	'Amanganj',	'MP',	'24.424833,80.035332'),
(307,	'Adra',	'WB',	'23.495895,86.676216'),
(308,	'Ode',	'GJ',	'22.623121,73.116676'),
(309,	'Ismailpur',	'UP',	'27.581621,80.653503'),
(310,	'Markona',	'OR',	'21.185001,86.605667'),
(311,	'Udala',	'OR',	'21.577162,86.565308'),
(312,	'Karanjia',	'OR',	'21.766436,85.977028'),
(313,	'Kaptipada',	'OR',	'21.513968,86.532494'),
(314,	'Chhapraula',	'UP',	'28.619186,77.480049'),
(315,	'Soraon',	'UP',	'25.60825,81.849686'),
(316,	'Kosamba',	'GJ',	'21.455423,72.95787'),
(317,	'Suigam',	'GJ',	'24.153646,71.356888'),
(318,	'Kumardungi',	'JH',	'22.213207,85.87677'),
(319,	'Khurdha',	'OR',	'20.194223,85.625725'),
(320,	'Urali',	'OR',	'20.407606,85.884438'),
(321,	'Bhaliabadi',	'OR',	'20.173817,85.61425'),
(322,	'Talcher',	'OR',	'20.951542,85.215668'),
(323,	'Maihar',	'MP',	'24.26936,80.756653'),
(324,	'Deobahal',	'OR',	'20.378691,82.72123'),
(325,	'Jhajjar',	'HR',	'28.607111,76.656914'),
(326,	'Subdega',	'OR',	'22.292572,84.106567'),
(327,	'Kunkuri',	'OR',	'22.738335,83.951569'),
(328,	'Balisankara',	'OR',	'22.349638,84.043175'),
(329,	'Sundargarh',	'OR',	'22.125401,84.045067'),
(330,	'Handia',	'UP',	'25.361561,82.189255'),
(331,	'Mavelikkara Municipality',	'KL',	'9.238487,76.531479'),
(332,	'Bewar',	'UP',	'27.217878,79.298668'),
(333,	'Rajgangpur',	'OR',	'22.190195,84.579865'),
(334,	'Sitimani',	'KA',	'16.319151,75.892525'),
(335,	'Kumily',	'KL',	'9.605056,77.169548'),
(336,	'Kallambalam',	'KL',	'8.764648,76.788467'),
(337,	'Sreekrishnapuram',	'KL',	'10.906673,76.41581'),
(338,	'Begun',	'RJ',	'24.986794,75.011459'),
(339,	'Dwarahat',	'UT',	'29.77603,79.426781'),
(340,	'Sayan',	'GJ',	'21.317869,72.881226'),
(341,	'Annavaram',	'APN',	'17.279295,82.396713'),
(342,	'Kambaladinne',	'APN',	'15.041622,79.539642'),
(343,	'Addanki',	'APN',	'15.809432,79.959869'),
(344,	'Jaithara',	'UP',	'27.516731,79.002342'),
(345,	'Tosham Rural',	'HR',	'28.875645,75.916557'),
(346,	'Tajpur',	'WB',	'21.652882,87.629272'),
(347,	'Garagaparru',	'APN',	'16.614643,81.53006'),
(348,	'Mehatpur',	'PB',	'31.047327,75.472343'),
(349,	'Kanina',	'HR',	'28.330292,76.308731'),
(350,	'Alampur',	'WB',	'22.583179,88.21447'),
(351,	'Bachhrawan',	'UP',	'26.471033,81.112709'),
(352,	'Karjan',	'GJ',	'22.055216,73.117256'),
(353,	'Manuguru',	'TS',	'17.931208,80.826622'),
(354,	'Salumbar',	'RJ',	'24.138653,74.038826'),
(355,	'Bhadkha',	'RJ',	'26.012671,71.365471'),
(356,	'Churu Rural',	'RJ',	'28.317497,74.985168'),
(357,	'Peeth',	'RJ',	'23.526808,73.763969'),
(358,	'Garhakota',	'MP',	'23.779512,79.143593'),
(359,	'Itia Thok',	'UP',	'27.297306,82.032623'),
(360,	'Palod',	'GJ',	'21.384312,72.958191'),
(361,	'Kurud',	'CT',	'20.83547,81.719482'),
(362,	'Kalipatnam',	'APN',	'16.390444,81.529472'),
(363,	'Sawantwadi',	'MH',	'15.905263,73.82132'),
(364,	'Barharwa',	'JH',	'24.856621,87.777565'),
(365,	'Mattannur',	'KL',	'11.93286,75.571861'),
(366,	'Iritty',	'KL',	'11.981863,75.670265'),
(367,	'Wadki',	'MH',	'20.280544,78.719131'),
(368,	'Digha',	'WB',	'21.626617,87.507431'),
(369,	'Rahemat Nagar',	'MH',	'20.155272,76.57106'),
(370,	'Amdapur',	'MH',	'20.408417,76.443291'),
(371,	'Cherrapunjee',	'ME',	'25.277685,91.726486'),
(372,	'Hanskhali',	'WB',	'23.361263,88.602417'),
(373,	'Rampur Bushah',	'HP',	'31.450926,77.630768'),
(374,	'Saraipali',	'CT',	'21.332024,82.997467'),
(375,	'Digoda',	'MP',	'24.964506,78.842094'),
(376,	'Maksi',	'MP',	'23.260588,76.147957'),
(377,	'Shaitrawa',	'RJ',	'26.616463,72.320595'),
(378,	'Nithari',	'UP',	'28.338602,77.720886'),
(379,	'Sanala',	'GJ',	'22.797956,70.803078'),
(380,	'Vanvadi',	'MH',	'17.310163,74.182945'),
(381,	'Kathora',	'MH',	'20.999266,77.757797'),
(382,	'Madhupuri',	'UP',	'26.176701,81.239433'),
(383,	'Chabba',	'PB',	'31.558708,74.88726'),
(384,	'Mukerian',	'PB',	'31.956289,75.616844'),
(385,	'Nana Vadala',	'GJ',	'22.119593,70.541367'),
(386,	'Baisinga',	'OR',	'21.646507,86.914825'),
(387,	'Mugbosan',	'WB',	'22.597254,87.482681'),
(388,	'Mungeli',	'CT',	'22.068542,81.685684'),
(389,	'Dhola',	'WB',	'22.022955,88.297462'),
(390,	'Ramnagar',	'UT',	'29.394764,79.126503'),
(391,	'Chandur Railway',	'MH',	'20.814163,77.976723'),
(392,	'Nala',	'JH',	'23.91958,87.037292'),
(393,	'Turekela',	'OR',	'20.519184,82.823669'),
(394,	'Kuravilangad',	'KL',	'9.758441,76.563271'),
(395,	'Neri',	'MH',	'20.848515,75.660339'),
(396,	'Nidholi Kalan',	'UP',	'27.574198,78.494072'),
(397,	'NAI HAVELI school',	'RJ',	'24.927698,73.823631'),
(398,	'Allur',	'TN',	'10.871771,78.628349'),
(399,	'Thuraiyur',	'TN',	'11.141455,78.594475'),
(400,	'Deralakatte',	'KA',	'12.809237,74.894753'),
(401,	'Chengam',	'TN',	'12.306786,78.795784'),
(402,	'Dasuya',	'PB',	'31.813227,75.663734'),
(403,	'Prince Computer Institute Vairagad',	'MH',	'20.434782,80.086372'),
(404,	'Shobhapur',	'MP',	'22.772196,78.262665'),
(405,	'Hamirgarh',	'RJ',	'25.188185,74.626869'),
(406,	'Namkum',	'JH',	'23.33235,85.380791'),
(407,	'Pichavaram',	'TN',	'11.422554,79.774834'),
(408,	'Narapala',	'APN',	'14.710377,77.808083'),
(409,	'Chandabali',	'OR',	'20.773993,86.743698'),
(410,	'Sainthal',	'RJ',	'27.034004,76.311623'),
(411,	'Arwal',	'BH',	'25.239105,84.669571'),
(412,	'Kurha',	'MH',	'20.941681,78.055756'),
(413,	'Jalesar',	'UP',	'27.472601,78.306557'),
(414,	'Ottapidaram',	'TN',	'8.907723,78.020966'),
(415,	'Hanumangarh Town',	'RJ',	'29.5748,74.332977'),
(416,	'Sahajbahal',	'OR',	'20.634178,83.328171'),
(417,	'Jhusi',	'UP',	'25.425602,81.917152'),
(418,	'Mahidharpur',	'OR',	'20.694019,85.179703'),
(419,	'Dhasa',	'GJ',	'21.786919,71.517563'),
(420,	'Yermala',	'MH',	'18.39283,75.870705'),
(421,	'Niali',	'OR',	'20.141563,86.059158'),
(422,	'Redhakhol',	'OR',	'21.074162,84.341057'),
(423,	'Magarload',	'CT',	'20.748428,81.850487'),
(424,	'Raver',	'MH',	'21.242662,76.034317'),
(425,	'Padmapur Town',	'OR',	'21.000067,83.064713'),
(426,	'Bhaderwah',	'JK',	'32.983025,75.710983'),
(427,	'Barkote',	'OR',	'21.535925,85.015167'),
(428,	'Eranellur',	'KL',	'10.618336,76.126198'),
(429,	'Boudh',	'OR',	'20.828445,84.327133'),
(430,	'Birmitrapur',	'OR',	'22.407398,84.7174'),
(431,	'Dankaur',	'UP',	'28.347696,77.553345'),
(432,	'Kantamal',	'OR',	'20.660383,83.744194'),
(433,	'Sohela',	'OR',	'21.300659,83.397507'),
(434,	'Satyabhamapur',	'OR',	'20.248751,85.893394'),
(435,	'Kannod',	'MP',	'22.666279,76.743347'),
(436,	'Barpali',	'OR',	'21.190334,83.59034'),
(437,	'Satpuli',	'UT',	'29.917006,78.710068'),
(438,	'Tembhurni',	'MH',	'18.029453,75.190842'),
(439,	'Pindara',	'HR',	'29.307491,76.366623'),
(440,	'Vinchur',	'MH',	'20.105982,74.235542'),
(441,	'Sholur',	'TN',	'11.497915,76.629723'),
(442,	'Phulaut',	'BH',	'25.510397,86.939247'),
(443,	'Phillaur',	'PB',	'31.013065,75.789474'),
(444,	'Tauru',	'HR',	'28.211967,76.951202'),
(445,	'Bahadurganj',	'BH',	'26.264252,87.828278'),
(446,	'Chauri Chaura',	'UP',	'26.650797,83.585609'),
(447,	'Vansda',	'GJ',	'20.757933,73.364037'),
(448,	'Machhra',	'UP',	'28.899305,77.894608'),
(449,	'Jahazpur',	'RJ',	'25.624435,75.277069'),
(450,	'Barauni',	'BH',	'25.471222,85.977745'),
(451,	'Raidighi',	'WB',	'22.001196,88.435364'),
(452,	'Machhali Shahar',	'UP',	'25.687368,82.412971'),
(453,	'Baberu',	'UP',	'25.550348,80.704811'),
(454,	'Motipur',	'BH',	'26.252548,85.160896'),
(455,	'Bandel',	'WB',	'22.927422,88.377342'),
(456,	'Kasimkota',	'APN',	'17.666401,82.964012'),
(457,	'Chikodi',	'KA',	'16.429251,74.587769'),
(458,	'Badarwas',	'MP',	'24.977015,77.565384'),
(459,	'Mudbi',	'KA',	'17.724798,76.936935'),
(460,	'Baraula Jafrabad',	'UP',	'27.920179,78.051598'),
(461,	'Harpalpur',	'MP',	'25.290844,79.328247'),
(462,	'Daspalla',	'OR',	'20.335644,84.848976'),
(463,	'Chitrada',	'OR',	'21.849848,86.945351'),
(464,	'Ellora',	'MH',	'20.022638,75.161858'),
(465,	'Garoth',	'MP',	'24.328077,75.649902'),
(466,	'Chakghat',	'MP',	'25.032261,81.730209'),
(467,	'Akathiyoor',	'KL',	'10.684984,76.093971'),
(468,	'Jhalrapatan',	'RJ',	'24.540264,76.172577'),
(469,	'Sarlanagar',	'MP',	'24.202192,80.807533'),
(470,	'Nawagarh',	'CT',	'21.907166,81.611244'),
(471,	'Jatara',	'MP',	'25.003206,79.058853'),
(472,	'Saidupur',	'UP',	'25.041494,83.278694'),
(473,	'Padiabahal',	'OR',	'21.452351,84.152748'),
(474,	'Jangipara',	'WB',	'22.736254,88.058311'),
(475,	'Daudnagar',	'BH',	'25.032417,84.417915'),
(476,	'Abhanpur',	'CT',	'21.054815,81.747604'),
(477,	'Lalbarra',	'MP',	'21.938848,80.050697'),
(478,	'Mathur',	'TN',	'13.24053,79.567192'),
(479,	'Chhutmalpur',	'UP',	'30.037149,77.75351'),
(480,	'Piplia Mandi',	'MP',	'24.188171,75.008453'),
(481,	'Waidhan',	'MP',	'24.067116,82.629501'),
(482,	'Anthiyur',	'TN',	'11.577073,77.58773'),
(483,	'Talgram',	'UP',	'27.047874,79.646004'),
(484,	'Chinnamanur',	'TN',	'9.841051,77.383965'),
(485,	'Mathabari',	'WB',	'24.930731,88.039024'),
(486,	'Honnali',	'KA',	'14.23425,75.646996'),
(487,	'Allapalli',	'MH',	'19.430779,80.060593'),
(488,	'Khatu',	'RJ',	'27.367512,75.405708'),
(489,	'Dumar',	'BH',	'25.532276,87.325363'),
(490,	'Jhansa',	'HR',	'30.116125,76.7416'),
(491,	'Mohan',	'UP',	'26.779018,80.67569'),
(492,	'Sarangarh',	'CT',	'21.587696,83.073715'),
(493,	'Hafiz Ganj',	'UP',	'28.492607,79.58007'),
(494,	'Amta',	'WB',	'22.577894,88.016739'),
(495,	'Bach Kande',	'UT',	'29.509537,79.782028'),
(496,	'Naubatpur',	'BH',	'25.502596,84.963547'),
(497,	'Barwadih',	'JH',	'23.847519,84.117126'),
(498,	'Rajur',	'MH',	'19.24321,73.804565'),
(499,	'Khetri',	'RJ',	'28.003496,75.788498'),
(500,	'Mahagama',	'JH',	'25.025505,87.319008'),
(501,	'Nadbai',	'RJ',	'27.216396,77.200325'),
(502,	'Dhupguri',	'WB',	'26.582132,89.005142'),
(503,	'Joypur',	'WB',	'23.053061,87.443512'),
(504,	'Kurwar',	'UP',	'26.3451,81.978027'),
(505,	'Dhaurehra',	'UP',	'27.992762,81.092026'),
(506,	'Kheralu',	'GJ',	'23.885292,72.61895'),
(507,	'Chamorshi',	'MH',	'19.86722,80.000389'),
(508,	'Champa',	'CT',	'22.033178,82.651733'),
(509,	'Tappal',	'UP',	'28.043842,77.577423'),
(510,	'Nirmali',	'BH',	'26.31074,86.572876'),
(511,	'Tapan',	'WB',	'25.30731,88.570251'),
(512,	'Tukaithad',	'MP',	'21.430889,76.667953'),
(513,	'Nigohi',	'UP',	'28.102089,79.871681'),
(514,	'Asilmetta',	'APN',	'17.726217,83.315468'),
(515,	'Sanderao',	'RJ',	'25.304359,73.173309'),
(516,	'Mayapur',	'WB',	'23.423201,88.388268'),
(517,	'Paradeep',	'OR',	'20.316551,86.611366'),
(518,	'Kundarki',	'UP',	'28.687614,78.785492'),
(519,	'Pondi',	'CT',	'22.117725,81.263695'),
(520,	'Kolanupaaka',	'TS',	'17.694084,79.034843'),
(521,	'Jahangirpur',	'UP',	'28.178797,77.703712'),
(522,	'Patiram',	'WB',	'25.334879,88.761421'),
(523,	'Gogawan',	'MP',	'21.911575,75.740059'),
(524,	'Amangal',	'TS',	'16.849434,78.530304'),
(525,	'Bhagwatgarh',	'RJ',	'26.137217,76.242119'),
(526,	'Baisi',	'BH',	'25.865635,87.746002'),
(527,	'Jais',	'UP',	'26.264786,81.546364'),
(528,	'Tangi',	'OR',	'19.924606,85.396645'),
(529,	'Charama',	'CT',	'20.484501,81.372261'),
(530,	'Sardha',	'CT',	'21.608732,81.571983'),
(531,	'Raypur',	'WB',	'22.431278,88.216904'),
(532,	'Walwa',	'MH',	'17.026506,74.374344'),
(533,	'Gosainganj',	'UP',	'26.767679,81.111336'),
(534,	'Madhuban',	'BH',	'26.437077,85.132378'),
(535,	'Piro',	'BH',	'25.331371,84.403099'),
(536,	'Abburu',	'APN',	'16.448223,80.165886'),
(537,	'Sargachhi',	'WB',	'24.016617,88.248993'),
(538,	'Kalasar',	'RJ',	'27.93347,73.161926'),
(539,	'Shamsabad',	'UP',	'27.015577,78.123894'),
(540,	'Joshimath',	'UT',	'30.550552,79.565964'),
(541,	'Bah',	'UP',	'26.869789,78.593704'),
(542,	'Sikta',	'BH',	'27.030914,84.682358'),
(543,	'Kushalpura',	'RJ',	'26.097408,73.958023'),
(544,	'Junnardeo',	'MP',	'22.186609,78.593269'),
(545,	'Seppakkam',	'TN',	'11.560295,79.142151'),
(546,	'Pirthipur',	'UP',	'25.701899,83.540329'),
(547,	'Siddapur',	'KA',	'14.341617,74.892799'),
(548,	'Visavadar',	'GJ',	'21.340731,70.7519'),
(549,	'Pahalgam',	'JK',	'34.016373,75.318054'),
(550,	'Muttambalam',	'KL',	'9.575614,76.551277'),
(551,	'Dag',	'RJ',	'23.931732,75.834694'),
(552,	'Nidadavolu',	'APN',	'16.901621,81.66378'),
(553,	'Mejia',	'WB',	'23.563927,87.107368'),
(554,	'Kamuthi',	'TN',	'9.412188,78.366638'),
(555,	'Chilla Ghat',	'UP',	'25.766365,80.531342'),
(556,	'Kallakurichi',	'TN',	'11.738187,78.963882'),
(557,	'Langting',	'AS',	'25.496683,93.112549'),
(558,	'Chakulia',	'JH',	'22.473358,86.716484'),
(559,	'Khargapur',	'MP',	'24.821583,79.137917'),
(560,	'Khairabad',	'UP',	'27.528427,80.749153'),
(561,	'Kalanaur',	'HR',	'28.831238,76.395561'),
(562,	'Nanpara',	'UP',	'27.867472,81.49929'),
(563,	'Barbigha',	'BH',	'25.220768,85.731842'),
(564,	'Huzur Nagar',	'TS',	'16.900265,79.874535'),
(565,	'Shigli',	'KA',	'15.063042,75.467972'),
(566,	'Campirganj',	'UP',	'27.029491,83.2742'),
(567,	'Bheldi',	'BH',	'25.900654,84.955688'),
(568,	'Jagdishpur',	'BH',	'25.468313,84.422516'),
(569,	'Nauhatta',	'BH',	'24.543266,83.81813'),
(570,	'Mahrauni',	'UP',	'24.583147,78.727783'),
(571,	'Nandaur',	'UP',	'26.945826,83.064323'),
(572,	'Jaspur',	'UT',	'29.278334,78.826683'),
(573,	'Kujang',	'OR',	'20.317423,86.527443'),
(574,	'Hosa Kadrolli',	'KA',	'15.686029,74.722733'),
(575,	'Villivakkam',	'TN',	'13.109045,80.204941'),
(576,	'Amauli',	'UP',	'26.013577,80.307381'),
(577,	'Pethanaickenpalayam',	'TN',	'11.648952,78.506447'),
(578,	'Manora',	'MH',	'20.216112,77.559074'),
(579,	'Bori',	'MH',	'19.49818,76.727882'),
(580,	'Devadurga',	'KA',	'16.423534,76.935501'),
(581,	'Mangalwedha',	'MH',	'17.510986,75.45195'),
(582,	'Kothapeta',	'APN',	'16.716015,81.895782'),
(583,	'Nilbagan',	'AS',	'26.065323,92.899254'),
(584,	'Karanji',	'MH',	'19.133781,74.995392'),
(585,	'Muttom',	'TN',	'8.126215,77.319641'),
(586,	'Turki',	'BH',	'26.043619,85.3498'),
(587,	'Meham',	'HR',	'28.965895,76.296394'),
(588,	'Jegurupadu',	'APN',	'16.909117,81.849754'),
(589,	'Rakholi',	'DN',	'20.234716,73.014084'),
(590,	'Seethampeta',	'APN',	'18.692533,83.816803'),
(591,	'Seondha',	'MP',	'26.153719,78.780968'),
(592,	'Palari',	'CT',	'21.538742,82.168648'),
(593,	'Kalameshwar',	'MH',	'21.233473,78.91185'),
(594,	'Palladam',	'TN',	'10.999667,77.280739'),
(595,	'Golaghat',	'AS',	'26.524075,93.963188'),
(596,	'Khambha',	'GJ',	'21.139948,71.254753'),
(597,	'Punganur',	'APN',	'13.36592,78.575012'),
(598,	'Pathalgaon',	'CT',	'22.556366,83.461021'),
(599,	'Ghatanji',	'MH',	'20.143688,78.311668'),
(600,	'Pichhore',	'MP',	'25.176607,78.190384'),
(601,	'Shamarikuna',	'AS',	'24.638632,92.634438'),
(602,	'Aruppukottai',	'TN',	'9.510524,78.095795'),
(603,	'Mala',	'KL',	'10.240298,76.26313'),
(604,	'Ganjam',	'OR',	'19.387388,85.051544'),
(605,	'Dhamtan Sahib',	'HR',	'29.69729,76.018883'),
(606,	'Padapai',	'TN',	'12.888113,80.017052'),
(607,	'Uppilipalayam',	'TN',	'11.012617,77.019005'),
(608,	'Babubarhi',	'BH',	'26.459446,86.271721'),
(609,	'Jalore',	'RJ',	'25.344481,72.625374'),
(610,	'Turuvekere',	'KA',	'13.16054,76.667259'),
(611,	'Badnawar',	'MP',	'23.020788,75.233582'),
(612,	'Kanigiri',	'APN',	'15.404765,79.506714'),
(613,	'Kaimri',	'HR',	'29.081245,75.717491'),
(614,	'Sikanderpur',	'UP',	'26.042059,84.041435'),
(615,	'Osian',	'RJ',	'26.724545,72.904716'),
(616,	'Dhadgaon',	'MH',	'21.826254,74.217201'),
(617,	'Rukhamini Nagar',	'MH',	'20.482189,77.469589'),
(618,	'Kesamudram',	'TS',	'17.686165,79.905045'),
(619,	'Kanke',	'JH',	'23.434549,85.320702'),
(620,	'Selu',	'MH',	'19.456173,76.439415'),
(621,	'Jale',	'BH',	'26.386536,85.728027'),
(622,	'Lalsot',	'RJ',	'26.561304,76.32946'),
(623,	'Chhata',	'UP',	'27.723215,77.507233'),
(624,	'Gagaha',	'UP',	'26.435993,83.444771'),
(625,	'Chakbandi',	'MP',	'24.578583,80.79921'),
(626,	'Khamari',	'MH',	'21.426317,80.233528'),
(627,	'Hazrat Jandaha',	'BH',	'25.714897,85.532295'),
(628,	'Vakayar',	'KL',	'9.196866,76.850601'),
(629,	'Mathabhanga',	'WB',	'26.34273,89.21534'),
(630,	'Khetia',	'MP',	'21.659981,74.588928'),
(631,	'Prabhas Patan',	'GJ',	'20.889338,70.405678'),
(632,	'Kavalapur',	'MH',	'16.919977,74.613335'),
(633,	'Bamor',	'MP',	'26.35619,78.092194'),
(634,	'Macherla',	'APN',	'16.475988,79.439445'),
(635,	'Maswasi',	'UP',	'29.100615,79.063583'),
(636,	'Umbraj',	'MH',	'17.40202,74.101089'),
(637,	'Paithan',	'MH',	'19.475899,75.385178'),
(638,	'Bibiyapur',	'UP',	'27.583122,79.724518'),
(639,	'Balesar',	'RJ',	'26.399557,72.47509'),
(640,	'Haripota',	'WB',	'24.961674,88.083969'),
(641,	'Uthamapalayam',	'TN',	'9.808606,77.328133'),
(642,	'Mannath',	'MH',	'21.455797,78.650154'),
(643,	'Illuppur',	'TN',	'10.512054,78.623421'),
(644,	'Pathanamthitta',	'KL',	'9.264758,76.787041'),
(645,	'Chidambaram',	'TN',	'11.398194,79.695358'),
(646,	'Vaiampatti',	'TN',	'10.55109,78.302422'),
(647,	'Kanjirappally',	'KL',	'9.55727,76.789436'),
(648,	'Rahata',	'MH',	'19.712702,74.483337'),
(649,	'Ambrad',	'MH',	'16.19125,73.744682'),
(650,	'Daroh',	'HP',	'31.997007,76.477997'),
(651,	'Vadamazhai Vadapathy',	'TN',	'10.496083,79.667191'),
(652,	'Hunsur',	'KA',	'12.300942,76.28846'),
(653,	'Balapur',	'MH',	'20.685555,76.797951'),
(654,	'Kariapatti',	'TN',	'9.674022,78.102272'),
(655,	'Dandeli',	'KA',	'15.246489,74.622681'),
(656,	'Dumaria Ganj',	'UP',	'27.201487,82.653831'),
(657,	'Bilimora',	'GJ',	'20.769026,72.977776'),
(658,	'Joginder Nagar',	'HP',	'31.99124,76.789917'),
(659,	'Bhatpar Rani',	'UP',	'26.308722,84.031281'),
(660,	'Tigaon',	'HR',	'28.351624,77.396599'),
(661,	'Naraini',	'UP',	'25.187754,80.472977'),
(662,	'Singhana',	'RJ',	'28.09841,75.838867'),
(663,	'Perunali',	'TN',	'9.233789,78.318787'),
(664,	'Gotegaon',	'MP',	'23.03973,79.484451'),
(665,	'Gurua',	'BH',	'24.669584,84.772026'),
(666,	'Purani Chhawani',	'MP',	'26.263882,78.130791'),
(667,	'Tikait Nagar',	'UP',	'26.935944,81.567871'),
(668,	'Sausar',	'MP',	'21.651981,78.795784'),
(669,	'Viralimalai',	'TN',	'10.60368,78.546211'),
(670,	'Rawanwadi',	'MH',	'21.538589,80.228554'),
(671,	'Pathakhera',	'MP',	'22.124487,78.145966'),
(672,	'Barela',	'MP',	'23.096006,80.050301'),
(673,	'Jalalpur',	'UP',	'26.311863,82.733978'),
(674,	'Visarwadi',	'MH',	'21.182276,73.963905'),
(675,	'Rajabpur',	'UP',	'28.836697,78.377113'),
(676,	'Mumfordganj',	'UP',	'25.47687,81.854965'),
(677,	'Bagathala',	'GJ',	'22.855722,70.721603'),
(678,	'Kattappana',	'KL',	'9.756835,77.116867'),
(679,	'Kottara',	'KA',	'12.905163,74.834633'),
(680,	'Naigaon',	'MH',	'19.342911,72.823486'),
(681,	'Vannappuram',	'KL',	'9.9964,76.783722'),
(682,	'Thisayanvilai',	'TN',	'8.334946,77.865311'),
(683,	'Lalganj Ajhara',	'UP',	'25.932085,81.703476'),
(684,	'Dhamangaon Nagar Parishad',	'MH',	'20.786779,78.137802'),
(685,	'Jadupur',	'WB',	'25.08,88.146042'),
(686,	'Chausana',	'UP',	'29.664375,77.181587'),
(687,	'Sompeta',	'APN',	'18.945608,84.582481'),
(688,	'Balod',	'CT',	'20.731133,81.202309'),
(689,	'Bhesan',	'GJ',	'21.554853,70.703468'),
(690,	'Kaliachak',	'WB',	'24.861023,88.018097'),
(691,	'Harraiya',	'UP',	'26.792673,82.470222'),
(692,	'Bahadurpur',	'WB',	'23.43881,88.460976'),
(693,	'Viriyur',	'TN',	'11.880297,78.965591'),
(694,	'Dondaicha',	'MH',	'21.324507,74.556389'),
(695,	'Vandavasi',	'TN',	'12.502883,79.602478'),
(696,	'Kaushambi',	'UP',	'25.361053,81.403168'),
(697,	'Chilkigarh',	'WB',	'22.449696,86.874725'),
(698,	'Pandaria',	'CT',	'22.222729,81.408669'),
(699,	'Onjal',	'GJ',	'20.823423,72.84269'),
(700,	'Mandhal',	'MH',	'20.955179,79.457733'),
(701,	'Bidhuna',	'UP',	'26.803043,79.505524'),
(702,	'Anupshahar',	'UP',	'28.354086,78.267548'),
(703,	'Valia',	'GJ',	'21.57184,73.161514'),
(704,	'Naraingarh',	'HR',	'30.478479,77.131256'),
(705,	'Orachha',	'MP',	'25.368271,78.628525'),
(706,	'Thangadh',	'GJ',	'22.576147,71.200989'),
(707,	'Mangalapuram',	'KL',	'8.626767,76.846153'),
(708,	'Charni',	'GJ',	'21.510168,73.462219'),
(709,	'Lasur',	'MH',	'19.928226,75.011459'),
(710,	'Timarni',	'MP',	'22.36923,77.226143'),
(711,	'Mavjinjava',	'GJ',	'21.553867,70.911583'),
(712,	'Chebrolu',	'APN',	'17.198614,82.317543'),
(713,	'Ghiror',	'UP',	'27.188972,78.800835'),
(714,	'Bhagwanpur',	'UT',	'29.941095,77.812424'),
(715,	'Kargaina',	'UP',	'28.324816,79.398643'),
(716,	'Gunupur',	'OR',	'19.075464,83.812828'),
(717,	'Koduvayur',	'KL',	'10.663235,76.647049'),
(718,	'Sanand',	'GJ',	'22.991289,72.375511'),
(719,	'Khalilabad',	'UP',	'26.777416,83.065666'),
(720,	'Gazole',	'WB',	'25.213648,88.194023'),
(721,	'Palashipara',	'WB',	'23.792742,88.451286'),
(722,	'Tilda Newra',	'CT',	'21.552788,81.784172'),
(723,	'Jashpur Nagar',	'CT',	'22.887421,84.138237'),
(724,	'Ayyalur',	'APN',	'15.443404,78.519943'),
(725,	'Nallampalli',	'TN',	'12.058649,78.113678'),
(726,	'Madhogarh',	'UP',	'26.27202,79.189964'),
(727,	'Bijawar',	'MP',	'24.627342,79.495697'),
(728,	'Devendra Nagar',	'MP',	'24.610403,80.379784'),
(729,	'Manpur',	'MP',	'22.429586,75.619354'),
(730,	'Canada Corner',	'MH',	'20.007376,73.767365'),
(731,	'Bistan',	'MP',	'21.696724,75.665901'),
(732,	'Jayamkondan',	'TN',	'11.214348,79.361267'),
(733,	'Borgaon Manju',	'MH',	'20.719465,77.152107'),
(734,	'Rankai',	'MP',	'22.97053,79.083572'),
(735,	'Sihora',	'MP',	'23.488745,80.104507'),
(736,	'Ganj Basoda',	'MP',	'23.851463,77.9263'),
(737,	'Raisen',	'MP',	'23.326809,77.78492'),
(738,	'Nowrozabad',	'MP',	'23.352474,80.980202'),
(739,	'Soron',	'UP',	'27.886625,78.744789'),
(740,	'Attingal',	'KL',	'8.695034,76.817879'),
(741,	'Baroda',	'MP',	'25.490889,76.660042'),
(742,	'Kirnapur',	'MP',	'21.622005,80.338554'),
(743,	'Melattur',	'KL',	'11.068381,76.268188'),
(744,	'Parapatti',	'TN',	'11.581842,78.129364'),
(745,	'Bakshirhat',	'WB',	'26.328613,89.759972'),
(746,	'Bagh',	'MP',	'22.358315,74.790756'),
(747,	'Suhagi',	'MP',	'23.22193,79.951447'),
(748,	'Manjlegaon',	'MH',	'19.165823,76.202354'),
(749,	'Kotma',	'MP',	'23.208326,81.97924'),
(750,	'Umreth',	'GJ',	'22.698717,73.114304'),
(751,	'Abasaheb Raikar Nagar',	'MH',	'18.452682,73.813972'),
(752,	'Marakkanam',	'TN',	'12.186952,79.927895'),
(753,	'Koduru',	'APN',	'13.956904,79.350563'),
(754,	'Kolgaon',	'MH',	'18.795862,74.666145'),
(755,	'Babai',	'MP',	'22.702965,77.936501'),
(756,	'Amarpur',	'BH',	'25.037542,86.903435'),
(757,	'Bagidora',	'RJ',	'23.404327,74.267258'),
(758,	'Narauli',	'UP',	'28.484741,78.712212'),
(759,	'Bachannapet',	'TS',	'17.788206,79.033882'),
(760,	'Nasvadi',	'GJ',	'22.045132,73.731606'),
(761,	'Piploda',	'MP',	'23.365801,75.427917'),
(762,	'Parikshitgarh',	'UP',	'28.977276,77.936386'),
(763,	'Jhajha',	'BH',	'24.7745,86.375687'),
(764,	'Siyana',	'UP',	'28.627911,78.060913'),
(765,	'Adimali',	'KL',	'10.011504,76.952782'),
(766,	'Shirwal',	'MH',	'18.146667,73.975578'),
(767,	'Samsi',	'WB',	'25.273493,88.003998'),
(768,	'Keolari',	'MP',	'22.365555,79.906998'),
(769,	'Doghat',	'UP',	'29.196714,77.367996'),
(770,	'Nagod',	'MP',	'24.570179,80.579948'),
(771,	'Barua Sagar',	'UP',	'25.376446,78.730949'),
(772,	'GUNGUN Computers',	'MP',	'23.638187,79.062057'),
(773,	'Khuldabad',	'MH',	'20.007555,75.192474'),
(774,	'Gauri Bazar',	'UP',	'26.595896,83.670746'),
(775,	'Sikandarpur',	'UP',	'26.036806,84.037888'),
(776,	'Seethangoli',	'KL',	'12.588816,75.002113'),
(777,	'Falakata',	'WB',	'26.517487,89.203918'),
(778,	'Amtala',	'WB',	'22.401115,88.054649'),
(779,	'Kusumanchi',	'TS',	'17.224657,79.955643'),
(780,	'Ramgarh Shekhawati',	'RJ',	'28.169897,74.975983'),
(781,	'Bhadarsa',	'UP',	'26.642122,82.121033'),
(782,	'Betma',	'MP',	'22.685429,75.614273'),
(783,	'Ratanpur',	'CT',	'22.281218,82.155045'),
(784,	'Sindagi',	'KA',	'16.917255,76.233429'),
(785,	'Harrai',	'MP',	'22.614813,79.219589'),
(786,	'Kakumanu',	'APN',	'16.055199,80.397873'),
(787,	'Gorhand',	'JH',	'24.326233,85.834549'),
(788,	'Mohand',	'UP',	'30.177711,77.901749'),
(789,	'Barnagar',	'MP',	'23.05044,75.377357'),
(790,	'Karamsad',	'GJ',	'22.541615,72.904198'),
(791,	'Pachore',	'MP',	'23.713461,76.730766'),
(792,	'Bada Malhera',	'MP',	'24.56381,79.30629'),
(793,	'Kolaras',	'MP',	'25.224258,77.610649'),
(794,	'Jhabrera',	'UT',	'29.804342,77.7967'),
(795,	'Tuljapur',	'MH',	'18.012182,76.067337'),
(796,	'Palakurthy',	'TS',	'17.659908,79.431084'),
(797,	'Mulanthuruthy',	'KL',	'9.898397,76.383987'),
(798,	'Bharatgarh',	'PB',	'31.096012,76.615395'),
(799,	'Uncha Siwana',	'HR',	'29.620476,76.998543'),
(800,	'Hasayan',	'UP',	'27.609028,78.269684'),
(801,	'Petlad',	'GJ',	'22.483616,72.801353'),
(802,	'Simhadri Puram',	'APN',	'14.629368,78.126678'),
(803,	'Dorangla',	'PB',	'32.104969,75.302696'),
(804,	'Parshivni',	'MH',	'21.373423,79.150421'),
(805,	'Bar',	'UP',	'24.867905,78.581947'),
(806,	'Sankarapuram',	'TN',	'11.887289,78.916718'),
(807,	'Jafarganj',	'UP',	'25.915216,80.50106'),
(808,	'Karmad',	'MH',	'19.869596,75.540215'),
(809,	'Barwala',	'HR',	'29.364075,75.906776'),
(810,	'Srimushnam',	'TN',	'11.401105,79.403999'),
(811,	'Athiyuthu',	'TN',	'9.397426,78.91185'),
(812,	'Narayanpet',	'TS',	'16.744511,77.49601'),
(813,	'Gudari',	'OR',	'19.346962,83.781548'),
(814,	'Hata',	'UP',	'26.73855,83.74382'),
(815,	'Kalamnuri',	'MH',	'19.676092,77.310394'),
(816,	'Jhalu',	'UP',	'29.335804,78.224854'),
(817,	'Kalandri',	'RJ',	'24.92358,72.684998'),
(818,	'Ajnala',	'PB',	'31.842825,74.762962'),
(819,	'Cuddalore',	'TN',	'11.75346,79.75956'),
(820,	'Manendragarh',	'CT',	'23.21389,82.201279'),
(821,	'Bhagwangola',	'WB',	'24.327723,88.306923'),
(822,	'Radaur',	'HR',	'30.027164,77.149292'),
(823,	'Vadlamudi',	'APN',	'16.234474,80.561256'),
(824,	'Utraula',	'UP',	'27.317518,82.418396'),
(825,	'Bhatapara',	'CT',	'21.738371,81.948029'),
(826,	'Barwaha',	'MP',	'22.253433,76.039673'),
(827,	'Rupauli',	'BH',	'25.808674,87.778793'),
(828,	'Fazilnagar',	'UP',	'26.682705,84.049782'),
(829,	'Kesrisinghpur',	'RJ',	'29.947521,73.621239'),
(830,	'Jirapur',	'MP',	'24.020752,76.376694'),
(831,	'Shevgaon',	'MH',	'19.350367,75.219376'),
(832,	'Modumudi',	'APN',	'16.018251,80.94017'),
(833,	'Koraon',	'UP',	'24.996948,82.071777'),
(834,	'Pachrukhi',	'BH',	'26.161003,84.414925'),
(835,	'Kolaghat',	'WB',	'22.432922,87.859886'),
(836,	'Golegaon',	'MH',	'19.237091,75.426369'),
(837,	'Sathamba',	'GJ',	'23.171768,73.336975'),
(838,	'Khesar',	'BH',	'24.964785,86.725288'),
(839,	'Dhilwan',	'PB',	'31.512264,75.344841'),
(840,	'Chincholi',	'KA',	'17.461023,77.419273'),
(841,	'Hati',	'CT',	'22.301207,83.090172'),
(842,	'Bhadrachalam',	'TS',	'17.670563,80.893677'),
(843,	'Talikoti',	'KA',	'16.478256,76.310936'),
(844,	'Dhanari Kalan',	'RJ',	'26.840376,73.249382'),
(845,	'Kuliana',	'OR',	'22.067127,86.64978'),
(846,	'Maheshwaram',	'TS',	'17.134188,78.433449'),
(847,	'Chunar',	'UP',	'25.104313,82.870895'),
(848,	'Manjhi',	'BH',	'25.838165,84.579117'),
(849,	'Kaisarganj',	'UP',	'27.251478,81.547302'),
(850,	'Bhitargaon',	'UP',	'26.210896,80.274033'),
(851,	'Khamaria',	'UP',	'25.240969,82.513206'),
(852,	'Jabarapar',	'UP',	'25.74049,83.372314'),
(853,	'Rahatgarh',	'MP',	'23.790548,78.398445'),
(854,	'Cherukupalli',	'APN',	'16.049566,80.680954'),
(855,	'Koratty',	'KL',	'10.267205,76.350388'),
(856,	'Gokarna',	'WB',	'24.03931,88.114868'),
(857,	'Shambhuganj',	'BH',	'25.080841,86.730194'),
(858,	'Patti',	'UP',	'25.919975,82.198555'),
(859,	'Jagatpur',	'UP',	'26.053865,81.272476'),
(860,	'Pudupattinam',	'TN',	'12.501898,80.148972'),
(861,	'Alwarthirunagari',	'TN',	'8.605237,77.943878'),
(862,	'Sironj',	'MP',	'24.099518,77.671471'),
(863,	'Kadaura',	'UP',	'25.98312,79.84108'),
(864,	'Perungalathur',	'TN',	'12.904759,80.089081'),
(865,	'Naugarh',	'UP',	'27.299067,83.092781'),
(866,	'Mahavir JI',	'RJ',	'26.697083,76.915237'),
(867,	'Bharwari',	'UP',	'25.559797,81.485565'),
(868,	'Thenkarai',	'TN',	'10.936621,76.843269'),
(869,	'Phulbani',	'OR',	'20.479712,84.233147'),
(870,	'Manjhaul',	'BH',	'25.560484,86.126099'),
(871,	'Varangaon',	'MH',	'21.017332,75.900742'),
(872,	'Mahadipur',	'WB',	'24.850147,88.126495'),
(873,	'Erandol',	'MH',	'20.926579,75.332474'),
(874,	'Hazratpur',	'UP',	'28.278534,77.865341'),
(875,	'Begumganj',	'MP',	'23.601509,78.336777'),
(876,	'Sahapur',	'WB',	'24.106197,87.821815'),
(877,	'Sindewahi',	'MH',	'20.290276,79.655479'),
(878,	'Sarai Ajitmal',	'UP',	'26.569376,79.311493'),
(879,	'Asfabad',	'UP',	'27.140444,78.425735'),
(880,	'Bihpuria',	'AS',	'27.018932,93.916763'),
(881,	'Vissannapetaa',	'APN',	'16.94257,80.779633'),
(882,	'Kotagiri',	'TN',	'11.415208,76.869385'),
(883,	'Neoria Husainpur',	'UP',	'28.733648,79.894081'),
(884,	'Izatnagar',	'UP',	'28.404764,79.425018'),
(885,	'Jamgaon',	'MH',	'19.654388,74.984383'),
(886,	'Kharela',	'UP',	'25.540396,79.810066'),
(887,	'Allaganj',	'UP',	'27.544962,79.688095'),
(888,	'Sarsawa',	'UP',	'30.019764,77.398468'),
(889,	'Omerga',	'MH',	'17.839767,76.622246'),
(890,	'Churpuni',	'WB',	'23.625731,88.052185'),
(891,	'Kakdwip',	'WB',	'21.872969,88.199615'),
(892,	'Khaper',	'MH',	'21.531015,73.929405'),
(893,	'Garhwa',	'JH',	'24.154898,83.799561'),
(894,	'Talwandi Rana',	'HR',	'29.222214,75.756874'),
(895,	'Benakar',	'WB',	'23.507801,88.267853'),
(896,	'Kusumgram',	'WB',	'23.389038,88.12944'),
(897,	'Brijmanganj',	'UP',	'27.198978,83.196716'),
(898,	'Samanti',	'WB',	'22.559092,88.088333'),
(899,	'Lambhua',	'UP',	'26.14027,82.227089'),
(900,	'Kurebhar',	'UP',	'26.414242,82.124367'),
(901,	'Ivar Kandapura',	'KA',	'13.136707,77.493759'),
(902,	'Laluk',	'AS',	'27.123619,93.931564'),
(903,	'Magam',	'JK',	'34.094589,74.596542'),
(904,	'Madhepura',	'BH',	'25.924702,86.794525'),
(905,	'Deoni',	'MH',	'18.262102,77.082352'),
(906,	'Bareilly',	'UP',	'28.363535,79.485954'),
(907,	'Palhari',	'UP',	'26.922915,81.217842'),
(908,	'Reusa',	'UP',	'27.545795,81.217461'),
(909,	'Khaira',	'MP',	'22.302269,79.826874'),
(910,	'Nautanwa',	'UP',	'27.424166,83.427002'),
(911,	'Ghodegaon',	'MH',	'19.044352,73.837334'),
(912,	'Jolarpettai',	'TN',	'12.554075,78.571762'),
(913,	'Korukonda',	'APN',	'17.170408,81.826538'),
(914,	'Shrawasti',	'UP',	'27.505379,82.035988'),
(915,	'Kuthera',	'HP',	'31.511057,76.729111'),
(916,	'Adari',	'UP',	'25.97912,83.612038'),
(917,	'Sonwa',	'RJ',	'26.095484,75.783737'),
(918,	'Nayagaon',	'PB',	'30.776133,76.794327'),
(919,	'Palshet',	'MH',	'17.441061,73.208511'),
(920,	'Baramkela',	'CT',	'21.565981,83.265198'),
(921,	'Mukhed',	'MH',	'18.702188,77.370186'),
(922,	'Phoolpur',	'UP',	'26.077511,82.875519'),
(923,	'Pilibanga',	'RJ',	'29.488796,74.074799'),
(924,	'Dariana',	'HP',	'31.384821,76.72419'),
(925,	'Hariharpur',	'UP',	'26.664379,83.002563'),
(926,	'Maholi',	'UP',	'27.653776,80.475754'),
(927,	'Degloor',	'MH ',	'18.545868,77.576271'),
(928,	'Chitrakoot',	'UP',	'25.175777,80.868324'),
(929,	'Ghatprabha',	'KA',	'16.237749,74.761787'),
(930,	'Banei',	'OR',	'21.816069,84.915405'),
(931,	'Vazhayur',	'KL',	'11.217532,75.899094'),
(932,	'Deaulgaon Raja',	'MH',	'20.018566,76.033905'),
(933,	'Bikram',	'BH',	'25.446569,84.86264'),
(934,	'Williamnagar',	'ME',	'25.5322,90.592392'),
(935,	'Mayapuri',	'DL',	'28.629564,77.127724'),
(936,	'Sarnath',	'UP',	'25.376165,83.022713'),
(937,	'Sabalgarh',	'MP',	'26.246981,77.407013'),
(938,	'Tarenga',	'CT',	'21.75629,81.899483'),
(939,	'Ambagarh Chowki',	'CT',	'20.777689,80.747795'),
(940,	'Dhanauha',	'UP',	'25.466448,82.581009'),
(941,	'Khairachatar',	'JH',	'23.539026,85.931808'),
(942,	'Gorka',	'CT',	'21.919167,83.382942'),
(943,	'Rajmahal',	'JH',	'25.054852,87.828217'),
(944,	'Bhadra',	'RJ',	'29.104315,75.165459'),
(945,	'Sikandra Rao',	'UP',	'27.686409,78.378273'),
(946,	'Puliyangudi',	'TN',	'9.177145,77.397324'),
(947,	'Dhatoori',	'UP',	'28.36952,77.902519'),
(948,	'Manteswar',	'WB',	'23.421667,88.109322'),
(949,	'Muvattupuzha',	'KL',	'9.979882,76.580307'),
(950,	'Jaggampeta',	'APN',	'17.17585,82.057732'),
(951,	'Uttarpara Kotrung',	'WB',	'22.676846,88.338509'),
(952,	'Bahera',	'CT',	'22.608583,82.698235'),
(953,	'Jankipuram',	'UP',	'26.921021,80.951187'),
(954,	'Kukuda',	'OR',	'22.228567,84.922195'),
(955,	'Dharmabad',	'MH',	'18.899151,77.842445'),
(956,	'Nandura',	'MH',	'20.830732,76.450523'),
(957,	'Amarpatan',	'MP',	'24.317583,80.973289'),
(958,	'Kakrala',	'UP',	'27.89333,79.195625'),
(959,	'Nalkheda',	'MP',	'23.834866,76.235703'),
(960,	'Kangra',	'HP',	'32.099804,76.269104'),
(961,	'Tikkaballi',	'OR',	'20.248075,84.352036'),
(962,	'Ashti Nagar',	'MH',	'18.809467,75.16378'),
(963,	'Julwania',	'MP',	'21.863537,75.204147'),
(964,	'Pupri',	'BH',	'26.46987,85.697411'),
(965,	'Maharra',	'UP',	'24.775785,78.439156'),
(966,	'Lar',	'JK',	'34.2575,74.756424'),
(967,	'Loha',	'MH',	'18.947388,77.11544'),
(968,	'Bilaigarh',	'CT',	'21.639717,82.721321'),
(969,	'Raghunathpur',	'WB',	'23.538631,86.673553'),
(970,	'Ranipet',	'TN',	'12.932063,79.333466'),
(971,	'Khaga',	'UP',	'25.772083,81.103531'),
(972,	'Singhia',	'BH',	'25.841215,86.160873'),
(973,	'Goniana',	'PB',	'30.317766,74.912994'),
(974,	'Chopadi',	'MH',	'17.349409,75.014915'),
(975,	'Jhirpani',	'OR',	'22.268684,84.901024'),
(976,	'Kotri',	'RJ',	'25.400812,74.900482'),
(977,	'Barhi',	'JH',	'24.303789,85.414345'),
(978,	'Baben',	'GJ',	'21.138327,73.09539'),
(979,	'Subudhipur',	'OR',	'20.254126,85.756569'),
(980,	'Azmatabad',	'JK',	'33.565006,74.380737'),
(981,	'Sindkhed Raja',	'MH',	'19.95657,76.134567'),
(982,	'Patashpur',	'WB',	'22.020357,87.542061'),
(983,	'Matipur',	'WB',	'23.306,86.649574'),
(984,	'Bediya',	'MP',	'22.095621,75.947739'),
(985,	'Shahuwadi',	'MH',	'16.910147,73.946266'),
(986,	'Mahich Bathan',	'WB',	'23.938311,88.616447'),
(987,	'Delho',	'BH',	'26.422005,85.219398'),
(988,	'Manik Chauk',	'BH',	'26.463474,85.530998'),
(989,	'Egarkunr',	'JH',	'23.755417,86.771576'),
(990,	'Ramdhari',	'WB',	'22.34239,88.568611'),
(991,	'Rahana',	'UP',	'27.17333,78.381378'),
(992,	'Sirsaganj',	'UP',	'27.057425,78.684654'),
(993,	'Kovvur',	'APN',	'17.018871,81.730301'),
(994,	'Sarkaghat',	'HP',	'31.698956,76.732407'),
(995,	'Jarwal',	'UP',	'27.163445,81.53907'),
(996,	'Thawe',	'BH',	'26.436766,84.39888'),
(997,	'Bhokardan',	'MH',	'20.259024,75.76976'),
(998,	'Nuzendla',	'APN',	'15.925831,79.740982'),
(999,	'Chettipalayam',	'TN',	'11.149687,77.346626'),
(1000,	'Naugawan Sadat',	'UP',	'29.00411,78.404129'),
(1001,	'Bargi',	'MP',	'22.99263,79.876198'),
(1002,	'Domari',	'UP',	'25.313381,83.028168'),
(1003,	'Versova',	'MH',	'19.135094,72.813423'),
(1004,	'Isru',	'PB',	'30.670086,76.108643'),
(1005,	'Kamrej',	'GJ',	'21.26919,72.958649'),
(1006,	'Maheshpur',	'JH',	'24.950375,87.168022'),
(1007,	'Jaitwara',	'MP',	'24.740635,80.864174'),
(1008,	'Moodbidri',	'KA',	'13.068799,74.993599'),
(1009,	'Tijara',	'RJ',	'27.933743,76.853127'),
(1010,	'Amla',	'MP',	'21.924892,78.126419'),
(1011,	'Shankargarh',	'UP',	'25.190769,81.611725'),
(1012,	'Harihareshwar',	'MH',	'17.994234,73.025803'),
(1013,	'Sonegaon',	'MH',	'20.792324,78.954277'),
(1014,	'Tirumalairayan Pattinam',	'PY',	'10.870649,79.830566'),
(1015,	'Kalpi',	'UP',	'26.120962,79.748398'),
(1016,	'Madhavapuram',	'TN',	'10.96664,79.352638'),
(1017,	'Kanyakumari',	'TN',	'8.088306,77.538452'),
(1018,	'Pallipadu',	'APN',	'14.508625,80.054741'),
(1019,	'Manikpur',	'AS',	'26.464119,90.803207'),
(1020,	'Chango',	'HP',	'31.975782,78.595184'),
(1021,	'Kadugodi',	'KA',	'12.996095,77.748917'),
(1022,	'Kannad',	'MH',	'20.265217,75.133972'),
(1023,	'Darzo',	'MI',	'22.831982,92.956017'),
(1024,	'Buniadpur',	'WB',	'25.387535,88.387711'),
(1025,	'Kapuluppada',	'APN',	'17.837767,83.39151'),
(1026,	'Dahiwadi',	'MH',	'17.704006,74.544868'),
(1027,	'Taloda',	'MH',	'21.562807,74.213531'),
(1028,	'Dolvi',	'MH',	'18.702391,73.046486'),
(1029,	'Rajwari',	'UP',	'25.50367,83.13752'),
(1030,	'Nand',	'MH',	'20.652424,79.291069'),
(1031,	'Shivampet',	'TS',	'17.787083,78.369698'),
(1032,	'Chandrakona',	'WB',	'22.732874,87.516922'),
(1033,	'Joranda',	'OR',	'20.788296,85.723526'),
(1034,	'Nagrota Bagwan',	'HP',	'32.106026,76.380035'),
(1035,	'Neemla',	'HR',	'29.416199,74.595238'),
(1036,	'Ghonsla',	'RJ',	'26.838854,77.004883'),
(1037,	'Nagarukhra',	'WB',	'22.947803,88.656815'),
(1038,	'Saur Bazar',	'BH',	'25.839487,86.683998'),
(1039,	'Udhranpur',	'UP',	'27.693338,79.929062'),
(1040,	'Jamna',	'WB',	'23.203171,87.852829'),
(1041,	'Trimulgherry',	'TS',	'17.475107,78.509193'),
(1042,	'Afzalpur',	'KA',	'17.203955,76.36171'),
(1043,	'Nandakumar',	'WB',	'22.192421,87.921227'),
(1044,	'Kadambur',	'TN',	'8.996599,77.860313'),
(1045,	'Tirwaganj',	'UP',	'26.959431,79.789047'),
(1046,	'Baroun',	'UP',	'27.410938,79.508507'),
(1047,	'Mallawan',	'UP',	'27.033972,80.159607'),
(1048,	'Chirawa',	'RJ',	'28.2416,75.649902'),
(1049,	'Ramganj',	'UP',	'26.118723,82.040787'),
(1050,	'Dhupdhara',	'AS',	'25.958778,91.054459'),
(1051,	'Chokkad',	'KL',	'11.218818,76.35215'),
(1052,	'Sonai',	'MH',	'19.395929,74.819542'),
(1053,	'Mohanpur',	'UP',	'28.253057,80.246063'),
(1054,	'Jodiya',	'GJ',	'22.692528,70.305923'),
(1055,	'Humnabad',	'KA',	'17.768276,77.131256'),
(1056,	'Lalganj',	'UP',	'25.016665,82.3591'),
(1057,	'Phulparas',	'BH',	'26.358973,86.494598'),
(1058,	'Chakia',	'BH',	'26.414856,85.049347'),
(1059,	'Dhaka',	'BH',	'26.658148,85.160126'),
(1060,	'Sonbarsa',	'BH',	'26.8477,85.578514'),
(1061,	'Dumra',	'BH',	'25.015131,83.973106'),
(1062,	'Bazpatti',	'BH',	'26.560854,85.611969'),
(1063,	'Kazipet',	'TS',	'17.972366,79.503448'),
(1064,	'Pratapgarh City',	'UP',	'25.897305,81.945297'),
(1065,	'Itwa',	'UP',	'27.333574,82.697655'),
(1066,	'Solan',	'HP',	'30.904486,77.096733'),
(1067,	'Babhnan',	'UP',	'26.934889,82.499924'),
(1068,	'Sultanganj',	'BH',	'25.240129,86.74044'),
(1069,	'Dhindsa',	'PB',	'30.425323,76.535095'),
(1070,	'Tartipur',	'WB',	'24.085238,88.474434'),
(1071,	'Pavoorchatram',	'TN',	'8.91492,77.382889'),
(1072,	'Nandipur',	'OR',	'20.802137,86.440239'),
(1073,	'Lakhipur',	'AS',	'24.792473,93.004555'),
(1074,	'Vairengte',	'MI',	'24.492617,92.759048'),
(1075,	'Katlicherra',	'AS',	'24.467756,92.557159'),
(1076,	'Serchhip',	'MI',	'23.341658,92.850227'),
(1077,	'Ambassa',	'TR',	'23.92477,91.846466'),
(1078,	'Lumding',	'AS',	'25.751627,93.172874'),
(1079,	'Haflong',	'AS',	'25.163309,93.012825'),
(1080,	'Buhchangphai',	'MI',	'24.336306,92.657417'),
(1081,	'Sakawrdai',	'MI',	'24.22646,92.954552'),
(1082,	'Siaha',	'MI',	'22.489735,92.979271'),
(1083,	'Bairabi',	'MI',	'24.185349,92.537125'),
(1084,	'Kashti',	'MH',	'18.549236,74.581871'),
(1085,	'North Thingdawl',	'MI',	'24.166325,92.694656'),
(1086,	'Lungdai',	'MI',	'23.880089,92.740097'),
(1087,	'Serkhan',	'MI',	'23.912077,92.738853'),
(1088,	'Khardi',	'MH',	'19.581392,73.393463'),
(1089,	'Ambalapuzha',	'KL',	'9.377914,76.357391'),
(1090,	'Ichhawar',	'MP',	'23.02733,77.018303'),
(1091,	'Poonch',	'JK',	'33.766987,74.092468'),
(1092,	'Bilari',	'UP',	'28.623253,78.801262'),
(1093,	'Shrimadhopur',	'RJ',	'27.472794,75.59687'),
(1094,	'Nandpur',	'MP',	'21.592699,78.536751'),
(1095,	'Barra Sagar',	'MP',	'22.688507,80.356926'),
(1096,	'Bairgania',	'BH',	'26.736094,85.27742'),
(1097,	'Makronia',	'MP',	'23.85405,78.793922'),
(1098,	'Bhalki',	'KA',	'18.050367,77.218369'),
(1099,	'Shendurni',	'MH',	'20.649483,75.593056'),
(1100,	'Indupur',	'OR',	'20.613184,86.405457'),
(1101,	'Sewarhi',	'UP',	'26.72336,84.23365'),
(1102,	'Manthani',	'TS',	'18.650993,79.668152'),
(1103,	'Veliyannur',	'KL',	'10.517096,76.212578'),
(1104,	'Tashpur',	'PB',	'31.170071,75.258476'),
(1105,	'Kattumannarkoil',	'TN',	'11.279966,79.55191'),
(1106,	'Demow',	'AS',	'27.127361,94.739922'),
(1107,	'Newali',	'MP',	'21.682524,74.921112'),
(1108,	'Chital',	'GJ',	'21.738453,71.202927'),
(1109,	'Raya',	'UP',	'27.556337,77.789375'),
(1110,	'Somnath',	'GJ',	'20.905886,70.387505'),
(1111,	'Kushinagar',	'UP',	'26.73988,83.886971'),
(1112,	'Dhodhsar',	'RJ',	'27.286196,75.6259'),
(1113,	'Boha',	'PB',	'29.835768,75.524117'),
(1114,	'Devarakonda',	'TS',	'16.693514,78.920197'),
(1115,	'Shahibag',	'GJ',	'23.058184,72.593231'),
(1116,	'Manikpur Sarhat',	'UP',	'25.058111,81.103058'),
(1117,	'Chhatari',	'UP',	'28.105843,78.146469'),
(1118,	'Siruguppa',	'KA',	'15.625062,76.895218'),
(1119,	'Pingla',	'WB',	'22.28179,87.585678'),
(1120,	'Kullu',	'HP',	'31.957851,77.109459'),
(1121,	'Tehatta',	'WB',	'23.730532,88.531059'),
(1122,	'Gobindpur',	'JH',	'23.832607,86.520226'),
(1123,	'Shyampur',	'WB',	'22.295937,88.027733'),
(1124,	'Pettai',	'TN',	'8.725252,77.649315'),
(1125,	'Songir',	'MH',	'21.081547,74.789291'),
(1126,	'Shriram Nagar',	'MH',	'18.455664,73.848824'),
(1127,	'Antulya Nagar',	'MH',	'18.440653,73.894836'),
(1128,	'Dattanagar',	'MH',	'18.44746,73.847443'),
(1129,	'Valanchery',	'KL',	'10.887746,76.073784'),
(1130,	'Ujhari',	'UP',	'28.659678,78.357201'),
(1131,	'Ramjibanpur',	'WB',	'22.82692,87.61171'),
(1132,	'Sonepur',	'OR',	'20.848015,83.895004'),
(1133,	'Lakshmikanta Pur',	'WB',	'22.109867,88.320869'),
(1134,	'Guledgudda',	'KA',	'16.049772,75.787415'),
(1135,	'Lakhnadon',	'MP',	'22.601498,79.601074'),
(1136,	'Harmoti',	'AR',	'27.123695,93.857895'),
(1137,	'Salmabad',	'UP',	'29.378492,78.16745'),
(1138,	'Uprauth',	'UP',	'25.277819,82.570312'),
(1139,	'Rafiganj',	'BH',	'24.817081,84.633949'),
(1140,	'Jawali',	'HP',	'32.144295,76.011734'),
(1141,	'Garhuwala',	'UP',	'29.147209,78.88224'),
(1142,	'Thakurdwara',	'UP',	'29.191149,78.86071'),
(1143,	'Kundapur',	'KA',	'13.632182,74.690544'),
(1144,	'Bannur Rural',	'KA',	'12.786232,75.200539'),
(1145,	'Katangi',	'MP',	'21.770464,79.804459'),
(1146,	'Alur',	'KA',	'13.138088,75.832558'),
(1147,	'Talakadu',	'KA',	'12.194678,77.03054'),
(1148,	'Bareta',	'PB',	'29.863522,75.696442'),
(1149,	'Cheepurupalli',	'APN',	'18.308632,83.566544'),
(1150,	'Pathapalya',	'KA',	'13.754965,77.946159'),
(1151,	'Murugamalla',	'KA',	'13.437396,78.126274'),
(1152,	'Manchenahalli',	'KA',	'13.499999,77.60289'),
(1153,	'Kaiwara',	'KA',	'13.35161,77.993851'),
(1154,	'Chelur',	'KA',	'13.703198,78.10054'),
(1155,	'Bettahalli',	'KA',	'13.016788,77.437271'),
(1156,	'Terakanambi',	'KA',	'11.813294,76.788483'),
(1157,	'Mangala',	'KA',	'12.000158,76.960609'),
(1158,	'Haradanahalli',	'KA',	'11.876905,76.9534'),
(1159,	'Gajanur',	'TN',	'11.766134,77.004723'),
(1160,	'Chamarajanagar',	'KA',	'11.926147,76.943733'),
(1161,	'Begur',	'KA',	'11.935327,76.671013'),
(1162,	'Thippagondanahalli',	'KA',	'12.966127,77.336189'),
(1163,	'Sarjapur',	'KA',	'12.854922,77.788116'),
(1164,	'Kengeri',	'KA',	'12.899623,77.482697'),
(1165,	'Jigani',	'KA',	'12.778907,77.643517'),
(1166,	'Anekal',	'KA',	'12.709884,77.693352'),
(1167,	'Sulibele',	'KA',	'13.188659,77.788116'),
(1168,	'Shivaganga',	'KA',	'13.171885,77.226067'),
(1169,	'Sasalu',	'KA',	'13.408401,77.384125'),
(1170,	'Nelamangala',	'KA',	'13.089093,77.410416'),
(1171,	'Bashettihalli',	'KA',	'13.260362,77.555099'),
(1172,	'Southegowdanahalli',	'KA',	'13.237477,77.721245'),
(1173,	'Changaramkulam',	'KL',	'10.736471,76.028633'),
(1174,	'Nikol',	'GJ',	'23.044628,72.667877'),
(1175,	'Pinjore',	'HR',	'30.797012,76.917793'),
(1176,	'Mandi Dabwali',	'HR',	'29.967102,74.700134'),
(1177,	'Badarpura',	'GJ',	'24.203896,72.345062'),
(1178,	'Ramgarhwa',	'BH',	'26.874058,84.783157'),
(1179,	'Vembarpatti',	'TN',	'10.249757,78.120811'),
(1180,	'Jaggayapeta',	'APN',	'16.892027,80.097412'),
(1181,	'Bylakuppe',	'KA',	'12.39915,75.982231'),
(1182,	'Ponnai',	'TN',	'13.124913,79.256302'),
(1183,	'Matheran',	'MH',	'18.988659,73.271179'),
(1184,	'Dostpur',	'UP',	'26.272202,82.472565'),
(1185,	'Agiripalli',	'APN',	'16.680471,80.783005'),
(1186,	'Chukam',	'UT',	'29.51133,79.133492'),
(1187,	'Ingur',	'TN',	'11.225393,77.581818'),
(1188,	'Pepeeganj',	'UP',	'26.931894,83.298241'),
(1189,	'Bhopal Ganj',	'RJ',	'25.34798,74.635651'),
(1190,	'Karoli',	'HR',	'28.391043,76.342857'),
(1191,	'Bhimadole',	'APN',	'16.816044,81.259644'),
(1192,	'Kokrajhar',	'AS',	'26.401436,90.266701'),
(1193,	'Bekal',	'KL',	'12.420353,75.023148'),
(1194,	'Chemnad',	'KL',	'12.487134,75.008842'),
(1195,	'Anklav',	'GJ',	'22.377476,72.999199'),
(1196,	'Mahua',	'BH',	'25.81214,85.398857'),
(1197,	'Dhakka',	'UP',	'28.697487,78.385857'),
(1198,	'Manana',	'HR',	'29.262365,76.989105'),
(1199,	'Utnoor',	'TS',	'19.369814,78.77623'),
(1200,	'Garividi',	'APN',	'18.285839,83.536339'),
(1201,	'Alapur',	'UP',	'27.91423,79.244972'),
(1202,	'Vaso',	'GJ',	'22.660976,72.755524'),
(1203,	'Por',	'GJ',	'22.140547,73.184296'),
(1204,	'Bamangam',	'GJ',	'22.288143,73.006721'),
(1205,	'Limda',	'GJ',	'22.285782,73.365166'),
(1206,	'Irongmara',	'AS',	'24.689009,92.741928'),
(1207,	'Sakri',	'BH',	'26.219749,86.079391'),
(1208,	'Kacharipara',	'AS',	'26.119068,92.890625'),
(1209,	'Suriyawa',	'UP',	'25.458872,82.415398'),
(1210,	'Bagasara',	'GJ',	'21.488495,70.951706'),
(1211,	'Sheron',	'PB',	'30.158693,75.718246'),
(1212,	'Bhambhoor',	'HR',	'29.509798,74.967964'),
(1213,	'Rajapur',	'UP',	'28.429983,81.092186'),
(1214,	'Kishni',	'UP',	'27.023077,79.259209'),
(1215,	'Hindoria',	'MP',	'23.902779,79.570175'),
(1216,	'Wagoora',	'JK',	'33.994007,74.864334'),
(1217,	'Chaksu',	'RJ',	'26.603464,75.943596'),
(1218,	'Mursan',	'UP',	'27.567827,77.93531'),
(1219,	'Khujner',	'MP',	'23.787163,76.622498'),
(1220,	'Damka',	'GJ',	'21.200136,72.659737'),
(1221,	'Nilje Gaon',	'MH',	'19.154026,73.083'),
(1222,	'Nellikuduru',	'TS',	'17.582195,79.754555'),
(1223,	'Daulatpur',	'HP',	'31.77475,75.998543'),
(1224,	'Ranj',	'OR',	'21.133743,86.565422'),
(1225,	'Rajakhera',	'RJ',	'26.89465,78.170692'),
(1226,	'Sasan Gir',	'GJ',	'21.169065,70.596481'),
(1227,	'Machla',	'MP',	'22.632648,75.84211'),
(1228,	'Colonelganj',	'UP',	'27.13162,81.700699'),
(1229,	'Indpur',	'WB',	'23.164431,86.934021'),
(1230,	'Edaikazhinadu',	'TN',	'12.288681,79.997589'),
(1231,	'Khatima',	'UT',	'28.919687,79.96981'),
(1232,	'Zaheerabad',	'TS',	'17.675264,77.615341'),
(1233,	'Medak',	'TS',	'18.045992,78.263359'),
(1234,	'Bemetara',	'CT',	'21.714025,81.535614'),
(1235,	'Shrigonda',	'MH',	'18.617544,74.698128'),
(1236,	'Gumia',	'JH',	'23.80809,85.823029'),
(1237,	'Sarita Vihar',	'DL',	'28.527958,77.289787'),
(1238,	'Mandal',	'RJ',	'25.439236,74.584404'),
(1239,	'Urma',	'WB',	'23.165495,86.266861'),
(1240,	'Poovar',	'KL',	'8.317691,77.070839'),
(1241,	'Chakkittapara',	'KL',	'11.575591,75.816536'),
(1242,	'Hulsoor',	'KA',	'18.018547,77.010757'),
(1243,	'Palacode',	'TN',	'12.304742,78.072861'),
(1244,	'Konanur',	'KA',	'12.628147,76.051521'),
(1245,	'Banjar',	'HP',	'31.638229,77.344131'),
(1246,	'Nadaun',	'HP',	'31.778503,76.34446'),
(1247,	'Kovvali',	'APN',	'16.730783,81.173508'),
(1248,	'Pedapadu',	'APN',	'18.317945,83.930756'),
(1249,	'Gainee',	'UP',	'28.352903,79.279884'),
(1250,	'Mahwa',	'RJ',	'27.047163,76.926674'),
(1251,	'Musabani',	'JH',	'22.503542,86.454147'),
(1252,	'Dehre',	'MH',	'19.242947,74.674767'),
(1253,	'Kiraoli',	'UP',	'27.136724,77.785255'),
(1254,	'Joya',	'UP',	'28.835295,78.470718'),
(1255,	'Padao',	'UP',	'25.309483,83.045494'),
(1256,	'Narsipatnam',	'APN',	'17.666187,82.612175'),
(1257,	'Dera Bassi',	'PB',	'30.596403,76.843269'),
(1258,	'Ahmedgarh',	'PB',	'30.683264,75.828102'),
(1259,	'Wadraf Nagar',	'CT',	'23.764038,83.197029'),
(1260,	'Dhanauli',	'UP',	'27.137947,77.965302'),
(1261,	'Ghosia',	'UP',	'25.269381,82.545799'),
(1262,	'Dinod',	'HR',	'28.793959,76.049347'),
(1263,	'Bamla',	'HR',	'28.806635,76.245285'),
(1264,	'Semariya',	'MP',	'24.793671,81.152695'),
(1265,	'Sheohar',	'BH',	'26.514587,85.294228'),
(1266,	'Maynaguri',	'WB',	'26.57383,88.821495'),
(1267,	'Rampura Phul',	'PB',	'30.271597,75.23732'),
(1268,	'Ahiwara',	'CT',	'21.356577,81.412346'),
(1269,	'Dumad',	'GJ',	'22.373301,73.189537'),
(1270,	'Nagra',	'UP',	'25.968019,83.871155'),
(1271,	'Saha',	'HR',	'30.30052,76.968613'),
(1272,	'Noniya',	'BH',	'26.68351,84.608742'),
(1273,	'Pakwara',	'UP',	'28.824261,78.674843'),
(1274,	'Rapthadu',	'APN',	'14.615817,77.606354'),
(1275,	'Kukshi',	'MP',	'22.206829,74.755653'),
(1276,	'Anjad',	'MP',	'22.041929,75.054665'),
(1277,	'Kurem',	'UP',	'25.852283,83.780983'),
(1278,	'Chanana',	'RJ',	'28.040342,75.608398'),
(1279,	'Guhala',	'RJ',	'27.692106,75.635406'),
(1280,	'Ganiari',	'CT',	'22.190386,82.038055'),
(1281,	'Kuvadva',	'GJ',	'22.359999,70.943588'),
(1282,	'Saoli',	'MH',	'20.081135,79.782784'),
(1283,	'Kothrud',	'MH',	'18.507399,73.807648'),
(1284,	'Devanahalli',	'KA',	'13.241715,77.71373'),
(1285,	'Talegaon Dabhade',	'MH',	'18.732103,73.676376'),
(1286,	'Nalhati',	'WB',	'24.292095,87.837784'),
(1287,	'Kanad',	'MP',	'23.670864,76.168228'),
(1288,	'Chatra',	'BH',	'24.73163,84.337532'),
(1289,	'Pirakata',	'WB',	'22.563982,87.180923'),
(1290,	'Kushali',	'MP',	'24.330479,80.796249'),
(1291,	'Lapkaman',	'GJ',	'23.13143,72.493858'),
(1292,	'Porur',	'TN',	'13.038063,80.159607'),
(1293,	'Tiruvallur',	'TN',	'13.144443,79.894005'),
(1294,	'Bhoom',	'MH',	'18.458967,75.661575'),
(1295,	'Pen',	'MH',	'18.734888,73.096603'),
(1296,	'Saundatti',	'KA',	'15.766649,75.115501'),
(1297,	'Tangori',	'PB',	'30.59487,76.705856'),
(1298,	'Zampani',	'APN',	'16.194115,80.708969'),
(1299,	'Miranpur',	'UP',	'29.292713,77.945312'),
(1300,	'Karanja Lad',	'MH',	'20.484125,77.486092'),
(1301,	'Someswaram',	'APN',	'16.863417,81.990295'),
(1302,	'Heduva',	'GJ',	'23.567213,72.368111'),
(1303,	'Silvassa',	'DN',	'20.276266,73.008308'),
(1304,	'Amalapuram',	'APN',	'16.57209,82.000854'),
(1305,	'Kothapally',	'TS',	'18.258152,78.584358'),
(1306,	'Kasabad',	'PB',	'30.978966,75.842499'),
(1307,	'Madanpur',	'WB',	'23.008944,88.491241'),
(1308,	'Kudchi',	'KA',	'16.626383,74.85656'),
(1309,	'Ghuntu',	'GJ',	'22.829414,70.895233'),
(1310,	'Vimanpuri',	'UP',	'26.398367,80.381683'),
(1311,	'Delol',	'GJ',	'22.629906,73.503998'),
(1312,	'Kotra',	'RJ',	'24.502087,73.728539'),
(1313,	'Vambori',	'MH',	'19.289661,74.730782'),
(1314,	'Rudraprayag',	'UT',	'30.284414,78.98114'),
(1315,	'Jharli',	'HR',	'28.498011,76.383682'),
(1316,	'Pawani',	'CT',	'21.662193,82.693771'),
(1317,	'Nowrangpur',	'OR',	'19.23,82.550003'),
(1318,	'Chaurai',	'MP',	'22.053663,79.248337'),
(1319,	'Kaliakkavilai',	'TN',	'8.33444,77.171013'),
(1320,	'Colachel',	'TN',	'8.17862,77.256096'),
(1321,	'Suchindram',	'TN',	'8.155,77.464996'),
(1322,	'Chinnur',	'TS',	'18.855518,79.794312'),
(1323,	'Pandua',	'WB',	'23.078054,88.278732'),
(1324,	'Naxalbari',	'WB',	'26.683882,88.200783'),
(1325,	'Kadayal',	'TN',	'8.404483,77.266617'),
(1326,	'Gosalpur',	'MP',	'23.39916,80.06031'),
(1327,	'Manesar',	' HR',	'28.372324,76.919563'),
(1328,	'Chromepet',	'TN',	'12.953195,80.141602'),
(1329,	'Biaora',	'MP',	'23.918566,76.911324'),
(1330,	'Kalamboli',	'MH',	'19.02577,73.10157'),
(1331,	'Aseda',	'GJ',	'24.156303,72.177963'),
(1332,	'Taraori',	'HR',	'29.798412,76.926498'),
(1333,	'Kismatpur',	'TS',	'17.336552,78.383987'),
(1334,	'Batlagundu',	'TN',	'10.163919,77.757133'),
(1335,	'Rayavaram',	'APN',	'16.192787,81.054611'),
(1336,	'Chharra Rafatpur',	'UP',	'27.924475,78.400703'),
(1337,	'Chinthal',	'TS',	'17.494022,78.459457'),
(1338,	'Katargam',	'Sur',	'21.228125,72.833771'),
(1339,	'Yelandur',	'KA',	'12.049126,77.03054'),
(1340,	'Laranpur',	'BH',	'25.095751,85.309746'),
(1341,	'Bhelupur',	'UP',	'25.296021,83.000572'),
(1342,	'Khunti',	'JH',	'23.07976,85.27742'),
(1343,	'Taranagar',	'RJ',	'28.671349,75.034264'),
(1344,	'Vyara',	'GJ',	'21.120001,73.400002'),
(1345,	'Trapaj',	'GJ',	'21.424757,72.107018'),
(1346,	'Melameignanapuram',	'TN',	'8.932928,77.342644'),
(1347,	'Shenkottai',	'TN',	'8.974165,77.249016'),
(1348,	'Mettu',	'TN',	'13.995705,79.997292'),
(1349,	'Thadi',	'APN',	'17.686468,83.06823'),
(1350,	'Nainital',	'UT',	'29.380304,79.46357'),
(1351,	'Vasad',	'GJ',	'22.450001,73.066704'),
(1352,	'Madanpura',	'MH',	'18.970585,72.826843'),
(1353,	'Kariseri',	'TN',	'9.515095,77.853928'),
(1354,	'Dusipeta',	'APN',	'18.371025,83.858566'),
(1355,	'Calangute',	'GA',	'15.533414,73.764954'),
(1356,	'Minalur',	'KL',	'10.625728,76.221771'),
(1357,	'Naldurg',	'MH',	'17.816668,76.273979'),
(1358,	'Ganj Dundwara',	'UP',	'27.731571,78.941208'),
(1359,	'awana',	'UP',	'29.096956,77.920494'),
(1360,	'Chanchal',	'WB',	'25.386837,88.009415'),
(1361,	'Gangeo',	'MP',	'24.717363,81.594429'),
(1362,	'Badvel',	'APN',	'14.730908,79.058853'),
(1363,	'Coonoor',	'TN',	'11.350208,76.796104'),
(1364,	'Talwara Khurd',	'RJ',	'29.494858,74.632034'),
(1365,	'Ellenabad',	'HR',	'29.452583,74.66214'),
(1366,	'Kymore',	'MP',	'24.059319,80.611839'),
(1367,	'Ugar Khurd',	'KA',	'16.658726,74.818649'),
(1368,	'Barhalganj',	'UP',	'26.279255,83.51326'),
(1369,	'Mugat',	'MH',	'19.151087,77.431221'),
(1370,	'Gehun Kheda',	'MP',	'23.166124,77.418556'),
(1371,	'Kuchanur',	'TN',	'9.877395,77.375511'),
(1372,	'Maudaha',	'UP',	'25.686987,80.113106'),
(1373,	'Mehra',	'UP',	'26.527721,83.774872'),
(1374,	'Barhaj',	'UP',	'26.288334,83.725227'),
(1375,	'Kalyanpur Town',	'UP',	'26.504221,80.249718'),
(1376,	'Kutabadh',	'HR',	'29.462093,74.818291'),
(1377,	'Durgauti',	'BH',	'25.215115,83.518753'),
(1378,	'Sathyamangalam',	'TN',	'11.504776,77.238396'),
(1379,	'Pasur',	'TN',	'11.239274,77.854958'),
(1380,	'Thuckanaickenpalayam',	'TN',	'11.507255,77.385033'),
(1381,	'Gobichettipalayam',	'TN',	'11.455799,77.433868'),
(1382,	'Bagru',	'RJ',	'26.809267,75.54174'),
(1383,	'Bangomunda',	'OR',	'20.343611,82.909721'),
(1384,	'Kempwad',	'MH',	'16.763783,74.878693'),
(1385,	'Titwala',	'MH',	'19.299,73.223839'),
(1386,	'Atmakur',	'APN',	'15.879042,78.585258'),
(1387,	'Punnam',	'TN',	'10.99314,77.996239'),
(1388,	'Bibi',	'MH',	'20.020281,76.376457'),
(1389,	'Kolasib',	'MI',	'24.226772,92.67775'),
(1390,	'Pocharam',	'TS',	'17.173595,78.607178'),
(1391,	'Muskara',	'UP',	'25.664583,79.799835'),
(1392,	'Hatod',	'MP',	'22.794075,75.739883'),
(1393,	'Yewalewadi',	'MH',	'18.436337,73.896492'),
(1394,	'Lavale',	'MH',	'18.523481,73.718361'),
(1395,	'Charummoodu',	'KL',	'9.173661,76.607986'),
(1396,	'Srirampur',	'WB',	'23.403339,88.338509'),
(1397,	'Amdad',	'MH',	'20.850801,74.903336'),
(1398,	'Koheda',	'TS',	'17.283333,78.633331'),
(1399,	'Mudalur',	'TN',	'8.419547,77.949593'),
(1400,	'Sirkazhi',	'TN',	'11.239088,79.736122'),
(1401,	'Peddapuram',	'APN',	'17.075666,82.136002'),
(1402,	'Borabanda',	'TS',	'17.456455,78.412086'),
(1403,	'Thuthibari',	'UP',	'27.427565,83.690681'),
(1404,	'Kinathukadavu',	'TN',	'10.822477,77.016144'),
(1405,	'Dahina',	'HR',	'28.296219,76.384163'),
(1406,	'Keeranur',	'TN',	'10.571564,78.784416'),
(1407,	'Katigara',	'AS',	'24.891418,92.588051'),
(1408,	'Mehnagar',	'UP',	'25.879999,83.120003'),
(1409,	'Balimela',	'OR',	'18.229839,82.061218'),
(1410,	'Nizampatnam',	'APN',	'15.905502,80.668243'),
(1411,	'Kovanur',	'APN',	'13.661424,79.7491'),
(1412,	'Kaveripattinam',	'TN',	'12.420609,78.216713'),
(1413,	'Barabhum',	'WB',	'23.027212,86.363998'),
(1414,	'Kompally',	'TS',	'17.542881,78.481445'),
(1415,	'Simdega',	'JH',	'22.611673,84.501793'),
(1416,	'Makhu',	'PB',	'31.107153,74.976402'),
(1417,	'Roha',	'MH',	'18.439472,73.118263'),
(1418,	'Asangaon',	'MH',	'19.440128,73.308563'),
(1419,	'Anjap',	'MH',	'19.00161,73.386299'),
(1420,	'Pipraundh',	'MP',	'23.760185,80.335236'),
(1421,	'Kodumudi',	'TN',	'11.07883,77.886749'),
(1422,	'Neota',	'RJ',	'26.799147,75.67778'),
(1423,	'Panvel',	'MH',	'18.990713,73.116844'),
(1424,	'Indirma & Amruthnagar Housing Colony',	'APN',	'14.764467,78.586098'),
(1425,	'Gauriganj',	'UP',	'26.20635,81.691956'),
(1426,	'Kawari',	'BH',	'24.94902,87.002388'),
(1427,	'Saroli',	'MH',	'16.168268,74.302834'),
(1428,	'Kishanpura',	'PB',	'30.652311,76.851059'),
(1429,	'Akbarpur',	'UP',	'26.434149,82.540199'),
(1430,	'Nalegaon',	'MH',	'18.422146,76.810104'),
(1431,	'Koppa',	'KA',	'13.531711,75.361755'),
(1432,	'Pavaratty',	'KL',	'10.565458,76.061607'),
(1433,	'Phulambri',	'MH',	'20.088863,75.418274'),
(1434,	'Gandipalem',	'APN',	'14.998619,79.309586'),
(1435,	'Jangareddigudem',	'APN',	'17.122318,81.292313'),
(1436,	'Beerwah',	'JK',	'34.012363,74.595352'),
(1437,	'Kathali',	'CT',	'21.723543,83.273224'),
(1438,	'Yadagirigutta',	'TS',	'17.586021,78.945747'),
(1439,	'Shobhasar',	'RJ',	'27.774754,74.722107'),
(1440,	'Duroo',	'JK',	'34.349281,74.461029'),
(1441,	'Siswa Bazar',	'UP',	'27.144215,83.759789'),
(1442,	'Katan',	'WB',	'22.638298,87.740654'),
(1443,	'Mansuka',	'WB',	'22.713629,87.737167'),
(1444,	'Chandra',	'UP',	'25.567995,78.493118'),
(1445,	'Kallam',	'MH',	'18.576128,76.021828'),
(1446,	'Kolpa',	'MH',	'18.42569,76.640434'),
(1447,	'Murud',	'MH',	'18.402437,76.24131'),
(1448,	'MIDC Ambad',	'Nas',	'19.952959,73.737518'),
(1449,	'Salempur',	'UP',	'26.297764,83.919441'),
(1450,	'Nattukal',	'KL',	'10.967883,76.35231'),
(1451,	'Ghooghra',	'RJ',	'26.505259,74.692322'),
(1452,	'Mohanur',	'TN',	'11.059875,78.142189'),
(1453,	'Kalka',	'HR',	'30.83,76.93'),
(1454,	'Vettavalam',	'TN',	'12.109666,79.244896'),
(1455,	'Eklingji',	'RJ',	'24.741297,73.722099'),
(1456,	'Yerrabalem',	'APN',	'16.456211,80.56736'),
(1457,	'Bhopa',	'UP',	'29.476851,77.877731'),
(1458,	'Kottampatty',	'TN',	'10.221849,78.371338'),
(1459,	'Gajanan Nagar',	'MH',	'20.926802,77.789215'),
(1460,	'Pulgaon',	'MH',	'20.719194,78.315712'),
(1461,	'Mhasala',	'MH',	'20.85857,77.761002'),
(1462,	'Ner',	'MH',	'20.491026,77.866386'),
(1463,	'Baraho',	'MP',	'23.965195,80.313858'),
(1464,	'Guhagar',	'MH',	'17.465267,73.195427'),
(1465,	'Sokkanathan Puthur',	'TN',	'9.352296,77.463196'),
(1466,	'Akluj',	'MH',	'17.882444,75.020531'),
(1467,	'Balasinor',	'GJ',	'22.953241,73.33255'),
(1468,	'Makhdumpur',	'BH',	'25.065567,84.973953'),
(1469,	'Jattari',	'UP',	'28.023335,77.656479'),
(1470,	'Armoor',	'TS',	'18.789457,78.289276'),
(1471,	'Uttara',	'OR',	'20.191484,85.855705'),
(1472,	'Kufri',	'HP',	'31.097858,77.267815'),
(1473,	'Bahoriband',	'MP',	'23.667835,80.0653'),
(1474,	'Potta',	'KL',	'10.333449,76.326096'),
(1475,	'Sundarpur',	'WB',	'23.87336,87.942513'),
(1476,	'Saloora',	'JK',	'34.210064,74.76635'),
(1477,	'Dhuvaran',	'GJ',	'22.240803,72.763138'),
(1478,	'Akaltara',	'CT',	'22.02,82.43'),
(1479,	'Naltoli',	'AS',	'26.546305,92.896378'),
(1480,	'Babatpur',	'UP',	'25.448313,82.852043'),
(1481,	'Rajouri',	'JK',	'33.371288,74.315506'),
(1482,	'Madavara',	'KA',	'13.052974,77.47226'),
(1483,	'Tilikiam',	'AS',	'26.728104,94.128349'),
(1484,	'Phey',	'JK',	'34.134113,77.469109'),
(1485,	'Phonjila',	'JK',	'34.199337,76.873535'),
(1486,	'Haider Pur',	'DL',	'28.722498,77.144699'),
(1487,	'Hebbur',	'KA',	'13.15,77.033333'),
(1488,	'Santola',	'AS',	'26.089163,91.548256'),
(1489,	'Atrauli',	'UP',	'27.173159,80.660439'),
(1490,	'Jhiri',	'JK',	'32.830811,74.732246'),
(1491,	'Reka',	'JK',	'32.704979,74.859337'),
(1492,	'Netteri',	'TN',	'12.844828,79.685287'),
(1493,	'Thiruvangad',	'KL',	'11.746093,75.500969'),
(1494,	'Nuchiyad',	'KL',	'12.044357,75.638985'),
(1495,	'Birkona',	'CT',	'22.14138,82.161644'),
(1496,	'Nanpur',	'BH',	'26.440929,85.665321'),
(1497,	'Vajrakarur',	'APN',	'15.02753,77.386429'),
(1498,	'Allurivaripalem',	'APN',	'16.22714,80.014381'),
(1499,	'Maruru',	'APN',	'14.492499,77.628319'),
(1500,	'Lepakshi',	'APN',	'13.81,77.599998'),
(1501,	'Madhoganj',	'UP',	'27.115368,80.143204'),
(1502,	'Morni Hills',	'HR',	'30.705967,76.97583'),
(1503,	'Hadinaru',	'KA',	'12.166693,76.739426'),
(1504,	'Guiya',	'AS',	'26.347914,91.654205'),
(1505,	'Minjur',	'TN',	'13.269188,80.263718'),
(1506,	'Poynad',	'MH',	'18.685278,72.992737'),
(1507,	'Kusali',	'MH',	'19.81823,75.688118'),
(1508,	'Derawal Nagar',	'DL',	'28.697289,77.190239'),
(1509,	'Edakkad',	'KL',	'11.803638,75.449036'),
(1510,	'Mannanchery',	'KL',	'9.56859,76.347748'),
(1511,	'Hosanagar',	'KA',	'13.92,75.07'),
(1512,	'Guruvayoor',	'KL',	'10.595821,76.032944'),
(1513,	'Ralla',	'PB',	'30.119556,75.433289'),
(1514,	'Kalitakuchi',	'AS',	'26.273945,91.51226'),
(1515,	'Fatehganj Pashchimi',	'UP',	'28.4646,79.30423'),
(1516,	'Sonamukhi',	'WB',	'23.299999,87.416664'),
(1517,	'Tekanpur',	'MP',	'25.983774,78.298866'),
(1518,	'Dharmadom',	'KL',	'11.776793,75.466515'),
(1519,	'Meharban',	'PB',	'30.951998,75.901367'),
(1520,	'Maranalloor',	'KL',	'8.471725,77.072487'),
(1521,	'Kandla',	'GJ',	'23.030001,70.220001'),
(1522,	'Chimni',	'HR',	'28.72702,76.480888'),
(1523,	'Sukhi Sewania',	'MP',	'23.355495,77.484169'),
(1524,	'Chichli',	'MP',	'22.831236,78.825523'),
(1525,	'Jawhar',	'MH',	'19.905876,73.230736'),
(1526,	'Mamda',	'TS',	'19.078899,78.522072'),
(1527,	'Dhapali',	'PB',	'30.367785,75.267921'),
(1528,	'Pathri',	'MH',	'19.277443,76.430511'),
(1529,	'Haroa',	'WB',	'22.6068,88.678596'),
(1530,	'Israna',	'HR',	'29.276979,76.851913'),
(1531,	'Amingad',	'KA',	'16.057327,75.94458'),
(1532,	'Rohida',	'RJ',	'24.613117,72.960701'),
(1533,	'Badheen',	'RJ',	'27.850145,76.383987'),
(1534,	'Sirvella',	'APN',	'15.324246,78.5411'),
(1535,	'Mylaudy',	'TN',	'8.154739,77.50174'),
(1536,	'Polur',	'TN',	'12.511665,79.126106'),
(1537,	'Narayanapur',	'AS',	'26.95179,93.859169'),
(1538,	'Nawa',	'RJ',	'27.026152,75.007225'),
(1539,	'Yellandu',	'TS',	'17.594133,80.322365'),
(1540,	'Said Nagli',	'UP',	'28.668877,78.397018'),
(1541,	'Rasulabad',	'UP',	'26.68,79.779999'),
(1542,	'Bhagwanpura',	'MP',	'21.681585,75.593163'),
(1543,	'Layja Mota',	'GJ',	'22.889748,69.220703'),
(1544,	'Chak Maroof',	'UP',	'27.925516,79.931862'),
(1545,	'Garhmukteshwar',	'UP',	'28.789221,78.082306'),
(1546,	'Ghumarwin',	'HP',	'31.435841,76.711868'),
(1547,	'Bodeli',	'GJ',	'22.273268,73.714897'),
(1548,	'Amirgadh',	'GJ',	'24.406965,72.640251'),
(1549,	'Lodhipur',	'UP',	'27.880547,79.927193'),
(1550,	'Kishore Nagar',	'MP',	'21.842751,76.347809'),
(1551,	'Deokali',	'UP',	'25.830952,82.676369'),
(1552,	'Kanth',	'UP',	'29.059,78.627998'),
(1553,	'Dharamshala',	'HP',	'32.219044,76.323402'),
(1554,	'Onthupacha',	'KL',	'8.858924,77.035576'),
(1555,	'Kemri',	'UP',	'28.800758,79.204216'),
(1556,	'Dimili',	'APN',	'17.512041,82.872269'),
(1557,	'Bhikangaon',	'MP',	'21.8615,75.94162'),
(1558,	'Arasalu',	'KA',	'13.998363,75.309151'),
(1559,	'Malliakarai',	'TN',	'11.568932,78.499344'),
(1560,	'Peppeganj',	'UP',	'26.931253,83.298943'),
(1561,	'Kala',	'PB',	'31.153849,75.825066'),
(1562,	'Kappatralla',	'APN',	'15.593608,77.631668'),
(1563,	'Khirpai',	'WB',	'22.700001,87.620003'),
(1564,	'Pudhukulam',	'TN',	'11.439298,79.163322'),
(1565,	'Kauria Jairam',	'UP',	'26.276632,83.944801'),
(1566,	'Tafazalpura',	'PB',	'31.414162,75.445404'),
(1567,	'Tirora',	'MH',	'21.406832,79.930908'),
(1568,	'Kaliyapuram',	'TN',	'10.539817,76.918831'),
(1569,	'Milak',	'UP',	'28.612368,79.166367'),
(1570,	'Mirganj',	'BH',	'26.366571,84.344444'),
(1571,	'Kauriram',	'UP',	'26.532175,83.405373'),
(1572,	'Badapur',	'MH',	'19.749256,75.71772'),
(1573,	'Dhoki Town',	'MH',	'18.371246,76.104454'),
(1574,	'Pallam',	'TN',	'8.099403,77.434181'),
(1575,	'Chilakaluripet',	'APN',	'16.08917,80.167221'),
(1576,	'Mandrup',	'MH',	'17.494804,75.821434'),
(1577,	'Prantij',	'GJ',	'23.436584,72.848595'),
(1578,	'Jaleswar',	'OR',	'21.803888,87.226997'),
(1579,	'Awan',	'MP',	'24.408623,77.137802'),
(1580,	'Kond',	'MH',	'17.043465,73.356133'),
(1581,	'Bagalkote',	'KA',	'16.1817,75.695801'),
(1582,	'Pal',	'GJ',	'22.214027,70.758972'),
(1583,	'Puraopur',	'UP',	'25.634541,82.164566'),
(1584,	'Sheragada',	'OR',	'19.513845,84.605797'),
(1585,	'Aklera',	'RJ',	'24.42,76.57'),
(1586,	'Thanipadi',	'TN',	'12.107423,78.834099'),
(1587,	'Ropale',	'MH',	'17.785583,75.416992'),
(1588,	'Melchhamunda',	'OR',	'21.089674,83.241905'),
(1589,	'Kandabahal',	'OR',	'22.069613,84.036179'),
(1590,	'Tumsar',	'MH',	'21.38084,79.745598'),
(1591,	'Belpahar',	'OR',	'21.823406,83.85099'),
(1592,	'GAljan',	'WB',	'24.111559,88.240036'),
(1593,	'Kalimpong',	'WB',	'27.066668,88.466667'),
(1594,	'Paravalur',	'TN',	'11.529566,79.269531'),
(1595,	'Chitlapakkam',	'TN',	'12.93245,80.142677'),
(1596,	'Panchbaga',	'WB',	'23.251905,87.041191'),
(1597,	'Mandleshwar',	'MP',	'22.186132,75.586624'),
(1598,	'Khizrabad',	'PB',	'30.880478,76.65715'),
(1599,	'Velim',	'GA',	'15.157283,73.96537'),
(1600,	'Badami Bagh Cantonment',	'JK',	'34.063259,74.859482'),
(1601,	'Rengali Project Town',	'OR',	'21.271341,85.017319'),
(1602,	'New Colony',	'OR',	'21.638655,85.61618'),
(1603,	'Naduvakurichi',	'TN',	'8.740818,77.795265'),
(1604,	'Chitri',	'OR',	'21.105305,86.018532'),
(1605,	'Nunna',	'APN',	'16.576286,80.685402'),
(1606,	'Bale',	'MH',	'17.699858,75.878082'),
(1607,	'Bilsi',	'UP',	'28.130129,78.9105'),
(1608,	'Saifai',	'UP',	'26.956867,78.968414'),
(1609,	'Kasara Budruk',	'MH',	'19.644302,73.474976'),
(1610,	'Kottakkal',	'KL',	'11.000112,75.998833'),
(1611,	'Kalwa',	'MH',	'19.194386,72.999199'),
(1612,	'Fagane',	'MH',	'20.889898,74.837555'),
(1613,	'Chinnaganjam',	'APN',	'15.698071,80.237709'),
(1614,	'Koorikuzhi',	'KL',	'10.341602,76.128174'),
(1615,	'Methala',	'KL',	'10.204638,76.195763'),
(1616,	'Jayant',	'MP',	'24.145815,82.636971'),
(1617,	'Galag',	'KA',	'16.267908,76.83754'),
(1618,	'Gogipeth',	'KA',	'16.735277,76.744164'),
(1619,	'Pamidi',	'APN',	'14.952117,77.594795'),
(1620,	'Sankha Nagar',	'WB',	'22.973715,88.390694'),
(1621,	'Mahud',	'MH',	'17.609299,75.097794'),
(1622,	'Mendhapur',	'MH',	'17.794052,75.357246'),
(1623,	'Sadgaon',	'MH',	'20.816778,74.653656'),
(1624,	'Hebri',	'KA',	'13.45876,74.99247'),
(1625,	'Niphad',	'MH',	'20.079966,74.109314'),
(1626,	'Gurram Konda',	'APN',	'13.779373,78.587379'),
(1627,	'Thol',	'HR',	'30.166519,76.709602'),
(1628,	'Mehli',	'PB',	'31.21104,75.814377'),
(1629,	'Kolakaluru',	'APN',	'16.303612,80.617226'),
(1630,	'Amboli',	'MH',	'15.9625,73.99778'),
(1631,	'Tikri',	'HR',	'28.42,77.03611'),
(1632,	'Madathukulam',	'TN',	'10.559584,77.365463'),
(1633,	'Ajeetgarh',	'RJ',	'27.420864,75.818214'),
(1634,	'Chhajli',	'PB',	'30.032778,75.828888'),
(1635,	'Guduvancherry',	'TN',	'12.844101,80.064995'),
(1636,	'Thammampatti',	'TN',	'11.444725,78.485847'),
(1637,	'Aoras',	'UP',	'26.91787,80.504944'),
(1638,	'Shambunipet',	'TS',	'17.949709,79.599442'),
(1639,	'Bhildi',	'GJ',	'24.19541,72.027145'),
(1640,	'Vavdi',	'GJ',	'22.230988,70.797127'),
(1641,	'Sembanarkoil',	'TN',	'11.107746,79.74279'),
(1642,	'Thirumudivakkam',	'TN',	'12.969946,80.089806'),
(1643,	'Nakodar',	'PB',	'31.12702,75.481773'),
(1644,	'Uppalapadu',	'APN',	'16.076809,80.233528'),
(1645,	'Bandikui',	'RJ',	'27.044718,76.569054'),
(1646,	'Palus',	'MH',	'17.098709,74.449753'),
(1647,	'Ganwadi',	'UP',	'28.886766,77.593346'),
(1648,	'Shahzadpur',	'HR',	'30.446484,77.033943'),
(1649,	'Jiaganj',	'WB',	'24.244104,88.268021'),
(1650,	'Varca',	'GA',	'15.232366,73.943115'),
(1651,	'Benaulim',	'GA',	'15.250526,73.920891'),
(1652,	'Mandraud',	'CT',	'20.81074,81.773712'),
(1653,	'Goindwal Sahib',	'PB',	'31.365051,75.136154'),
(1654,	'Balachaur',	'PB',	'31.057878,76.300041'),
(1655,	'Bulandpur',	'PB',	'31.376244,75.593163'),
(1656,	'Nahal',	'PB',	'31.452112,75.709892'),
(1657,	'Samrala',	'PB',	'30.835669,76.191025'),
(1658,	'Petlawad',	'MP',	'23.012297,74.796608'),
(1659,	'Ponkh',	'RJ',	'27.836967,75.61499'),
(1660,	'Peth',	'MH',	'18.930258,73.925163'),
(1661,	'Lohegaon',	'MH',	'18.596024,73.924698'),
(1662,	'Ormaura',	'UP',	'24.663956,83.060303'),
(1663,	'Khair',	'UP',	'27.939196,77.842445'),
(1664,	'Sahnewal',	'PB',	'30.844801,75.9758'),
(1665,	'Gopiganj',	'UP',	'25.285719,82.432869'),
(1666,	'Vengola',	'KL',	'10.082,76.467003'),
(1667,	'Sugauli',	'BH',	'26.764004,84.738235'),
(1668,	'Todabhim',	'RJ',	'26.9167,76.816704'),
(1669,	'Tupran',	'TS',	'17.844292,78.478035'),
(1670,	'Chhokarwara Kalan',	'RJ',	'27.099476,77.064972'),
(1671,	'Marriguda',	'TS',	'17.090834,79.249619'),
(1672,	'Shinoli',	'MH',	'15.862899,74.396866'),
(1673,	'Rasra',	'UP',	'25.859106,83.855469'),
(1674,	'Fulchur Tola',	'MH',	'21.435078,80.215469'),
(1675,	'Doraha',	'PB',	'30.803919,76.033386'),
(1676,	'Ter',	'MH',	'18.3218,76.142143'),
(1677,	'Sakharkherda',	'MH',	'20.202019,76.398643'),
(1678,	'Peravali',	'APN',	'16.752501,81.741669'),
(1679,	'Kheda',	'GJ',	'22.75065,72.684669'),
(1680,	'Choma',	'HR',	'28.516537,77.03054'),
(1681,	'Rayappanur',	'TN',	'11.605662,78.813667'),
(1682,	'Manki',	'KA',	'14.188768,74.484802'),
(1683,	'Kaman',	'RJ',	'27.656761,77.269005'),
(1684,	'Deeg',	'RJ',	'27.472399,77.324974'),
(1685,	'Turkapally',	'TS',	'17.670841,78.602989'),
(1686,	'Makkapeta',	'APN',	'16.925962,80.189598'),
(1687,	'Behror',	'RJ',	'27.879993,76.279999'),
(1688,	'Aluva',	'KL',	'10.107796,76.350693'),
(1689,	'Paonta Sahib',	'HP',	'30.450001,77.620003'),
(1690,	'Kotwa Kala',	'UP',	'27.072098,83.860558'),
(1691,	'Annaram',	'TS',	'17.63257,78.378868'),
(1692,	'Turbhe',	'MH',	'19.10811,73.090698'),
(1693,	'Lutukurru',	'APN',	'16.491888,81.935066'),
(1694,	'Yanam',	'PY',	'16.733334,82.216667'),
(1695,	'Sariya',	'JH',	'24.174795,85.887634'),
(1696,	'Alakkad',	'KL',	'12.154406,75.250824'),
(1697,	'Aranthangi',	'TN',	'10.1631,78.996201'),
(1698,	'Susner',	'MP',	'23.94281,76.100098'),
(1699,	'Jairampur',	'AR',	'27.35111,96.015831'),
(1700,	'Karimpur',	'WB',	'23.966667,88.616669'),
(1701,	'Wakad',	'MH',	'20.046255,76.693497'),
(1702,	'Amod',	'GJ',	'22,72.870003'),
(1703,	'Ukarda',	'GJ',	'22.477962,70.649193'),
(1704,	'Rehli',	'MP',	'23.639891,79.065498'),
(1705,	'Sagwara',	'RJ',	'23.68,74.019997'),
(1706,	'Chandauli',	'UP',	'25.260456,83.266266'),
(1707,	'Malkangiri',	'OR',	'18.343586,81.88253'),
(1708,	'Belan Baraudha',	'UP',	'24.955267,82.258736'),
(1709,	'Mulkalapally',	'TS',	'17.506903,80.835014'),
(1710,	'Ajivali',	'MH',	'18.955776,73.168884'),
(1711,	'Alsisar',	'RJ',	'28.306725,75.287277'),
(1712,	'Gorantla',	'APN',	'13.983799,77.772324'),
(1713,	'Ikauna',	'UP',	'27.5315,81.967117'),
(1714,	'Mehgaon',	'MP',	'26.496389,78.613609'),
(1715,	'Parvathipuram',	'APN',	'18.781715,83.42675'),
(1716,	'Kakarwal',	'PB',	'30.369202,75.834511'),
(1717,	'Kedar',	'TN',	'12.008346,79.404274'),
(1718,	'Farakka',	'WB',	'24.7976,87.914299'),
(1719,	'Yellareddy',	'TS',	'18.185894,78.021202'),
(1720,	'Belur',	'TN',	'11.708082,78.41124'),
(1721,	'Bolbolla',	'AS',	'26.081493,90.606209'),
(1722,	'Srisailam',	'APN',	'16.073275,78.868729'),
(1723,	'Natham',	'TN',	'10.224932,78.231796'),
(1724,	'Deola',	'MH',	'20.460423,74.182892'),
(1725,	'Budanpur',	'HR',	'30.690777,76.828529'),
(1726,	'Madhavnagar',	'MH',	'16.892214,74.588058'),
(1727,	'Harot Kot',	'JK',	'33.084305,74.879951'),
(1728,	'Gulwanch',	'MH',	'19.885828,74.090225'),
(1729,	'Baner',	'MH',	'18.559658,73.779938'),
(1730,	'Bikrampur',	'WB',	'23.641472,88.348221'),
(1731,	'Bhabaniprasad',	'WB',	'26.047953,89.510826'),
(1732,	'Kukana',	'MH',	'19.434975,75.070602'),
(1733,	'Chobari',	'GJ',	'22.268288,71.210114'),
(1734,	'Leh',	'LA',	'34.152588,77.577049'),
(1735,	'Gaadhi',	'UP',	'28.997332,77.279305'),
(1736,	'Jaitaran',	'RJ',	'26.201229,73.939491'),
(1737,	'Eriyodu',	'TN',	'10.510865,78.059486'),
(1738,	'Pargi',	'TS',	'17.176582,77.876747'),
(1739,	'Ramkola',	'UP',	'26.9,83.839996'),
(1740,	'Laxmipuram',	'TS',	'17.172268,80.121223'),
(1741,	'Yellapura',	'KA',	'14.964311,74.712074'),
(1742,	'Pandavapura',	'KA',	'12.492862,76.664284'),
(1743,	'Pasara',	'TS',	'18.193851,80.16658'),
(1744,	'Rangapur',	'TS',	'16.171949,77.966728'),
(1745,	'Panoor',	'KL',	'11.759342,75.578522'),
(1746,	'Majholi',	'MP',	'23.5,79.919998'),
(1747,	'Mahendragarh',	'HR',	'28.268347,76.150932'),
(1748,	'Daaur Nagar',	'MH',	'18.871811,72.939415'),
(1749,	'Mammigatti',	'KA',	'15.507638,74.944992'),
(1750,	'Anjugramam',	'TN',	'8.157288,77.577377'),
(1751,	'Kattuvilai',	'TN',	'8.158933,77.336746'),
(1752,	'Kalpakkam',	'TN',	'12.523812,80.156815'),
(1753,	'Piparcity',	'RJ',	'26.385599,73.537804'),
(1754,	'Vadgam',	'GJ',	'24.073397,72.492378'),
(1755,	'Cherpoli',	'MH',	'19.470055,73.326653'),
(1756,	'Risod',	'MH',	'19.97468,76.783058'),
(1757,	'Neem Ka Thana',	'RJ',	'27.738001,75.782997'),
(1758,	'Vaniputhur',	'TN',	'11.507423,77.363083'),
(1759,	'Aralehalli',	'KA',	'13.894048,75.748055'),
(1760,	'Seloo',	'MH',	'20.834999,78.709167'),
(1761,	'Jasra',	'UP',	'25.281691,81.776649'),
(1762,	'Bhachau',	'GJ',	'23.293039,70.339043'),
(1763,	'Vontimitta',	'APN',	'14.394819,79.026367'),
(1764,	'Pirangut',	'MH',	'18.511477,73.680107'),
(1765,	'Thirunageswaram',	'TN',	'10.965292,79.428749'),
(1766,	'Nirtoo',	'CT',	'22.160702,82.111511'),
(1767,	'Belmundi',	'CT',	'22.049376,82.059097'),
(1768,	'Mandapakala',	'APN',	'15.980925,80.998161'),
(1769,	'Dindori',	'MP',	'22.941793,81.076843'),
(1770,	'Kongadai',	'TN',	'11.699917,77.461594'),
(1771,	'Kovur',	'APN',	'14.501208,79.988129'),
(1772,	'Gunderdehi',	'CT',	'20.946711,81.291512'),
(1773,	'Jangaon',	'TS',	'17.721872,79.172287'),
(1774,	'Singaram',	'TS',	'17.892527,79.58844'),
(1775,	'Charai',	'MH',	'19.198542,72.974846'),
(1776,	'Perumalpattu',	'TN',	'13.096199,79.985275'),
(1777,	'Kulithalai',	'TN',	'10.937347,78.421188'),
(1778,	'Niphan',	'MH',	'18.800913,73.298653'),
(1779,	'Neemrana',	'RJ',	'27.98889,76.388336'),
(1780,	'Kaikaluru',	'APN',	'16.552723,81.212936'),
(1781,	'Narmetta',	'TS',	'17.88611,79.16111'),
(1782,	'Panamanna',	'KL',	'10.807178,76.349258'),
(1783,	'Perambalur',	'TN',	'11.23,78.879997'),
(1784,	'Mominpet',	'TS',	'17.51639,77.898056'),
(1785,	'Sadashivpet',	'TS',	'17.616699,77.949997'),
(1786,	'Phulera',	'RJ',	'26.870001,75.230003'),
(1787,	'Nathdwara',	'RJ',	'24.92914,73.82132'),
(1788,	'Kajupada',	'MH',	'19.089664,72.886375'),
(1789,	'Sindri',	'JH',	'22.80658,85.993019'),
(1790,	'Paravadi',	'GJ',	'21.570572,71.630127'),
(1791,	'Gariyadhar',	'GJ',	'21.540594,71.571121'),
(1792,	'Kilmuttukur',	'TN',	'13.00272,79.002342'),
(1793,	'Thirukoilure',	'TN',	'11.968712,79.208664'),
(1794,	'Mannur',	'KL',	'10.803616,76.469254'),
(1795,	'Sethupet',	'PY',	'12.844775,79.899612'),
(1796,	'Gyanpur',	'UP',	'25.343454,82.477982'),
(1797,	'Bansi',	'UP',	'24.861198,78.479454'),
(1798,	'Hooghly',	'WB',	'22.9,88.389999'),
(1799,	'Indora',	'HP',	'32.134632,75.689171'),
(1800,	'Nuzividu',	'APN',	'16.780001,80.849998'),
(1801,	'Lormi',	'CT',	'22.275379,81.701759'),
(1802,	'Bhadal',	'MH',	'22.003302,74.434975'),
(1803,	'Bajaura',	'HP',	'31.848402,77.164337'),
(1804,	'Powayan',	'UP',	'28.066668,80.099998'),
(1805,	'Chapar',	'AS',	'26.274075,90.443161'),
(1806,	'Jaykaypur',	'OR',	'19.250996,83.413651'),
(1807,	'Bhor',	'MH',	'18.145821,73.842987'),
(1808,	'Sultanpur Lodhi',	'PB',	'31.213179,75.198502'),
(1809,	'Sarsehri',	'HR',	'30.346159,76.881187'),
(1810,	'Mau Ranipur',	'UP',	'25.243217,79.137917'),
(1811,	'Parasurampura',	'KA',	'14.259382,76.882187'),
(1812,	'Tala',	'MH',	'18.439386,73.132011'),
(1813,	'Kudligi',	'KA',	'14.905008,76.383987'),
(1814,	'Kotturu',	'KA',	'14.817,76.217003'),
(1815,	'Tharike',	'PB',	'30.877619,75.774223'),
(1816,	'Garhbeta',	'WB',	'22.860001,87.360001'),
(1817,	'Wankaner',	'GJ',	'22.623518,70.96962'),
(1818,	'Ojhar',	'MH',	'20.09194,73.931915'),
(1819,	'Kanker',	'CT',	'20.27,81.489998'),
(1820,	'Kondagaon',	'CT',	'19.6,81.669998'),
(1821,	'Simga',	'CT',	'21.629999,81.699997'),
(1822,	'Dantewada',	'CT',	'18.900764,81.345177'),
(1823,	'Geedam',	'CT',	'18.973896,81.399094'),
(1824,	'Takhatpur',	'CT',	'22.137691,81.86982'),
(1825,	'Koonimedu',	'TN',	'12.085485,79.892403'),
(1826,	'Gulothi',	'UP',	'28.593189,77.792557'),
(1827,	'Khedbrahma',	'GJ',	'24.028334,73.041389'),
(1828,	'Lunawada',	'GJ',	'23.133257,73.616074'),
(1829,	'Edneer',	'KL',	'12.523333,75.073891'),
(1830,	'Uran',	'MH',	'18.877235,72.928337'),
(1831,	'Nabapally',	'WB',	'22.727411,88.46666'),
(1832,	'Meenambakkam',	'TN',	'12.988166,80.176506'),
(1833,	'Vilathikulam',	'TN',	'9.131585,78.164581'),
(1834,	'Deulgaon Raja',	'MH',	'20.016666,76.033333'),
(1835,	'Kushalnagar',	'KA',	'12.467,75.967003'),
(1836,	'Jogiabari',	'UP',	'27.343966,83.369591'),
(1837,	'Gadra Road',	'RJ',	'25.743795,70.641296'),
(1838,	'Sullurupeta',	'APN',	'13.70215,80.018074'),
(1839,	'Hindoli',	'RJ',	'25.574915,75.501465'),
(1840,	'Nogama',	'RJ',	'25.013222,73.903648'),
(1841,	'Sonwada',	'GJ',	'20.695265,72.976173'),
(1842,	'Tarbhon',	'GJ',	'21.020115,73.059715'),
(1843,	'Astgam',	'GJ',	'20.901695,73.030197'),
(1844,	'Abrama',	'GJ',	'20.597246,72.943108'),
(1845,	'Boriyach',	'GJ',	'20.882872,73.050499'),
(1846,	'Gandevi',	'GJ',	'20.807676,72.999199'),
(1847,	'Dhamdachha',	'GJ',	'20.821787,72.974846'),
(1848,	'Kachholi',	'GJ',	'20.839472,72.976028'),
(1849,	'Salekasa',	'MH',	'21.307926,80.486526'),
(1850,	'Lalru',	'PB',	'30.49365,76.800613'),
(1851,	'Ambasamudram',	'TN',	'8.7,77.470001'),
(1852,	'Keonjhar',	'OR',	'21.628933,85.581688'),
(1853,	'Peth Vadgaon',	'MH',	'16.837532,74.314018'),
(1854,	'Dattawadi',	'MH',	'21.15864,78.988091'),
(1855,	'Amer',	'RJ',	'26.996471,75.876472'),
(1856,	'Tarabganj',	'UP',	'26.947475,81.994057'),
(1857,	'Koregaon',	'MH',	'17.696634,74.160721'),
(1858,	'Ruksin',	'AR',	'27.845148,95.247345'),
(1859,	'Barang',	'OR',	'20.394987,85.853745'),
(1860,	'Hupari',	'MH',	'16.619398,74.400925'),
(1861,	'Hirehal',	'KA',	'15.798352,75.763313'),
(1862,	'Ayyur',	'TN',	'10.072212,78.080879'),
(1863,	'Pipili',	'OR',	'20.120001,85.830002'),
(1864,	'Kodumur',	'APN',	'15.686007,77.770958'),
(1865,	'Champawat',	'UT',	'29.336098,80.091026'),
(1866,	'Chikka Tirupathi',	'KA',	'12.896745,77.866745'),
(1867,	'Olarikkara',	'KL',	'10.525576,76.171127'),
(1868,	'Arimbur',	'KL',	'10.487563,76.149391'),
(1869,	'Belapur',	'MH',	'19.574869,74.645897'),
(1870,	'Telsang',	'KA',	'16.790951,75.338303'),
(1871,	'Punnainallur',	'TN',	'10.783909,79.201408'),
(1872,	'Kichha',	'UT',	'28.92,79.5'),
(1873,	'Vallioor',	'TN',	'8.385437,77.607224'),
(1874,	'Ghatkopar East',	'MH',	'19.078505,72.907166'),
(1875,	'Khirkiya',	'MP',	'22.166668,76.861664'),
(1876,	'Hadgaon',	'MH',	'19.5,77.669998'),
(1877,	'Purana Bazar',	'NL',	'25.913431,93.749596'),
(1878,	'Hadapsar',	'MH',	'18.496668,73.941666'),
(1879,	'Kakandi',	'MH',	'19.070814,77.369049'),
(1880,	'Rahuri',	'MH',	'19.392677,74.648827'),
(1881,	'Dharur',	'MH',	'18.819164,76.109657'),
(1882,	'Mulund East',	'MH',	'19.175547,72.972099'),
(1883,	'Harsh Hagar',	'MH',	'19.164721,77.32383'),
(1884,	'Lakhala',	'MH',	'20.107927,77.116875'),
(1885,	'Nagaram',	'APN',	'16.002256,80.717926'),
(1886,	'Bagayam',	'TN',	'12.871807,79.126633'),
(1887,	'Ramban',	'JK',	'33.242134,75.233688'),
(1888,	'Kada',	'MH',	'18.896109,75.081558'),
(1889,	'Mahabaleshwar',	'MH',	'17.921721,73.655602'),
(1890,	'Mirpur',	'WB',	'22.709332,88.311783'),
(1891,	'Ekangar Sarai',	'BH',	'25.216667,85.23333'),
(1892,	'Rangpar',	'GJ',	'22.915964,70.901176'),
(1893,	'Anuppur',	'MP',	'23.113655,81.697632'),
(1894,	'Gulabpura',	'RJ',	'25.9063,74.657997'),
(1895,	'Machalgaon',	'MP',	'21.920547,75.750961'),
(1896,	'Mathurawala',	'RJ',	'26.740929,75.875183'),
(1897,	'Jwalapur',	'UT',	'29.927059,78.107979'),
(1898,	'Jagatpura',	'RJ',	'26.835251,75.824341'),
(1899,	'Uttar Mohammadpur',	'WB',	'24.644688,87.976357'),
(1900,	'Kharora',	'CT',	'21.405842,81.926201'),
(1901,	'Hiwara',	'MH',	'21.491049,80.160072'),
(1902,	'Yelburga',	'KA',	'15.614151,76.013077'),
(1903,	'Duggirala',	'APN',	'16.327999,80.624298'),
(1904,	'Nebua Naurangia',	'UP',	'27.039949,83.896332'),
(1905,	'Ambivali',	'MH',	'18.849728,73.231194'),
(1906,	'Malad West',	'MH',	'19.182755,72.840157'),
(1907,	'Bhankrota',	'RJ',	'26.871458,75.695869'),
(1908,	'Nerul',	'GA',	'15.504928,73.791908'),
(1909,	'Warvandi',	'MH',	'20.078505,73.829842'),
(1910,	'Morinda',	'PB',	'30.804373,76.497116'),
(1911,	'Sattur',	'TN',	'9.36442,77.911034'),
(1912,	'Ashiana',	'UP',	'26.784594,80.918007'),
(1913,	'Howly',	'AS',	'26.42322,90.980072'),
(1914,	'Heerawala',	'RJ',	'26.889006,75.732536'),
(1915,	'Jhotwara',	'RJ',	'26.958302,75.743347'),
(1916,	'Nahur',	'MH',	'19.154659,72.946655'),
(1917,	'Surnana',	'RJ',	'28.448343,73.697769'),
(1918,	'Mahlan',	'PB',	'30.154301,75.896965'),
(1919,	'Odhav',	'GJ',	'23.021582,72.668335'),
(1920,	'Mogra Khurd',	'RJ',	'26.142004,73.052338'),
(1921,	'Kherado',	'RJ',	'27.542675,76.649033'),
(1922,	'Alibag',	'MH',	'18.656654,72.879868'),
(1923,	'Bandala',	'PB',	'31.533333,74.98333'),
(1924,	'Manihari',	'BH',	'25.346062,87.622681'),
(1925,	'Kolluru',	'APN',	'16.184816,80.796249'),
(1926,	'Chhauchh',	'UP',	'27.933754,80.75621'),
(1927,	'Shivajinagar',	'MH',	'20.11784,79.029121'),
(1928,	'Kalwara',	'RJ',	'26.801395,75.629539'),
(1929,	'Tingachiya',	'BH',	'25.527443,87.57666'),
(1930,	'Kadwa',	'BH',	'25.537802,87.571083'),
(1931,	'Sunkadakatte',	'KA',	'12.98773,77.503304'),
(1932,	'Jamb',	'MH',	'20.618647,78.923721'),
(1933,	'Velur',	'TN',	'11.112119,78.004448'),
(1934,	'Pandaul',	'BH',	'26.256634,86.083565'),
(1935,	'Hukkeri',	'KA',	'16.23,74.599998'),
(1936,	'Talera',	'RJ',	'25.314676,75.735832'),
(1937,	'Kerakat',	'UP',	'25.637812,82.911415'),
(1938,	'Alirajpur',	'MP',	'22.3053,74.352501'),
(1939,	'Sarwadi',	'MH',	'21.149836,78.281364'),
(1940,	'Vazhapadi',	'TN',	'11.656012,78.404129'),
(1941,	'Surmi',	'HR',	'30.010485,76.67881'),
(1942,	'Khalghat',	'MP',	'22.157339,75.446053'),
(1943,	'Adada',	'GJ',	'20.905323,72.966728'),
(1944,	'Bhanpuri',	'CT',	'21.162003,80.890617'),
(1945,	'Baijnath',	'HP',	'32.052109,76.649284'),
(1946,	'Paipad',	'KL',	'9.426032,76.584579'),
(1947,	'Ombare',	'MH',	'17.874842,75.186638'),
(1948,	'Dhamane',	'KA',	'15.797209,74.545502'),
(1949,	'Pargaon',	'MH',	'18.559761,74.373405'),
(1950,	'Kambarasampettai',	'TN',	'10.857652,78.665405'),
(1951,	'Khairagarh',	'CT',	'21.421173,80.975761'),
(1952,	'Mauda',	'MH',	'21.149345,79.400337'),
(1953,	'Shirur',	'MH',	'18.825888,74.379272'),
(1954,	'Tamia',	'MP',	'22.346266,78.666916'),
(1955,	'Parasia',	'MP',	'22.196306,78.754807'),
(1956,	'Shakti Nagar',	'UP',	'26.880123,80.96804'),
(1957,	'Naidupeta',	'APN',	'13.909954,79.894081'),
(1958,	'Sunel',	'RJ',	'24.371576,75.958229'),
(1959,	'Lawspet',	'PY',	'11.953014,79.809669'),
(1960,	'Manglia',	'MP',	'22.814795,75.935097'),
(1961,	'Mundra',	'GJ',	'22.83952,69.721329'),
(1962,	'Sarthebari',	'AS',	'26.374645,91.228065'),
(1963,	'Jamkhed',	'MH',	'18.73801,75.312065'),
(1964,	'Modavalasa',	'APN',	'17.994177,83.417656'),
(1965,	'Diwon',	'ME',	'25.960135,92.019363'),
(1966,	'Umsning',	'ME',	'25.752899,91.894455'),
(1967,	'Nongpoh',	'ME',	'25.9,91.883301'),
(1968,	'Karamadai',	'TN',	'11.238106,76.961426'),
(1969,	'Kavindapadi',	'TN',	'11.427423,77.558159'),
(1970,	'Dahisara',	'GJ',	'23.092918,69.517754'),
(1971,	'Malab',	'HR',	'28.038652,77.011581'),
(1972,	'Anad',	'KL',	'8.633505,77.011093'),
(1973,	'Maharajganj',	'UP',	'27.144604,83.562172'),
(1974,	'Kunariya',	'GJ',	'23.404024,69.711685'),
(1975,	'Madikeri',	'KA',	'12.427189,75.747643'),
(1976,	'Siwani',	'HR',	'28.909611,75.607224'),
(1977,	'Epuru',	'TS',	'17.200855,78.988914'),
(1978,	'Sri Vijaynagar',	'RJ',	'29.241426,73.517815'),
(1979,	'Manapparai',	'TN',	'10.622817,78.447189'),
(1980,	'Belonia',	'TR',	'23.248976,91.463005'),
(1981,	'Nagrota',	'JK',	'32.786697,74.896889'),
(1982,	'Parakkai',	'TN',	'8.136897,77.452156'),
(1983,	'Raja Sansi',	'PB',	'31.724501,74.786003'),
(1984,	'Omalur',	'TN',	'11.743666,78.047585'),
(1985,	'Cumbum',	'TN',	'9.734426,77.280739'),
(1986,	'Bherunda',	'RJ',	'26.648897,74.415924'),
(1987,	'Kalayanthani',	'KL',	'9.87224,76.784142'),
(1988,	'Tarkeshwar',	'GJ',	'21.37031,73.055283'),
(1989,	'Chandwad',	'MH',	'20.327127,74.247276'),
(1990,	'Neamatpur',	'WB',	'23.717089,86.879738'),
(1991,	'Dighi',	'MH',	'18.612291,73.87719'),
(1992,	'Ner Chowk',	'HP',	'31.608522,76.915329'),
(1993,	'Samaguri',	'AS',	'26.416374,92.841507'),
(1994,	'Kalayarkoil',	'TN',	'9.847098,78.644943'),
(1995,	'Kundam',	'MP',	'23.223679,80.357437'),
(1996,	'Pala',	'KL',	'9.70838,76.684914'),
(1997,	'Tankara',	'GJ',	'22.655312,70.74807'),
(1998,	'Sivaganga',	'TN',	'9.8667,78.483299'),
(1999,	'Salawas',	'RJ',	'26.116667,72.98333'),
(2000,	'Rau',	'MP',	'22.636383,75.810692'),
(2001,	'Badagaon',	'MP',	'24.560053,79.007996'),
(2002,	'Alamathi',	'TN',	'13.213877,80.095306'),
(2003,	'Annur',	'TN',	'11.232017,77.106804'),
(2004,	'Mohra',	'HR',	'30.271942,76.851913'),
(2005,	'Belaganj',	'BH',	'24.9695,84.972191'),
(2006,	'Samudrapur',	'MH',	'20.638462,78.961349'),
(2007,	'Uttar Kamakhyaguri',	'WB',	'26.481636,89.732895'),
(2008,	'Chhawla',	'DL',	'28.562109,77.002304'),
(2009,	'Lalgudi',	'TN',	'10.879162,78.812485'),
(2010,	'Mall Colony',	'His',	'29.124165,75.724068'),
(2011,	'Sahdev Nagar',	'CT',	'21.091387,81.032326'),
(2012,	'Ashiyana',	'UP',	'26.799559,80.917397'),
(2013,	'Chowk',	'UP',	'26.863905,80.902802'),
(2014,	'Digod',	'RJ',	'25.21722,76.079803'),
(2015,	'Majhauli',	'MP',	'23.839369,81.018845'),
(2016,	'Talwara',	'PB',	'31.931129,75.894058'),
(2017,	'Hamirpur',	'HP',	'31.690783,76.517715'),
(2018,	'Vadalur',	'TN',	'11.560762,79.556976'),
(2019,	'Vasudevanallur',	'TN',	'9.241568,77.411812'),
(2020,	'Lehragaga',	'PB',	'29.940655,75.817337'),
(2021,	'Jagaddal',	'WB',	'22.858776,88.40612'),
(2022,	'Chandbali',	'OR',	'20.772806,86.748734'),
(2023,	'Veppampattu',	'TN',	'13.123146,80.003181'),
(2024,	'Reasi',	'JK',	'33.082806,74.833313'),
(2025,	'Nambiyur',	'TN',	'11.359291,77.318085'),
(2026,	'Akhnoor',	'JK',	'32.896957,74.735489'),
(2027,	'Uppal',	'APN',	'17.40181,78.560188'),
(2028,	'Udayamperoor',	'KL',	'9.900539,76.367851'),
(2029,	'Raman Mala',	'MH',	'16.721455,74.231575'),
(2030,	'Rajgarh',	'RJ',	'28.664082,75.38063'),
(2031,	'Ettaiyapuram',	'TN',	'9.14413,78.00087'),
(2032,	'Nagar',	'RJ',	'26.463915,75.20269'),
(2033,	'Vataman',	'GJ',	'22.52807,72.415459'),
(2034,	'Barrackpur Cantonment',	'WB',	'22.760195,88.371101'),
(2035,	'Raghunatpur',	'BH',	'25.65778,87.708206'),
(2036,	'Biloli',	'MH',	'18.773228,77.725609'),
(2037,	'Yeola',	'MH',	'20.04948,74.486618'),
(2038,	'Uniara',	'RJ',	'25.915607,76.026749'),
(2039,	'Indira Nagar',	'KA',	'12.971891,77.641151'),
(2040,	'Degana',	'RJ',	'26.891455,74.32457'),
(2041,	'Gozaria',	'GJ',	'23.479198,72.56485'),
(2042,	'Kabbur',	'KA',	'16.348751,74.726395'),
(2043,	'Thopramkudy',	'KL',	'9.881454,77.053566'),
(2044,	'Mohol',	'MH',	'17.807533,75.64241'),
(2045,	'Ahmadpur',	'MH',	'18.706741,76.934166'),
(2046,	'Sarangpur',	'MP',	'23.57028,76.476173'),
(2047,	'Bijeypur',	'MP',	'26.053829,77.369049'),
(2048,	'Aron',	'MP',	'24.381914,77.417145'),
(2049,	'Khodad',	'MH',	'19.082964,74.047638'),
(2050,	'Uruli Kanchan',	'MH',	'18.491005,74.134544'),
(2051,	'Trimbak',	'MH',	'19.939142,73.536819'),
(2052,	'Kurkumbh',	'MH',	'18.397533,74.52095'),
(2053,	'Kikvi',	'MH',	'18.201061,73.944275'),
(2054,	'Jejuri',	'MH',	'18.269781,74.172478'),
(2055,	'Theur',	'MH',	'18.525841,74.053001'),
(2056,	'Ambegaon',	'MH',	'19.112316,73.730133'),
(2057,	'Gargoti',	'MH',	'16.318493,74.139343'),
(2058,	'Dive',	'MH',	'18.385389,74.024681'),
(2059,	'Neknoor',	'MH',	'18.808493,75.781464'),
(2060,	'Kuppam',	'APN',	'12.748186,78.346085'),
(2061,	'Nangal',	'PB',	'31.385296,76.374893'),
(2062,	'Behat',	'UP',	'30.177185,77.620468'),
(2063,	'Chilkana Sultanpur',	'UP',	'30.080978,77.511978'),
(2064,	'Jalkot',	'MH',	'18.62933,77.180244'),
(2065,	'Zamania',	'UP',	'25.420465,83.557487'),
(2066,	'Anchuthengu',	'KL',	'8.675045,76.758644'),
(2067,	'Jaikhera',	'MH',	'20.794874,74.21003'),
(2068,	'Tadepalli',	'APN',	'16.481112,80.617958'),
(2069,	'Arachalur',	'TN',	'11.173687,77.698059'),
(2070,	'Sidhauli',	'UP',	'27.285755,80.837402'),
(2071,	'Prabhadevi',	'MH',	'19.015831,72.829391'),
(2072,	'Argari',	'WB',	'22.587601,88.226173'),
(2073,	'Andul',	'WB',	'22.582029,88.239029'),
(2074,	'Augustmuni',	'UT',	'30.246639,78.924568'),
(2075,	'New Tehri',	'UT',	'30.376251,78.435379'),
(2076,	'Bethuadahari',	'WB',	'23.611435,88.383362'),
(2077,	'Shankarpur',	'BH',	'26.029854,86.869858'),
(2078,	'Sahaspur',	'UT',	'30.391933,77.808746'),
(2079,	'Kaluahi',	'BH',	'26.465471,86.065384'),
(2080,	'Lunavada',	'GJ',	'23.1271,73.617149'),
(2081,	'Pulwama',	'JK',	'33.871841,74.899376'),
(2082,	'Kumbalgodu',	'KA',	'12.879166,77.446449'),
(2083,	'Asalfa',	'MH',	'19.102999,72.894203'),
(2084,	'Tarapur',	'BH',	'25.095316,86.66494'),
(2085,	'Baudpur',	'OR',	'21.064798,86.480728'),
(2086,	'Aundh',	'MH',	'18.562622,73.808723'),
(2087,	'Khushal Garh',	'UP',	'25.761093,82.071259'),
(2088,	'Balitikuri',	'WB',	'22.606722,88.303169'),
(2089,	'Partur',	'MH',	'19.59893,76.215424'),
(2090,	'Kollur',	'KA',	'13.866247,74.812988'),
(2091,	'Thiruvegappura',	'KL',	'10.873009,76.123863'),
(2092,	'Vikhroli East',	'MH',	'19.10465,72.931786'),
(2093,	'Dhanura',	'KA',	'17.963131,77.330948'),
(2094,	'Domjur',	'WB',	'22.638571,88.220474'),
(2095,	'Nibra',	'WB',	'22.600521,88.269539'),
(2096,	'Sohagpur',	'MP',	'22.700979,78.197548'),
(2097,	'Janakpuri',	'DL',	'28.61957,77.088104'),
(2098,	'Okha',	'GJ',	'22.468702,69.069824'),
(2099,	'Kammarpally',	'APN',	'18.836531,78.51165'),
(2100,	'Alibaugh',	'MH',	'18.651125,72.868279'),
(2101,	'Jobat',	'MP',	'22.4167,74.566704'),
(2102,	'Urmar Tanda',	'PB',	'31.678074,75.638641'),
(2103,	'Port Blair',	'AN',	'11.670000,92.760000'),
(2104,	'Adilabad',	'APN',	'19.680000,78.530000'),
(2105,	'Adoni',	'APN',	'15.630000,77.280000'),
(2106,	'Alwal',	'APN',	'17.500000,78.540000'),
(2107,	'Anakapalle',	'APN',	'17.690000,83.000000'),
(2108,	'Anantapur',	'APN',	'14.700000,77.590000'),
(2109,	'Bapatla',	'APN',	'15.910000,80.470000'),
(2110,	'Belampalli',	'APN',	'19.060000,79.490000'),
(2111,	'Bhimavaram',	'APN',	'16.550000,81.530000'),
(2112,	'Bhongir',	'APN',	'17.520000,78.880000'),
(2113,	'Bobbili',	'APN',	'18.570000,83.370000'),
(2114,	'Bodhan',	'APN',	'18.660000,77.880000'),
(2115,	'Chilakalurupet',	'APN',	'16.100000,80.160000'),
(2116,	'Chinna Chawk',	'APN',	'14.470000,78.830000'),
(2117,	'Chirala',	'APN',	'15.840000,80.350000'),
(2118,	'Chittur',	'APN',	'13.220000,79.100000'),
(2119,	'Cuddapah',	'APN',	'14.480000,78.810000'),
(2120,	'Dharmavaram',	'APN',	'14.420000,77.710000'),
(2121,	'Dhone',	'APN',	'15.420000,77.880000'),
(2122,	'Eluru',	'APN',	'16.720000,81.110000'),
(2123,	'Gaddiannaram',	'APN',	'17.360000,78.520000'),
(2124,	'Gadwal',	'APN',	'16.230000,77.800000'),
(2125,	'Gajuwaka',	'APN',	'17.700000,83.210000'),
(2126,	'Gudivada',	'APN',	'16.440000,81.000000'),
(2127,	'Gudur',	'APN',	'14.150000,79.840000'),
(2128,	'Guntakal',	'APN',	'15.180000,77.370000'),
(2129,	'Guntur',	'APN',	'16.310000,80.440000'),
(2130,	'Hindupur',	'APN',	'13.830000,77.480000'),
(2131,	'Hyderabad',	'TS',	'17.400000,78.480000'),
(2132,	'Jagtial',	'APN',	'18.800000,78.910000'),
(2133,	'Kadiri',	'APN',	'14.120000,78.160000'),
(2134,	'Kagaznagar',	'APN',	'19.340000,79.480000'),
(2135,	'Kakinada',	'APN',	'16.960000,82.240000'),
(2136,	'Kallur',	'APN',	'15.690000,77.770000'),
(2137,	'Kamareddi',	'APN',	'18.320000,78.350000'),
(2138,	'Kapra',	'APN',	'17.370000,78.480000'),
(2139,	'Karimnagar',	'APN',	'18.450000,79.130000'),
(2140,	'Karnul',	'APN',	'15.830000,78.030000'),
(2141,	'Kavali',	'APN',	'14.920000,79.990000'),
(2142,	'Khammam',	'APN',	'17.250000,80.150000'),
(2143,	'Kodar',	'APN',	'16.980000,79.970000'),
(2144,	'Kondukur',	'APN',	'15.220000,79.910000'),
(2145,	'Koratla',	'APN',	'18.820000,78.720000'),
(2146,	'Kottagudem',	'APN',	'17.560000,80.640000'),
(2147,	'Kukatpalle',	'APN',	'17.490000,78.410000'),
(2148,	'Lalbahadur Nagar',	'APN',	'17.430000,78.500000'),
(2149,	'Machilipatnam',	'APN',	'16.190000,81.140000'),
(2150,	'Mahbubnagar',	'APN',	'16.740000,77.980000'),
(2151,	'Malkajgiri',	'APN',	'17.550000,78.590000'),
(2152,	'Mancheral',	'APN',	'18.880000,79.450000'),
(2153,	'Mandamarri',	'APN',	'18.970000,79.470000'),
(2154,	'Mangalagiri',	'APN',	'16.440000,80.560000'),
(2155,	'Markapur',	'APN',	'15.730000,79.280000'),
(2156,	'Miryalaguda',	'APN',	'16.870000,79.570000'),
(2157,	'Nalgonda',	'APN',	'17.060000,79.260000'),
(2158,	'Nandyal',	'APN',	'15.490000,78.480000'),
(2159,	'Narasapur',	'APN',	'16.450000,81.700000'),
(2160,	'Narasaraopet',	'APN',	'16.240000,80.040000'),
(2161,	'Nellur',	'APN',	'14.460000,79.980000'),
(2162,	'Nirmal',	'APN',	'19.120000,78.350000'),
(2163,	'Nizamabad',	'APN',	'18.680000,78.100000'),
(2164,	'Nuzvid',	'APN',	'16.780000,80.850000'),
(2165,	'Ongole',	'APN',	'15.500000,80.050000'),
(2166,	'Palakollu',	'APN',	'16.520000,81.750000'),
(2167,	'Palasa',	'APN',	'18.770000,84.420000'),
(2168,	'Palwancha',	'APN',	'17.600000,80.680000'),
(2169,	'Patancheru',	'APN',	'17.530000,78.270000'),
(2170,	'Piduguralla',	'APN',	'16.480000,79.900000'),
(2171,	'Ponnur',	'APN',	'16.070000,80.560000'),
(2172,	'Proddatur',	'APN',	'14.730000,78.550000'),
(2173,	'Qutubullapur',	'APN',	'17.430000,78.470000'),
(2174,	'Rajamahendri',	'APN',	'17.020000,81.790000'),
(2175,	'Rajampet',	'APN',	'14.180000,79.170000'),
(2176,	'Rajendranagar',	'APN',	'17.290000,78.390000'),
(2177,	'Ramachandrapuram',	'APN',	'17.560000,78.040000'),
(2178,	'Ramagundam',	'APN',	'18.800000,79.450000'),
(2179,	'Rayachoti',	'APN',	'14.050000,78.750000'),
(2180,	'Rayadrug',	'APN',	'14.700000,76.870000'),
(2181,	'Samalkot',	'APN',	'17.060000,82.180000'),
(2182,	'Sangareddi',	'APN',	'17.630000,78.080000'),
(2183,	'Sattenapalle',	'APN',	'16.400000,80.180000'),
(2184,	'Serilungampalle',	'APN',	'17.480000,78.330000'),
(2185,	'Siddipet',	'APN',	'18.110000,78.840000'),
(2186,	'Sirsilla',	'APN',	'18.400000,78.810000'),
(2187,	'Srikakulam',	'APN',	'18.300000,83.900000'),
(2188,	'Srikalahasti',	'APN',	'13.760000,79.700000'),
(2189,	'Suriapet',	'APN',	'17.150000,79.620000'),
(2190,	'Tadepalle',	'APN',	'16.480000,80.600000'),
(2191,	'Tadepallegudem',	'APN',	'16.820000,81.520000'),
(2192,	'Tadpatri',	'APN',	'14.910000,78.000000'),
(2193,	'Tandur',	'APN',	'17.250000,77.580000'),
(2194,	'Tanuku',	'APN',	'16.750000,81.690000'),
(2195,	'Tenali',	'APN',	'16.240000,80.650000'),
(2196,	'Tirupati',	'APN',	'13.630000,79.410000'),
(2197,	'Tuni',	'APN',	'17.350000,82.550000'),
(2198,	'Uppal Kalan',	'APN',	'17.380000,78.550000'),
(2199,	'Vijayawada',	'APN',	'16.520000,80.630000'),
(2200,	'Vinukonda',	'APN',	'16.050000,79.750000'),
(2201,	'Visakhapatnam',	'APN',	'17.730000,83.300000'),
(2202,	'Vizianagaram',	'APN',	'18.120000,83.400000'),
(2203,	'Vuyyuru',	'APN',	'16.370000,80.850000'),
(2204,	'Wanparti',	'APN',	'16.370000,78.070000'),
(2205,	'Warangal',	'APN',	'18.010000,79.580000'),
(2206,	'Yemmiganur',	'APN',	'15.730000,77.480000'),
(2207,	'Itanagar',	'AR',	'27.140000,93.610000'),
(2208,	'Barpeta',	'AS',	'26.320000,91.000000'),
(2209,	'Bongaigaon',	'AS',	'26.480000,90.540000'),
(2210,	'Dhuburi',	'AS',	'26.030000,89.970000'),
(2211,	'Dibrugarh',	'AS',	'27.490000,94.910000'),
(2212,	'Diphu',	'AS',	'25.840000,93.430000'),
(2213,	'Guwahati',	'AS',	'26.190000,91.750000'),
(2214,	'Jorhat',	'AS',	'26.760000,94.200000'),
(2215,	'Karimganj',	'AS',	'24.850000,92.360000'),
(2216,	'Lanka',	'AS',	'25.930000,92.950000'),
(2217,	'Nagaon',	'AS',	'26.350000,92.680000'),
(2218,	'Sibsagar',	'AS',	'26.990000,94.630000'),
(2219,	'Silchar',	'AS',	'24.830000,92.770000'),
(2220,	'Tezpur',	'AS',	'26.630000,92.790000'),
(2221,	'Tinsukia',	'AS',	'27.500000,95.360000'),
(2222,	'Alipur Duar',	'WB',	'26.500000,89.530000'),
(2223,	'Arambagh',	'WB',	'22.880000,87.780000'),
(2224,	'Asansol',	'WB',	'23.690000,86.980000'),
(2225,	'Ashoknagar Kalyangarh',	'WB',	'22.840000,88.630000'),
(2226,	'Baharampur',	'WB',	'24.100000,88.240000'),
(2227,	'Baidyabati',	'WB',	'22.790000,88.330000'),
(2228,	'Baj Baj',	'WB',	'22.480000,88.170000'),
(2229,	'Bally',	'WB',	'22.650000,88.350000'),
(2230,	'Bally Cantonment',	'WB',	'22.650000,88.360000'),
(2231,	'Balurghat',	'WB',	'25.230000,88.770000'),
(2232,	'Bangaon',	'WB',	'23.050000,88.830000'),
(2233,	'Bankra',	'WB',	'22.580000,88.310000'),
(2234,	'Bankura',	'WB',	'23.240000,87.070000'),
(2235,	'Bansbaria',	'WB',	'22.950000,88.400000'),
(2236,	'Baranagar',	'WB',	'22.640000,88.370000'),
(2237,	'Barddhaman',	'WB',	'23.240000,87.860000'),
(2238,	'Basirhat',	'WB',	'22.660000,88.860000'),
(2239,	'Bhadreswar',	'WB',	'22.840000,88.350000'),
(2240,	'Bhatpara',	'WB',	'22.890000,88.420000'),
(2241,	'Bidhannagar',	'WB',	'22.570000,88.420000'),
(2242,	'Binnaguri',	'WB',	'26.740000,89.0370000'),
(2243,	'Bishnupur',	'WB',	'23.080000,87.330000'),
(2244,	'Bolpur',	'WB',	'23.670000,87.700000'),
(2245,	'Calcutta',	'WB',	'22.570000,88.360000'),
(2246,	'Chakdaha',	'WB',	'22.480000,88.350000'),
(2247,	'Champdani',	'WB',	'22.810000,88.340000'),
(2248,	'Chandannagar',	'WB',	'22.890000,88.370000'),
(2249,	'Contai',	'WB',	'21.790000,87.750000'),
(2250,	'Dabgram',	'WB',	'26.695900,88.443800'),
(2251,	'Darjiling',	'WB',	'27.050000,88.260000'),
(2252,	'Dhulian',	'WB',	'24.680000,87.970000'),
(2253,	'Dinhata',	'WB',	'26.130000,89.470000'),
(2254,	'Dum Dum',	'WB',	'22.630000,88.420000'),
(2255,	'Durgapur',	'WB',	'23.500000,87.310000'),
(2256,	'Gangarampur',	'WB',	'25.400000,88.520000'),
(2257,	'Garulia',	'WB',	'22.830000,88.370000'),
(2258,	'Gayespur',	'WB',	'22.980000,88.510000'),
(2259,	'Ghatal',	'WB',	'22.670000,87.720000'),
(2260,	'Gopalpur',	'WB',	'19.264700,84.862000'),
(2261,	'Habra',	'WB',	'22.840000,88.620000'),
(2262,	'Halisahar',	'WB',	'22.950000,88.420000'),
(2263,	'Haora',	'WB',	'22.580000,88.330000'),
(2264,	'HugliChunchura',	'WB',	'22.910000,88.400000'),
(2265,	'Ingraj Bazar',	'WB',	'25.010000,88.140000'),
(2266,	'Islampur',	'WB',	'26.270000,88.200000'),
(2267,	'Jalpaiguri',	'WB',	'26.530000,88.710000'),
(2268,	'Jamuria',	'WB',	'23.700000,87.080000'),
(2269,	'Jangipur',	'WB',	'24.470000,88.070000'),
(2270,	'Jhargram',	'WB',	'22.450000,86.980000'),
(2271,	'Kaliyaganj',	'WB',	'25.630000,88.320000'),
(2272,	'Kalna',	'WB',	'23.220000,88.370000'),
(2273,	'Kalyani',	'WB',	'22.980000,88.480000'),
(2274,	'Kamarhati',	'WB',	'22.670000,88.370000'),
(2275,	'Kanchrapara',	'WB',	'22.950000,88.450000'),
(2276,	'Kandi',	'WB',	'23.950000,88.030000'),
(2277,	'Karsiyang',	'WB',	'26.880000,88.280000'),
(2278,	'Katwa',	'WB',	'23.650000,88.130000'),
(2279,	'Kharagpur',	'WB',	'22.340000,87.310000'),
(2280,	'Kharagpur Railway Settlement',	'WB',	'22.340000,87.260000'),
(2281,	'Khardaha',	'WB',	'22.730000,88.380000'),
(2282,	'Kharia',	'WB',	'29.132900,75.517500'),
(2283,	'Koch Bihar',	'WB',	'26.330000,89.460000'),
(2284,	'Konnagar',	'WB',	'22.700000,88.360000'),
(2285,	'Krishnanagar',	'WB',	'23.410000,88.510000'),
(2286,	'Kulti',	'WB',	'23.720000,86.890000'),
(2287,	'Madhyamgram',	'WB',	'22.700000,88.450000'),
(2288,	'Maheshtala',	'WB',	'22.510000,88.230000'),
(2289,	'Memari',	'WB',	'23.200000,88.120000'),
(2290,	'Midnapur',	'WB',	'22.330000,87.150000'),
(2291,	'Naihati',	'WB',	'22.910000,88.430000'),
(2292,	'Navadwip',	'WB',	'23.420000,88.370000'),
(2293,	'Ni Barakpur',	'WB',	'22.770000,88.360000'),
(2294,	'North Barakpur',	'WB',	'22.780000,88.370000'),
(2295,	'North Dum Dum',	'WB',	'22.640000,88.410000'),
(2296,	'Old Maldah',	'WB',	'25.055700,88.136500'),
(2297,	'Panihati',	'WB',	'22.690000,88.370000'),
(2298,	'Phulia',	'WB',	'23.240000,88.500000'),
(2299,	'Pujali',	'WB',	'22.470000,88.150000'),
(2300,	'Puruliya',	'WB',	'23.340000,86.360000'),
(2301,	'Raiganj',	'WB',	'25.620000,88.120000'),
(2302,	'Rajpur',	'WB',	'22.440000,88.440000'),
(2303,	'Rampur Hat',	'WB',	'24.170000,87.780000'),
(2304,	'Ranaghat',	'WB',	'23.190000,88.580000'),
(2305,	'Raniganj',	'WB',	'23.620000,87.110000'),
(2306,	'Rishra',	'WB',	'22.710000,88.360000'),
(2307,	'Shantipur',	'WB',	'23.260000,88.440000'),
(2308,	'Shiliguri',	'WB',	'26.730000,88.420000'),
(2309,	'Siuri',	'WB',	'23.910000,87.530000'),
(2310,	'South Dum Dum',	'WB',	'22.610000,88.410000'),
(2311,	'Titagarh',	'WB',	'22.740000,88.380000'),
(2312,	'Ulubaria',	'WB',	'22.470000,88.110000'),
(2313,	'UttarparaKotrung',	'WB',	'22.660000,88.350000'),
(2314,	'Araria',	'BH',	'26.150000,87.520000'),
(2315,	'Arrah',	'BH',	'25.560000,84.660000'),
(2316,	'Bagaha',	'BH',	'27.100000,84.090000'),
(2317,	'Begusarai',	'BH',	'25.420000,86.120000'),
(2318,	'Bettiah',	'BH',	'26.810000,84.500000'),
(2319,	'Bhabua',	'BH',	'25.050000,83.620000'),
(2320,	'Bhagalpur',	'BH',	'25.260000,86.980000'),
(2321,	'Bihar',	'BH',	'25.210000,85.520000'),
(2322,	'Buxar',	'BH',	'25.580000,83.980000'),
(2323,	'Chhapra',	'BH',	'25.780000,84.720000'),
(2324,	'Darbhanga',	'BH',	'26.160000,85.880000'),
(2325,	'Dehri',	'BH',	'24.910000,84.180000'),
(2326,	'DighaMainpura',	'BH',	'21.622200,87.506600'),
(2327,	'Dinapur',	'BH',	'25.640000,85.040000'),
(2328,	'Dumraon',	'BH',	'25.550000,84.150000'),
(2329,	'Gaya',	'BH',	'24.810000,85.000000'),
(2330,	'Gopalganj',	'BH',	'26.470000,84.430000'),
(2331,	'Goura',	'BH',	'22.517900,87.759100'),
(2332,	'Hajipur',	'BH',	'25.692400,85.208300'),
(2333,	'Jahanabad',	'BH',	'25.220000,84.980000'),
(2334,	'Jamalpur',	'BH',	'25.320000,86.480000'),
(2335,	'Jamui',	'BH',	'24.920000,86.220000'),
(2336,	'Katihar',	'BH',	'25.550000,87.570000'),
(2337,	'Khagaria',	'BH',	'25.500000,86.480000'),
(2338,	'Khagaul',	'BH',	'25.580000,85.050000'),
(2339,	'Kishanganj',	'BH',	'26.110000,87.950000'),
(2340,	'Lakhisarai',	'BH',	'25.180000,86.090000'),
(2341,	'Madhipura',	'BH',	'25.920000,86.780000'),
(2342,	'Madhubani',	'BH',	'26.370000,86.060000'),
(2343,	'Masaurhi',	'BH',	'25.350000,85.030000'),
(2344,	'Mokama',	'BH',	'25.400000,85.920000'),
(2345,	'Motihari',	'BH',	'26.660000,84.910000'),
(2346,	'Munger',	'BH',	'25.390000,86.470000'),
(2347,	'Muzaffarpur',	'BH',	'26.130000,85.380000'),
(2348,	'Nawada',	'BH',	'24.880000,85.540000'),
(2349,	'Patna',	'BH',	'25.620000,85.130000'),
(2350,	'Phulwari',	'BH',	'25.600000,85.130000'),
(2351,	'Purnia',	'BH',	'25.780000,87.470000'),
(2352,	'Raxaul',	'BH',	'26.980000,84.850000'),
(2353,	'Saharsa',	'BH',	'25.880000,86.590000'),
(2354,	'Samastipur',	'BH',	'25.850000,85.780000'),
(2355,	'Sasaram',	'BH',	'24.960000,84.010000'),
(2356,	'Sitamarhi',	'BH',	'26.610000,85.480000'),
(2357,	'Siwan',	'BH',	'26.230000,84.350000'),
(2358,	'Supaul',	'BH',	'26.120000,86.600000'),
(2359,	'Chandigarh',	'CH',	'30.750000,76.780000'),
(2360,	'Ambikapur',	'CT',	'23.130000,83.200000'),
(2361,	'Bhilai',	'CT',	'21.210000,81.380000'),
(2362,	'Bilaspur',	'CT',	'22.090000,82.150000'),
(2363,	'Charoda',	'CT',	'21.230000,81.500000'),
(2364,	'Chirmiri',	'CT',	'23.210000,82.410000'),
(2365,	'Dhamtari',	'CT',	'20.710000,81.550000'),
(2366,	'Durg',	'CT',	'21.200000,81.280000'),
(2367,	'Jagdalpur',	'CT',	'19.090000,82.030000'),
(2368,	'Korba',	'CT',	'22.350000,82.690000'),
(2369,	'Raigarh',	'CT',	'21.900000,83.390000'),
(2370,	'Raipur',	'CT',	'21.240000,81.630000'),
(2371,	'Rajnandgaon',	'CT',	'21.100000,81.040000'),
(2372,	'Bhalswa Jahangirpur',	'DL',	'28.740000,77.170000'),
(2373,	'Burari',	'DL',	'28.758300,77.194600'),
(2374,	'Chilla Saroda Bangar',	'DL',	'28.590100,77.304000'),
(2375,	'Dallo Pura',	'DL',	'28.607800,77.317400'),
(2376,	'Delhi',	'DL',	'28.670000,77.210000'),
(2377,	'Deoli',	'DL',	'28.490000,77.220000'),
(2378,	'Dilli Cantonment',	'DL',	'28.570000,77.160000'),
(2379,	'Gharoli',	'DL',	'28.618300,77.335700'),
(2380,	'Gokalpur',	'DL',	'28.710000,77.280000'),
(2381,	'Hastsal',	'DL',	'28.637600,77.048900'),
(2382,	'Jaffrabad',	'DL',	'28.684100,77.272100'),
(2383,	'Karawal Nagar',	'DL',	'28.730100,77.272300'),
(2384,	'Khajuri Khas',	'DL',	'28.710000,77.260400'),
(2385,	'Kirari Suleman Nagar',	'DL',	'28.696800,77.064400'),
(2386,	'Mandoli',	'DL',	'28.702700,77.309900'),
(2387,	'Mithe Pur',	'DL',	'28.492100,77.324900'),
(2388,	'Molarband',	'DL',	'28.505400,77.311600'),
(2389,	'Mundka',	'DL',	'28.682300,77.034900'),
(2390,	'Mustafabad',	'DL',	'30.199400,77.145600'),
(2391,	'Nangloi Jat',	'DL',	'28.680000,77.070000'),
(2392,	'Ni Dilli',	'DL',	'28.600000,77.220000'),
(2393,	'Pul Pehlad',	'DL',	'28.499400,77.2918'),
(2394,	'Puth Kalan',	'DL',	'28.7111,77.078800'),
(2395,	'Roshan Pura',	'DL',	'28.600000,76.990000'),
(2396,	'Sadat Pur Gujran',	'DL',	'28.725900,77.262800'),
(2397,	'Sultanpur Majra',	'DL',	'28.760000,77.060000'),
(2398,	'Tajpul',	'DL',	'28.704100,77.102500'),
(2399,	'Tigri',	'DL',	'28.500000,77.220000'),
(2400,	'Ziauddin Pur',	'DL',	'28.707500,77.269600'),
(2401,	'Madgaon',	'GA',	'15.280000,73.940000'),
(2402,	'Mormugao',	'GA',	'15.420000,73.780000'),
(2403,	'Panaji',	'GA',	'15.500000,73.810000'),
(2404,	'Ahmadabad',	'GJ',	'23.030000,72.580000'),
(2405,	'Amreli',	'GJ',	'21.610000,71.220000'),
(2406,	'Anand',	'GJ',	'22.560000,72.950000'),
(2407,	'Anjar',	'GJ',	'23.120000,70.020000'),
(2408,	'Bardoli',	'GJ',	'21.120000,73.120000'),
(2409,	'Bharuch',	'GJ',	'21.710000,72.970000'),
(2410,	'Bhavnagar',	'GJ',	'21.790000,72.130000'),
(2411,	'Bhuj',	'GJ',	'23.260000,69.660000'),
(2412,	'Borsad',	'GJ',	'22.420000,72.900000'),
(2413,	'Botad',	'GJ',	'22.180000,71.660000'),
(2414,	'Chandkheda',	'GJ',	'23.150000,72.610000'),
(2415,	'Chandlodiya',	'GJ',	'23.100000,72.560000'),
(2416,	'Dabhoi',	'GJ',	'22.130000,73.410000'),
(2417,	'Dahod',	'GJ',	'22.840000,74.250000'),
(2418,	'Dholka',	'GJ',	'22.740000,72.440000'),
(2419,	'Dhoraji',	'GJ',	'21.740000,70.440000'),
(2420,	'Dhrangadhra',	'GJ',	'23.000000,71.460000'),
(2421,	'Disa',	'GJ',	'24.260000,72.180000'),
(2422,	'Gandhidham',	'GJ',	'23.070000,70.130000'),
(2423,	'Gandhinagar',	'GJ',	'23.300000,72.630000'),
(2424,	'Ghatlodiya',	'GJ',	'23.050000,72.550000'),
(2425,	'Godhra',	'GJ',	'22.770000,73.600000'),
(2426,	'Gondal',	'GJ',	'21.970000,70.800000'),
(2427,	'Himatnagar',	'GJ',	'23.600000,72.960000'),
(2428,	'Jamnagar',	'GJ',	'22.470000,70.070000'),
(2429,	'Jetpur',	'GJ',	'21.750000,70.610000'),
(2430,	'Junagadh',	'GJ',	'21.520000,70.450000'),
(2431,	'Kalol',	'GJ',	'23.250000,72.490000'),
(2432,	'Keshod',	'GJ',	'21.310000,70.230000'),
(2433,	'Khambhat',	'GJ',	'22.320000,72.610000'),
(2434,	'Kundla',	'GJ',	'21.350000,71.300000'),
(2435,	'Mahuva',	'GJ',	'21.100000,71.750000'),
(2436,	'Mangrol',	'GJ',	'21.120000,70.120000'),
(2437,	'Modasa',	'GJ',	'23.470000,73.300000'),
(2438,	'Morvi',	'GJ',	'22.820000,70.830000'),
(2439,	'Nadiad',	'GJ',	'22.700000,72.850000'),
(2440,	'Navagam Ghed',	'GJ',	'22.483400,70.072100'),
(2441,	'Navsari',	'GJ',	'20.960000,72.920000'),
(2442,	'Palitana',	'GJ',	'21.520000,71.830000'),
(2443,	'Patan',	'GJ',	'23.860000,72.110000'),
(2444,	'Porbandar',	'GJ',	'21.650000,69.600000'),
(2445,	'Puna',	'GJ',	'20.932800,73.238200'),
(2446,	'Rajkot',	'GJ',	'22.310000,70.790000'),
(2447,	'Ramod',	'GJ',	'21.966400,21.966400'),
(2448,	'Ranip',	'GJ',	'23.030000,72.540000'),
(2449,	'Siddhapur',	'GJ',	'23.920000,72.370000'),
(2450,	'Sihor',	'GJ',	'21.700000,71.970000'),
(2451,	'Surat',	'GJ',	'21.200000,72.820000'),
(2452,	'Surendranagar',	'GJ',	'22.710000,71.670000'),
(2453,	'Thaltej',	'GJ',	'23.050400,72.499100'),
(2454,	'Una',	'GJ',	'20.820000,71.030000'),
(2455,	'Unjha',	'GJ',	'23.810000,72.380000'),
(2456,	'Upleta',	'GJ',	'21.750000,70.270000'),
(2457,	'Vadodara',	'GJ',	'22.310000,73.180000'),
(2458,	'Valsad',	'GJ',	'20.620000,72.920000'),
(2459,	'Vapi',	'GJ',	'20.370000,72.900000'),
(2460,	'Vastral',	'GJ',	'22.997800,72.666000'),
(2461,	'Vejalpur',	'GJ',	'23.006100,72.516400'),
(2462,	'Veraval',	'GJ',	'20.920000,70.340000'),
(2463,	'Vijalpor',	'GJ',	'20.945900,72.912800'),
(2464,	'Visnagar',	'GJ',	'23.710000,72.540000'),
(2465,	'Wadhwan',	'GJ',	'22.730000,71.720000'),
(2466,	'Ambala',	'HR',	'30.380000,76.770000'),
(2467,	'Ambala Cantonment',	'HR',	'30.390000,76.860000'),
(2468,	'Ambala Sadar',	'HR',	'30.350000,76.840000'),
(2469,	'Bahadurgarh',	'HR',	'28.690000,76.920000'),
(2470,	'Bhiwani',	'HR',	'28.810000,76.120000'),
(2471,	'Charkhi Dadri',	'HR',	'28.600000,76.270000'),
(2472,	'Dabwali',	'HR',	'29.950000,74.730000'),
(2473,	'Faridabad',	'HR',	'28.380000,77.300000'),
(2474,	'Gohana',	'HR',	'29.130000,76.700000'),
(2475,	'Hisar',	'HR',	'29.170000,75.720000'),
(2476,	'Jagadhri',	'HR',	'30.180000,77.290000'),
(2477,	'Jind',	'HR',	'29.310000,76.300000'),
(2478,	'Kaithal',	'HR',	'29.810000,76.400000'),
(2479,	'Karnal',	'HR',	'29.690000,76.970000'),
(2480,	'Narnaul',	'HR',	'28.040000,76.100000'),
(2481,	'Narwana',	'HR',	'29.620000,76.120000'),
(2482,	'Palwal',	'HR',	'28.150000,77.320000'),
(2483,	'Panchkula',	'HR',	'30.700000,76.880000'),
(2484,	'Panipat',	'HR',	'29.390000,76.960000'),
(2485,	'Rewari',	'HR',	'28.190000,76.600000'),
(2486,	'Rohtak',	'HR',	'28.900000,76.580000'),
(2487,	'Sirsa',	'HR',	'29.530000,75.030000'),
(2488,	'Sonipat',	'HR',	'28.990000,77.010000'),
(2489,	'Thanesar',	'HR',	'29.980000,76.820000'),
(2490,	'Tohana',	'HR',	'29.700000,75.900000'),
(2491,	'Yamunanagar',	'HR',	'30.140000,77.280000'),
(2492,	'Shimla',	'HP',	'31.110000,77.160000'),
(2493,	'Anantnag',	'JK',	'33.730000,75.150000'),
(2494,	'Baramula',	'JK',	'34.200000,74.350000'),
(2495,	'Bari Brahmana',	'JK',	'32.636500,74.914100'),
(2496,	'Jammu',	'JK',	'32.710000,74.850000'),
(2497,	'Kathua',	'JK',	'32.370000,75.520000'),
(2498,	'Sopur',	'JK',	'34.300000,74.470000'),
(2499,	'Srinagar',	'JK',	'34.090000,74.790000'),
(2500,	'Udhampur',	'JK',	'32.930000,75.130000'),
(2501,	'Adityapur',	'JH',	'22.800000,86.040000'),
(2502,	'Bagbahra',	'JH',	'22.820000,86.200000'),
(2503,	'Bhuli',	'JH',	'23.790000,86.380000'),
(2504,	'Bokaro',	'JH',	'23.780000,85.960000'),
(2505,	'Chaibasa',	'JH',	'22.560000,85.800000'),
(2506,	'Chas',	'JH',	'23.650000,86.170000'),
(2507,	'Daltenganj',	'JH',	'24.050000,84.060000'),
(2508,	'Devghar',	'JH',	'24.490000,86.690000'),
(2509,	'Dhanbad',	'JH',	'23.800000,86.420000'),
(2510,	'Hazaribag',	'JH',	'24.010000,85.360000'),
(2511,	'Jamshedpur',	'JH',	'22.790000,86.200000'),
(2512,	'Jharia',	'JH',	'23.760000,86.420000'),
(2513,	'Jhumri Tilaiya',	'JH',	'24.430000,85.520000'),
(2514,	'Jorapokhar',	'JH',	'23.790000,86.360000'),
(2515,	'Katras',	'JH',	'23.800000,86.280000'),
(2516,	'Lohardaga',	'JH',	'23.430000,84.680000'),
(2517,	'Mango',	'JH',	'22.850000,86.210000'),
(2518,	'Phusro',	'JH',	'23.680000,85.860000'),
(2519,	'Ramgarh',	'JH',	'23.630000,85.510000'),
(2520,	'Ranchi',	'JH',	'23.360000,85.330000'),
(2521,	'Sahibganj',	'JH',	'25.250000,87.620000'),
(2522,	'Saunda',	'JH',	'23.640000,85.370000'),
(2523,	'Sindari',	'JH',	'23.680000,86.490000'),
(2524,	'Bagalkot',	'KA',	'16.190000,75.690000'),
(2525,	'Bengaluru',	'KA',	'12.970000,77.560000'),
(2526,	'Basavakalyan',	'KA',	'17.870000,76.950000'),
(2527,	'Belgaum',	'KA',	'15.860000,74.500000'),
(2528,	'Bellary',	'KA',	'15.140000,76.910000'),
(2529,	'Bidar',	'KA',	'17.920000,77.520000'),
(2530,	'Bijapur',	'KA',	'16.830000,75.710000'),
(2531,	'Bommanahalli',	'KA',	'13.010000,77.630000'),
(2532,	'Byatarayanapura',	'KA',	'13.059800,77.593300'),
(2533,	'Challakere',	'KA',	'14.320000,76.650000'),
(2534,	'Chamrajnagar',	'KA',	'11.920000,76.950000'),
(2535,	'Channapatna',	'KA',	'12.660000,77.190000'),
(2536,	'Chik Ballapur',	'KA',	'13.470000,77.730000'),
(2537,	'Chikmagalur',	'KA',	'13.320000,75.760000'),
(2538,	'Chintamani',	'KA',	'13.400000,78.050000'),
(2539,	'Chitradurga',	'KA',	'14.230000,76.390000'),
(2540,	'Dasarahalli',	'KA',	'13.010000,77.490000'),
(2541,	'Davanagere',	'KA',	'14.460000,75.920000'),
(2542,	'Dod Ballapur',	'KA',	'13.300000,77.520000'),
(2543,	'Gadag',	'KA',	'15.440000,75.630000'),
(2544,	'Gangawati',	'KA',	'15.440000,76.520000'),
(2545,	'Gokak',	'KA',	'16.180000,74.810000'),
(2546,	'Gulbarga',	'KA',	'17.340000,76.820000'),
(2547,	'Harihar',	'KA',	'14.520000,75.800000'),
(2548,	'Hassan',	'KA',	'13.010000,76.080000'),
(2549,	'Haveri',	'KA',	'14.800000,75.400000'),
(2550,	'Hiriyur',	'KA',	'13.970000,76.600000'),
(2551,	'Hosakote',	'KA',	'13.069300,77.798200'),
(2552,	'Hospet',	'KA',	'15.280000,76.370000'),
(2553,	'Hubli',	'KA',	'15.360000,75.130000'),
(2554,	'Ilkal',	'KA',	'15.970000,76.130000'),
(2555,	'Jamkhandi',	'KA',	'16.510000,75.280000'),
(2556,	'Kanakapura',	'KA',	'12.540000,77.420000'),
(2557,	'Karwar',	'KA',	'14.820000,74.120000'),
(2558,	'Kolar',	'KA',	'13.140000,78.130000'),
(2559,	'Kollegal',	'KA',	'12.150000,77.120000'),
(2560,	'Koppal',	'KA',	'15.350000,76.150000'),
(2561,	'Krishnarajapura',	'KA',	'12.970000,77.740000'),
(2562,	'Mahadevapura',	'KA',	'12.988000,77.689500'),
(2563,	'Maisuru',	'KA',	'12.310000,76.650000'),
(2564,	'Mandya',	'KA',	'12.540000,76.890000'),
(2565,	'Mangaluru',	'KA',	'12.880000,74.840000'),
(2566,	'Nipani',	'KA',	'16.410000,74.380000'),
(2567,	'Pattanagere',	'KA',	'12.918700,77.511100'),
(2568,	'Puttur',	'KA',	'12.770000,75.220000'),
(2569,	'Rabkavi',	'KA',	'16.470000,75.110000'),
(2570,	'Raichur',	'KA',	'16.210000,77.350000'),
(2571,	'Ramanagaram',	'KA',	'12.720000,77.270000'),
(2572,	'Ranibennur',	'KA',	'14.620000,75.610000'),
(2573,	'Robertsonpet',	'KA',	'12.970000,78.280000'),
(2574,	'Shahpur',	'KA',	'16.700000,76.830000'),
(2575,	'Shimoga',	'KA',	'13.930000,75.570000'),
(2576,	'Shorapur',	'KA',	'16.520000,76.750000'),
(2577,	'Sidlaghatta',	'KA',	'13.380000,77.870000'),
(2578,	'Sira',	'KA',	'13.750000,76.900000'),
(2579,	'Sirsi',	'KA',	'14.620000,74.850000'),
(2580,	'Tiptur',	'KA',	'13.270000,76.480000'),
(2581,	'Tumkur',	'KA',	'13.340000,77.100000'),
(2582,	'Udupi',	'KA',	'13.350000,74.750000'),
(2583,	'Ullal',	'KA',	'12.800000,74.850000'),
(2584,	'Yadgir',	'KA',	'16.770000,77.130000'),
(2585,	'Yelahanka',	'KA',	'13.100000,77.600000'),
(2586,	'Alappuzha',	'KL',	'9.500000,76.330000'),
(2587,	'Beypur',	'KL',	'11.180000,75.820000'),
(2588,	'Cheruvannur',	'KL',	'11.210000,75.840000'),
(2589,	'Edakkara',	'KL',	'11.361500,76.3027'),
(2590,	'Edathala',	'KL',	'10.030000,76.320000'),
(2591,	'Kalamassery',	'KL',	'10.050000,76.270000'),
(2592,	'Kannan Devan Hills',	'KL',	'10.142700,77.119900'),
(2593,	'Kannangad',	'KL',	'12.340000,75.090000'),
(2594,	'Kannur',	'KL',	'11.860000,75.350000'),
(2595,	'Kayankulam',	'KL',	'9.170000,76.490000'),
(2596,	'Kochi',	'KL',	'10.020000,76.220000'),
(2597,	'Kollam',	'KL',	'8.890000,76.580000'),
(2598,	'Kottayam',	'KL',	'9.600000,76.520000'),
(2599,	'Koyilandi',	'KL',	'11.430000,75.700000'),
(2600,	'Kozhikode',	'KL',	'11.260000,75.780000'),
(2601,	'Kunnamkulam',	'KL',	'10.650000,76.080000'),
(2602,	'Malappuram',	'KL',	'11.070000,76.060000'),
(2603,	'Manjeri',	'KL',	'11.120000,76.110000'),
(2604,	'Nedumangad',	'KL',	'8.610000,77.000000'),
(2605,	'Neyyattinkara',	'KL',	'8.400000,77.080000'),
(2606,	'Palakkad',	'KL',	'10.780000,76.650000'),
(2607,	'Pallichal',	'KL',	'8.450000,77.026100'),
(2608,	'Payyannur',	'KL',	'12.100000,75.190000'),
(2609,	'Ponnani',	'KL',	'10.780000,75.920000'),
(2610,	'Talipparamba',	'KL',	'12.030000,75.360000'),
(2611,	'Thalassery',	'KL',	'11.750000,75.490000'),
(2612,	'Thiruvananthapuram',	'KL',	'8.510000,76.950000'),
(2613,	'Thrippunithura',	'KL',	'9.940000,76.350000'),
(2614,	'Thrissur',	'KL',	'10.520000,76.210000'),
(2615,	'Tirur',	'KL',	'10.910000,75.920000'),
(2616,	'Tiruvalla',	'KL',	'9.390000,76.570000'),
(2617,	'Vadakara',	'KL',	'11.610000,75.580000'),
(2618,	'Ashoknagar',	'MP',	'24.570000,77.720000'),
(2619,	'Balaghat',	'MP',	'21.800000,80.180000'),
(2620,	'Basoda',	'MP',	'23.850000,77.930000'),
(2621,	'Betul',	'MP',	'21.920000,77.900000'),
(2622,	'Bhind',	'MP',	'26.570000,78.770000'),
(2623,	'Bhopal',	'MP',	'23.240000,77.400000'),
(2624,	'BinaEtawa',	'MP',	'24.200000,78.200000'),
(2625,	'Burhanpur',	'MP',	'21.330000,76.220000'),
(2626,	'Chhatarpur',	'MP',	'24.920000,79.580000'),
(2627,	'Chhindwara',	'MP',	'22.070000,78.940000'),
(2628,	'Dabra',	'MP',	'25.900000,78.330000'),
(2629,	'Damoh',	'MP',	'23.850000,79.440000'),
(2630,	'Datia',	'MP',	'25.670000,78.450000'),
(2631,	'Dewas',	'MP',	'22.970000,76.050000'),
(2632,	'Dhar',	'MP',	'22.600000,75.290000'),
(2633,	'Gohad',	'MP',	'26.430000,78.450000'),
(2634,	'Guna',	'MP',	'24.650000,77.300000'),
(2635,	'Gwalior',	'MP',	'26.230000,78.170000'),
(2636,	'Harda',	'MP',	'22.330000,77.110000'),
(2637,	'Hoshangabad',	'MP',	'22.750000,77.710000'),
(2638,	'Indore',	'MP',	'22.720000,75.860000'),
(2639,	'Itarsi',	'MP',	'22.620000,77.760000'),
(2640,	'Jabalpur',	'MP',	'23.170000,79.940000'),
(2641,	'Jabalpur Cantonment',	'MP',	'23.160000,79.950000'),
(2642,	'Jaora',	'MP',	'23.640000,75.110000'),
(2643,	'Khandwa',	'MP',	'21.830000,76.350000'),
(2644,	'Khargone',	'MP',	'21.830000,75.600000'),
(2645,	'Mandidip',	'MP',	'23.100000,77.520000'),
(2646,	'Mandsaur',	'MP',	'24.070000,75.070000'),
(2647,	'Morena',	'MP',	'26.510000,77.990000'),
(2648,	'Murwara',	'MP',	'23.850000,80.390000'),
(2649,	'Nagda',	'MP',	'23.460000,75.420000'),
(2650,	'Nimach',	'MP',	'24.470000,74.870000'),
(2651,	'Pithampur',	'MP',	'22.611100,75.677300'),
(2652,	'Raghogarh',	'MP',	'24.450000,77.200000'),
(2653,	'Ratlam',	'MP',	'23.350000,75.030000'),
(2654,	'Rewa',	'MP',	'24.530000,81.290000'),
(2655,	'Sagar',	'MP',	'23.850000,78.750000'),
(2656,	'Sarni',	'MP',	'22.040000,78.270000'),
(2657,	'Satna',	'MP',	'24.580000,80.830000'),
(2658,	'Sehore',	'MP',	'23.200000,77.080000'),
(2659,	'Sendhwa',	'MP',	'21.680000,75.100000'),
(2660,	'Seoni',	'MP',	'22.100000,79.550000'),
(2661,	'Shahdol',	'MP',	'23.300000,81.360000'),
(2662,	'Shajapur',	'MP',	'23.430000,76.270000'),
(2663,	'Sheopur',	'MP',	'25.670000,76.700000'),
(2664,	'Shivapuri',	'MP',	'25.430000,77.650000'),
(2665,	'Sidhi',	'MP',	'24.420000,81.880000'),
(2666,	'Singrauli',	'MP',	'23.840000,82.270000'),
(2667,	'Tikamgarh',	'MP',	'24.740000,78.830000'),
(2668,	'Ujjain',	'MP',	'23.190000,75.780000'),
(2669,	'Vidisha',	'MP',	'23.530000,77.800000'),
(2670,	'Achalpur',	'MH',	'21.260000,77.500000'),
(2671,	'Ahmadnagar',	'MH',	'19.100000,74.740000'),
(2672,	'Akola',	'MH',	'20.710000,77.000000'),
(2673,	'Akot',	'MH',	'21.100000,77.050000'),
(2674,	'Amalner',	'MH',	'21.050000,75.060000'),
(2675,	'Ambajogai',	'MH',	'18.730000,76.380000'),
(2676,	'Amravati',	'MH',	'20.950000,77.760000'),
(2677,	'Anjangaon',	'MH',	'21.160000,77.310000'),
(2678,	'Aurangabad',	'MH',	'19.890000,75.320000'),
(2679,	'Badlapur',	'MH',	'19.150000,73.270000'),
(2680,	'Ballarpur',	'MH',	'19.850000,79.350000'),
(2681,	'Baramati',	'MH',	'18.150000,74.580000'),
(2682,	'Barsi',	'MH',	'18.240000,75.690000'),
(2683,	'Basmat',	'MH',	'19.320000,77.170000'),
(2684,	'Bhadravati',	'MH',	'20.110000,79.120000'),
(2685,	'Bhandara',	'MH',	'21.180000,79.650000'),
(2686,	'Bhiwandi',	'MH',	'19.300000,73.050000'),
(2687,	'Bhusawal',	'MH',	'21.050000,75.780000'),
(2688,	'Bid',	'MH',	'18.990000,75.760000'),
(2689,	'Mumbai',	'MH',	'18.960000,72.820000'),
(2690,	'Buldana',	'MH',	'20.540000,76.180000'),
(2691,	'Chalisgaon',	'MH',	'20.460000,74.990000'),
(2692,	'Chandrapur',	'MH',	'19.960000,79.300000'),
(2693,	'Chikhli',	'MH',	'20.350000,76.250000'),
(2694,	'Chiplun',	'MH',	'17.530000,73.520000'),
(2695,	'Chopda',	'MH',	'21.250000,75.280000'),
(2696,	'Dahanu',	'MH',	'19.970000,72.730000'),
(2697,	'Deolali',	'MH',	'19.950000,73.840000'),
(2698,	'Dhule',	'MH',	'20.900000,74.770000'),
(2699,	'Digdoh',	'MH',	'21.110800,79.012600'),
(2700,	'Diglur',	'MH',	'18.550000,77.600000'),
(2701,	'Gadchiroli',	'MH',	'20.170000,80.000000'),
(2702,	'Gondiya',	'MH',	'21.470000,80.200000'),
(2703,	'Hinganghat',	'MH',	'20.560000,78.830000'),
(2704,	'Hingoli',	'MH',	'19.720000,77.140000'),
(2705,	'Ichalkaranji',	'MH',	'16.690000,74.460000'),
(2706,	'Jalgaon',	'MH',	'21.010000,75.560000'),
(2707,	'Jalna',	'MH',	'19.850000,75.880000'),
(2708,	'Kalyan',	'MH',	'19.250000,73.160000'),
(2709,	'Kamthi',	'MH',	'21.230000,79.200000'),
(2710,	'Karanja',	'MH',	'20.480000,77.480000'),
(2711,	'Khadki',	'MH',	'18.570000,73.830000'),
(2712,	'Khamgaon',	'MH',	'20.700000,76.560000'),
(2713,	'Khopoli',	'MH',	'18.780000,73.330000'),
(2714,	'Kolhapur',	'MH',	'16.700000,74.220000'),
(2715,	'Kopargaon',	'MH',	'19.880000,74.480000'),
(2716,	'Latur',	'MH',	'18.410000,76.580000'),
(2717,	'Lonavale',	'MH',	'18.750000,73.420000'),
(2718,	'Malegaon',	'MH',	'20.560000,74.520000'),
(2719,	'Malkapur',	'MH',	'20.900000,76.190000'),
(2720,	'Manmad',	'MH',	'20.260000,74.430000'),
(2721,	'Mira Bhayandar',	'MH',	'19.290000,72.850000'),
(2722,	'Nagpur',	'MH',	'21.160000,79.080000'),
(2723,	'Nalasopara',	'MH',	'19.430000,72.780000'),
(2724,	'Nanded',	'MH',	'19.170000,77.290000'),
(2725,	'Nandurbar',	'MH',	'21.380000,74.230000'),
(2726,	'Nashik',	'MH',	'20.010000,73.780000'),
(2727,	'Navghar',	'MH',	'19.340000,72.900000'),
(2728,	'Navi Mumbai',	'MH',	'19.000000,73.100000'),
(2729,	'Osmanabad',	'MH',	'18.170000,76.030000'),
(2730,	'Palghar',	'MH',	'19.680000,72.750000'),
(2731,	'Pandharpur',	'MH',	'17.680000,75.310000'),
(2732,	'Parbhani',	'MH',	'19.270000,76.760000'),
(2733,	'Phaltan',	'MH',	'17.980000,74.430000'),
(2734,	'Pimpri',	'MH',	'18.620000,73.800000'),
(2735,	'Pune',	'MH',	'18.530000,73.840000'),
(2736,	'Pune Cantonment',	'MH',	'18.500000,73.880000'),
(2737,	'Pusad',	'MH',	'19.910000,77.570000'),
(2738,	'Ratnagiri',	'MH',	'17.000000,73.290000'),
(2739,	'SangliMiraj',	'MH',	'16.860000,74.570000'),
(2740,	'Satara',	'MH',	'17.700000,74.000000'),
(2741,	'Shahada',	'MH',	'21.550000,74.470000'),
(2742,	'Shegaon',	'MH',	'20.780000,76.680000'),
(2743,	'Shirpur',	'MH',	'21.350000,74.880000'),
(2744,	'Sholapur',	'MH',	'17.670000,75.890000'),
(2745,	'Shrirampur',	'MH',	'19.630000,74.640000'),
(2746,	'Sillod',	'MH',	'20.300000,75.650000'),
(2747,	'Thana',	'MH',	'19.200000,72.970000'),
(2748,	'Udgir',	'MH',	'18.400000,77.110000'),
(2749,	'Ulhasnagar',	'MH',	'19.230000,73.150000'),
(2750,	'Uran Islampur',	'MH',	'17.050000,74.270000'),
(2751,	'Vasai',	'MH',	'19.360000,72.800000'),
(2752,	'Virar',	'MH',	'19.470000,72.790000'),
(2753,	'Wadi',	'MH',	'21.154400,78.994300'),
(2754,	'Wani',	'MH',	'20.070000,78.950000'),
(2755,	'Wardha',	'MH',	'20.750000,78.600000'),
(2756,	'Warud',	'MH',	'21.470000,78.270000'),
(2757,	'Washim',	'MH',	'20.100000,77.130000'),
(2758,	'Yavatmal',	'MH',	'20.410000,78.130000'),
(2759,	'Imphal',	'MN',	'24.790000,93.940000'),
(2760,	'Shillong',	'ME',	'25.570000,91.870000'),
(2761,	'Tura',	'ME',	'25.520000,90.220000'),
(2762,	'Aizawl',	'MI',	'23.710000,92.710000'),
(2763,	'Lunglei',	'MI',	'22.880000,92.730000'),
(2764,	'Dimapur',	'NL',	'25.920000,93.730000'),
(2765,	'Kohima',	'NL',	'25.670000,94.110000'),
(2766,	'Wokha',	'NL',	'26.100000,94.270000'),
(2767,	'Balangir',	'OR',	'20.710000,83.500000'),
(2768,	'Baleshwar',	'OR',	'21.490000,86.950000'),
(2769,	'Barbil',	'OR',	'22.120000,85.400000'),
(2770,	'Bargarh',	'OR',	'21.340000,83.610000'),
(2771,	'Baripada',	'OR',	'21.950000,86.730000'),
(2772,	'Bhadrak',	'OR',	'21.060000,86.520000'),
(2773,	'Bhawanipatna',	'OR',	'19.910000,83.170000'),
(2774,	'Bhubaneswar',	'OR',	'20.270000,85.840000'),
(2775,	'Brahmapur',	'OR',	'19.320000,84.800000'),
(2776,	'Brajrajnagar',	'OR',	'21.820000,83.910000'),
(2777,	'Dhenkanal',	'OR',	'20.670000,85.600000'),
(2778,	'Jaypur',	'OR',	'18.860000,82.560000'),
(2779,	'Jharsuguda',	'OR',	'21.870000,84.010000'),
(2780,	'Kataka',	'OR',	'20.470000,85.880000'),
(2781,	'Kendujhar',	'OR',	'21.630000,85.580000'),
(2782,	'Paradwip',	'OR',	'20.320000,86.620000'),
(2783,	'Puri',	'OR',	'19.810000,85.830000'),
(2784,	'Raurkela',	'OR',	'22.240000,84.810000'),
(2785,	'Raurkela Industrial Township',	'OR',	'22.199300,84.862000'),
(2786,	'Rayagada',	'OR',	'19.180000,83.410000'),
(2787,	'Sambalpur',	'OR',	'21.470000,83.970000'),
(2788,	'Sunabeda',	'OR',	'18.690000,82.860000'),
(2789,	'Karaikal',	'PY',	'10.930000,79.830000'),
(2790,	'Ozhukarai',	'PY',	'11.940000,79.770000'),
(2791,	'Pondicherry',	'PY',	'11.940000,79.830000'),
(2792,	'Abohar',	'PB',	'30.140000,74.200000'),
(2793,	'Amritsar',	'PB',	'31.640000,74.870000'),
(2794,	'Barnala',	'PB',	'30.390000,75.540000'),
(2795,	'Batala',	'PB',	'31.820000,75.210000'),
(2796,	'Bathinda',	'PB',	'30.170000,74.970000'),
(2797,	'Dhuri',	'PB',	'30.370000,75.870000'),
(2798,	'Faridkot',	'PB',	'30.680000,74.740000'),
(2799,	'Fazilka',	'PB',	'30.410000,74.020000'),
(2800,	'Firozpur',	'PB',	'30.920000,74.610000'),
(2801,	'Firozpur Cantonment',	'PB',	'30.950000,74.600000'),
(2802,	'Gobindgarh',	'PB',	'30.660000,76.310000'),
(2803,	'Gurdaspur',	'PB',	'32.040000,75.400000'),
(2804,	'Hoshiarpur',	'PB',	'31.530000,75.910000'),
(2805,	'Jagraon',	'PB',	'30.780000,75.480000'),
(2806,	'Jalandhar',	'PB',	'31.330000,75.570000'),
(2807,	'Kapurthala',	'PB',	'31.380000,75.380000'),
(2808,	'Khanna',	'PB',	'30.710000,76.210000'),
(2809,	'Kot Kapura',	'PB',	'30.590000,74.800000'),
(2810,	'Ludhiana',	'PB',	'30.910000,75.840000'),
(2811,	'Malaut',	'PB',	'30.230000,74.480000'),
(2812,	'Maler Kotla',	'PB',	'30.540000,75.870000'),
(2813,	'Mansa',	'PB',	'29.980000,75.390000'),
(2814,	'Moga',	'PB',	'30.820000,75.170000'),
(2815,	'Mohali',	'PB',	'30.780000,76.690000'),
(2816,	'Pathankot',	'PB',	'32.270000,75.640000'),
(2817,	'Patiala',	'PB',	'30.320000,76.390000'),
(2818,	'Phagwara',	'PB',	'31.220000,75.760000'),
(2819,	'Rajpura',	'PB',	'30.480000,76.590000'),
(2820,	'Rupnagar',	'PB',	'30.980000,76.520000'),
(2821,	'Samana',	'PB',	'30.150000,76.200000'),
(2822,	'Sangrur',	'PB',	'30.250000,75.840000'),
(2823,	'Sirhind',	'PB',	'30.650000,76.380000'),
(2824,	'Sunam',	'PB',	'30.130000,75.800000'),
(2825,	'Tarn Taran',	'PB',	'31.450000,74.920000'),
(2826,	'Ajmer',	'RJ',	'26.450000,74.640000'),
(2827,	'Alwar',	'RJ',	'27.560000,76.600000'),
(2828,	'Balotra',	'RJ',	'25.830000,72.230000'),
(2829,	'Banswara',	'RJ',	'23.540000,74.440000'),
(2830,	'Baran',	'RJ',	'25.100000,76.510000'),
(2831,	'Bari',	'RJ',	'26.650000,77.600000'),
(2832,	'Barmer',	'RJ',	'25.750000,71.390000'),
(2833,	'Beawar',	'RJ',	'26.100000,74.300000'),
(2834,	'Bharatpur',	'RJ',	'27.230000,77.490000'),
(2835,	'Bhilwara',	'RJ',	'25.350000,74.630000'),
(2836,	'Bhiwadi',	'RJ',	'28.201400,76.827600'),
(2837,	'Bikaner',	'RJ',	'28.030000,73.320000'),
(2838,	'Bundi',	'RJ',	'25.450000,75.630000'),
(2839,	'Chittaurgarh',	'RJ',	'24.890000,74.630000'),
(2840,	'Chomun',	'RJ',	'27.170000,75.720000'),
(2841,	'Churu',	'RJ',	'28.310000,74.960000'),
(2842,	'Daosa',	'RJ',	'26.880000,76.330000'),
(2843,	'Dhaulpur',	'RJ',	'26.700000,77.870000'),
(2844,	'Didwana',	'RJ',	'27.390000,74.570000'),
(2845,	'Ganganagar',	'RJ',	'29.930000,73.860000'),
(2846,	'Gangapur',	'RJ',	'26.470000,76.720000'),
(2847,	'Hanumangarh',	'RJ',	'29.620000,74.290000'),
(2848,	'Hindaun',	'RJ',	'26.740000,77.020000'),
(2849,	'Jaipur',	'RJ',	'26.920000,75.800000'),
(2850,	'Jaisalmer',	'RJ',	'26.920000,70.900000'),
(2851,	'Jalor',	'RJ',	'25.350000,72.620000'),
(2852,	'Jhalawar',	'RJ',	'24.600000,76.150000'),
(2853,	'Jhunjhunun',	'RJ',	'28.130000,75.390000'),
(2854,	'Jodhpur',	'RJ',	'26.290000,73.020000'),
(2855,	'Karauli',	'RJ',	'26.500000,77.020000'),
(2856,	'Kishangarh',	'RJ',	'26.580000,74.860000'),
(2857,	'Kota',	'RJ',	'25.180000,75.830000'),
(2858,	'Kuchaman',	'RJ',	'27.150000,74.850000'),
(2859,	'Ladnun',	'RJ',	'27.640000,74.380000'),
(2860,	'Makrana',	'RJ',	'27.050000,74.720000'),
(2861,	'Nagaur',	'RJ',	'27.210000,73.730000'),
(2862,	'Nawalgarh',	'RJ',	'27.850000,75.270000'),
(2863,	'Nimbahera',	'RJ',	'24.620000,74.680000'),
(2864,	'Nokha',	'RJ',	'27.600000,73.420000'),
(2865,	'Pali',	'RJ',	'25.790000,73.320000'),
(2866,	'Rajsamand',	'RJ',	'25.070000,73.880000'),
(2867,	'Ratangarh',	'RJ',	'28.090000,74.600000'),
(2868,	'Sardarshahr',	'RJ',	'28.450000,74.480000'),
(2869,	'Sawai Madhopur',	'RJ',	'26.030000,76.340000'),
(2870,	'Sikar',	'RJ',	'27.610000,75.130000'),
(2871,	'Sujangarh',	'RJ',	'27.700000,74.460000'),
(2872,	'Suratgarh',	'RJ',	'29.320000,73.900000'),
(2873,	'Tonk',	'RJ',	'26.170000,75.780000'),
(2874,	'Udaipur',	'RJ',	'24.580000,73.690000'),
(2875,	'Alandur',	'TN',	'13.030000,80.230000'),
(2876,	'Ambattur',	'TN',	'13.110000,80.170000'),
(2877,	'Ambur',	'TN',	'12.800000,78.720000'),
(2878,	'Arakonam',	'TN',	'13.080000,79.670000'),
(2879,	'Arani',	'TN',	'12.680000,79.280000'),
(2880,	'Aruppukkottai',	'TN',	'9.510000,78.090000'),
(2881,	'Attur',	'TN',	'11.600000,78.600000'),
(2882,	'Avadi',	'TN',	'13.120000,80.110000'),
(2883,	'Avaniapuram',	'TN',	'9.860000,78.120000'),
(2884,	'Avinashi',	'TN',	'11.1730,77.2686'),
(2885,	'Bodinayakkanur',	'TN',	'10.010000,77.350000'),
(2886,	'Chengalpattu',	'TN',	'12.700000,79.970000'),
(2887,	'Dharapuram',	'TN',	'10.740000,77.520000'),
(2888,	'Dharmapuri',	'TN',	'12.130000,78.160000'),
(2889,	'Dindigul',	'TN',	'10.360000,77.970000'),
(2890,	'Erode',	'TN',	'11.350000,77.730000'),
(2891,	'Gopichettipalaiyam',	'TN',	'11.460000,77.430000'),
(2892,	'Gudalur',	'TN',	'11.760000,79.750000'),
(2893,	'Gudiyattam',	'TN',	'12.950000,78.860000'),
(2894,	'Hosur',	'TN',	'12.720000,77.820000'),
(2895,	'Idappadi',	'TN',	'11.580000,77.850000'),
(2896,	'Kadayanallur',	'TN',	'9.080000,77.350000'),
(2897,	'Kambam',	'TN',	'9.740000,77.280000'),
(2898,	'Kanchipuram',	'TN',	'12.840000,79.700000'),
(2899,	'Karur',	'TN',	'10.960000,78.070000'),
(2900,	'Kavundampalaiyam',	'TN',	'11.050000,76.920000'),
(2901,	'Kovilpatti',	'TN',	'9.190000,77.860000'),
(2902,	'Koyampattur',	'TN',	'11.010000,76.960000'),
(2903,	'Krishnagiri',	'TN',	'12.540000,78.210000'),
(2904,	'Kumarapalaiyam',	'TN',	'11.440000,77.730000'),
(2905,	'Kumbakonam',	'TN',	'10.970000,79.380000'),
(2906,	'Kuniyamuthur',	'TN',	'10.980000,76.950000'),
(2907,	'Kurichi',	'TN',	'10.920000,76.960000'),
(2908,	'Madhavaram',	'TN',	'13.020000,80.260000'),
(2909,	'Chennai',	'TN',	'13.090000,80.270000'),
(2910,	'Madurai',	'TN',	'9.920000,78.120000'),
(2911,	'Maduravoyal',	'TN',	'13.065600,80.160800'),
(2912,	'Mannargudi',	'TN',	'10.670000,79.450000'),
(2913,	'Mayiladuthurai',	'TN',	'11.110000,79.650000'),
(2914,	'Mettupalayam',	'TN',	'11.300000,76.940000'),
(2915,	'Mettur',	'TN',	'11.800000,77.800000'),
(2916,	'Nagapattinam',	'TN',	'10.800000,79.840000'),
(2917,	'Nagercoil',	'TN',	'8.180000,77.430000'),
(2918,	'Namakkal',	'TN',	'11.230000,78.170000'),
(2919,	'Nerkunram',	'TN',	'13.040000,80.260000'),
(2920,	'Neyveli',	'TN',	'11.620000,79.480000'),
(2921,	'Pallavaram',	'TN',	'12.990000,80.160000'),
(2922,	'Pammal',	'TN',	'12.970000,80.110000'),
(2923,	'Pannuratti',	'TN',	'11.780000,79.550000'),
(2924,	'Paramakkudi',	'TN',	'9.540000,78.590000'),
(2925,	'Pattukkottai',	'TN',	'10.430000,79.310000'),
(2926,	'Pollachi',	'TN',	'10.670000,77.000000'),
(2927,	'Pudukkottai',	'TN',	'10.390000,78.820000'),
(2928,	'Puliyankudi',	'TN',	'9.180000,77.400000'),
(2929,	'Punamalli',	'TN',	'13.050000,80.110000'),
(2930,	'Rajapalayam',	'TN',	'9.460000,77.550000'),
(2931,	'Ramanathapuram',	'TN',	'9.370000,78.830000'),
(2932,	'Salem',	'TN',	'11.670000,78.160000'),
(2933,	'Sankarankoil',	'TN',	'9.170000,77.540000'),
(2934,	'Sivakasi',	'TN',	'9.460000,77.790000'),
(2935,	'Srivilliputtur',	'TN',	'9.520000,77.630000'),
(2936,	'Tambaram',	'TN',	'12.930000,80.120000'),
(2937,	'Tenkasi',	'TN',	'8.960000,77.310000'),
(2938,	'Thanjavur',	'TN',	'10.790000,79.130000'),
(2939,	'Theni Allinagaram',	'TN',	'10.020000,77.480000'),
(2940,	'Thiruthangal',	'TN',	'9.480700,77.808100'),
(2941,	'Thiruvarur',	'TN',	'10.780000,79.640000'),
(2942,	'Thuthukkudi',	'TN',	'8.810000,78.140000'),
(2943,	'Tindivanam',	'TN',	'12.240000,79.650000'),
(2944,	'Tiruchchirappalli',	'TN',	'10.810000,78.690000'),
(2945,	'Tiruchengode',	'TN',	'11.380000,77.900000'),
(2946,	'Tirunelveli',	'TN',	'8.730000,77.690000'),
(2947,	'Tirupathur',	'TN',	'12.500000,78.570000'),
(2948,	'Tiruppur',	'TN',	'11.090000,77.350000'),
(2949,	'Tiruvannamalai',	'TN',	'12.240000,79.070000'),
(2950,	'Tiruvottiyur',	'TN',	'13.160000,80.290000'),
(2951,	'Udagamandalam',	'TN',	'11.420000,76.690000'),
(2952,	'Udumalaipettai',	'TN',	'10.580000,77.240000'),
(2953,	'Valparai',	'TN',	'10.380000,76.990000'),
(2954,	'Vaniyambadi',	'TN',	'12.690000,78.600000'),
(2955,	'Velampalaiyam',	'TN',	'11.136200,77.311900'),
(2956,	'Velluru',	'TN',	'12.920000,79.130000'),
(2957,	'Viluppuram',	'TN',	'11.950000,79.490000'),
(2958,	'Virappanchatram',	'TN',	'11.400000,77.700000'),
(2959,	'Virudhachalam',	'TN',	'11.510000,79.320000'),
(2960,	'Virudunagar',	'TN',	'9.590000,77.950000'),
(2961,	'Agartala',	'TR',	'23.840000,91.270000'),
(2962,	'Agartala MCl',	'TR',	'23.829321,91.277847'),
(2963,	'Badharghat',	'TR',	'23.802700,91.272300'),
(2964,	'Agra',	'UP',	'27.190000,78.010000'),
(2965,	'Aligarh',	'UP',	'27.890000,78.060000'),
(2966,	'Allahabad',	'UP',	'25.450000,81.840000'),
(2967,	'Amroha',	'UP',	'28.910000,78.460000'),
(2968,	'Aonla',	'UP',	'28.280000,79.150000'),
(2969,	'Auraiya',	'UP',	'26.470000,79.500000'),
(2970,	'Ayodhya',	'UP',	'26.800000,82.200000'),
(2971,	'Azamgarh',	'UP',	'26.070000,83.180000'),
(2972,	'Baheri',	'UP',	'28.780000,79.500000'),
(2973,	'Bahraich',	'UP',	'27.580000,81.590000'),
(2974,	'Ballia',	'UP',	'25.760000,84.150000'),
(2975,	'Balrampur',	'UP',	'27.430000,82.180000'),
(2976,	'Banda',	'UP',	'25.480000,80.330000'),
(2977,	'Baraut',	'UP',	'29.100000,77.260000'),
(2978,	'Bareli',	'UP',	'28.360000,79.410000'),
(2979,	'Basti',	'UP',	'26.800000,82.740000'),
(2980,	'Behta Hajipur',	'UP',	'28.721700,77.304100'),
(2981,	'Bela',	'UP',	'25.920000,81.990000'),
(2982,	'Bhadohi',	'UP',	'25.400000,82.560000'),
(2983,	'Bijnor',	'UP',	'29.380000,78.130000'),
(2984,	'Bisalpur',	'UP',	'28.300000,79.800000'),
(2985,	'Biswan',	'UP',	'27.500000,81.000000'),
(2986,	'Budaun',	'UP',	'28.040000,79.120000'),
(2987,	'Bulandshahr',	'UP',	'28.410000,77.850000'),
(2988,	'Chandausi',	'UP',	'28.460000,78.780000'),
(2989,	'Chandpur',	'UP',	'29.140000,78.270000'),
(2990,	'Chhibramau',	'UP',	'27.150000,79.520000'),
(2991,	'Chitrakut Dham',	'UP',	'25.200000,80.840000'),
(2992,	'Dadri',	'UP',	'28.570000,77.550000'),
(2993,	'Deoband',	'UP',	'29.700000,77.670000'),
(2994,	'Deoria',	'UP',	'26.510000,83.780000'),
(2995,	'Etah',	'UP',	'27.570000,78.640000'),
(2996,	'Etawah',	'UP',	'26.780000,79.010000'),
(2997,	'Faizabad',	'UP',	'26.780000,82.140000'),
(2998,	'Faridpur',	'UP',	'28.220000,79.530000'),
(2999,	'Farrukhabad',	'UP',	'27.400000,79.570000'),
(3000,	'Fatehpur',	'UP',	'25.930000,80.810000'),
(3001,	'Firozabad',	'UP',	'27.150000,78.390000'),
(3002,	'Gajraula',	'UP',	'28.850000,78.230000'),
(3003,	'Ganga Ghat',	'UP',	'26.520000,80.450000'),
(3004,	'Gangoh',	'UP',	'29.770000,77.250000'),
(3005,	'Ghaziabad',	'UP',	'28.660000,77.410000'),
(3006,	'Ghazipur',	'UP',	'25.590000,83.590000'),
(3007,	'Gola Gokarannath',	'UP',	'28.080000,80.470000'),
(3008,	'Gonda',	'UP',	'27.140000,81.950000'),
(3009,	'Gorakhpur',	'UP',	'26.760000,83.360000'),
(3010,	'Hapur',	'UP',	'28.730000,77.770000'),
(3011,	'Hardoi',	'UP',	'27.420000,80.120000'),
(3012,	'Hasanpur',	'UP',	'28.720000,78.280000'),
(3013,	'Hathras',	'UP',	'27.600000,78.040000'),
(3014,	'Jahangirabad',	'UP',	'28.420000,78.100000'),
(3015,	'Jalaun',	'UP',	'26.150000,79.350000'),
(3016,	'Jaunpur',	'UP',	'25.760000,82.690000'),
(3017,	'Jhansi',	'UP',	'25.450000,78.560000'),
(3018,	'Kadi',	'UP',	'23.310000,72.330000'),
(3019,	'Kairana',	'UP',	'29.400000,77.200000'),
(3020,	'Kannauj',	'UP',	'27.060000,79.910000'),
(3021,	'Kanpur',	'UP',	'26.470000,80.330000'),
(3022,	'Kanpur Cantonment',	'UP',	'26.500000,80.280000'),
(3023,	'Kasganj',	'UP',	'27.810000,78.630000'),
(3024,	'Khatauli',	'UP',	'29.280000,77.720000'),
(3025,	'Khora',	'UP',	'28.753900,77.399900'),
(3026,	'Khurja',	'UP',	'28.260000,77.850000'),
(3027,	'Kiratpur',	'UP',	'29.520000,78.200000'),
(3028,	'Kosi Kalan',	'UP',	'27.800000,77.440000'),
(3029,	'Laharpur',	'UP',	'27.720000,80.900000'),
(3030,	'Lakhimpur',	'UP',	'27.950000,80.780000'),
(3031,	'Lakhnau',	'UP',	'26.850000,80.920000'),
(3032,	'Lakhnau Cantonment',	'UP',	'26.810000,80.970000'),
(3033,	'Lalitpur',	'UP',	'24.700000,78.410000'),
(3034,	'Loni',	'UP',	'28.750000,77.280000'),
(3035,	'Mahoba',	'UP',	'25.300000,79.870000'),
(3036,	'Mainpuri',	'UP',	'27.240000,79.020000'),
(3037,	'Mathura',	'UP',	'27.500000,77.680000'),
(3038,	'Mau',	'UP',	'25.960000,83.560000'),
(3039,	'Mauranipur',	'UP',	'25.240000,79.130000'),
(3040,	'Mawana',	'UP',	'29.110000,77.910000'),
(3041,	'Mirat',	'UP',	'28.990000,77.700000'),
(3042,	'Mirat Cantonment',	'UP',	'29.020000,77.670000'),
(3043,	'Mirzapur',	'UP',	'25.160000,82.560000'),
(3044,	'Modinagar',	'UP',	'28.920000,77.620000'),
(3045,	'Moradabad',	'UP',	'28.840000,78.760000'),
(3046,	'Mubarakpur',	'UP',	'26.090000,83.280000'),
(3047,	'Mughal Sarai',	'UP',	'25.300000,83.120000'),
(3048,	'Muradnagar',	'UP',	'28.780000,77.500000'),
(3049,	'Muzaffarnagar',	'UP',	'29.480000,77.690000'),
(3050,	'Nagina',	'UP',	'29.450000,78.430000'),
(3051,	'Najibabad',	'UP',	'29.620000,78.330000'),
(3052,	'Nawabganj',	'UP',	'26.940000,81.190000'),
(3053,	'Noida',	'UP',	'28.580000,77.330000'),
(3054,	'Obra',	'UP',	'24.420000,82.980000'),
(3055,	'Orai',	'UP',	'25.990000,79.450000'),
(3056,	'Pilibhit',	'UP',	'28.640000,79.810000'),
(3057,	'Pilkhuwa',	'UP',	'28.720000,77.650000'),
(3058,	'Rae Bareli',	'UP',	'26.230000,81.230000'),
(3059,	'Ramgarh Nagla Kothi',	'UP',	'27.154700,78.3548'),
(3060,	'Rampur',	'UP',	'28.820000,79.020000'),
(3061,	'Rath',	'UP',	'25.580000,79.570000'),
(3062,	'Renukut',	'UP',	'24.200000,83.030000'),
(3063,	'Saharanpur',	'UP',	'29.970000,77.540000'),
(3064,	'Sahaswan',	'UP',	'28.080000,78.740000'),
(3065,	'Sambhal',	'UP',	'28.590000,78.560000'),
(3066,	'Sandila',	'UP',	'27.080000,80.520000'),
(3067,	'Shahabad',	'UP',	'27.650000,79.950000'),
(3068,	'Shahjahanpur',	'UP',	'27.880000,79.900000'),
(3069,	'Shamli',	'UP',	'29.460000,77.310000'),
(3070,	'Sherkot',	'UP',	'29.350000,78.580000'),
(3071,	'Shikohabad',	'UP',	'27.120000,78.580000'),
(3072,	'Sikandarabad',	'UP',	'28.440000,77.690000'),
(3073,	'Sitapur',	'UP',	'27.570000,80.690000'),
(3074,	'Sukhmalpur Nizamabad',	'UP',	'27.173700,78.402700'),
(3075,	'Sultanpur',	'UP',	'26.260000,82.060000'),
(3076,	'Tanda',	'UP',	'26.550000,82.650000'),
(3077,	'Tilhar',	'UP',	'27.980000,79.730000'),
(3078,	'Tundla',	'UP',	'27.200000,78.280000'),
(3079,	'Ujhani',	'UP',	'28.020000,79.020000'),
(3080,	'Unnao',	'UP',	'26.550000,80.490000'),
(3081,	'Varanasi',	'UP',	'25.320000,83.010000'),
(3082,	'Vrindavan',	'UP',	'27.580000,77.700000'),
(3083,	'Dehra Dun',	'UT',	'30.340000,78.050000'),
(3084,	'Dehra Dun Cantonment',	'UT',	'30.340000,77.970000'),
(3085,	'Gola Range',	'UT',	'29.114900,79.571600'),
(3086,	'Haldwani',	'UT',	'29.230000,79.520000'),
(3087,	'Haridwar',	'UT',	'29.980000,78.160000'),
(3088,	'Kashipur',	'UT',	'29.220000,78.960000'),
(3089,	'Pithoragarh',	'UT',	'29.580000,80.220000'),
(3090,	'Rishikesh',	'UT',	'30.120000,78.290000'),
(3091,	'Rudrapur',	'UT',	'28.987500,79.414100'),
(3092,	'Rurki',	'UT',	'29.870000,77.890000'),
(3093,	'Tiruchirappalli',	'TN',	'10.790500,78.704700'),
(3094,	'Trichy',	'TN',	'10.790500,78.704700'),
(3095,	'Sindhanur',	'KA',	'15.772963, 76.753319'),
(3096,	'Coimbatore',	'TN',	'11.017363,76.958885');

DROP TABLE IF EXISTS `ob_companies`;
CREATE TABLE `ob_companies` (
  `id` mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(100) NOT NULL,
  `address1` varchar(200) DEFAULT NULL,
  `address2` varchar(200) DEFAULT NULL,
  `city` varchar(20) DEFAULT NULL,
  `stateCode` varchar(6) DEFAULT NULL,
  `stateId` mediumint(8) unsigned DEFAULT NULL,
  `stateName` varchar(50) DEFAULT NULL,
  `zip` varchar(20) DEFAULT NULL,
  `countryCode` varchar(3) DEFAULT NULL,
  `country` varchar(20) DEFAULT NULL,
  `email` varchar(200) DEFAULT NULL,
  `phone` varchar(50) DEFAULT NULL,
  `currency` varchar(3) DEFAULT NULL,
  `fyStart` tinyint(2) NOT NULL DEFAULT 4,
  `primUserid` mediumint(8) unsigned NOT NULL DEFAULT 0,
  `dateFormat` varchar(20) DEFAULT NULL,
  `logo` varchar(60) DEFAULT NULL,
  `invsign` varchar(60) DEFAULT NULL,
  `lockedTill` date DEFAULT NULL,
  `crdDate` timestamp NOT NULL DEFAULT current_timestamp(),
  `isActive` tinyint(1) NOT NULL DEFAULT 1,
  `addInfo` varchar(500) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ob_compconfig`;
CREATE TABLE `ob_compconfig` (
  `cId` mediumint(8) unsigned NOT NULL,
  `code` varchar(24) NOT NULL,
  `value` varchar(24) NOT NULL,
  PRIMARY KEY (`cId`,`code`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ob_compcontent`;
CREATE TABLE `ob_compcontent` (
  `id` mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
  `cId` mediumint(8) unsigned NOT NULL,
  `contentCode` char(10) NOT NULL COMMENT 'SI/SR/SC/SD/SB/SA/SH/SP/SE/PI/PE/PC/PD/PA/PO + N/T/E (Notes/Terms/E-EmailContent)',
  `content` text NOT NULL,
  `subject` varchar(1024) DEFAULT NULL,
  `cc` varchar(2500) NOT NULL,
  `isDefault` tinyint(4) NOT NULL DEFAULT 0,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

INSERT INTO `ob_compcontent` (`id`, `cId`, `contentCode`, `content`, `subject`, `cc`, `isDefault`) VALUES
(1,	0,	'POE',	'Dear {CustomerName}, \n\nThe purchase order ({TransNumber}) is attached with this email. \n\nAn overview of the purchase order is available below:  \nOrder# : {TransNumber}\nAmount:   {Total}\nDate:  {TransDate}\n\nPlease go through it and confirm the order. \nLooking forward to work with you again.\n\n\nRegards,\n{UserName}\n{CompanyName}',	'Purchase Order from {CompanyName} (Purchase Order #: {TransNumber})',	'',	1),
(2,	0,	'SCE',	'Dear {CustomerName}, \n\nThank you for your business with us. Please find attached a detailed copy of Credit Note.\n\nInvoice: {TransNumber}\nAmount: {Total}\nDate: {TransDate}\n\nPlease remit payment at your earliest convenience.\nLooking forward to see you at your next service.\n\nRegards,\n{UserName}\n{CompanyName}',	'Credit Note - {TransNumber} from {CompanyName}',	'',	1),
(3,	0,	'SDE',	'Dear {CustomerName}, \n\nThank you for your business with us. Please find attached a detailed copy of Debit Note.\n\nInvoice: {TransNumber}\nAmount: {Total}\nDate: {TransDate}\n\nPlease remit payment at your earliest convenience.\nLooking forward to see you at your next service.\n\nRegards,\n{UserName}\n{CompanyName}',	'Debit Note - {TransNumber} from {CompanyName}',	'',	1),
(4,	0,	'SEE',	'Dear {CustomerName}, \n\nThank you for your inquiry. Please find attached our best quote for your review.\n\nQuote: {TransNumber}\nAmount: {Total}\nDate: {TransDate}\n\nWe are happy to answer any questions or talk more about it.\nLooking forward to receiving your valued order.\n\nRegards,\n{UserName}\n{CompanyName}',	'Quote- {TransNumber}  is awaiting your approval',	'',	1),
(5,	0,	'SHE',	'Dear {CustomerName}, \r\n\r\nThank you for your business with us. Please find attached a detailed copy of Delivery Challan.\r\n\r\nDelivery Challan: {TransNumber}\r\nAmount: {Total}\r\nDate: {TransDate}\r\n\r\nPlease remit payment at your earliest convenience.\r\nLooking forward to see you at your next service.\r\n\r\nRegards,\r\n{UserName}\r\n{CompanyName}',	'Delivery Challan - {TransNumber} from {CompanyName}',	'',	1),
(6,	0,	'SIE',	'Dear {CustomerName}, \n\nThank you for your business with us. Please find attached a detailed copy of Invoice.\n\nInvoice: {TransNumber}\nAmount: {Total}\nDate: {TransDate}\nDue Date: {DueDate}\n\nPlease remit payment at your earliest convenience.\nLooking forward to see you at your next service.\n\nRegards,\n{UserName}\n{CompanyName}',	'Invoice - {TransNumber} from {CompanyName}',	'',	1),
(7,	0,	'SOE',	'Dear {CustomerName}, \r\n\r\nThe sales order ({TransNumber}) is attached with this email. \r\n\r\nAn overview of the sales order is available below:  \r\nOrder# : {TransNumber}\r\nAmount:   {Total}\r\nDate:  {TransDate}\r\n\r\nPlease go through it and confirm the order. \r\nLooking forward to work with you again.\r\n\r\n\r\nRegards,\r\n{UserName}\r\n{CompanyName}',	'Sales Order to {CompanyName} (Sales Order #: {TransNumber})',	'',	1),
(8,	0,	'SPE',	'Dear {CustomerName},\n\nThank you for your business with us. Please find attached a detailed copy of Receipt.\n\nReceipt: {TransNumber}\nAmount: {Total}\nDate: {TransDate}\n\nLooking forward to see you at your next service.\n\nRegards,\n{UserName}\n{CompanyName}',	'Receipt - {TransNumber} from {CompanyName}',	'',	1),
(9,	0,	'SRE',	'Dear {CustomerName}, \n\nThank you for your business with us. Please find attached a detailed copy of Invoice.\n\nInvoice: {TransNumber}\nAmount: {Total}\nDate: {TransDate}\n\nPlease remit payment at your earliest convenience.\nLooking forward to see you at your next service.\n\nRegards,\n{UserName}\n{CompanyName}',	'Sales Retail - {TransNumber} from {CompanyName}',	'',	1),
(10,	0,	'PQE',	'Dear {CustomerName}, \n\nThe purchase quote ({TransNumber}) is attached with this email. \n\nAn overview of the purchase quote is available below:  \nOrder# : {TransNumber}\nAmount:   {Total}\nDate:  {TransDate}\n\nPlease go through it and confirm the order. \nLooking forward to work with you again.\n\n\nRegards,\n{UserName}\n{CompanyName}',	'Purchase Quote from {CompanyName} (Purchase Quote #: {TransNumber})',	'',	1),
(11,	0,	'EIE',	'Dear {CustomerName}, \n\nan export invoice ({TransNumber}) is attached with this email. \n\nAn overview of the export invoice is available below:  \nOrder# : {TransNumber}\nAmount:   {Total}\nDate:  {TransDate}\n\nPlease go through it and confirm the order. \nLooking forward to work with you again.\n\n\nRegards,\n{UserName}\n{CompanyName}',	'Export Invoice from {CompanyName} (Export Invoice #: {TransNumber})',	'',	1),
(12,	0,	'SIREG',	'Dear {CustomerName}, \n\nThank you for your business with us. Please find attached a detailed copy of Invoice.\n\nInvoice: {TransNumber}\nAmount: {Total}\nDate: {TransDate}\nDue Date: {DueDate}\n\nPlease remit payment at your earliest convenience.\nLooking forward to see you at your next service.\n\nRegards,\n{UserName}\n{CompanyName}',	'Invoice - {TransNumber} from {CompanyName}',	'',	1),
(13,	0,	'SRBOSE',	'Dear {CustomerName}, \n\n Bill of supply  ({TransNumber}) is attached with this email. \n\n Thank you for your business with us.An overview of the Bill of supply is available below:  \nBill of supply# : {TransNumber}\nAmount:   {Total}\nDate:  {TransDate}\n\n. \n Looking forward to work with you again.\n\n\nRegards,\n{UserName}\n{CompanyName}',	'Bill of supply from {CompanyName} (Bill of supply #: {TransNumber})',	'',	1),
(14,	0,	'SIBOSE',	'Dear {CustomerName}, \n\n Bill of supply  ({TransNumber}) is attached with this email. \n\n Thank you for your business with us.An overview of the Bill of supply is available below:  \nBill of supply# : {TransNumber}\nAmount:   {Total}\nDate:  {TransDate}\n\n. \n Looking forward to work with you again.\n\n\nRegards,\n{UserName}\n{CompanyName}',	'Bill of supply from {CompanyName} (Bill of supply #: {TransNumber})',	'',	1),
(15,	0,	'SIEXPWPE',	'Dear {CustomerName}, \n\n Export with Tax Payment  ({TransNumber}) is attached with this email. \n\n Thank you for your business with us.An overview of the Export with Tax Payment is available below:  \nBill of supply# : {TransNumber}\nAmount:   {Total}\nDate:  {TransDate}\n\n \n Looking forward to work with you again.\n\n\nRegards,\n{UserName}\n{CompanyName}',	'Export with Tax Payment from {CompanyName} (Export with Tax Payment #: {TransNumber})',	'',	1),
(16,	0,	'SIEXPWOPE',	'Dear {CustomerName}, \n\n  Export without Tax Payment (bond/LUT) ({TransNumber}) is attached with this email. \n\n Thank you for your business with us.An overview of the Export without Tax Payment (bond/LUT)  is available below:  \nExport without Tax Payment# : {TransNumber}\nAmount:   {Total}\nDate:  {TransDate}\n\n\nLooking forward to work with you again.\n\n\nRegards,\n{UserName}\n{CompanyName}',	'Export without Tax Payment (bond/LUT) from {CompanyName} (Export without Tax Payment (bond/LUT) #: {TransNumber})',	'',	1),
(17,	0,	'SISEZWPE',	'Dear {CustomerName}, \n\n SEZ supplies with Tax payment  ({TransNumber}) is attached with this email. \n\nThank you for your business with us.An overview of the SEZ supplies with Tax payment is available below:  \n SEZ supplies with Tax payment# : {TransNumber}\nAmount:   {Total}\nDate:  {TransDate}\n\n\nLooking forward to work with you again.\n\n\nRegards,\n{UserName}\n{CompanyName}',	'SEZ supplies with Tax payment from {CompanyName} (SEZ supplies with Tax payment #: {TransNumber})',	'',	1),
(18,	0,	'SISEZWOPE',	'Dear {CustomerName}, \n\n SEZ supplies without Tax payment  ({TransNumber}) is attached with this email. \n\n Thank you for your business with us.An overview of the SEZ supplies without Tax payment is available below:  \nSEZ supplies without Tax payment# : {TransNumber}\nAmount:   {Total}\nDate:  {TransDate}\n\n \nLooking forward to work with you again.\n\n\nRegards,\n{UserName}\n{CompanyName}',	'SEZ supplies without Tax payment from {CompanyName} (SEZ supplies without Tax payment #: {TransNumber})',	'',	1),
(19,	0,	'SIDEEME',	'Dear {CustomerName}, \n\n Deemed Export ({TransNumber}) is attached with this email. \n\n Thank you for your business with us.An overview of the Deemed Export is available below:  \nDeemed Export# : {TransNumber}\nAmount:   {Total}\nDate:  {TransDate}\n\n\nLooking forward to work with you again.\n\n\nRegards,\n{UserName}\n{CompanyName}',	'Deemed Export from {CompanyName} (Deemed Export #: {TransNumber})',	'',	1),
(20,	0,	'SIC',	'{\"unit\":true}',	'',	'',	1),
(21,	0,	'SRC',	'{\"unit\":true}',	'',	'',	1),
(22,	0,	'SCC',	'{\"unit\":true}',	'',	'',	1),
(23,	0,	'SDC',	'{\"unit\":true}',	'',	'',	1),
(24,	0,	'SHC',	'{\"unit\":true}',	'',	'',	1),
(25,	0,	'SEC',	'{\"unit\":true}',	'',	'',	1),
(26,	0,	'SOC',	'{\"unit\":true}',	'',	'',	1),
(27,	0,	'PQC',	'{\"unit\":true}',	'',	'',	1),
(28,	0,	'POC',	'{\"unit\":true}',	'',	'',	1),
(29,	0,	'PIC',	'{\"unit\":true}',	'',	'',	1),
(30,	0,	'PCC',	'{\"unit\":true}',	'',	'',	1),
(31,	0,	'PDC',	'{\"unit\":true}',	'',	'',	1),
(32,	0,	'GRC',	'{\"unit\":true}',	'',	'',	1),
(33,	0,	'RSTROR',	'{\"obo\":{\"oboDays\":14},\"cal\":{\"reOrdDays\":14,\"basSales\":14,\"consDays\":90,\"expGrowth\":0,\"delBuffer\":0}}',	NULL,	'',	1);

DROP TABLE IF EXISTS `ob_compfields`;
CREATE TABLE `ob_compfields` (
  `id` mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
  `cId` mediumint(8) unsigned NOT NULL,
  `tType` varchar(2) NOT NULL,
  `accId` mediumint(8) unsigned DEFAULT NULL,
  `accCode` varchar(16) DEFAULT NULL,
  `fName` varchar(20) NOT NULL,
  `fCode` varchar(3) NOT NULL DEFAULT '',
  `fType` varchar(12) NOT NULL DEFAULT 'text',
  `fOptions` text NOT NULL,
  `fValue` varchar(1024) NOT NULL,
  `isActive` tinyint(1) NOT NULL DEFAULT 1,
  `isRequired` tinyint(1) NOT NULL DEFAULT 0,
  `isPrint` tinyint(1) NOT NULL DEFAULT 0,
  `isGrid` tinyint(1) NOT NULL DEFAULT 0,
  `isTotCol` tinyint(1) NOT NULL DEFAULT 0,
  `orderId` mediumint(8) unsigned NOT NULL,
  `classCode` varchar(6) NOT NULL DEFAULT 'REG',
  PRIMARY KEY (`id`),
  KEY `cId` (`cId`,`tType`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

INSERT INTO `ob_compfields` (`id`, `cId`, `tType`, `accId`, `accCode`, `fName`, `fCode`, `fType`, `fOptions`, `fValue`, `isActive`, `isRequired`, `isPrint`, `isGrid`, `isTotCol`, `orderId`, `classCode`) VALUES
(3,	0,	'SI',	NULL,	NULL,	'Delivery Note No#',	'',	'text',	'',	'',	0,	0,	1,	0,	0,	0,	'REG'),
(4,	0,	'SI',	NULL,	NULL,	'Delivery Note Date',	'',	'text',	'',	'',	0,	0,	1,	0,	0,	0,	'REG'),
(5,	0,	'SI',	NULL,	NULL,	'Despatch Method',	'',	'text',	'',	'',	0,	0,	1,	0,	0,	0,	'REG'),
(6,	0,	'SI',	NULL,	NULL,	'Despatch Date',	'',	'text',	'',	'',	0,	0,	1,	0,	0,	0,	'REG'),
(7,	0,	'SH',	NULL,	NULL,	'Transportation Mode',	'TMO',	'text',	'',	'',	1,	0,	1,	0,	0,	0,	'REG'),
(8,	0,	'SH',	NULL,	NULL,	'Transport Company',	'TCO',	'text',	'',	'',	1,	0,	1,	0,	0,	0,	'REG'),
(9,	0,	'SH',	NULL,	NULL,	'Vehicle No',	'VNO',	'text',	'',	'',	1,	0,	1,	0,	0,	0,	'REG'),
(10,	0,	'SH',	NULL,	NULL,	'Despatch Date',	'DSD',	'text',	'',	'',	1,	0,	1,	0,	0,	0,	'REG'),
(11,	0,	'PG',	51,	'CD',	'Customs Duty',	'',	'text',	'',	'',	0,	0,	1,	0,	1,	0,	'REG');

DROP TABLE IF EXISTS `ob_comprelunits`;
CREATE TABLE `ob_comprelunits` (
  `unitName` varchar(4) NOT NULL,
  `cId` mediumint(8) unsigned NOT NULL,
  `relUnitName` varchar(4) NOT NULL,
  `convFactor` double(16,8) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

INSERT INTO `ob_comprelunits` (`unitName`, `cId`, `relUnitName`, `convFactor`) VALUES
('Gms',	0,	'Kgs',	1000.00000000),
('Gms',	0,	'Ton',	1000000.00000000),
('Kgs',	0,	'Gms',	0.00100000),
('Kgs',	0,	'Ton',	1000.00000000),
('Ton',	0,	'Gms',	0.00000100),
('Ton',	0,	'Kgs',	0.00100000);

DROP TABLE IF EXISTS `ob_compsettings`;
CREATE TABLE `ob_compsettings` (
  `cId` mediumint(8) unsigned NOT NULL,
  `salModCodes` varchar(200) NOT NULL,
  `salSKU` tinyint(1) NOT NULL,
  `salDueDate` smallint(3) NOT NULL,
  `salAccountsCol` tinyint(1) NOT NULL,
  `salRoundOff` smallint(3) NOT NULL,
  `salNonItem` tinyint(1) NOT NULL,
  `salChargesCode` text NOT NULL,
  `purChargesCode` text NOT NULL,
  `recpChargesCode` text NOT NULL,
  `salReverse` tinyint(1) NOT NULL,
  `salInvType` tinyint(1) NOT NULL DEFAULT 1,
  `salLastEntryDate` tinyint(1) NOT NULL DEFAULT 0,
  `salOrdNo` varchar(1) NOT NULL DEFAULT '0',
  `salOnlyStock` tinyint(1) NOT NULL DEFAULT 0,
  `salInfoPanel` tinyint(1) NOT NULL DEFAULT 1,
  `salTotDisc` tinyint(1) NOT NULL DEFAULT 0,
  `mrpInPurSal` tinyint(1) NOT NULL DEFAULT 0,
  `purModCodes` varchar(20) NOT NULL,
  `purItemCol` tinyint(1) NOT NULL,
  `purAccountsCol` tinyint(1) NOT NULL,
  `purForCustomer` tinyint(1) NOT NULL,
  `salEstTemplate` varchar(20) NOT NULL DEFAULT 'est',
  `salOrdTemplate` varchar(20) NOT NULL DEFAULT 'salord',
  `salInvTemplate` varchar(20) NOT NULL,
  `salRetInvTemplate` varchar(20) NOT NULL,
  `delChalTemplate` varchar(20) NOT NULL DEFAULT 'delchallan',
  `receiptTemplate` varchar(20) NOT NULL,
  `expInvTemplate` varchar(20) NOT NULL,
  `purOrdTemplate` varchar(20) DEFAULT NULL,
  `purinvTemplate` varchar(20) DEFAULT NULL,
  `defBank` mediumint(8) unsigned DEFAULT NULL,
  `resetSeries` tinyint(1) NOT NULL DEFAULT 1,
  `shareContacts` tinyint(4) NOT NULL DEFAULT 0,
  `defaultHS` varchar(20) NOT NULL,
  `defaultType` varchar(1) NOT NULL DEFAULT 'G',
  `shareConbtwBranches` tinyint(1) NOT NULL DEFAULT 1,
  `stkRate` char(1) NOT NULL DEFAULT 'A' COMMENT 'A- Average Purchase Rate, S-ItemSalesRate, P-ItemPurchaseRate',
  `incPurCharges` tinyint(1) NOT NULL DEFAULT 0,
  `salRateInPur` tinyint(1) NOT NULL DEFAULT 0,
  `salPercent` decimal(5,2) NOT NULL,
  `freeQty` tinyint(1) NOT NULL DEFAULT 0,
  `isIncludeTax` tinyint(1) NOT NULL DEFAULT 0 COMMENT '0 - exclusive, 1- inclusive,2-exclusive only,3-inclusive only',
  `salSettings` text NOT NULL DEFAULT '',
  `templates` text NOT NULL DEFAULT '',
  PRIMARY KEY (`cId`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

INSERT INTO `ob_compsettings` (`cId`, `salModCodes`, `salSKU`, `salDueDate`, `salAccountsCol`, `salRoundOff`, `salNonItem`, `salChargesCode`, `purChargesCode`, `recpChargesCode`, `salReverse`, `salInvType`, `salLastEntryDate`, `salOrdNo`, `salOnlyStock`, `salInfoPanel`, `salTotDisc`, `mrpInPurSal`, `purModCodes`, `purItemCol`, `purAccountsCol`, `purForCustomer`, `salEstTemplate`, `salOrdTemplate`, `salInvTemplate`, `salRetInvTemplate`, `delChalTemplate`, `receiptTemplate`, `expInvTemplate`, `purOrdTemplate`, `purinvTemplate`, `defBank`, `resetSeries`, `shareContacts`, `defaultHS`, `defaultType`, `shareConbtwBranches`, `stkRate`, `incPurCharges`, `salRateInPur`, `salPercent`, `freeQty`, `isIncludeTax`, `salSettings`, `templates`) VALUES
(0,	'SE,SH,SC,SD,SP',	1,	0,	1,	1,	0,	'{}',	'',	'',	0,	0,	0,	'0',	0,	1,	0,	0,	'',	0,	0,	0,	'est',	'salord',	'salinv',	'salretail',	'delchallan',	'salpmt',	'exp',	NULL,	NULL,	0,	1,	0,	'',	'G',	1,	'A',	0,	0,	0.00,	0,	0,	'{\"salRepCommission\":\"0\",\"referredByCommission\":0,\"referredByLabel\":\"\",\"strictContacts\":true,\"purRateType\":\"F\",\"rateFraction\":\"2\",\"currFraction\":\"2\"}',	'');

DROP TABLE IF EXISTS `ob_compsmtp`;
CREATE TABLE `ob_compsmtp` (
  `id` mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
  `cId` mediumint(8) unsigned NOT NULL,
  `bId` int(11) NOT NULL DEFAULT 0,
  `type` varchar(1) NOT NULL DEFAULT 'E' COMMENT 'E-Email,S-SMS',
  `settings` text NOT NULL DEFAULT '',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

INSERT INTO `ob_compsmtp` (`id`, `cId`, `bId`, `type`, `settings`) VALUES
(1,	0,	0,	'S',	'{\"data\":[],\"url\":\"https://web.whatsapp.com/\",\"gateway\":\"SRIMAX\"}');

DROP TABLE IF EXISTS `ob_compunits`;
CREATE TABLE `ob_compunits` (
  `cId` mediumint(8) unsigned NOT NULL,
  `name` varchar(4) NOT NULL,
  `descr` varchar(20) NOT NULL,
  `isDefault` tinyint(1) NOT NULL DEFAULT 0,
  `isActive` tinyint(1) NOT NULL DEFAULT 1,
  `isSys` tinyint(1) NOT NULL DEFAULT 1,
  `uqcCode` varchar(3) NOT NULL,
  `convFactor` float(9,4) NOT NULL DEFAULT 1.0000,
  UNIQUE KEY `IX_name_cid` (`name`,`cId`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

INSERT INTO `ob_compunits` (`cId`, `name`, `descr`, `isDefault`, `isActive`, `isSys`, `uqcCode`, `convFactor`) VALUES
(0,	'Gms',	'Grammes',	0,	1,	0,	'GMS',	1.0000),
(0,	'Kgs',	'Kilograms',	0,	1,	0,	'KGS',	1.0000),
(0,	'Ltr',	'Liters',	0,	1,	0,	'MLT',	0.0010),
(0,	'Nos',	'Numbers',	1,	1,	0,	'NOS',	1.0000),
(0,	'Oth',	'Others',	0,	1,	0,	'OTH',	1.0000),
(0,	'Pcs',	'Numbers',	0,	1,	0,	'PCS',	1.0000),
(0,	'Ton',	'Tonnes',	0,	1,	0,	'TON',	1.0000);

DROP TABLE IF EXISTS `ob_compusers`;
CREATE TABLE `ob_compusers` (
  `userId` mediumint(8) unsigned NOT NULL,
  `cId` mediumint(8) unsigned NOT NULL,
  `roleId` mediumint(8) unsigned DEFAULT NULL,
  `invsign` varchar(64) DEFAULT NULL,
  UNIQUE KEY `compuser` (`userId`,`cId`),
  KEY `cId` (`cId`),
  KEY `userId` (`userId`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ob_compusers_location`;
CREATE TABLE `ob_compusers_location` (
  `uId` mediumint(8) unsigned NOT NULL,
  `cId` mediumint(8) unsigned NOT NULL,
  `locId` mediumint(8) unsigned NOT NULL,
  UNIQUE KEY `ucl_id` (`uId`,`cId`,`locId`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ob_contacts`;
CREATE TABLE `ob_contacts` (
  `id` mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
  `cId` mediumint(8) unsigned NOT NULL,
  `mconId` mediumint(8) unsigned NOT NULL DEFAULT 0,
  `name` varchar(100) NOT NULL,
  `company` varchar(100) NOT NULL DEFAULT '',
  `csType` char(1) NOT NULL DEFAULT 'C' COMMENT 'C - Customer / S - Supplier / L - Warehouse / B - Branches',
  `stateCode` varchar(6) NOT NULL,
  `stateId` mediumint(8) unsigned NOT NULL,
  `email` varchar(200) NOT NULL DEFAULT '',
  `contactPerson` varchar(60) NOT NULL,
  `contactPersonMobile` varchar(45) NOT NULL DEFAULT '',
  `salesDue` smallint(6) NOT NULL COMMENT 'Due Days',
  `salesDiscount` decimal(4,2) NOT NULL,
  `isActive` tinyint(1) NOT NULL DEFAULT 1,
  `taxNo` varchar(20) NOT NULL,
  `conTaxScheme` varchar(1) DEFAULT NULL COMMENT 'C-Composition Scheme,U-Unregister,R-Registered*',
  `balance` decimal(11,2) NOT NULL,
  `perTax` varchar(20) DEFAULT NULL,
  `tds` decimal(5,2) NOT NULL DEFAULT 0.00,
  `plId` int(11) NOT NULL DEFAULT -1,
  `rank` smallint(5) NOT NULL DEFAULT 0,
  `updatedOn` timestamp NOT NULL DEFAULT current_timestamp() ON UPDATE current_timestamp(),
  `bId` mediumint(8) unsigned NOT NULL DEFAULT 0,
  `defaultPayAcc` mediumint(8) unsigned NOT NULL,
  `password` varchar(64) CHARACTER SET latin1 NOT NULL,
  `score` tinyint(3) unsigned NOT NULL DEFAULT 0,
  PRIMARY KEY (`id`),
  KEY `IX_cid_bid` (`cId`,`bId`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ob_contacts_address`;
CREATE TABLE `ob_contacts_address` (
  `id` mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
  `cId` mediumint(8) unsigned NOT NULL,
  `conId` mediumint(8) unsigned NOT NULL,
  `addrType` char(1) NOT NULL DEFAULT 'A' COMMENT 'B - Bill/S - Ship/A - All',
  `address1` varchar(200) NOT NULL,
  `address2` varchar(200) NOT NULL,
  `city` varchar(20) NOT NULL,
  `stateCode` varchar(5) NOT NULL,
  `stateId` mediumint(8) unsigned NOT NULL,
  `stateName` varchar(32) DEFAULT NULL,
  `zip` varchar(20) NOT NULL,
  `countryCode` varchar(3) NOT NULL,
  `country` varchar(20) NOT NULL,
  `phone` varchar(20) NOT NULL,
  `location` varchar(50) NOT NULL,
  `email` varchar(200) NOT NULL,
  `name` varchar(200) NOT NULL,
  `taxNo` varchar(20) NOT NULL,
  UNIQUE KEY `id` (`id`),
  KEY `IX_conId` (`conId`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ob_contacts_config`;
CREATE TABLE `ob_contacts_config` (
  `cId` mediumint(8) unsigned NOT NULL,
  `conId` mediumint(8) unsigned NOT NULL,
  `code` varchar(24) NOT NULL,
  `value` varchar(256) NOT NULL,
  PRIMARY KEY (`cId`,`conId`,`code`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ob_contacts_tags`;
CREATE TABLE `ob_contacts_tags` (
  `cId` mediumint(8) unsigned NOT NULL,
  `tagId` mediumint(8) unsigned NOT NULL,
  `conId` mediumint(8) unsigned NOT NULL,
  PRIMARY KEY (`tagId`,`conId`),
  KEY `IX_conId` (`conId`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ob_countries`;
CREATE TABLE `ob_countries` (
  `id` mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
  `countryCode` char(2) NOT NULL,
  `countryName` varchar(100) NOT NULL,
  `phonecode` mediumint(8) unsigned NOT NULL,
  `currencyCode` char(3) NOT NULL,
  `isoAlpha3` char(3) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
ALTER TABLE `ob_countries` ADD `timezone` VARCHAR(10) NOT NULL AFTER `isoAlpha3`;
INSERT INTO `ob_countries` (`id`, `countryCode`, `countryName`, `phonecode`, `currencyCode`, `isoAlpha3`, `timezone`) VALUES
(1, 'AF', 'Afghanistan', 93, 'AFN', 'AFG', 'UP45'),
(2, 'AL', 'Albania', 355, 'ALL', 'ALB', 'UP1'),
(3, 'DZ', 'Algeria', 213, 'DZD', 'DZA', 'UP1'),
(4, 'AS', 'American Samoa', 1684, 'USD', 'ASM', 'UM11'),
(5, 'AD', 'Andorra', 376, 'EUR', 'AND', 'UP1'),
(6, 'AO', 'Angola', 244, 'AOA', 'AGO', 'UP1'),
(7, 'AI', 'Anguilla', 1264, 'XCD', 'AIA', 'UM4'),
(8, 'AQ', 'Antarctica', 0, '', 'ATA', 'UP12'),
(9, 'AG', 'Antigua And Barbuda', 1268, 'XCD', 'ATG', 'UM4'),
(10, 'AR', 'Argentina', 54, 'ARS', 'ARG', 'UM3'),
(11, 'AM', 'Armenia', 374, 'AMD', 'ARM', 'UP4'),
(12, 'AW', 'Aruba', 297, 'AWG', 'ABW', 'UM4'),
(13, 'AU', 'Australia', 61, 'AUD', 'AUS', 'UP95'),
(14, 'AT', 'Austria', 43, 'EUR', 'AUT', 'UP1'),
(15, 'AZ', 'Azerbaijan', 994, 'AZN', 'AZE', 'UP4'),
(16, 'BS', 'Bahamas The', 1242, 'BSD', 'BHS', 'UM5'),
(17, 'BH', 'Bahrain', 973, 'BHD', 'BHR', 'UP3'),
(18, 'BD', 'Bangladesh', 880, 'BDT', 'BGD', 'UP6'),
(19, 'BB', 'Barbados', 1246, 'BBD', 'BRB', 'UM4'),
(20, 'BY', 'Belarus', 375, 'BYR', 'BLR', 'UP3'),
(21, 'BE', 'Belgium', 32, 'EUR', 'BEL', 'UP1'),
(22, 'BZ', 'Belize', 501, 'BZD', 'BLZ', 'UM6'),
(23, 'BJ', 'Benin', 229, 'XOF', 'BEN', 'UP1'),
(24, 'BM', 'Bermuda', 1441, 'BMD', 'BMU', 'UM4'),
(25, 'BT', 'Bhutan', 975, 'BTN', 'BTN', 'UP6'),
(26, 'BO', 'Bolivia', 591, 'BOB', 'BOL', 'UM4'),
(27, 'BA', 'Bosnia and Herzegovina', 387, 'BAM', 'BIH', 'UP1'),
(28, 'BW', 'Botswana', 267, 'BWP', 'BWA', 'UP2'),
(29, 'BV', 'Bouvet Island', 0, 'NOK', 'BVT', 'UP1'),
(30, 'BR', 'Brazil', 55, 'BRL', 'BRA', 'UM3'),
(31, 'IO', 'British Indian Ocean Territory', 246, 'USD', 'IOT', 'UP6'),
(32, 'BN', 'Brunei', 673, 'BND', 'BRN', 'UP8'),
(33, 'BG', 'Bulgaria', 359, 'BGN', 'BGR', 'UP2'),
(34, 'BF', 'Burkina Faso', 226, 'XOF', 'BFA', 'UTC'),
(35, 'BI', 'Burundi', 257, 'BIF', 'BDI', 'UP2'),
(36, 'KH', 'Cambodia', 855, 'KHR', 'KHM', 'UP7'),
(37, 'CM', 'Cameroon', 237, 'XAF', 'CMR', 'UP1'),
(38, 'CA', 'Canada', 1, 'CAD', 'CAN', 'UM4'),
(39, 'CV', 'Cape Verde', 238, 'CVE', 'CPV', 'UM1'),
(40, 'KY', 'Cayman Islands', 1345, 'KYD', 'CYM', 'UM5'),
(41, 'CF', 'Central African Republic', 236, 'XAF', 'CAF', 'UP1'),
(42, 'TD', 'Chad', 235, 'XAF', 'TCD', 'UP1'),
(43, 'CL', 'Chile', 56, 'CLP', 'CHL', 'UM4'),
(44, 'CN', 'China', 86, 'CNY', 'CHN', 'UP8'),
(45, 'CX', 'Christmas Island', 61, 'AUD', 'CXR', 'UP7'),
(46, 'CC', 'Cocos (Keeling) Islands', 672, 'AUD', 'CCK', 'UP65'),
(47, 'CO', 'Colombia', 57, 'COP', 'COL', 'UM5'),
(48, 'KM', 'Comoros', 269, 'KMF', 'COM', 'UP3'),
(49, 'CG', 'Republic Of The Congo', 242, 'XAF', 'COG', 'UP1'),
(50, 'CD', 'Democratic Republic Of The Congo', 242, 'CDF', 'COD', 'UP1'),
(51, 'CK', 'Cook Islands', 682, 'NZD', 'COK', 'UM10'),
(52, 'CR', 'Costa Rica', 506, 'CRC', 'CRI', 'UM6'),
(53, 'CI', 'Cote D\'Ivoire (Ivory Coast)', 225, 'XOF', 'CIV', 'UTC'),
(54, 'HR', 'Croatia (Hrvatska)', 385, 'HRK', 'HRV', 'UP1'),
(55, 'CU', 'Cuba', 53, 'CUP', 'CUB', 'UM5'),
(56, 'CY', 'Cyprus', 357, 'EUR', 'CYP', 'UP2'),
(57, 'CZ', 'Czech Republic', 420, 'CZK', 'CZE', 'UP1'),
(58, 'DK', 'Denmark', 45, 'DKK', 'DNK', 'UP1'),
(59, 'DJ', 'Djibouti', 253, 'DJF', 'DJI', 'UP3'),
(60, 'DM', 'Dominica', 1767, 'XCD', 'DMA', 'UM4'),
(61, 'DO', 'Dominican Republic', 1809, 'DOP', 'DOM', 'UM4'),
(62, 'TL', 'East Timor', 670, 'USD', 'TLS', 'UP9'),
(63, 'EC', 'Ecuador', 593, 'USD', 'ECU', 'UM5'),
(64, 'EG', 'Egypt', 20, 'EGP', 'EGY', 'UP2'),
(65, 'SV', 'El Salvador', 503, 'USD', 'SLV', 'UM6'),
(66, 'GQ', 'Equatorial Guinea', 240, 'XAF', 'GNQ', 'UP1'),
(67, 'ER', 'Eritrea', 291, 'ERN', 'ERI', 'UP3'),
(68, 'EE', 'Estonia', 372, 'EUR', 'EST', 'UP2'),
(69, 'ET', 'Ethiopia', 251, 'ETB', 'ETH', 'UP3'),
(70, 'XA', 'External Territories of Australia', 61, '', '', ''),
(71, 'FK', 'Falkland Islands', 500, 'FKP', 'FLK', 'UM3'),
(72, 'FO', 'Faroe Islands', 298, 'DKK', 'FRO', 'UTC'),
(73, 'FJ', 'Fiji Islands', 679, 'FJD', 'FJI', 'UP12'),
(74, 'FI', 'Finland', 358, 'EUR', 'FIN', 'UP2'),
(75, 'FR', 'France', 33, 'EUR', 'FRA', 'UP1'),
(76, 'GF', 'French Guiana', 594, 'EUR', 'GUF', 'UM3'),
(77, 'PF', 'French Polynesia', 689, 'XPF', 'PYF', ''),
(78, 'TF', 'French Southern Territories', 0, 'EUR', 'ATF', 'UP5'),
(79, 'GA', 'Gabon', 241, 'XAF', 'GAB', 'UP1'),
(80, 'GM', 'Gambia The', 220, 'GMD', 'GMB', 'UTC'),
(81, 'GE', 'Georgia', 995, 'GEL', 'GEO', 'UP4'),
(82, 'DE', 'Germany', 49, 'EUR', 'DEU', 'UP1'),
(83, 'GH', 'Ghana', 233, 'GHS', 'GHA', 'UTC'),
(84, 'GI', 'Gibraltar', 350, 'GIP', 'GIB', 'UP1'),
(85, 'GR', 'Greece', 30, 'EUR', 'GRC', 'UP2'),
(86, 'GL', 'Greenland', 299, 'DKK', 'GRL', 'UM2'),
(87, 'GD', 'Grenada', 1473, 'XCD', 'GRD', 'UM4'),
(88, 'GP', 'Guadeloupe', 590, 'EUR', 'GLP', 'UM4'),
(89, 'GU', 'Guam', 1671, 'USD', 'GUM', 'UP10'),
(90, 'GT', 'Guatemala', 502, 'GTQ', 'GTM', 'UM6'),
(91, 'XU', 'Guernsey and Alderney', 44, '', '', 'UTC'),
(92, 'GN', 'Guinea', 224, 'GNF', 'GIN', 'UTC'),
(93, 'GW', 'Guinea-Bissau', 245, 'XOF', 'GNB', 'UTC'),
(94, 'GY', 'Guyana', 592, 'GYD', 'GUY', 'UM4'),
(95, 'HT', 'Haiti', 509, 'HTG', 'HTI', 'UM5'),
(96, 'HM', 'Heard and McDonald Islands', 0, 'AUD', 'HMD', 'UP5'),
(97, 'HN', 'Honduras', 504, 'HNL', 'HND', 'UM6'),
(98, 'HK', 'Hong Kong S.A.R.', 852, 'HKD', 'HKG', 'UP8'),
(99, 'HU', 'Hungary', 36, 'HUF', 'HUN', 'UP1'),
(100, 'IS', 'Iceland', 354, 'ISK', 'ISL', 'UTC'),
(101, 'IN', 'India', 91, 'INR', 'IND', 'UP55'),
(102, 'ID', 'Indonesia', 62, 'IDR', 'IDN', 'UP7'),
(103, 'IR', 'Iran', 98, 'IRR', 'IRN', 'UP35'),
(104, 'IQ', 'Iraq', 964, 'IQD', 'IRQ', 'UP3'),
(105, 'IE', 'Ireland', 353, 'EUR', 'IRL', 'UTC'),
(106, 'IL', 'Israel', 972, 'ILS', 'ISR', 'UP2'),
(107, 'IT', 'Italy', 39, 'EUR', 'ITA', 'UP1'),
(108, 'JM', 'Jamaica', 1876, 'JMD', 'JAM', 'UM5'),
(109, 'JP', 'Japan', 81, 'JPY', 'JPN', 'UP9'),
(110, 'XJ', 'Jersey', 44, '', '', 'UTC'),
(111, 'JO', 'Jordan', 962, 'JOD', 'JOR', 'UP2'),
(112, 'KZ', 'Kazakhstan', 7, 'KZT', 'KAZ', 'UP6'),
(113, 'KE', 'Kenya', 254, 'KES', 'KEN', 'UP3'),
(114, 'KI', 'Kiribati', 686, 'AUD', 'KIR', ''),
(115, 'KP', 'Korea North', 850, 'KPW', 'PRK', 'UP85'),
(116, 'KR', 'Korea South', 82, 'KRW', 'KOR', 'UP9'),
(117, 'KW', 'Kuwait', 965, 'KWD', 'KWT', 'UP3'),
(118, 'KG', 'Kyrgyzstan', 996, 'KGS', 'KGZ', 'UP6'),
(119, 'LA', 'Laos', 856, 'LAK', 'LAO', 'UP7'),
(120, 'LV', 'Latvia', 371, 'EUR', 'LVA', 'UP2'),
(121, 'LB', 'Lebanon', 961, 'LBP', 'LBN', 'UP2'),
(122, 'LS', 'Lesotho', 266, 'LSL', 'LSO', 'UP2'),
(123, 'LR', 'Liberia', 231, 'LRD', 'LBR', 'UTC'),
(124, 'LY', 'Libya', 218, 'LYD', 'LBY', 'UP2'),
(125, 'LI', 'Liechtenstein', 423, 'CHF', 'LIE', 'UP1'),
(126, 'LT', 'Lithuania', 370, 'EUR', 'LTU', 'UP2'),
(127, 'LU', 'Luxembourg', 352, 'EUR', 'LUX', 'UP1'),
(128, 'MO', 'Macau S.A.R.', 853, 'MOP', 'MAC', 'UP8'),
(129, 'MK', 'Macedonia', 389, 'MKD', 'MKD', 'UP1'),
(130, 'MG', 'Madagascar', 261, 'MGA', 'MDG', 'UP3'),
(131, 'MW', 'Malawi', 265, 'MWK', 'MWI', 'UP2'),
(132, 'MY', 'Malaysia', 60, 'MYR', 'MYS', 'UP8'),
(133, 'MV', 'Maldives', 960, 'MVR', 'MDV', 'UP5'),
(134, 'ML', 'Mali', 223, 'XOF', 'MLI', 'UTC'),
(135, 'MT', 'Malta', 356, 'EUR', 'MLT', 'UP1'),
(136, 'XM', 'Man (Isle of)', 44, '', '', 'UTC'),
(137, 'MH', 'Marshall Islands', 692, 'USD', 'MHL', 'UP12'),
(138, 'MQ', 'Martinique', 596, 'EUR', 'MTQ', 'UM4'),
(139, 'MR', 'Mauritania', 222, 'MRO', 'MRT', 'UTC'),
(140, 'MU', 'Mauritius', 230, 'MUR', 'MUS', 'UP4'),
(141, 'YT', 'Mayotte', 269, 'EUR', 'MYT', 'UP3'),
(142, 'MX', 'Mexico', 52, 'MXN', 'MEX', 'UM6'),
(143, 'FM', 'Micronesia', 691, 'USD', 'FSM', 'UP11'),
(144, 'MD', 'Moldova', 373, 'MDL', 'MDA', 'UP2'),
(145, 'MC', 'Monaco', 377, 'EUR', 'MCO', 'UP1'),
(146, 'MN', 'Mongolia', 976, 'MNT', 'MNG', 'UP8'),
(147, 'MS', 'Montserrat', 1664, 'XCD', 'MSR', 'UM4'),
(148, 'MA', 'Morocco', 212, 'MAD', 'MAR', 'UTC'),
(149, 'MZ', 'Mozambique', 258, 'MZN', 'MOZ', 'UP2'),
(150, 'MM', 'Myanmar', 95, 'MMK', 'MMR', 'UP65'),
(151, 'NA', 'Namibia', 264, 'NAD', 'NAM', 'UP2'),
(152, 'NR', 'Nauru', 674, 'AUD', 'NRU', 'UP12'),
(153, 'NP', 'Nepal', 977, 'NPR', 'NPL', 'UP575'),
(154, 'AN', 'Netherlands Antilles', 599, '', '', 'UM4'),
(155, 'NL', 'Netherlands The', 31, 'EUR', 'NLD', 'UP1'),
(156, 'NC', 'New Caledonia', 687, 'XPF', 'NCL', 'UP11'),
(157, 'NZ', 'New Zealand', 64, 'NZD', 'NZL', 'UP12'),
(158, 'NI', 'Nicaragua', 505, 'NIO', 'NIC', 'UM6'),
(159, 'NE', 'Niger', 227, 'XOF', 'NER', 'UP1'),
(160, 'NG', 'Nigeria', 234, 'NGN', 'NGA', 'UP1'),
(161, 'NU', 'Niue', 683, 'NZD', 'NIU', 'UM11'),
(162, 'NF', 'Norfolk Island', 672, 'AUD', 'NFK', 'UP115'),
(163, 'MP', 'Northern Mariana Islands', 1670, 'USD', 'MNP', 'UP10'),
(164, 'NO', 'Norway', 47, 'NOK', 'NOR', 'UP1'),
(165, 'OM', 'Oman', 968, 'OMR', 'OMN', 'UP4'),
(166, 'PK', 'Pakistan', 92, 'PKR', 'PAK', 'UP5'),
(167, 'PW', 'Palau', 680, 'USD', 'PLW', 'UP9'),
(168, 'PS', 'Palestinian Territory Occupied', 970, 'ILS', 'PSE', 'UP2'),
(169, 'PA', 'Panama', 507, 'PAB', 'PAN', 'UM5'),
(170, 'PG', 'Papua new Guinea', 675, 'PGK', 'PNG', 'UP10'),
(171, 'PY', 'Paraguay', 595, 'PYG', 'PRY', 'UM4'),
(172, 'PE', 'Peru', 51, 'PEN', 'PER', 'UM5'),
(173, 'PH', 'Philippines', 63, 'PHP', 'PHL', 'UP8'),
(174, 'PN', 'Pitcairn Island', 0, 'NZD', 'PCN', 'UM8'),
(175, 'PL', 'Poland', 48, 'PLN', 'POL', 'UP1'),
(176, 'PT', 'Portugal', 351, 'EUR', 'PRT', 'UTC'),
(177, 'PR', 'Puerto Rico', 1787, 'USD', 'PRI', 'UM4'),
(178, 'QA', 'Qatar', 974, 'QAR', 'QAT', 'UP3'),
(179, 'RE', 'Reunion', 262, 'EUR', 'REU', 'UP4'),
(180, 'RO', 'Romania', 40, 'RON', 'ROU', 'UP2'),
(181, 'RU', 'Russia', 70, 'RUB', 'RUS', 'UP3'),
(182, 'RW', 'Rwanda', 250, 'RWF', 'RWA', 'UP2'),
(183, 'SH', 'Saint Helena', 290, 'SHP', 'SHN', 'UTC'),
(184, 'KN', 'Saint Kitts And Nevis', 1869, 'XCD', 'KNA', 'UM4'),
(185, 'LC', 'Saint Lucia', 1758, 'XCD', 'LCA', 'UM4'),
(186, 'PM', 'Saint Pierre and Miquelon', 508, 'EUR', 'SPM', 'UM3'),
(187, 'VC', 'Saint Vincent And The Grenadines', 1784, 'XCD', 'VCT', 'UM4'),
(188, 'WS', 'Samoa', 684, 'WST', 'WSM', 'UP13'),
(189, 'SM', 'San Marino', 378, 'EUR', 'SMR', 'UP1'),
(190, 'ST', 'Sao Tome and Principe', 239, 'STD', 'STP', 'UTC'),
(191, 'SA', 'Saudi Arabia', 966, 'SAR', 'SAU', 'UP3'),
(192, 'SN', 'Senegal', 221, 'XOF', 'SEN', 'UTC'),
(193, 'RS', 'Serbia', 381, 'RSD', 'SRB', 'UP1'),
(194, 'SC', 'Seychelles', 248, 'SCR', 'SYC', 'UP4'),
(195, 'SL', 'Sierra Leone', 232, 'SLL', 'SLE', 'UTC'),
(196, 'SG', 'Singapore', 65, 'SGD', 'SGP', 'UP8'),
(197, 'SK', 'Slovakia', 421, 'EUR', 'SVK', 'UP1'),
(198, 'SI', 'Slovenia', 386, 'EUR', 'SVN', 'UP1'),
(199, 'XG', 'Smaller Territories of the UK', 44, '', '', ''),
(200, 'SB', 'Solomon Islands', 677, 'SBD', 'SLB', 'UP11'),
(201, 'SO', 'Somalia', 252, 'SOS', 'SOM', 'UP3'),
(202, 'ZA', 'South Africa', 27, 'ZAR', 'ZAF', 'UP2'),
(203, 'GS', 'South Georgia', 0, 'GBP', 'SGS', 'UM2'),
(204, 'SS', 'South Sudan', 211, 'SSP', 'SSD', 'UP3'),
(205, 'ES', 'Spain', 34, 'EUR', 'ESP', 'UP1'),
(206, 'LK', 'Sri Lanka', 94, 'LKR', 'LKA', 'UP55'),
(207, 'SD', 'Sudan', 249, 'SDG', 'SDN', 'UP2'),
(208, 'SR', 'Suriname', 597, 'SRD', 'SUR', 'UM3'),
(209, 'SJ', 'Svalbard And Jan Mayen Islands', 47, 'NOK', 'SJM', 'UP1'),
(210, 'SZ', 'Swaziland', 268, 'SZL', 'SWZ', 'UP2'),
(211, 'SE', 'Sweden', 46, 'SEK', 'SWE', 'UP1'),
(212, 'CH', 'Switzerland', 41, 'CHF', 'CHE', 'UP1'),
(213, 'SY', 'Syria', 963, 'SYP', 'SYR', 'UP2'),
(214, 'TW', 'Taiwan', 886, 'TWD', 'TWN', 'UP8'),
(215, 'TJ', 'Tajikistan', 992, 'TJS', 'TJK', 'UP5'),
(216, 'TZ', 'Tanzania', 255, 'TZS', 'TZA', 'UP3'),
(217, 'TH', 'Thailand', 66, 'THB', 'THA', 'UP7'),
(218, 'TG', 'Togo', 228, 'XOF', 'TGO', 'UTC'),
(219, 'TK', 'Tokelau', 690, 'NZD', 'TKL', 'UP13'),
(220, 'TO', 'Tonga', 676, 'TOP', 'TON', 'UP13'),
(221, 'TT', 'Trinidad And Tobago', 1868, 'TTD', 'TTO', 'UM4'),
(222, 'TN', 'Tunisia', 216, 'TND', 'TUN', 'UP1'),
(223, 'TR', 'Turkey', 90, 'TRY', 'TUR', 'UP3'),
(224, 'TM', 'Turkmenistan', 7370, 'TMT', 'TKM', 'UP5'),
(225, 'TC', 'Turks And Caicos Islands', 1649, 'USD', 'TCA', 'UM5'),
(226, 'TV', 'Tuvalu', 688, 'AUD', 'TUV', 'UP12'),
(227, 'UG', 'Uganda', 256, 'UGX', 'UGA', 'UP3'),
(228, 'UA', 'Ukraine', 380, 'UAH', 'UKR', 'UP2'),
(229, 'AE', 'United Arab Emirates', 971, 'AED', 'ARE', 'UP4'),
(230, 'GB', 'United Kingdom', 44, 'GBP', 'GBR', 'UTC'),
(231, 'US', 'United States', 1, 'USD', 'USA', 'UM3'),
(232, 'UM', 'United States Minor Outlying Islands', 1, 'USD', 'UMI', 'UP1'),
(233, 'UY', 'Uruguay', 598, 'UYU', 'URY', 'UM3'),
(234, 'UZ', 'Uzbekistan', 998, 'UZS', 'UZB', 'UP5'),
(235, 'VU', 'Vanuatu', 678, 'VUV', 'VUT', 'UP11'),
(236, 'VA', 'Vatican City State (Holy See)', 39, 'EUR', 'VAT', 'UP1'),
(237, 'VE', 'Venezuela', 58, 'VEF', 'VEN', 'UM4'),
(238, 'VN', 'Vietnam', 84, 'VND', 'VNM', 'UP7'),
(239, 'VG', 'Virgin Islands (British)', 1284, 'USD', 'VGB', 'UM4'),
(240, 'VI', 'Virgin Islands (US)', 1340, 'USD', 'VIR', 'UM4'),
(241, 'WF', 'Wallis And Futuna Islands', 681, 'XPF', 'WLF', 'UP12'),
(242, 'EH', 'Western Sahara', 212, 'MAD', 'ESH', 'UTC'),
(243, 'YE', 'Yemen', 967, 'YER', 'YEM', 'UP3'),
(244, 'YU', 'Yugoslavia', 38, '', '', 'UP1'),
(245, 'ZM', 'Zambia', 260, 'ZMW', 'ZMB', 'UP2'),
(246, 'ZW', 'Zimbabwe', 263, 'ZWL', 'ZWE', 'UP2'),
(249, 'BQ', 'Bonaire, Sint Eustatius and Saba', 0, 'USD', 'BES', 'UM4'),
(251, 'ME', 'Montenegro', 0, 'EUR', 'MNE', 'UP1'),
(252, 'GG', 'Guernsey', 0, 'GBP', 'GGY', 'UTC'),
(253, 'BL', 'Saint Barthelemy', 0, 'EUR', 'BLM', 'UM4'),
(254, 'SX', 'Sint Maarten', 0, 'ANG', 'SXM', 'UM4'),
(255, 'JE', 'Jersey', 0, 'GBP', 'JEY', 'UTC'),
(256, 'CW', 'Curacao', 0, 'ANG', 'CUW', 'UM4'),
(257, 'XK', 'Kosovo', 0, 'EUR', 'XKX', 'UP1'),
(258, 'AX', 'aland Islands', 0, 'EUR', 'ALA', 'UP2'),
(259, 'MF', 'Saint Martin', 0, 'EUR', 'MAF', 'UM4'),
(260, 'IM', 'Isle of Man', 0, 'GBP', 'IMN', 'UTC');

DROP TABLE IF EXISTS `ob_credit_limit`;
CREATE TABLE `ob_credit_limit` (
  `conTId` varchar(10) NOT NULL,
  `creditLimit` decimal(11,2) NOT NULL,
  `cId` varchar(10) NOT NULL,
  `ctType` varchar(1) NOT NULL COMMENT 'C-Contact/T-Tag',
  `dueDays` smallint(5) unsigned NOT NULL,
  `invCnt` tinyint(3) unsigned NOT NULL,
  PRIMARY KEY (`conTId`,`ctType`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ob_currency_rate`;
CREATE TABLE `ob_currency_rate` (
  `id` int(10) NOT NULL AUTO_INCREMENT,
  `fromDate` date NOT NULL,
  `currencyCode` varchar(3) NOT NULL DEFAULT '',
  `excRate` decimal(11,6) NOT NULL,
  `cId` int(10) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `IX_cidfromDate` (`cId`,`fromDate`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;


DROP TABLE IF EXISTS `ob_devices`;
CREATE TABLE `ob_devices` (
  `deviceId` mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
  `cId` mediumint(8) unsigned NOT NULL,
  `os` varchar(20) NOT NULL,
  `deviceType` varchar(1) NOT NULL,
  `deviceName` varchar(20) NOT NULL,
  `details` varchar(500) NOT NULL,
  `clientName` varchar(20) NOT NULL,
  `location` varchar(60) NOT NULL,
  `deviceIP` varchar(40) NOT NULL,
  `initDate` timestamp NULL DEFAULT NULL,
  `lastAccess` timestamp NULL DEFAULT NULL,
  `authorized` varchar(1) NOT NULL COMMENT 'A-Authorized/B-Blocked/Empty-Un Authorized',
  `dCode` varchar(250) NOT NULL,
  PRIMARY KEY (`deviceId`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ob_devicesusers`;
CREATE TABLE `ob_devicesusers` (
  `deviceId` mediumint(8) unsigned NOT NULL,
  `uId` mediumint(8) unsigned NOT NULL,
  `cId` mediumint(8) unsigned NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ob_devices_loc`;
CREATE TABLE `ob_devices_loc` (
  `deviceId` mediumint(8) unsigned NOT NULL,
  `latit` decimal(10,8) NOT NULL,
  `longit` decimal(11,8) NOT NULL,
  `accessTime` timestamp NULL DEFAULT NULL,
  `mins` mediumint(8) unsigned NOT NULL DEFAULT 0,
  KEY `IX_deviceId` (`deviceId`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ob_ewb_trans`;
CREATE TABLE `ob_ewb_trans` (
  `id` mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
  `cId` mediumint(8) unsigned NOT NULL,
  `transMode` tinyint(1) NOT NULL COMMENT 'Road-1, Rail-2, Air-3, Ship-4',
  `transDistance` mediumint(8) unsigned NOT NULL,
  `transporterId` mediumint(8) unsigned NOT NULL,
  `transDocNo` varchar(15) NOT NULL,
  `transDocDate` date NOT NULL,
  `vehicleNo` varchar(15) NOT NULL,
  `vehicleType` varchar(1) NOT NULL COMMENT 'R - Regular, O - ODC',
  `status` varchar(1) NOT NULL DEFAULT 'G' COMMENT 'G - Generated, C - Cancelled, E - Expired',
  `ewbNo` varchar(20) NOT NULL DEFAULT '',
  `ewbDt` timestamp NULL DEFAULT NULL,
  `ewbValidTill` timestamp NULL DEFAULT NULL,
  `dispatch` text NOT NULL,
  PRIMARY KEY (`id`),
  KEY `IX_cId` (`cId`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ob_ewb_trans_map`;
CREATE TABLE `ob_ewb_trans_map` (
  `ewbId` mediumint(8) unsigned NOT NULL,
  `transId` mediumint(8) unsigned NOT NULL,
  `cId` mediumint(8) unsigned NOT NULL,
  `supplyType` varchar(1) NOT NULL DEFAULT 'O',
  `subType` tinyint(1) NOT NULL,
  UNIQUE KEY `IX_ewb` (`ewbId`,`transId`,`cId`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ob_field_values`;
CREATE TABLE `ob_field_values` (
  `cId` mediumint(8) unsigned NOT NULL,
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `modId` int(11) NOT NULL,
  `modType` varchar(2) NOT NULL DEFAULT '',
  `fId` mediumint(8) unsigned NOT NULL,
  `fValue` text NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `modId` (`modId`,`modType`,`fId`),
  KEY `fValue` (`fValue`(1024))
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ob_itemrelunits`;
CREATE TABLE `ob_itemrelunits` (
  `itemId` mediumint(8) unsigned NOT NULL,
  `cId` mediumint(8) unsigned NOT NULL,
  `relUnitName` varchar(12) DEFAULT NULL,
  `convFactor` double(16,8) NOT NULL,
  `saleRate` decimal(11,2) DEFAULT NULL,
  `purchaseRate` decimal(11,2) DEFAULT NULL,
  `type` varchar(1) NOT NULL,
  `currencyCode` varchar(3) NOT NULL DEFAULT '',
  KEY `IX_itemId` (`itemId`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ob_items`;
CREATE TABLE `ob_items` (
  `itemId` mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
  `cId` mediumint(8) unsigned NOT NULL,
  `name` varchar(255) NOT NULL,
  `itemCode` varchar(6) NOT NULL,
  `type` char(1) NOT NULL COMMENT 'G / S',
  `HS` varchar(8) NOT NULL COMMENT 'HSN/SAC Code',
  `SKU` varchar(20) NOT NULL,
  `uom` varchar(10) NOT NULL,
  `isSale` tinyint(1) NOT NULL DEFAULT 0,
  `isInventory` tinyint(1) NOT NULL,
  `saleRate` decimal(11,3) NOT NULL DEFAULT 0.000,
  `saleDesc` varchar(1000) DEFAULT '',
  `saleDiscount` decimal(5,2) NOT NULL DEFAULT 0.00,
  `saleAccount` mediumint(8) unsigned NOT NULL,
  `isPurchase` tinyint(1) NOT NULL DEFAULT 0,
  `purchaseRate` decimal(11,3) NOT NULL DEFAULT 0.000,
  `purchaseDesc` varchar(1000) NOT NULL DEFAULT '',
  `purchaseAccount` mediumint(8) unsigned NOT NULL,
  `taxId` mediumint(10) unsigned NOT NULL,
  `itc` tinyint(1) NOT NULL DEFAULT 1,
  `isActive` tinyint(1) NOT NULL DEFAULT 1,
  `rank` smallint(5) NOT NULL DEFAULT 0,
  `stkLevel` decimal(9,3) DEFAULT NULL,
  `curStk` decimal(9,3) NOT NULL DEFAULT 0.000,
  `updatedOn` timestamp NOT NULL DEFAULT current_timestamp() ON UPDATE current_timestamp(),
  `mrp` decimal(11,3) NOT NULL DEFAULT 0.000,
  `minOrdQty` decimal(9,3) NOT NULL DEFAULT 0.000,
  `hsDesc` varchar(80) NOT NULL,
  `supConId` int(10) unsigned NOT NULL,
  `isOboLevel` char(1) NOT NULL,
  `currencyCode` varchar(3) NOT NULL DEFAULT '',
  `printName` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`itemId`),
  KEY `cId_name_sku` (`cId`,`name`,`SKU`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

INSERT INTO `ob_items` (`itemId`, `cId`, `name`, `itemCode`, `type`, `HS`, `SKU`, `uom`, `isSale`, `isInventory`, `saleRate`, `saleDesc`, `saleDiscount`, `saleAccount`, `isPurchase`, `purchaseRate`, `purchaseDesc`, `purchaseAccount`, `taxId`, `itc`, `isActive`, `rank`, `stkLevel`, `curStk`, `updatedOn`, `mrp`, `minOrdQty`, `hsDesc`, `supConId`, `isOboLevel`, `currencyCode`, `printName`) VALUES
(1,	0,	'Freight Charges',	'',	'A',	'',	'',	'ABT',	1,	0,	0.000,	'',	0.00,	41,	0,	0.000,	'',	0,	0,	1,	1,	0,	NULL,	0.000,	'2021-11-17 05:42:12',	0.000,	0.000,	'',	0,	'',	'',	NULL),
(2,	0,	'Packing and Forwarding Charges',	'',	'A',	'',	'',	'ABT',	1,	0,	0.000,	'',	0.00,	42,	0,	0.000,	'',	0,	0,	1,	1,	0,	NULL,	0.000,	'2021-11-17 05:42:12',	0.000,	0.000,	'',	0,	'',	'',	NULL),
(3,	0,	'Insurance Charges',	'',	'A',	'',	'',	'ABT',	1,	0,	0.000,	'',	0.00,	43,	0,	0.000,	'',	0,	0,	1,	1,	0,	NULL,	0.000,	'2021-11-17 05:42:12',	0.000,	0.000,	'',	0,	'',	'',	NULL),
(4,	0,	'TCS Payable',	'',	'A',	'',	'',	'AAT',	1,	0,	0.000,	'',	0.00,	52,	0,	0.000,	'',	0,	0,	1,	1,	0,	NULL,	0.000,	'2021-11-17 05:43:09',	0.000,	0.000,	'',	0,	'',	'',	NULL),
(8,	0,	'Customs Duty Payable',	'',	'A',	'',	'',	'AAT',	0,	0,	0.000,	'',	0.00,	0,	1,	0.000,	'',	51,	0,	1,	1,	0,	NULL,	0.000,	'2021-11-17 05:45:03',	0.000,	0.000,	'',	0,	'',	'',	NULL),
(9,	0,	'TCS Receivable',	'',	'A',	'',	'',	'AAT',	0,	0,	0.000,	'',	0.00,	0,	1,	0.000,	'',	53,	0,	1,	1,	0,	NULL,	0.000,	'2021-11-17 05:44:56',	0.000,	0.000,	'',	0,	'',	'',	NULL);

DROP TABLE IF EXISTS `ob_items_category`;
CREATE TABLE `ob_items_category` (
  `cId` mediumint(8) unsigned NOT NULL,
  `catId` mediumint(8) unsigned NOT NULL,
  `itemId` mediumint(8) unsigned NOT NULL,
  PRIMARY KEY (`catId`,`itemId`),
  KEY `IX_cId_itemId` (`cId`,`itemId`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ob_items_cur`;
CREATE TABLE `ob_items_cur` (
  `itemId` int(8) unsigned NOT NULL,
  `cId` mediumint(8) unsigned NOT NULL,
  `bId` mediumint(8) unsigned NOT NULL,
  `curStk` decimal(9,3) NOT NULL DEFAULT 0.000,
  `stkLevel` decimal(9,3) NOT NULL DEFAULT 0.000,
  `minOrdQty` decimal(9,3) NOT NULL DEFAULT 0.000,
  `supConId` int(10) unsigned NOT NULL,
  UNIQUE KEY `cId_bId_itemId` (`itemId`,`cId`,`bId`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ob_item_attr`;
CREATE TABLE `ob_item_attr` (
  `itemAttrId` mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
  `itemId` mediumint(8) unsigned NOT NULL,
  `sku` varchar(20) NOT NULL,
  `saleRate` decimal(11,3) NOT NULL DEFAULT 0.000,
  `mrp` decimal(11,3) NOT NULL DEFAULT 0.000,
  `uom` varchar(10) NOT NULL DEFAULT '',
  `cId` mediumint(8) unsigned NOT NULL,
  `flag` tinyint(1) NOT NULL DEFAULT 1,
  `currencyCode` varchar(3) NOT NULL DEFAULT '',
  PRIMARY KEY (`itemAttrId`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ob_item_attr_link`;
CREATE TABLE `ob_item_attr_link` (
  `itemAttrId` mediumint(8) unsigned NOT NULL,
  `attrId` mediumint(8) unsigned NOT NULL,
  `cId` mediumint(8) unsigned NOT NULL,
  PRIMARY KEY (`itemAttrId`,`attrId`),
  KEY `IX_attrId` (`attrId`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ob_item_attr_serial`;
CREATE TABLE `ob_item_attr_serial` (
  `id` mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
  `itemAttrId` mediumint(8) unsigned NOT NULL,
  `serialNo` varchar(32) NOT NULL,
  `cId` mediumint(8) unsigned NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `cId_itemAttrId_serialNo` (`cId`,`itemAttrId`,`serialNo`) USING BTREE,
  KEY `serialNo` (`serialNo`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ob_item_attr_serial_cur`;
CREATE TABLE `ob_item_attr_serial_cur` (
  `asid` mediumint(8) unsigned NOT NULL,
  `cId` mediumint(8) unsigned NOT NULL,
  `bId` mediumint(8) unsigned NOT NULL,
  `curStk` int(11) NOT NULL DEFAULT 0,
  UNIQUE KEY `cId_itemAttrId_serialNo` (`asid`,`cId`,`bId`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ob_item_images`;
CREATE TABLE `ob_item_images` (
  `id` mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
  `itemId` mediumint(8) unsigned NOT NULL,
  `itemAttrId` mediumint(8) unsigned NOT NULL,
  `cId` mediumint(8) unsigned NOT NULL,
  `filePath` varchar(250) NOT NULL,
  `videoUrl` varchar(500) NOT NULL,
  `orderId` smallint(2) NOT NULL DEFAULT 1,
  PRIMARY KEY (`id`),
  UNIQUE KEY `cid_itemid` (`cId`,`itemId`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ob_item_spec`;
CREATE TABLE `ob_item_spec` (
  `id` mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL,
  `options` varchar(5000) NOT NULL,
  `cId` mediumint(8) unsigned NOT NULL,
  `orderid` mediumint(8) unsigned NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;


DROP TABLE IF EXISTS `ob_item_spec_link`;
CREATE TABLE `ob_item_spec_link` (
  `itemId` int(11) unsigned NOT NULL,
  `specId` mediumint(8) unsigned NOT NULL,
  `value` varchar(500) NOT NULL,
  `cId` int(11) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;


DROP TABLE IF EXISTS `ob_licensekey`;
CREATE TABLE `ob_licensekey` (
  `id` mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
  `uId` mediumint(8) unsigned NOT NULL,
  `licenseKey` text NOT NULL,
  `plan` varchar(1) NOT NULL,
  `createdOn` timestamp NULL DEFAULT NULL,
  `expiredOn` timestamp NULL DEFAULT NULL,
  `isDeviceApprove` tinytext NOT NULL,
  `isApprovePin` varchar(24) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ob_messages`;
CREATE TABLE `ob_messages` (
  `id` mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
  `cId` int(10) unsigned NOT NULL,
  `mDate` timestamp NOT NULL DEFAULT current_timestamp() ON UPDATE current_timestamp(),
  `mType` char(2) NOT NULL,
  `message` varchar(1000) NOT NULL,
  `toUid` mediumint(8) unsigned NOT NULL,
  `toRoles` varchar(50) NOT NULL,
  `priority` char(1) NOT NULL COMMENT 'N-Normal,H-High,U-Urgent.',
  `isActive` char(1) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `IDX_mDate` (`mDate`,`toUid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;


DROP TABLE IF EXISTS `ob_oauth`;
CREATE TABLE `ob_oauth` (
  `mId` mediumint(8) unsigned NOT NULL COMMENT 'cId, uId',
  `module` varchar(64) NOT NULL COMMENT 'company, user',
  `application` varchar(64) NOT NULL COMMENT 'google, microsoft',
  `accessToken` text NOT NULL COMMENT 'JSON Content',
  `params` text NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ob_oboactions`;
CREATE TABLE `ob_oboactions` (
  `id` mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(32) NOT NULL,
  `actCode` varchar(4) NOT NULL,
  `sdesc` varchar(512) NOT NULL,
  `dirName` varchar(32) NOT NULL,
  `version` mediumint(8) unsigned NOT NULL,
  `isActive` tinyint(1) NOT NULL COMMENT '0,1,2-Always active',
  PRIMARY KEY (`id`,`name`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

INSERT INTO `ob_oboactions` (`id`, `name`, `actCode`, `sdesc`, `dirName`, `version`, `isActive`) VALUES
(1,	'Recurring Transaction',	'RTR',	'',	'RecurringTransaction',	1,	1),
(2,	'Daily Maintenance',	'DMT',	'',	'Maintenance',	1,	1),
(3,	'Weekly Maintenance',	'WMT',	'',	'Maintenance',	1,	1),
(4,	'Monthly Maintenance',	'MMT',	'',	'Maintenance',	1,	1),
(5,	'Manage Sale Rate',	'MSR',	'',	'ManageSaleRate',	1,	1),
(6,	'Payment Reminder',	'PAR',	'',	'PaymentReminder',	1,	1),
(7,	'Customer Score',	'CUS',	'',	'CustomerScore',	1,	1),
(8,	'Weekly Backup',	'WEB',	'',	'WeeklyBackup',	1,	1),
(9,	'Stock Reorder Level',	'STR',	'',	'StockRoOrderLevel',	1,	1);

DROP TABLE IF EXISTS `ob_obojobact`;
CREATE TABLE `ob_obojobact` (
  `id` mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
  `jobActName` varchar(64) NOT NULL,
  `jobId` mediumint(8) unsigned NOT NULL,
  `actId` mediumint(8) unsigned NOT NULL,
  `primeRefId` mediumint(8) unsigned NOT NULL,
  `actConfig` text NOT NULL,
  `orderId` smallint(4) NOT NULL DEFAULT 1,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

INSERT INTO `ob_obojobact` (`id`, `jobActName`, `jobId`, `actId`, `primeRefId`, `actConfig`, `orderId`) VALUES
(1,	'Daily Maintenance',	1,	2,	0,	'{}',	1),
(2,	'Weekly Maintenance',	2,	3,	0,	'{}',	1),
(3,	'Monthly Maintenance',	3,	4,	0,	'{}',	1);

DROP TABLE IF EXISTS `ob_obojobact_ref`;
CREATE TABLE `ob_obojobact_ref` (
  `jobActId` mediumint(8) unsigned NOT NULL,
  `refId` mediumint(8) unsigned NOT NULL,
  `refType` char(1) NOT NULL COMMENT 'C-Contact/T-Transaction/#-Tag',
  KEY `jobActId` (`jobActId`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ob_obojobs`;
CREATE TABLE `ob_obojobs` (
  `id` mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(64) NOT NULL,
  `cId` mediumint(8) unsigned NOT NULL,
  `bId` mediumint(8) unsigned NOT NULL,
  `nextExecOn` datetime NOT NULL,
  `lastExecOn` datetime NOT NULL,
  `isActive` tinyint(1) NOT NULL,
  `isHidden` tinyint(1) NOT NULL,
  PRIMARY KEY (`id`,`name`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

INSERT INTO `ob_obojobs` (`id`, `name`, `cId`, `bId`, `nextExecOn`, `lastExecOn`, `isActive`, `isHidden`) VALUES
(1,	'Daily Maintenance',	0,	0,	'2023-03-18 06:18:22',	'0000-00-00 00:00:00',	1,	1),
(2,	'Weekly Maintenance',	0,	0,	'2023-03-18 06:18:22',	'0000-00-00 00:00:00',	1,	1),
(3,	'Monthly Maintenance',	0,	0,	'2023-03-18 06:18:22',	'0000-00-00 00:00:00',	1,	1);

DROP TABLE IF EXISTS `ob_obojobscheduler`;
CREATE TABLE `ob_obojobscheduler` (
  `id` mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
  `jobId` mediumint(8) unsigned NOT NULL,
  `startDate` datetime NOT NULL,
  `endDate` datetime NOT NULL,
  `freqType` char(1) NOT NULL COMMENT 'O,D,W,M,A',
  `freqInterval` tinyint(2) NOT NULL COMMENT '0-Once, #-for others',
  `nextExecOn` datetime NOT NULL,
  `lastExecOn` datetime NOT NULL,
  `isActive` tinyint(1) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

INSERT INTO `ob_obojobscheduler` (`id`, `jobId`, `startDate`, `endDate`, `freqType`, `freqInterval`, `nextExecOn`, `lastExecOn`, `isActive`) VALUES
(1,	1,	'2023-03-18 06:18:22',	'2100-12-31 00:00:00',	'D',	0,	'2023-03-18 06:18:22',	'0000-00-00 00:00:00',	1),
(2,	2,	'2023-03-18 06:18:22',	'2100-12-31 00:00:00',	'W',	2,	'2023-03-18 06:18:22',	'0000-00-00 00:00:00',	1),
(3,	3,	'2023-03-18 06:18:22',	'2100-12-31 00:00:00',	'M',	2,	'2023-03-18 06:18:22',	'0000-00-00 00:00:00',	1);

DROP TABLE IF EXISTS `ob_paymentmode`;
CREATE TABLE `ob_paymentmode` (
  `id` mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
  `cId` mediumint(8) unsigned NOT NULL,
  `name` varchar(25) NOT NULL,
  `accGroupCode` char(2) NOT NULL COMMENT 'CH-Cash/BA-Cheque;Credit/Debit Card;Transfer',
  `isActive` tinyint(1) NOT NULL DEFAULT 1,
  `pType` char(2) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

INSERT INTO `ob_paymentmode` (`id`, `cId`, `name`, `accGroupCode`, `isActive`, `pType`) VALUES
(1,	0,	'Cash',	'CH',	1,	'C'),
(2,	0,	'Cheque / DD',	'BA',	1,	'Q'),
(3,	0,	'Debit/Credit Card',	'BA',	1,	'D'),
(4,	0,	'Electronic Transfer',	'BA',	1,	'T');

DROP TABLE IF EXISTS `ob_points`;
CREATE TABLE `ob_points` (
  `cId` mediumint(11) unsigned NOT NULL,
  `pType` char(1) NOT NULL DEFAULT 'V',
  `crInv` char(1) DEFAULT NULL,
  `inPrint` tinyint(1) NOT NULL DEFAULT 1,
  `config` text NOT NULL,
  PRIMARY KEY (`cId`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;


DROP TABLE IF EXISTS `ob_pointscontact`;
CREATE TABLE `ob_pointscontact` (
  `id` mediumint(11) unsigned NOT NULL AUTO_INCREMENT,
  `cId` mediumint(11) unsigned NOT NULL,
  `conId` mediumint(11) unsigned NOT NULL,
  `transId` mediumint(11) unsigned NOT NULL,
  `tDate` date NOT NULL,
  `pIn` mediumint(8) unsigned NOT NULL,
  `pOut` mediumint(8) unsigned NOT NULL,
  `pAvail` mediumint(8) unsigned NOT NULL,
  `expDate` date NOT NULL,
  PRIMARY KEY (`id`),
  KEY `IX_conId_tDate` (`conId`,`tDate`) USING BTREE,
  KEY `IX_transId` (`transId`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;


DROP TABLE IF EXISTS `ob_pointsdetail`;
CREATE TABLE `ob_pointsdetail` (
  `cId` mediumint(11) unsigned NOT NULL,
  `itemId` mediumint(11) unsigned NOT NULL,
  `itemType` char(1) DEFAULT NULL COMMENT 'I-Item/C-Category',
  `valFrom` int(11) unsigned NOT NULL,
  `valTo` int(11) unsigned NOT NULL,
  `points` mediumint(11) unsigned NOT NULL,
  `pointstype` char(1) NOT NULL COMMENT 'P-Percentage, N-Number',
  `qty` mediumint(8) unsigned NOT NULL,
  `expdays` smallint(5) unsigned NOT NULL,
  KEY `cId` (`cId`,`itemId`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;


DROP TABLE IF EXISTS `ob_price_item`;
CREATE TABLE `ob_price_item` (
  `plId` mediumint(8) unsigned NOT NULL,
  `itemId` mediumint(8) unsigned NOT NULL,
  `rateVal` decimal(11,2) NOT NULL,
  `currency` varchar(4) NOT NULL,
  `isPercentage` tinyint(1) NOT NULL,
  `minQty` decimal(9,3) NOT NULL,
  `unit` varchar(10) NOT NULL,
  KEY `ix_plId_itemId` (`plId`,`itemId`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ob_price_list`;
CREATE TABLE `ob_price_list` (
  `id` mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
  `cid` mediumint(8) unsigned NOT NULL,
  `name` varchar(240) NOT NULL,
  `plType` varchar(1) NOT NULL COMMENT '''V'' for volume discount for line item,''C'' for volume discount for Category Total',
  `operator` varchar(1) NOT NULL,
  `rateVal` decimal(11,3) NOT NULL DEFAULT 0.000,
  `currency` varchar(4) NOT NULL,
  `roundoff` mediumint(8) unsigned NOT NULL,
  `modType` varchar(1) NOT NULL,
  `validFrom` datetime NOT NULL,
  `validTill` datetime NOT NULL,
  `isDefault` tinyint(1) DEFAULT NULL,
  `isActive` tinyint(1) DEFAULT 1,
  `invValGL` varchar(1) DEFAULT NULL COMMENT 'G-Greater/L-Lesser',
  `invVal` decimal(11,2) DEFAULT NULL,
  `invValPer` varchar(1) DEFAULT NULL COMMENT 'I-Inv/D-Day/M-Month/Y-Year',
  `isFranchise` tinyint(1) DEFAULT 0,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ob_price_list_apply`;
CREATE TABLE `ob_price_list_apply` (
  `plId` mediumint(8) unsigned NOT NULL,
  `applyFor` mediumint(8) unsigned NOT NULL,
  `ctype` varchar(1) NOT NULL COMMENT 'A-ALL/T-Contacts Tags/S-Supplier/C-Contacts/I-Item/G-Item Categories',
  KEY `IX_plId` (`plId`),
  KEY `IX_applyFor` (`applyFor`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ob_printers`;
CREATE TABLE `ob_printers` (
  `id` mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
  `cId` mediumint(8) unsigned NOT NULL,
  `bId` mediumint(8) unsigned NOT NULL,
  `name` varchar(63) NOT NULL,
  `tType` char(2) NOT NULL,
  `accessUrl` varchar(255) NOT NULL,
  `template` varchar(20) NOT NULL,
  `settings` text NOT NULL,
  `isDefault` tinyint(1) DEFAULT 0,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;


DROP TABLE IF EXISTS `ob_printers_access`;
CREATE TABLE `ob_printers_access` (
  `prId` mediumint(8) unsigned NOT NULL,
  `accessId` mediumint(8) unsigned NOT NULL,
  `accessType` char(1) NOT NULL COMMENT 'T-Tags, C-ContactId, I-Items'
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;


DROP TABLE IF EXISTS `ob_printsettings`;
CREATE TABLE `ob_printsettings` (
  `id` mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
  `cId` mediumint(8) unsigned NOT NULL,
  `tType` varchar(2) NOT NULL,
  `settings` text NOT NULL,
  `bId` mediumint(8) unsigned NOT NULL DEFAULT 0,
  `template` varchar(20) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

INSERT INTO `ob_printsettings` (`id`, `cId`, `tType`, `settings`, `bId`, `template`) VALUES
(1,	0,	'SI',	'{\"isLogo\":\"1\",\"color\":\"#208ED3\",\"hidShipAdr\":\"1\",\"isDueDate\":\"1\",\"isSlNoCol\":\"1\",\"isItemDesc\":\"0\",\"isHsnCol\":\"1\",\"isSkuCol\":\"0\",\"isMrpCol\":\"0\",\"isTaxDetailCol\":\"1\",\"isTaxPanel\":\"0\",\"isBankDetail\":\"1\",\"isCustSign\":\"1\",\"signMailPdf\":\"1\",\"signOnPrint\":\"0\",\"isPageNo\":\"1\",\"isFullPage\":\"1\",\"isPrintDate\":\"0\",\"footerText\":\"\",\"titleText\":\"Tax Invoice\",\"copiesToPrint\":\"1\",\"printType\":\"1\",\"paper\":\"A4,P\",\"topMargin\":\"0.50\",\"rightMargin\":\"0.50\",\"bottomMargin\":\"0.50\",\"leftMargin\":\"0.50\",\"printcolor\":\"-1\",\"fontsize\":\"13\",\"isAllPageHeader\":\"1\",\"incOldBal\":\"0\",\"price\":\"0\",\"units\":\"1\",\"isvertical\":\"0\",\"isqty\":\"1\",\"isRate\":\"1\",\"bannerImg\":\"\"}',	0,	'salinv'),
(2,	0,	'SR',	'{\"isLogo\":\"1\",\"color\":\"#208ED3\",\"hidShipAdr\":\"1\",\"isDueDate\":\"0\",\"isSlNoCol\":\"1\",\"isItemDesc\":\"1\",\"isHsnCol\":\"1\",\"isSkuCol\":\"0\",\"isMrpCol\":\"0\",\"isTaxDetailCol\":\"1\",\"isTaxPanel\":\"0\",\"isBankDetail\":\"1\",\"isCustSign\":\"0\",\"signMailPdf\":\"1\",\"signOnPrint\":\"0\",\"isPageNo\":\"1\",\"isFullPage\":\"0\",\"isPrintDate\":\"1\",\"footerText\":\"\",\"titleText\":\"Tax Invoice\",\"copiesToPrint\":\"1\",\"printType\":\"1\",\"paper\":\"A4,P\",\"topMargin\":\"0.50\",\"rightMargin\":\"0.50\",\"bottomMargin\":\"0.50\",\"leftMargin\":\"0.50\",\"printcolor\":\"-1\",\"fontsize\":\"13\",\"isAllPageHeader\":\"1\",\"incOldBal\":\"0\",\"price\":\"0\",\"units\":\"1\",\"isvertical\":\"0\",\"isqty\":\"1\",\"isRate\":\"1\",\"bannerImg\":\"\"}',	0,	'salretail'),
(3,	0,	'SP',	'{\"isLogo\":\"1\",\"color\":\"#208ED3\",\"hidShipAdr\":\"1\",\"isDueDate\":\"0\",\"isSlNoCol\":\"0\",\"isItemDesc\":\"1\",\"isHsnCol\":\"1\",\"isSkuCol\":\"0\",\"isMrpCol\":\"0\",\"isTaxDetailCol\":\"1\",\"isTaxPanel\":\"0\",\"isBankDetail\":\"1\",\"isCustSign\":\"1\",\"signMailPdf\":\"1\",\"signOnPrint\":\"0\",\"isPageNo\":\"0\",\"isFullPage\":\"0\",\"isPrintDate\":\"1\",\"footerText\":\"\",\"titleText\":\"Receipt\",\"copiesToPrint\":\"1\",\"printType\":\"1\",\"paper\":\"A4,P\",\"topMargin\":\"0.50\",\"rightMargin\":\"0.50\",\"bottomMargin\":\"0.50\",\"leftMargin\":\"0.50\",\"printcolor\":\"-1\",\"fontsize\":\"13\",\"isAllPageHeader\":\"1\",\"incOldBal\":\"0\",\"price\":\"0\",\"units\":\"1\",\"isvertical\":\"0\",\"isqty\":\"1\",\"isRate\":\"1\",\"bannerImg\":\"\"}',	0,	'salpmt'),
(4,	0,	'PO',	'{\"isLogo\":\"1\",\"color\":\"#208ED3\",\"hidShipAdr\":\"1\",\"isDueDate\":\"1\",\"isSlNoCol\":\"1\",\"isItemDesc\":\"0\",\"isHsnCol\":\"1\",\"isSkuCol\":\"0\",\"isMrpCol\":\"0\",\"isTaxDetailCol\":\"1\",\"isTaxPanel\":\"0\",\"isBankDetail\":\"1\",\"isCustSign\":\"1\",\"signMailPdf\":\"1\",\"signOnPrint\":\"0\",\"isPageNo\":\"1\",\"isFullPage\":\"1\",\"isPrintDate\":\"0\",\"footerText\":\"\",\"titleText\":\"Order\",\"copiesToPrint\":\"1\",\"printType\":\"1\",\"paper\":\"LETTER,P\",\"topMargin\":\"0.50\",\"rightMargin\":\"0.50\",\"bottomMargin\":\"0.50\",\"leftMargin\":\"0.50\",\"printcolor\":\"-1\",\"fontsize\":\"13\",\"isAllPageHeader\":\"1\",\"incOldBal\":\"0\",\"price\":\"0\",\"units\":\"1\",\"isvertical\":\"0\",\"isqty\":\"1\",\"isRate\":\"1\",\"bannerImg\":\"\"}',	0,	''),
(5,	0,	'PI',	'{\"isLogo\":\"0\",\"color\":\"#208ED3\",\"hidShipAdr\":\"1\",\"isDueDate\":\"1\",\"isSlNoCol\":\"1\",\"isItemDesc\":\"0\",\"isHsnCol\":\"1\",\"isSkuCol\":\"0\",\"isMrpCol\":\"0\",\"isTaxDetailCol\":\"1\",\"isTaxPanel\":\"0\",\"isBankDetail\":\"1\",\"isCustSign\":\"1\",\"signMailPdf\":\"1\",\"signOnPrint\":\"0\",\"isPageNo\":\"1\",\"isFullPage\":\"1\",\"isPrintDate\":\"0\",\"footerText\":\"\",\"titleText\":\"Purchase Bill\",\"copiesToPrint\":\"1\",\"printType\":\"1\",\"paper\":\"A4,P\",\"topMargin\":\"0.50\",\"rightMargin\":\"0.50\",\"bottomMargin\":\"0.50\",\"leftMargin\":\"0.50\",\"printcolor\":\"-1\",\"fontsize\":\"13\",\"isAllPageHeader\":\"1\",\"incOldBal\":\"0\",\"price\":\"0\",\"units\":\"1\",\"isvertical\":\"0\",\"isqty\":\"1\",\"isRate\":\"1\",\"bannerImg\":\"\"}',	0,	''),
(6,	0,	'SE',	'{\"isLogo\":\"1\",\"color\":\"-1\",\"hidShipAdr\":\"1\",\"isDueDate\":\"0\",\"isSlNoCol\":\"1\",\"isItemDesc\":\"1\",\"isHsnCol\":\"1\",\"isSkuCol\":\"0\",\"isMrpCol\":\"0\",\"isTaxDetailCol\":\"1\",\"isTaxPanel\":\"0\",\"isBankDetail\":\"1\",\"isCustSign\":\"0\",\"signMailPdf\":\"0\",\"signOnPrint\":\"0\",\"isPageNo\":\"1\",\"isFullPage\":\"1\",\"isPrintDate\":\"1\",\"footerText\":\"\",\"titleText\":\"Quotation\",\"copiesToPrint\":\"1\",\"printType\":\"1\",\"paper\":\"A4,P\",\"topMargin\":\"0.50\",\"rightMargin\":\"0.50\",\"bottomMargin\":\"0.50\",\"leftMargin\":\"0.50\",\"printcolor\":\"-1\",\"fontsize\":\"13\",\"isAllPageHeader\":\"1\",\"incOldBal\":\"0\",\"price\":\"0\",\"units\":\"1\",\"isvertical\":\"0\",\"isqty\":\"1\",\"isRate\":\"1\",\"bannerImg\":\"\"}',	0,	'est'),
(7,	0,	'SO',	'{\"isLogo\":\"1\",\"color\":\"-1\",\"hidShipAdr\":\"1\",\"isDueDate\":\"0\",\"isSlNoCol\":\"1\",\"isItemDesc\":\"1\",\"isHsnCol\":\"1\",\"isSkuCol\":\"0\",\"isMrpCol\":\"0\",\"isTaxDetailCol\":\"1\",\"isTaxPanel\":\"0\",\"isBankDetail\":\"1\",\"isCustSign\":\"0\",\"signMailPdf\":\"0\",\"signOnPrint\":\"0\",\"isPageNo\":\"1\",\"isFullPage\":\"1\",\"isPrintDate\":\"1\",\"footerText\":\"\",\"titleText\":\"Sales Order\",\"copiesToPrint\":\"1\",\"printType\":\"1\",\"paper\":\"A4,P\",\"topMargin\":\"0.50\",\"rightMargin\":\"0.50\",\"bottomMargin\":\"0.50\",\"leftMargin\":\"0.50\",\"printcolor\":\"-1\",\"fontsize\":\"13\",\"isAllPageHeader\":\"1\",\"incOldBal\":\"0\",\"price\":\"0\",\"units\":\"1\",\"isvertical\":\"0\",\"isqty\":\"1\",\"isRate\":\"1\",\"bannerImg\":\"\"}',	0,	'salord'),
(8,	0,	'SH',	'{\"isLogo\":\"1\",\"color\":\"-1\",\"hidShipAdr\":\"1\",\"isDueDate\":\"0\",\"isSlNoCol\":\"1\",\"isItemDesc\":\"1\",\"isHsnCol\":\"1\",\"isSkuCol\":\"0\",\"isMrpCol\":\"0\",\"isTaxDetailCol\":\"1\",\"isTaxPanel\":\"0\",\"isBankDetail\":\"1\",\"isCustSign\":\"0\",\"signMailPdf\":\"0\",\"signOnPrint\":\"0\",\"isPageNo\":\"1\",\"isFullPage\":\"1\",\"isPrintDate\":\"1\",\"footerText\":\"\",\"titleText\":\"Delivery Challan\",\"copiesToPrint\":\"1\",\"printType\":\"1\",\"paper\":\"A4,P\",\"topMargin\":\"0.50\",\"rightMargin\":\"0.50\",\"bottomMargin\":\"0.50\",\"leftMargin\":\"0.50\",\"printcolor\":\"-1\",\"fontsize\":\"13\",\"isAllPageHeader\":\"1\",\"incOldBal\":\"0\",\"price\":\"0\",\"units\":\"1\",\"isvertical\":\"0\",\"isqty\":\"1\",\"isRate\":\"1\",\"bannerImg\":\"\"}',	0,	'delchallan'),
(9,	0,	'PP',	'{\"isLogo\": \"0\", \"color\": \"#208ED3\", \"hidShipAdr\": \"1\", \"isDueDate\": \"0\", \"isSlNoCol\": \"0\", \"isItemDesc\": \"1\", \"isHsnCol\": \"1\", \"isSkuCol\": \"0\", \"isMrpCol\": \"0\", \"isTaxDetailCol\": \"1\", \"isTaxPanel\": \"0\", \"isBankDetail\": \"1\", \"isCustSign\": \"1\", \"signMailPdf\": \"1\", \"signOnPrint\": \"3\", \"isPageNo\": \"0\", \"isFullPage\": \"0\", \"isPrintDate\": \"1\", \"footerText\": \"\", \"titleText\": \"Bill Payment Voucher\", \"copiesToPrint\": \"1\", \"printType\": \"1\", \"paper\": \"A4,P\", \"topMargin\": \"0.50\", \"rightMargin\": \"0.50\", \"bottomMargin\": \"0.50\", \"leftMargin\": \"0.50\", \"printcolor\": \"-1\", \"fontsize\": \"13\", \"isAllPageHeader\": \"1\", \"incOldBal\": \"0\", \"price\": \"0\", \"units\": \"0\", \"isvertical\": \"0\", \"isqty\": \"1\", \"isRate\": \"1\", \"bannerImg\": null}',	0,	'purpmt'),
(10,	0,	'PE',	'{\"isLogo\": \"0\", \"color\": \"#208ED3\", \"hidShipAdr\": \"1\", \"isDueDate\": \"0\", \"isSlNoCol\": \"0\", \"isItemDesc\": \"1\", \"isHsnCol\": \"1\", \"isSkuCol\": \"0\", \"isMrpCol\": \"0\", \"isTaxDetailCol\": \"1\", \"isTaxPanel\": \"0\", \"isBankDetail\": \"1\", \"isCustSign\": \"1\", \"signMailPdf\": \"1\", \"signOnPrint\": \"3\", \"isPageNo\": \"0\", \"isFullPage\": \"0\", \"isPrintDate\": \"1\", \"footerText\": \"\", \"titleText\": \" Payment Voucher\", \"copiesToPrint\": \"1\", \"printType\": \"1\", \"paper\": \"A4,P\", \"topMargin\": \"0.50\", \"rightMargin\": \"0.50\", \"bottomMargin\": \"0.50\", \"leftMargin\": \"0.50\", \"printcolor\": \"-1\", \"fontsize\": \"13\", \"isAllPageHeader\": \"1\", \"incOldBal\": \"0\", \"price\": \"0\", \"units\": \"0\", \"isvertical\": \"0\", \"isqty\": \"1\", \"isRate\": \"1\", \"bannerImg\": null}',	0,	'purpmt'),
(11,	0,	'PC',	'{\"isLogo\": \"0\", \"color\": \"#208ED3\", \"hidShipAdr\": \"1\", \"isDueDate\": \"0\", \"isSlNoCol\": \"0\", \"isItemDesc\": \"1\", \"isHsnCol\": \"1\", \"isSkuCol\": \"0\", \"isMrpCol\": \"0\", \"isTaxDetailCol\": \"1\", \"isTaxPanel\": \"0\", \"isBankDetail\": \"1\", \"isCustSign\": \"1\", \"signMailPdf\": \"1\", \"signOnPrint\": \"3\", \"isPageNo\": \"0\", \"isFullPage\": \"0\", \"isPrintDate\": \"1\", \"footerText\": \"\", \"titleText\": \"Supplier Credit Note\", \"copiesToPrint\": \"1\", \"printType\": \"1\", \"paper\": \"A4,P\", \"topMargin\": \"0.50\", \"rightMargin\": \"0.50\", \"bottomMargin\": \"0.50\", \"leftMargin\": \"0.50\", \"printcolor\": \"-1\", \"fontsize\": \"13\", \"isAllPageHeader\": \"1\", \"incOldBal\": \"0\", \"price\": \"0\", \"units\": \"0\", \"isvertical\": \"0\", \"isqty\": \"1\", \"isRate\": \"1\", \"bannerImg\": null}',	0,	'salinv'),
(12,	0,	'PD',	'{\"isLogo\": \"0\", \"color\": \"#208ED3\", \"hidShipAdr\": \"1\", \"isDueDate\": \"0\", \"isSlNoCol\": \"0\", \"isItemDesc\": \"1\", \"isHsnCol\": \"1\", \"isSkuCol\": \"0\", \"isMrpCol\": \"0\", \"isTaxDetailCol\": \"1\", \"isTaxPanel\": \"0\", \"isBankDetail\": \"1\", \"isCustSign\": \"1\", \"signMailPdf\": \"1\", \"signOnPrint\": \"3\", \"isPageNo\": \"0\", \"isFullPage\": \"0\", \"isPrintDate\": \"1\", \"footerText\": \"\", \"titleText\": \"Supplier Debit Note\", \"copiesToPrint\": \"1\", \"printType\": \"1\", \"paper\": \"A4,P\", \"topMargin\": \"0.50\", \"rightMargin\": \"0.50\", \"bottomMargin\": \"0.50\", \"leftMargin\": \"0.50\", \"printcolor\": \"-1\", \"fontsize\": \"13\", \"isAllPageHeader\": \"1\", \"incOldBal\": \"0\", \"price\": \"0\", \"units\": \"0\", \"isvertical\": \"0\", \"isqty\": \"1\", \"isRate\": \"1\", \"bannerImg\": null}',	0,	'salinv'),
(13,	0,	'SC',	'{\"isLogo\": \"0\", \"color\": \"#208ED3\", \"hidShipAdr\": \"1\", \"isDueDate\": \"0\", \"isSlNoCol\": \"0\", \"isItemDesc\": \"1\", \"isHsnCol\": \"1\", \"isSkuCol\": \"0\", \"isMrpCol\": \"0\", \"isTaxDetailCol\": \"1\", \"isTaxPanel\": \"0\", \"isBankDetail\": \"1\", \"isCustSign\": \"1\", \"signMailPdf\": \"1\", \"signOnPrint\": \"3\", \"isPageNo\": \"0\", \"isFullPage\": \"0\", \"isPrintDate\": \"1\", \"footerText\": \"\", \"titleText\": \"Credit Note\", \"copiesToPrint\": \"1\", \"printType\": \"1\", \"paper\": \"A4,P\", \"topMargin\": \"0.50\", \"rightMargin\": \"0.50\", \"bottomMargin\": \"0.50\", \"leftMargin\": \"0.50\", \"printcolor\": \"-1\", \"fontsize\": \"13\", \"isAllPageHeader\": \"1\", \"incOldBal\": \"0\", \"price\": \"0\", \"units\": \"0\", \"isvertical\": \"0\", \"isqty\": \"1\", \"isRate\": \"1\", \"bannerImg\": null}',	0,	'salinv'),
(14,	0,	'SD',	'{\"isLogo\": \"0\", \"color\": \"#208ED3\", \"hidShipAdr\": \"1\", \"isDueDate\": \"0\", \"isSlNoCol\": \"0\", \"isItemDesc\": \"1\", \"isHsnCol\": \"1\", \"isSkuCol\": \"0\", \"isMrpCol\": \"0\", \"isTaxDetailCol\": \"1\", \"isTaxPanel\": \"0\", \"isBankDetail\": \"1\", \"isCustSign\": \"1\", \"signMailPdf\": \"1\", \"signOnPrint\": \"3\", \"isPageNo\": \"0\", \"isFullPage\": \"0\", \"isPrintDate\": \"1\", \"footerText\": \"\", \"titleText\": \"Debit Note\", \"copiesToPrint\": \"1\", \"printType\": \"1\", \"paper\": \"A4,P\", \"topMargin\": \"0.50\", \"rightMargin\": \"0.50\", \"bottomMargin\": \"0.50\", \"leftMargin\": \"0.50\", \"printcolor\": \"-1\", \"fontsize\": \"13\", \"isAllPageHeader\": \"1\", \"incOldBal\": \"0\", \"price\": \"0\", \"units\": \"0\", \"isvertical\": \"0\", \"isqty\": \"1\", \"isRate\": \"1\", \"bannerImg\": null}',	0,	'salinv');

DROP TABLE IF EXISTS `ob_role`;
CREATE TABLE `ob_role` (
  `roleId` mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
  `cId` mediumint(8) unsigned NOT NULL,
  `roleCode` varchar(1) NOT NULL COMMENT 'A - Admin / C - Auditor / S- Staff',
  `roleName` varchar(16) NOT NULL,
  `is_system` tinyint(1) NOT NULL DEFAULT 0,
  PRIMARY KEY (`roleId`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

INSERT INTO `ob_role` (`roleId`, `cId`, `roleCode`, `roleName`, `is_system`) VALUES
(1,	0,	'A',	'Administrator',	1),
(2,	0,	'C',	'Accountant',	1),
(3,	0,	'I',	'Sales & Purchase',	1),
(4,	0,	'S',	'Sales',	1),
(5,	0,	'R',	'Sales Rep',	1);

DROP TABLE IF EXISTS `ob_role_permissions`;
CREATE TABLE `ob_role_permissions` (
  `roleId` mediumint(8) unsigned NOT NULL,
  `cId` mediumint(8) unsigned NOT NULL,
  `modCode` varchar(5) NOT NULL,
  `actionRights` tinyint(1) NOT NULL COMMENT '(1-View,2-Add,3-Edit,4-Delete/All)',
  KEY `IX_roleId` (`roleId`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

INSERT INTO `ob_role_permissions` (`roleId`, `cId`, `modCode`, `actionRights`) VALUES
(2,	0,	'ACCCT',	4),
(2,	0,	'ACCHA',	4),
(2,	0,	'ACJRL',	4),
(2,	0,	'ACOPB',	4),
(2,	0,	'BAN',	4),
(2,	0,	'DAS',	4),
(2,	0,	'MNCUS',	4),
(3,	0,	'MNCUS',	4),
(4,	0,	'MNCUS',	4),
(2,	0,	'MNITM',	4),
(3,	0,	'MNITM',	4),
(4,	0,	'MNITM',	4),
(2,	0,	'MNRBY',	4),
(2,	0,	'MNSAR',	4),
(2,	0,	'MNSTJ',	4),
(2,	0,	'MNSUP',	4),
(3,	0,	'MNSUP',	4),
(2,	0,	'PRO',	4),
(2,	0,	'PUPUC',	4),
(2,	0,	'PUPUD',	4),
(2,	0,	'PUPUQ',	4),
(3,	0,	'PUPUC',	4),
(3,	0,	'PUPUD',	4),
(3,	0,	'PUPUQ',	4),
(2,	0,	'PUPUB',	4),
(3,	0,	'PUPUB',	4),
(2,	0,	'PUPUE',	4),
(3,	0,	'PUPUE',	4),
(2,	0,	'PUPUG',	4),
(3,	0,	'PUPUG',	4),
(2,	0,	'PUPUO',	4),
(3,	0,	'PUPUO',	4),
(2,	0,	'PUPUP',	4),
(3,	0,	'PUPUP',	4),
(2,	0,	'RABAS',	1),
(2,	0,	'RABUD',	1),
(2,	0,	'RACBK',	1),
(2,	0,	'RADAY',	1),
(2,	0,	'RAOPB',	1),
(2,	0,	'RAPAL',	1),
(2,	0,	'RATBL',	1),
(2,	0,	'RICAS',	1),
(2,	0,	'RIDPI',	1),
(3,	0,	'RIDPI',	4),
(2,	0,	'RIFRS',	1),
(2,	0,	'RIITP',	1),
(3,	0,	'RIITP',	4),
(2,	0,	'RIITS',	1),
(3,	0,	'RIITS',	4),
(2,	0,	'RIPFM',	1),
(2,	0,	'RIPPO',	1),
(3,	0,	'RIPPO',	4),
(2,	0,	'RIPSO',	1),
(3,	0,	'RIPSO',	4),
(2,	0,	'RITRG',	1),
(2,	0,	'RLCOG',	1),
(3,	0,	'RLCOG',	1),
(2,	0,	'RLCUS',	1),
(2,	0,	'RLLDG',	1),
(2,	0,	'RLSRP',	1),
(2,	0,	'RLSUP',	1),
(2,	0,	'RLTAX',	1),
(2,	0,	'RRGS1',	1),
(2,	0,	'RRGS2',	1),
(2,	0,	'RRGS3',	1),
(2,	0,	'RRGS4',	1),
(2,	0,	'RRGS9',	1),
(2,	0,	'RSBWS',	1),
(3,	0,	'RSBWS',	4),
(2,	0,	'RSCSK',	1),
(3,	0,	'RSCSK',	4),
(2,	0,	'RSMST',	1),
(3,	0,	'RSMST',	4),
(2,	0,	'RSRER',	1),
(3,	0,	'RSRER',	4),
(2,	0,	'RSSTC',	1),
(3,	0,	'RSSTC',	4),
(2,	0,	'RSSTE',	1),
(3,	0,	'RSSTE',	4),
(2,	0,	'RSSTL',	1),
(3,	0,	'RSSTL',	4),
(2,	0,	'RSSTS',	1),
(3,	0,	'RSSTS',	4),
(2,	0,	'RTAGI',	1),
(2,	0,	'RTCUS',	1),
(3,	0,	'RTCUS',	1),
(2,	0,	'RTOSP',	1),
(3,	0,	'RTOSP',	1),
(2,	0,	'RTOSQ',	1),
(2,	0,	'RTOSR',	1),
(3,	0,	'RTOSR',	1),
(2,	0,	'RTPDC',	1),
(2,	0,	'RTPUR',	1),
(3,	0,	'RTPUR',	1),
(2,	0,	'RTPYM',	1),
(2,	0,	'RTRBY',	1),
(2,	0,	'RTSAR',	1),
(3,	0,	'RTSAR',	1),
(2,	0,	'RTSRA',	1),
(2,	0,	'RTSUP',	1),
(3,	0,	'RTSUP',	1),
(2,	0,	'SAEWB',	4),
(2,	0,	'SAJOB',	4),
(2,	0,	'SAJOB',	1),
(3,	0,	'SAJOB',	4),
(2,	0,	'SASAC',	4),
(3,	0,	'SASAC',	4),
(4,	0,	'SASAC',	4),
(2,	0,	'SASAD',	4),
(3,	0,	'SASAD',	4),
(4,	0,	'SASAD',	4),
(2,	0,	'SASAI',	4),
(3,	0,	'SASAI',	4),
(4,	0,	'SASAI',	4),
(2,	0,	'SASAO',	4),
(3,	0,	'SASAO',	4),
(4,	0,	'SASAO',	4),
(2,	0,	'SASAQ',	4),
(3,	0,	'SASAQ',	4),
(4,	0,	'SASAQ',	4),
(2,	0,	'SASAR',	4),
(3,	0,	'SASAR',	4),
(4,	0,	'SASAR',	4),
(2,	0,	'SASDH',	4),
(3,	0,	'SASDH',	4),
(2,	0,	'SET',	1),
(5,	0,	'MNCUS',	4),
(5,	0,	'MNITM',	4),
(5,	0,	'RIDPI',	1),
(4,	0,	'RIITS',	4),
(5,	0,	'RIITS',	1),
(4,	0,	'RIPSO',	4),
(5,	0,	'RIPSO',	1),
(4,	0,	'RLCOG',	1),
(5,	0,	'RLCOG',	1),
(5,	0,	'RLSRP',	1),
(4,	0,	'RSBWS',	4),
(5,	0,	'RSBWS',	1),
(4,	0,	'RSCSK',	4),
(5,	0,	'RSCSK',	1),
(4,	0,	'RSMST',	4),
(5,	0,	'RSMST',	1),
(4,	0,	'RSRER',	4),
(5,	0,	'RSRER',	1),
(4,	0,	'RSSTC',	4),
(5,	0,	'RSSTC',	1),
(4,	0,	'RSSTE',	4),
(5,	0,	'RSSTE',	1),
(4,	0,	'RSSTL',	4),
(5,	0,	'RSSTL',	1),
(4,	0,	'RSSTS',	4),
(5,	0,	'RSSTS',	1),
(5,	0,	'RTAGI',	1),
(4,	0,	'RTCUS',	1),
(5,	0,	'RTCUS',	1),
(4,	0,	'RTOSR',	1),
(5,	0,	'RTOSR',	1),
(4,	0,	'RTSAR',	1),
(5,	0,	'RTSAR',	1),
(5,	0,	'RTSRA',	1),
(4,	0,	'SAJOB',	4),
(5,	0,	'SAJOB',	4),
(5,	0,	'SASAC',	4),
(5,	0,	'SASAD',	4),
(5,	0,	'SASAI',	4),
(5,	0,	'SASAO',	4),
(5,	0,	'SASAQ',	4),
(5,	0,	'SASAR',	4),
(4,	0,	'SASDH',	4),
(5,	0,	'SASDH',	4),
(2,	0,	'MNBOM',	4),
(3,	0,	'MNBOM',	4),
(4,	0,	'MNBOM',	4),
(5,	0,	'MNBOM',	4),
(2,	0,	'MNMFG',	4),
(3,	0,	'MNMFG',	4),
(4,	0,	'MNMFG',	4),
(5,	0,	'MNMFG',	4);

DROP TABLE IF EXISTS `ob_sales`;
CREATE TABLE `ob_sales` (
  `id` mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
  `cId` mediumint(8) unsigned NOT NULL,
  `stype` char(2) NOT NULL COMMENT 'SS-Sales /SC-CreditNote/SD-DebitNote/SB-BillofSupply/SA-AdvanceReceipt/SC-DeliveryChallan',
  `sno` varchar(16) NOT NULL,
  `sdate` date NOT NULL,
  `ref` varchar(20) NOT NULL,
  `refId` mediumint(8) unsigned NOT NULL,
  `dueFreqCode` char(3) NOT NULL,
  `dueDate` date NOT NULL,
  `csId` mediumint(8) unsigned NOT NULL,
  `csGstin` varchar(20) NOT NULL,
  `csPOScode` varchar(3) NOT NULL,
  `address1` varchar(200) NOT NULL,
  `address2` varchar(200) NOT NULL,
  `city` varchar(20) NOT NULL,
  `stateCode` varchar(3) NOT NULL,
  `zip` varchar(20) NOT NULL,
  `countryCode` varchar(3) NOT NULL,
  `country` varchar(20) NOT NULL,
  `email` varchar(200) NOT NULL,
  `phone` varchar(20) NOT NULL,
  `contactPerson` varchar(60) NOT NULL,
  `salesDue` smallint(6) NOT NULL,
  `salesDiscount` decimal(4,2) NOT NULL,
  `shipBillAddr` tinyint(1) NOT NULL,
  `shipAddress1` varchar(200) NOT NULL,
  `shipAddress2` varchar(200) NOT NULL,
  `shipCity` varchar(20) NOT NULL,
  `shipState` varchar(60) NOT NULL,
  `shipZip` varchar(20) NOT NULL,
  `shipCountry` varchar(20) NOT NULL,
  `totTaxableAmt` decimal(11,2) NOT NULL,
  `totTax` decimal(9,2) NOT NULL,
  `totAmt` decimal(11,2) NOT NULL,
  `sCategoryCode` char(3) NOT NULL COMMENT 'B2B / BCS / BCL',
  `sStatus` char(1) NOT NULL COMMENT 'D-Draft/S-Sent/P-Paid',
  `fStatus` char(1) NOT NULL COMMENT 'f-Filed',
  `isReverse` tinyint(1) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `cId` (`cId`),
  KEY `sno` (`sno`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ob_salesdetail`;
CREATE TABLE `ob_salesdetail` (
  `id` mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
  `cId` mediumint(8) unsigned NOT NULL,
  `sId` mediumint(8) unsigned NOT NULL,
  `itemId` mediumint(8) unsigned NOT NULL,
  `itemName` varchar(255) NOT NULL,
  `itemDesc` varchar(1000) NOT NULL,
  `itemType` char(1) NOT NULL COMMENT 'G / S',
  `itemHS` varchar(20) NOT NULL COMMENT 'HSN/SAC Code',
  `rate` decimal(11,2) NOT NULL,
  `qty` decimal(7,2) NOT NULL,
  `disc` decimal(11,2) NOT NULL,
  `taxableAmount` decimal(11,2) NOT NULL,
  `taxId` mediumint(8) unsigned NOT NULL,
  `taxName` varchar(20) NOT NULL,
  `itemTotal` decimal(11,2) NOT NULL,
  `sortNo` smallint(6) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `cId` (`cId`),
  KEY `sId` (`sId`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ob_salesdetailtax`;
CREATE TABLE `ob_salesdetailtax` (
  `sId` mediumint(8) unsigned NOT NULL,
  `cId` mediumint(8) unsigned NOT NULL,
  `sdID` mediumint(8) unsigned NOT NULL,
  `taxTypeCode` varchar(7) NOT NULL,
  `taxRate` decimal(5,2) NOT NULL,
  `taxValue` decimal(11,2) NOT NULL,
  PRIMARY KEY (`sId`,`cId`,`sdID`,`taxTypeCode`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ob_series`;
CREATE TABLE `ob_series` (
  `id` mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
  `cId` mediumint(8) unsigned NOT NULL,
  `tType` char(2) NOT NULL COMMENT 'SI-Sales/SC-CreditNote/SD-DebitNote/SB-BillofSupply/SA-AdvanceReceipt/SH-DeliveryChallan/SE-Estimate',
  `prefix` varchar(12) NOT NULL,
  `suffix` varchar(12) NOT NULL DEFAULT '',
  `seriesStart` mediumint(8) unsigned NOT NULL,
  `editable` tinyint(1) NOT NULL,
  `manual` tinyint(1) NOT NULL,
  `nxtNumber` mediumint(8) unsigned DEFAULT NULL,
  `fYear` smallint(5) NOT NULL,
  `bId` mediumint(8) unsigned NOT NULL DEFAULT 0,
  `followbId` varchar(2500) NOT NULL DEFAULT '',
  `sName` varchar(16) NOT NULL,
  `classCode` varchar(6) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `cId` (`cId`,`tType`,`fYear`,`bId`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ob_sessions`;
CREATE TABLE `ob_sessions` (
  `id` varchar(128) NOT NULL,
  `ip_address` varchar(45) NOT NULL,
  `timestamp` int(10) unsigned NOT NULL DEFAULT 0,
  `data` blob NOT NULL,
  PRIMARY KEY (`id`,`ip_address`),
  KEY `ob_sessions_timestamp` (`timestamp`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ob_skvalue`;
CREATE TABLE `ob_skvalue` (
  `id` mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
  `cId` mediumint(8) unsigned NOT NULL,
  `bId` int(11) NOT NULL DEFAULT 0,
  `vdate` date NOT NULL,
  `amt` decimal(11,2) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ob_states`;
CREATE TABLE `ob_states` (
  `id` mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(60) NOT NULL,
  `countryCode` char(3) NOT NULL,
  `stateCode` varchar(5) DEFAULT NULL,
  `tinCode` tinyint(4) NOT NULL DEFAULT 0,
  `pnc_range` varchar(40) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`),
  KEY `stateCode` (`stateCode`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

INSERT INTO `ob_states` (`id`, `name`, `countryCode`, `stateCode`, `tinCode`, `pnc_range`) VALUES
(1,	'Andaman and Nicobar Islands',	'IN',	'AN',	35,	'744-744'),
(3,	'Arunachal Pradesh',	'IN',	'AR',	12,	'790-792'),
(4,	'Assam',	'IN',	'AS',	18,	'781-788'),
(5,	'Bihar',	'IN',	'BR',	10,	'800-855'),
(6,	'Chandigarh',	'IN',	'CH',	4,	'160-160'),
(7,	'Chhattisgarh',	'IN',	'CG',	22,	'490-497'),
(8,	'DADRA AND NAGAR HAVELI AND DAMAN AND DIU',	'IN',	'DNHDD',	26,	'396-396'),
(10,	'Delhi',	'IN',	'DL',	7,	'110-110'),
(11,	'Goa',	'IN',	'GA',	30,	'403-403'),
(12,	'Gujarat',	'IN',	'GJ',	24,	'360-396'),
(13,	'Haryana',	'IN',	'HR',	6,	'121-136'),
(14,	'Himachal Pradesh',	'IN',	'HP',	2,	'171-177'),
(15,	'Jammu and Kashmir',	'IN',	'JK',	1,	'180-194'),
(16,	'Jharkhand',	'IN',	'JH',	20,	'813-835'),
(17,	'Karnataka',	'IN',	'KA',	29,	'560-591'),
(19,	'Kerala',	'IN',	'KL',	32,	'670-695'),
(20,	'Lakshadweep',	'IN',	'LD',	31,	'682-682'),
(21,	'Madhya Pradesh',	'IN',	'MP',	23,	'450-488'),
(22,	'Maharashtra',	'IN',	'MH',	27,	'400-445'),
(23,	'Manipur',	'IN',	'MN',	14,	'795-795'),
(24,	'Meghalaya',	'IN',	'ML',	17,	'793-794'),
(25,	'Mizoram',	'IN',	'MZ',	15,	'796-796'),
(26,	'Nagaland',	'IN',	'NL',	13,	'797-798'),
(29,	'Odisha',	'IN',	'OD',	21,	'751-770'),
(31,	'Pondicherry',	'IN',	'PY',	34,	'533;605;607;609'),
(32,	'Punjab',	'IN',	'PB',	3,	'140-160'),
(33,	'Rajasthan',	'IN',	'RJ',	8,	'301-345'),
(34,	'Sikkim',	'IN',	'SK',	11,	'737-737'),
(35,	'Tamil Nadu',	'IN',	'TN',	33,	'600-643'),
(36,	'Telangana',	'IN',	'TS',	36,	'500-509;518;533'),
(37,	'Tripura',	'IN',	'TR',	16,	'799-799'),
(38,	'Uttar Pradesh',	'IN',	'UP',	9,	'201-285'),
(39,	'Uttarakhand',	'IN',	'UK',	5,	'244-263'),
(41,	'West Bengal',	'IN',	'WB',	19,	'700-743'),
(42,	'Andhra Pradesh (New)',	'IN',	'AD',	37,	'500-535'),
(4122,	'Other Territory',	'IN',	'OT',	97,	''),
(4123,	'Ladakh',	'IN',	'LA',	38,	'194-194');

DROP TABLE IF EXISTS `ob_stock_entries`;
CREATE TABLE `ob_stock_entries` (
  `id` mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
  `cId` mediumint(8) unsigned NOT NULL,
  `sType` char(2) DEFAULT NULL COMMENT 'AD/OP/PU/PO/SR/SA/DI/CO/PR/MJ/BJ',
  `sDate` date NOT NULL,
  `notes` text NOT NULL,
  `locId` mediumint(8) unsigned NOT NULL DEFAULT 0,
  `stNo` mediumint(8) unsigned NOT NULL,
  `bomId` mediumint(8) unsigned NOT NULL,
  `addExp` decimal(11,2) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `IX_cId_sDate` (`cId`,`sDate`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ob_stock_items`;
CREATE TABLE `ob_stock_items` (
  `id` mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
  `sId` mediumint(8) unsigned NOT NULL,
  `cId` mediumint(8) unsigned NOT NULL,
  `itemId` mediumint(8) unsigned NOT NULL,
  `qty` decimal(11,3) NOT NULL,
  `unit` varchar(4) NOT NULL DEFAULT '',
  `rate` decimal(11,3) NOT NULL DEFAULT 0.000,
  `mrp` decimal(11,3) NOT NULL DEFAULT 0.000,
  `description` text NOT NULL,
  `itemAttrId` mediumint(8) unsigned NOT NULL,
  `tolocId` mediumint(8) unsigned NOT NULL DEFAULT 0,
  `fromlocId` mediumint(8) unsigned NOT NULL DEFAULT 0,
  `refTitemId` mediumint(8) unsigned NOT NULL DEFAULT 0,
  `ratePer` decimal(5,2) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `IX_sId` (`sId`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ob_stock_physical`;
CREATE TABLE `ob_stock_physical` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `sId` int(11) unsigned NOT NULL,
  `cId` int(11) unsigned NOT NULL,
  `bId` int(11) NOT NULL DEFAULT 0,
  `itemId` int(11) unsigned NOT NULL,
  `itemAttrId` int(11) NOT NULL,
  `pQty` decimal(11,3) NOT NULL,
  `pUnit` varchar(4) NOT NULL,
  `pSerial` mediumtext NOT NULL,
  `bQty` decimal(11,3) NOT NULL,
  `bUnit` varchar(4) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `IX_sId_itemId` (`sId`,`itemId`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;


DROP TABLE IF EXISTS `ob_stock_ref`;
CREATE TABLE `ob_stock_ref` (
  `sId` mediumint(8) unsigned NOT NULL,
  `refTransId` mediumint(8) unsigned NOT NULL,
  `cId` mediumint(8) unsigned NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;


DROP TABLE IF EXISTS `ob_syshsnsac`;
CREATE TABLE `ob_syshsnsac` (
  `cId` int(10) unsigned NOT NULL,
  `code` varchar(20) NOT NULL,
  `type` char(1) NOT NULL COMMENT 'H/S',
  `ITC` char(1) NOT NULL,
  `taxId` int(10) unsigned NOT NULL,
  `taxDesc` varchar(255) NOT NULL,
  `taxApply` char(1) NOT NULL DEFAULT 'S' COMMENT 'R-Rate Variable,S-Single',
  `config` varchar(2047) NOT NULL,
  PRIMARY KEY (`code`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ob_sysStates`;
CREATE TABLE `ob_sysStates` (
  `countryCode` varchar(3) NOT NULL,
  `stateCode` varchar(3) NOT NULL,
  `name` varchar(60) NOT NULL,
  `tinCode` tinyint(4) NOT NULL COMMENT 'To identify GSTIN',
  PRIMARY KEY (`countryCode`,`stateCode`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ob_systaxtype`;
CREATE TABLE `ob_systaxtype` (
  `id` mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
  `countryCode` varchar(3) NOT NULL,
  `taxName` varchar(20) NOT NULL,
  `taxTypeCode` varchar(7) NOT NULL,
  `accCodeSales` varchar(3) NOT NULL,
  `accCodePur` varchar(3) NOT NULL,
  `stateType` char(1) NOT NULL COMMENT 'I/U/X/A',
  `accCodeGen` mediumint(8) unsigned NOT NULL,
  `taxCalc` varchar(1) NOT NULL DEFAULT 'V' COMMENT 'V-Value / Q-Quantity / B-Both',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

INSERT INTO `ob_systaxtype` (`id`, `countryCode`, `taxName`, `taxTypeCode`, `accCodeSales`, `accCodePur`, `stateType`, `accCodeGen`, `taxCalc`) VALUES
(1,	'IN',	'IGST',	'IGST',	'',	'',	'X',	0,	'V'),
(2,	'IN',	'CGST',	'CGST',	'',	'',	'I',	0,	'V'),
(3,	'IN',	'SGST',	'SGST',	'',	'',	'I',	0,	'V'),
(5,	'IN',	'UTGST',	'UTGST',	'',	'',	'U',	0,	'V'),
(6,	'IN',	'Cess',	'CESS',	'',	'',	'A',	0,	'B'),
(7,	'US',	'Sales Tax',	'SALES',	'',	'',	'A',	0,	'V'),
(8,	'US',	'Excise taxes',	'EXCISE',	'',	'',	'A',	0,	'V'),
(9,	'IN',	'VAT',	'VAT',	'',	'',	'I',	0,	'V'),
(10,	'IN',	'CST',	'CST',	'',	'',	'X',	0,	'V'),
(11,	'IN',	'Kerala Flood Cess',	'KFCESS',	'',	'',	'A',	0,	'V');

DROP TABLE IF EXISTS `ob_sysuqc`;
CREATE TABLE `ob_sysuqc` (
  `uqcCode` varchar(3) NOT NULL,
  `uqcName` varchar(20) NOT NULL,
  PRIMARY KEY (`uqcCode`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

INSERT INTO `ob_sysuqc` (`uqcCode`, `uqcName`) VALUES
('BAG',	'Bags'),
('BAL',	'Bale'),
('BDL',	'Bundles'),
('BKL',	'Buckles'),
('BOU',	'Billion Of Units'),
('BOX',	'Box'),
('BTL',	'Bottles'),
('BUN',	'Bunches'),
('CAN',	'Cans'),
('CBM',	'Cubic Meters'),
('CCM',	'Cubic Centimeters'),
('CMS',	'Centimeters'),
('CTN',	'Cartons'),
('DOZ',	'Dozens'),
('DRM',	'Drums'),
('GGK',	'Great Gross'),
('GMS',	'Grammes'),
('GRS',	'Gross'),
('GYD',	'Gross Yards'),
('KGS',	'Kilograms'),
('KLR',	'Kilolitre'),
('KME',	'Kilometre'),
('MLT',	'Mililitre'),
('MTR',	'Meters'),
('MTS',	'Metric Tons'),
('NOS',	'Numbers'),
('OTH',	'Others'),
('PAC',	'Packs'),
('PCS',	'Pieces'),
('PRS',	'Pairs'),
('QTL',	'Quintal'),
('ROL',	'Rolls'),
('SET',	'Sets'),
('SQF',	'Square Feet'),
('SQM',	'Square Meters'),
('SQY',	'Square Yards'),
('TBS',	'Tablets'),
('TGM',	'Ten Gross'),
('THD',	'Thousands'),
('TON',	'Tonnes'),
('TUB',	'Tubes'),
('UNT',	'Units'),
('USG',	'Us Gallons'),
('YDS',	'Yards');

DROP TABLE IF EXISTS `ob_sys_custom_fields`;
CREATE TABLE `ob_sys_custom_fields` (
  `id` mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
  `module` varchar(1) NOT NULL COMMENT 'C-Contact,O-Company',
  `countryCode` varchar(3) NOT NULL,
  `key` varchar(24) NOT NULL,
  `value` varchar(10) NOT NULL COMMENT 'Default Value',
  `label` varchar(32) NOT NULL,
  `type` varchar(10) NOT NULL DEFAULT 'text' COMMENT 'text,number,option,check,select,date',
  `options` text DEFAULT NULL,
  `required` tinyint(1) NOT NULL DEFAULT 0,
  `orderId` smallint(3) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

INSERT INTO `ob_sys_custom_fields` (`id`, `module`, `countryCode`, `key`, `value`, `label`, `type`, `options`, `required`, `orderId`) VALUES
(1,	'C',	'IN',	'taxNo',	'',	'GSTIN',	'text',	NULL,	0,	2),
(2,	'C',	'IN',	'panNo',	'',	'PAN Number',	'text',	NULL,	0,	1),
(3,	'O',	'IN',	'taxNo',	'',	'GSTIN',	'text',	NULL,	1,	1),
(4,	'O',	'IN',	'panNo',	'',	'Pan No',	'text',	NULL,	1,	3),
(5,	'O',	'IN',	'compositionScheme',	'',	'Composition Scheme',	'checkbox',	NULL,	1,	2);

DROP TABLE IF EXISTS `ob_sys_role_modules`;
CREATE TABLE `ob_sys_role_modules` (
  `modCode` varchar(5) NOT NULL,
  `modName` varchar(250) NOT NULL,
  `actionOption` tinyint(1) NOT NULL,
  `orderIndex` smallint(3) unsigned NOT NULL,
  `roleCode` varchar(11) NOT NULL,
  `oldModCode` varchar(3) NOT NULL,
  PRIMARY KEY (`modCode`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

INSERT INTO `ob_sys_role_modules` (`modCode`, `modName`, `actionOption`, `orderIndex`, `roleCode`, `oldModCode`) VALUES
('ACCCT',	'Cash Contra',	4,	29,	'C',	'ACE'),
('ACCHA',	'Chart of Accounts',	4,	30,	'C',	'ACE'),
('ACJRL',	'Journal Entry',	4,	28,	'C',	'ACE'),
('ACOPB',	'Opening Balances',	4,	31,	'C',	'ACE'),
('BAN',	'Bank Transactions',	4,	25,	'C',	'BAN'),
('DAS',	'Dashboard',	1,	1,	'C',	'ACE'),
('ECO',	'E-Commerce',	4,	27,	'E,C',	'ECO'),
('MNBOM',	'Bill of Material',	4,	6,	'C,K',	''),
('MNCUS',	'Customer',	4,	2,	'R,S,C,F,I',	'CON'),
('MNITM',	'Items',	4,	4,	'R,S,I,F,C,K',	'CON'),
('MNMFG',	'Manufacturing Journal',	4,	6,	'C,K',	''),
('MNRBY',	'Refered By',	4,	7,	'C',	'CON'),
('MNRTS',	'Rate Sheet',	4,	5,	'R,S,I,F,C,K',	''),
('MNSAR',	'Sales Rep',	4,	6,	'C',	'CON'),
('MNSTJ',	'Stock Journal',	4,	5,	'C,K',	'STJ'),
('MNSUP',	'Supplier',	4,	3,	'I,C,F',	'CON'),
('PRO',	'Projects',	4,	26,	'C',	'ACE'),
('PUPUB',	'Purchase Bill',	4,	19,	'I,C,F',	'PUB'),
('PUPUC',	'Sup.Credit Note',	4,	22,	'I,C,F',	'PUC'),
('PUPUD',	' Sup.Debit Note',	4,	23,	'I,C,F',	'PUD'),
('PUPUE',	'Expense / Payment',	4,	21,	'I,C,F',	'PUB'),
('PUPUG',	'Goods Receipt Note',	4,	24,	'I,C,K',	'SDH'),
('PUPUO',	'Purchase Order',	4,	18,	'I,C,F',	'PUO'),
('PUPUP',	'Bill Payment',	4,	20,	'I,C,F',	'PUP'),
('PUPUQ',	'Purchase Quotes',	4,	17,	'I,C,F',	'PUQ'),
('RABAS',	'Balance Sheet',	1,	37,	'C',	'RBS'),
('RABUD',	'Budget Variance',	1,	39,	'C',	'RDB'),
('RACBK',	'Cash / Bank Book',	1,	34,	'C',	'RDB'),
('RADAY',	'Daybook',	1,	33,	'C',	'RDB'),
('RAOPB',	'Opening Balance',	1,	38,	'C',	'RDB'),
('RAPAL',	'Profit & Loss',	1,	36,	'C',	'RBS'),
('RATBL',	'Trial Balance',	1,	35,	'C',	'RBS'),
('RICAS',	'Category Sales',	1,	60,	'F,C',	'RLT'),
('RIDPI',	'Delivery Pending For Invoice',	1,	66,	'R,I,C',	'RLT'),
('RIFRS',	'Free Supplies',	1,	62,	'F,C',	'RLT'),
('RIITP',	'Item Purchases',	1,	59,	'I,F,C',	'RLT'),
('RIITS',	'Item Sales',	1,	58,	'R,S,I,F,C',	'RLT'),
('RIPFM',	'Profit Margin',	1,	61,	'F,C',	'RLT'),
('RIPPO',	'Pending Purchase Order',	1,	64,	'I,F,C',	'RLT'),
('RIPSO',	'Pending Sales Order',	1,	63,	'R,S,I,F,C',	'RLT'),
('RITRG',	'Track Returnable Goods ',	1,	65,	'C',	'RLT'),
('RLCOG',	'Contact Tags',	1,	44,	'R,C,S,I',	'RLG'),
('RLCUS',	'Customer',	1,	41,	'C',	'RLG'),
('RLLDG',	'Ledger',	1,	40,	'C',	'RLG'),
('RLSRP',	'Sales Representative',	1,	43,	'R,C',	'RLG'),
('RLSUP',	'Supplier',	1,	42,	'C',	'RLG'),
('RLTAX',	'Tax Accounts',	1,	45,	'C',	'RLG'),
('RRGS1',	'GSTR1',	1,	75,	'C',	'RGS'),
('RRGS2',	'GSTR2 Reconciliation',	1,	76,	'C',	'RGS'),
('RRGS3',	'GSTR3B',	1,	77,	'C',	'RGS'),
('RRGS4',	'GSTR4',	1,	78,	'C',	'RGS'),
('RRGS9',	'GSTR9',	1,	79,	'C',	'RGS'),
('RSBWS',	'Batch-wise-stock',	1,	71,	'R,S,I,F,C,K',	'RLT'),
('RSCSK',	'Current Stock',	1,	67,	'R,S,I,F,C,K',	'RLT'),
('RSMST',	'Merge Stock',	1,	74,	'R,S,I,F,C,K',	'RLT'),
('RSRER',	'Reorder Report',	1,	70,	'R,S,I,F,C,K',	'RLT'),
('RSSTC',	'Stock Category',	1,	73,	'R,S,I,F,C,K',	'RLT'),
('RSSTE',	'Stock Expiry',	1,	72,	'R,S,I,F,C,K',	'RLT'),
('RSSTL',	'Stock Ledger',	1,	69,	'R,S,I,F,C,K',	'RLT'),
('RSSTS',	'Stock Summary',	1,	68,	'R,S,I,F,C,K',	'RLT'),
('RTAGI',	'Aging',	1,	52,	'C,R',	'RTR'),
('RTCUS',	'Customer Sales',	1,	46,	'R,C,S,I',	'RTR'),
('RTOSP',	'Outstanding Payables',	1,	54,	'C,I',	'RTR'),
('RTOSQ',	'Outstanding Quotes',	1,	55,	'C',	'RTR'),
('RTOSR',	'Outstanding Receivables',	1,	53,	'R,C,S,I',	'RTR'),
('RTPDC',	'Post Dated Cheques',	1,	57,	'C',	'RTR'),
('RTPUR',	'Purchase Register',	1,	51,	'C,I',	'RTR'),
('RTPYM',	'Payment Modes',	1,	56,	'C',	'RTR'),
('RTRBY',	'Referred By Report',	1,	50,	'C',	'RTR'),
('RTSAR',	'Sales Register',	1,	48,	'R,C,S,I',	'RTR'),
('RTSRA',	'Sales Rep.Analysis',	1,	49,	'R,C',	'RTR'),
('RTSUP',	'Supplier purchases',	1,	47,	'C,I',	'RTR'),
('SAEWB',	'E-way Bill',	4,	16,	'C',	'SAI'),
('SAJOB',	'Job Order',	4,	10,	'R,S,I,C',	'JOB'),
('SASAC',	'Sales Credit Note',	4,	13,	'R,S,I,C,F',	'SAI'),
('SASAD',	'Sales Debit Note',	4,	14,	'R,S,I,C,F',	'SAI'),
('SASAI',	'Sales Invoice',	4,	11,	'R,S,I,C,F',	'SAI'),
('SASAO',	'Sales Order',	4,	9,	'R,S,I,C,F',	'SAQ'),
('SASAQ',	'Quotes',	4,	8,	'R,S,I,C,F',	'SAQ'),
('SASAR',	'Receipt',	4,	15,	'R,S,I,C,F',	'SAR'),
('SASDH',	'Delivery Challan',	4,	12,	'R,S,I,C,K,F',	'SDH'),
('SET',	'Settings',	1,	32,	'C',	'SET');

DROP TABLE IF EXISTS `ob_tags`;
CREATE TABLE `ob_tags` (
  `id` mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
  `cId` mediumint(8) unsigned NOT NULL,
  `tagName` varchar(60) NOT NULL,
  `tagType` varchar(1) NOT NULL DEFAULT 'C' COMMENT 'C-Contacts,I-Item',
  `updatedOn` timestamp NOT NULL DEFAULT current_timestamp() ON UPDATE current_timestamp(),
  `sortNo` mediumint(4) unsigned NOT NULL DEFAULT 0,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ob_tax`;
CREATE TABLE `ob_tax` (
  `id` mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
  `cId` mediumint(8) unsigned NOT NULL,
  `name` varchar(20) NOT NULL,
  `taxCode` varchar(10) NOT NULL DEFAULT '0',
  `isActive` tinyint(1) NOT NULL DEFAULT 1,
  `isDefault` tinyint(1) NOT NULL DEFAULT 0,
  PRIMARY KEY (`id`),
  KEY `cId` (`cId`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

INSERT INTO `ob_tax` (`id`, `cId`, `name`, `taxCode`, `isActive`, `isDefault`) VALUES
(1,	0,	'GST 28%',	'GST28',	1,	0),
(2,	0,	'GST 18%',	'GST18',	1,	1),
(3,	0,	'GST 12%',	'GST12',	1,	0),
(4,	0,	'GST 5%',	'GST5',	1,	0),
(5,	0,	'GST 0%',	'GST0',	1,	0),
(6,	0,	'GST 3%',	'GST3',	0,	0),
(7,	0,	'GST 7.5%',	'GST7.5',	0,	0),
(8,	0,	'GST 1.5%',	'GST1.5',	0,	0),
(9,	0,	'GST 1%',	'GST1',	0,	0),
(10,	0,	'GST 0.25%',	'GST025',	0,	0),
(11,	0,	'GST 0.1%',	'GST01',	0,	0);

DROP TABLE IF EXISTS `ob_taxacctemplate`;
CREATE TABLE `ob_taxacctemplate` (
  `id` mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(40) NOT NULL,
  `groupCode` char(2) NOT NULL,
  `accCodeSuffix` varchar(6) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ob_taxdetail`;
CREATE TABLE `ob_taxdetail` (
  `id` mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
  `cId` mediumint(8) unsigned NOT NULL,
  `taxId` mediumint(8) unsigned NOT NULL,
  `taxTypeCode` varchar(7) NOT NULL,
  `taxRate` decimal(5,2) NOT NULL,
  `stateType` char(1) NOT NULL COMMENT 'I or U-InteraState,x-otherState,A- All state',
  `taxCalc` varchar(1) DEFAULT 'V' COMMENT 'V-Value / Q-Quantity',
  PRIMARY KEY (`id`),
  KEY `IX_TAX` (`cId`,`taxId`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

INSERT INTO `ob_taxdetail` (`id`, `cId`, `taxId`, `taxTypeCode`, `taxRate`, `stateType`, `taxCalc`) VALUES
(1,	0,	1,	'CGST',	14.00,	'I',	'V'),
(2,	0,	1,	'SGST',	14.00,	'I',	'V'),
(3,	0,	1,	'IGST',	28.00,	'X',	'V'),
(4,	0,	2,	'CGST',	9.00,	'I',	'V'),
(5,	0,	2,	'SGST',	9.00,	'I',	'V'),
(6,	0,	2,	'IGST',	18.00,	'X',	'V'),
(7,	0,	3,	'CGST',	6.00,	'I',	'V'),
(8,	0,	3,	'SGST',	6.00,	'I',	'V'),
(9,	0,	3,	'IGST',	12.00,	'X',	'V'),
(10,	0,	4,	'CGST',	2.50,	'I',	'V'),
(11,	0,	4,	'SGST',	2.50,	'I',	'V'),
(12,	0,	4,	'IGST',	5.00,	'X',	'V'),
(13,	0,	5,	'CGST',	0.00,	'I',	'V'),
(14,	0,	5,	'SGST',	0.00,	'I',	'V'),
(15,	0,	5,	'IGST',	0.00,	'X',	'V'),
(16,	0,	6,	'CGST',	1.50,	'I',	'V'),
(17,	0,	6,	'SGST',	1.50,	'I',	'V'),
(18,	0,	6,	'IGST',	3.00,	'X',	'V'),
(19,	0,	7,	'CGST',	3.75,	'I',	'V'),
(20,	0,	7,	'SGST',	3.75,	'I',	'V'),
(21,	0,	7,	'IGST',	7.50,	'X',	'V'),
(22,	0,	8,	'CGST',	0.75,	'I',	'V'),
(23,	0,	8,	'SGST',	0.75,	'I',	'V'),
(24,	0,	8,	'IGST',	1.50,	'X',	'V'),
(25,	0,	9,	'CGST',	0.50,	'I',	'V'),
(26,	0,	9,	'SGST',	0.50,	'I',	'V'),
(27,	0,	9,	'IGST',	1.00,	'X',	'V'),
(28,	0,	10,	'CGST',	0.13,	'I',	'V'),
(29,	0,	10,	'SGST',	0.13,	'I',	'V'),
(30,	0,	10,	'IGST',	0.25,	'X',	'V'),
(31,	0,	11,	'CGST',	0.05,	'I',	'V'),
(32,	0,	11,	'SGST',	0.05,	'I',	'V'),
(33,	0,	11,	'IGST',	0.10,	'X',	'V');

DROP TABLE IF EXISTS `ob_taxreturns`;
CREATE TABLE `ob_taxreturns` (
  `id` mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
  `cId` mediumint(8) unsigned NOT NULL,
  `cTaxNo` varchar(20) NOT NULL DEFAULT '',
  `conTaxNo` varchar(20) NOT NULL,
  `conInvNo` varchar(50) NOT NULL,
  `conInvDate` date NOT NULL,
  `conName` varchar(60) NOT NULL,
  `totAmount` decimal(11,2) NOT NULL,
  `isReverse` varchar(1) NOT NULL DEFAULT 'N',
  `comments` varchar(255) NOT NULL,
  `taxValues` varchar(255) NOT NULL,
  `taxableAmount` decimal(11,2) NOT NULL,
  `CGST` decimal(11,2) NOT NULL,
  `SGST` decimal(11,2) NOT NULL,
  `IGST` decimal(11,2) NOT NULL,
  `CESS` decimal(11,2) NOT NULL,
  `tType` varchar(2) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `idx` (`cId`,`conInvDate`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ob_taxyearlyreturns`;
CREATE TABLE `ob_taxyearlyreturns` (
  `id` mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
  `year` smallint(4) NOT NULL,
  `taxNo` varchar(20) NOT NULL,
  `cId` mediumint(8) unsigned NOT NULL,
  `importjson` text NOT NULL,
  `updateddata` text NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ob_trans`;
CREATE TABLE `ob_trans` (
  `id` mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
  `cId` mediumint(8) unsigned NOT NULL,
  `tType` char(2) NOT NULL COMMENT 'SI-Sales/SR-Retail/SC-CreditNote/SD-DebitNote/SB-BillofSupply/SA-AdvanceReceipt/ SH-DeliveryChallan/SP-Sales Payment/SE-Estimate PI-Purchase Invoice/PE-Expenses/PC-Purchase Credit Note/PD-Purchase Debit Note/ PA-AdvancePayment/PP-Purchase Payment JV - Journal Voucher',
  `tNo` varchar(50) NOT NULL,
  `seriesNo` varchar(20) NOT NULL,
  `tDate` date NOT NULL,
  `ref` varchar(255) NOT NULL,
  `ref_id` mediumint(8) unsigned NOT NULL DEFAULT 0,
  `notes` varchar(500) NOT NULL,
  `status` char(1) NOT NULL COMMENT 'D-Draft/S-Sent/P-Paid/V-Void//O-Overdue',
  `conId` mediumint(8) unsigned NOT NULL,
  `conName` varchar(60) NOT NULL,
  `conStateCode` varchar(5) NOT NULL,
  `conStateId` mediumint(8) unsigned NOT NULL,
  `conLocCode` char(1) NOT NULL,
  `conTaxNo` varchar(20) NOT NULL,
  `conTaxScheme` varchar(1) DEFAULT NULL COMMENT 'C-Composition Scheme,U-Unregister,R-Registered*',
  `dstStateCode` varchar(3) NOT NULL,
  `dstStateId` mediumint(8) unsigned NOT NULL,
  `dueDate` date NOT NULL,
  `taxableAmount` decimal(11,2) NOT NULL,
  `roundAmount` decimal(4,2) NOT NULL,
  `totTax` decimal(9,2) NOT NULL,
  `totAmount` decimal(11,2) NOT NULL,
  `categoryCode` varchar(6) NOT NULL COMMENT 'B2B/B2CS/B2CL/RD/URD/EXP/COM',
  `categorySubCode` varchar(2) DEFAULT NULL COMMENT 'EX- Excempt, RC- RCM, EC-ecom',
  `returnStatus` char(1) NOT NULL COMMENT 'N-Not Filed / F-Filed',
  `isComposition` tinyint(1) NOT NULL DEFAULT 0,
  `isReverse` tinyint(1) NOT NULL,
  `includeTax` tinyint(1) NOT NULL DEFAULT 0,
  `tdsPercentage` decimal(4,2) NOT NULL,
  `tdsAmount` decimal(9,2) NOT NULL,
  `paymentMode` mediumint(8) unsigned NOT NULL,
  `paymentAccId` mediumint(8) unsigned NOT NULL,
  `classCode` varchar(6) NOT NULL COMMENT 'REG/EXPWP/EXPWOP/SEZWP/SEZWOP/EXPBO/DEEM/CNSR/CNPS/CNDS/CNCI/CNPS/CNPA/CNO/SHJW/SHLG/SHSA/SHO',
  `plId` int(11) NOT NULL DEFAULT -1,
  `updatedBy` varchar(60) NOT NULL,
  `updatedOn` timestamp NOT NULL DEFAULT current_timestamp(),
  `sRepId` mediumint(8) unsigned NOT NULL DEFAULT 0,
  `bId` mediumint(8) unsigned NOT NULL DEFAULT 0,
  `refTtype` varchar(2) NOT NULL,
  `progress` tinyint(4) NOT NULL,
  `recAmt` decimal(11,2) NOT NULL,
  `seriesId` mediumint(8) unsigned NOT NULL,
  `isLocked` varchar(1) NOT NULL DEFAULT '',
  `info` text NOT NULL,
  `source` varchar(1) NOT NULL COMMENT 'E-ECommerce',
  PRIMARY KEY (`id`) USING BTREE,
  KEY `cId` (`cId`,`tDate`),
  KEY `conId` (`conId`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ob_transporter`;
CREATE TABLE `ob_transporter` (
  `id` mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
  `cId` mediumint(8) unsigned NOT NULL,
  `name` varchar(100) NOT NULL,
  `taxId` varchar(15) NOT NULL COMMENT 'Transporter GSTIN/TRANSIN',
  PRIMARY KEY (`id`),
  KEY `IX_cId` (`cId`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ob_trans_acc`;
CREATE TABLE `ob_trans_acc` (
  `id` mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
  `transId` mediumint(8) unsigned NOT NULL,
  `cId` mediumint(8) unsigned NOT NULL,
  `accCode` char(16) NOT NULL DEFAULT '',
  `accId` mediumint(8) unsigned NOT NULL,
  `desc` varchar(255) NOT NULL DEFAULT '',
  `debit` decimal(11,2) NOT NULL,
  `credit` decimal(11,2) NOT NULL,
  `conId` mediumint(8) unsigned NOT NULL,
  `dueAmount` decimal(11,2) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `IX_transId_accId` (`transId`,`accId`),
  KEY `IX_conId` (`conId`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ob_trans_addr`;
CREATE TABLE `ob_trans_addr` (
  `transId` mediumint(8) unsigned NOT NULL,
  `cId` mediumint(8) unsigned NOT NULL,
  `name` varchar(100) DEFAULT NULL,
  `addrType` char(1) NOT NULL COMMENT 'B - Bill/S - Ship/A - All',
  `address1` varchar(200) NOT NULL,
  `address2` varchar(200) NOT NULL,
  `city` varchar(20) NOT NULL,
  `stateCode` varchar(5) NOT NULL,
  `stateId` mediumint(8) unsigned NOT NULL,
  `stateName` varchar(32) DEFAULT NULL,
  `zip` varchar(20) NOT NULL,
  `countryCode` varchar(3) NOT NULL,
  `country` varchar(20) NOT NULL,
  `phone` varchar(20) NOT NULL,
  `email` varchar(200) NOT NULL,
  `extraCont` varchar(500) DEFAULT NULL,
  `conAddrId` int(11) NOT NULL,
  PRIMARY KEY (`transId`,`addrType`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ob_trans_attachments`;
CREATE TABLE `ob_trans_attachments` (
  `id` mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
  `transId` mediumint(8) unsigned NOT NULL,
  `cId` mediumint(8) unsigned NOT NULL,
  `fileName` varchar(100) NOT NULL,
  `filePath` varchar(200) NOT NULL,
  `fileType` varchar(200) NOT NULL,
  `fileSize` varchar(200) NOT NULL,
  PRIMARY KEY (`id`) USING BTREE,
  UNIQUE KEY `id` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ob_trans_billable`;
CREATE TABLE `ob_trans_billable` (
  `transItemId` mediumint(8) unsigned NOT NULL,
  `prjconId` mediumint(8) unsigned NOT NULL,
  `invTransId` mediumint(8) unsigned NOT NULL,
  `cid` mediumint(8) unsigned NOT NULL,
  `transId` mediumint(8) unsigned NOT NULL,
  `tsType` varchar(1) NOT NULL DEFAULT 't' COMMENT 't - transaction s - stock transfer',
  PRIMARY KEY (`transId`,`transItemId`) USING BTREE,
  KEY `IX_billableConId` (`prjconId`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ob_trans_export`;
CREATE TABLE `ob_trans_export` (
  `transId` mediumint(8) unsigned NOT NULL,
  `cId` mediumint(8) unsigned NOT NULL,
  `shipBillNo` varchar(20) NOT NULL,
  `shipBillDate` date NOT NULL,
  `shipPortCode` varchar(16) NOT NULL,
  `expCurrencyCode` varchar(4) NOT NULL,
  `excRate` decimal(11,6) NOT NULL,
  `totForexAmt` decimal(11,2) NOT NULL,
  UNIQUE KEY `transId` (`transId`,`cId`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ob_trans_fields`;
CREATE TABLE `ob_trans_fields` (
  `transId` mediumint(8) unsigned NOT NULL,
  `fId` mediumint(8) unsigned NOT NULL,
  `fName` varchar(20) NOT NULL,
  `fValue` text NOT NULL,
  UNIQUE KEY `IX_transId_fId` (`transId`,`fId`),
  KEY `IX_transId` (`transId`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ob_trans_items`;
CREATE TABLE `ob_trans_items` (
  `id` mediumint(10) unsigned NOT NULL AUTO_INCREMENT,
  `transId` mediumint(8) unsigned NOT NULL,
  `cId` mediumint(8) unsigned NOT NULL,
  `itemId` mediumint(8) unsigned NOT NULL,
  `itemName` varchar(255) NOT NULL,
  `itemDesc` varchar(4000) NOT NULL,
  `itemType` char(1) NOT NULL COMMENT 'G / S',
  `itemHS` varchar(8) NOT NULL COMMENT 'HSN/SAC Code',
  `rate` decimal(11,3) NOT NULL,
  `qty` decimal(9,3) NOT NULL,
  `freeQty` decimal(8,3) NOT NULL DEFAULT 0.000,
  `discPercentage` decimal(5,2) NOT NULL,
  `discItem` decimal(11,2) DEFAULT NULL,
  `discAmount` decimal(11,2) NOT NULL,
  `unit` varchar(10) NOT NULL,
  `taxableAmount` decimal(11,2) NOT NULL,
  `taxId` mediumint(8) unsigned NOT NULL,
  `taxName` varchar(20) NOT NULL,
  `itemTotal` decimal(11,2) NOT NULL,
  `accId` mediumint(8) unsigned NOT NULL,
  `itc` tinyint(1) NOT NULL,
  `itemAttrId` mediumint(8) unsigned NOT NULL,
  `mrp` decimal(11,3) NOT NULL DEFAULT 0.000,
  `locId` mediumint(8) unsigned NOT NULL DEFAULT 0,
  `refTitemId` mediumint(8) unsigned NOT NULL,
  `chargesAmount` decimal(11,2) NOT NULL,
  `currencyCode` varchar(3) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`),
  KEY `itemId` (`itemId`),
  KEY `IX_transId` (`transId`),
  KEY `IX_refTitemId` (`refTitemId`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ob_trans_log`;
CREATE TABLE `ob_trans_log` (
  `id` mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
  `cId` mediumint(8) unsigned NOT NULL,
  `tId` mediumint(8) unsigned NOT NULL,
  `aDate` timestamp NOT NULL DEFAULT current_timestamp() ON UPDATE current_timestamp(),
  `aUserId` mediumint(8) unsigned NOT NULL,
  `aUserName` varchar(20) NOT NULL,
  `aEvent` varchar(2) NOT NULL COMMENT 'A - Add / E - Edit / D - Delete / P - Payment/ L - Login / S - Status/ R-Receipt / C - Credit / CO - Comment',
  `aValue` text NOT NULL,
  `aRelValue` varchar(60) NOT NULL,
  `devDetails` varchar(500) NOT NULL,
  `deviceId` varchar(11) NOT NULL,
  `type` varchar(3) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ob_trans_notes`;
CREATE TABLE `ob_trans_notes` (
  `transId` mediumint(8) unsigned NOT NULL,
  `cId` mediumint(8) unsigned NOT NULL,
  `bankAccId` mediumint(8) unsigned NOT NULL,
  `notes` varchar(4000) NOT NULL,
  `terms` varchar(4000) NOT NULL,
  UNIQUE KEY `transId` (`transId`,`cId`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ob_trans_pay`;
CREATE TABLE `ob_trans_pay` (
  `transId` mediumint(8) unsigned NOT NULL,
  `cId` mediumint(8) unsigned NOT NULL,
  `pAccId` mediumint(8) unsigned NOT NULL,
  `pMode` mediumint(8) unsigned NOT NULL,
  `pRef` varchar(255) NOT NULL,
  `pAmount` decimal(11,2) NOT NULL,
  `pConId` int(10) NOT NULL DEFAULT 0,
  KEY `IX_transId` (`transId`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ob_trans_payment`;
CREATE TABLE `ob_trans_payment` (
  `transId` mediumint(8) unsigned NOT NULL,
  `cId` mediumint(8) unsigned NOT NULL,
  `allotTransId` mediumint(8) unsigned NOT NULL,
  `allotAmt` decimal(11,2) NOT NULL,
  `tdsAmt` decimal(11,2) NOT NULL,
  `allotConId` mediumint(8) unsigned DEFAULT NULL,
  `writeOff` decimal(11,2) DEFAULT 0.00,
  KEY `IX_transId` (`transId`),
  KEY `IX_allotTransId` (`allotTransId`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ob_trans_payment_ex`;
CREATE TABLE `ob_trans_payment_ex` (
  `transId` mediumint(8) unsigned NOT NULL,
  `cId` mediumint(8) unsigned NOT NULL,
  `allotTransId` mediumint(8) unsigned NOT NULL,
  `forexAmount` decimal(11,2) NOT NULL,
  `excRate` decimal(11,6) NOT NULL,
  `forexGL` decimal(11,2) NOT NULL,
  `forexWriteOff` decimal(11,2) DEFAULT NULL,
  KEY `IX_transId` (`transId`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ob_trans_ref`;
CREATE TABLE `ob_trans_ref` (
  `transId` mediumint(8) unsigned NOT NULL,
  `refTransId` mediumint(8) unsigned NOT NULL,
  `cId` mediumint(8) unsigned NOT NULL,
  UNIQUE KEY `trc_id` (`transId`,`refTransId`),
  KEY `IX_refTransId` (`refTransId`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ob_trans_rel`;
CREATE TABLE `ob_trans_rel` (
  `transId` mediumint(8) unsigned NOT NULL,
  `cId` mediumint(8) unsigned NOT NULL,
  `relDate` date NOT NULL,
  `relNumber` varchar(50) NOT NULL,
  PRIMARY KEY (`transId`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ob_trans_serial`;
CREATE TABLE `ob_trans_serial` (
  `tsItemId` mediumint(8) unsigned NOT NULL,
  `asId` mediumint(8) unsigned NOT NULL,
  `tsType` varchar(2) NOT NULL DEFAULT 'T' COMMENT 'T-TransItem, S-StockItem',
  KEY `tsItemId` (`tsItemId`,`tsType`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ob_trans_tax`;
CREATE TABLE `ob_trans_tax` (
  `transId` mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
  `cId` mediumint(8) unsigned NOT NULL,
  `transItemID` mediumint(8) unsigned NOT NULL,
  `taxTypeCode` varchar(7) NOT NULL,
  `taxRate` decimal(5,2) NOT NULL,
  `taxValue` decimal(11,2) NOT NULL,
  `itc` tinyint(1) NOT NULL,
  `taxCalc` varchar(1) NOT NULL DEFAULT 'V',
  KEY `IX_transId` (`transId`),
  KEY `IX_transItemID` (`transItemID`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ob_useraccess`;
CREATE TABLE `ob_useraccess` (
  `id` mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
  `uId` mediumint(8) unsigned NOT NULL,
  `updatedOn` timestamp NOT NULL DEFAULT current_timestamp() ON UPDATE current_timestamp(),
  `userIP` varchar(500) NOT NULL,
  `accCnt` mediumint(8) unsigned NOT NULL DEFAULT 1,
  `cId` mediumint(8) unsigned NOT NULL,
  `deviceId` mediumint(8) unsigned NOT NULL,
  `lType` varchar(1) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ob_userpermissions`;
CREATE TABLE `ob_userpermissions` (
  `cId` mediumint(8) unsigned NOT NULL,
  `uId` mediumint(8) unsigned NOT NULL,
  `moduleCode` mediumint(8) unsigned NOT NULL,
  `perAdd` tinyint(1) NOT NULL,
  `perEdit` tinyint(1) NOT NULL,
  `perDel` tinyint(1) NOT NULL,
  `perList` tinyint(1) NOT NULL,
  PRIMARY KEY (`cId`,`uId`,`moduleCode`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ob_users`;
CREATE TABLE `ob_users` (
  `id` mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(60) NOT NULL,
  `email` varchar(200) NOT NULL,
  `loginName` varchar(200) NOT NULL,
  `password` varchar(64) NOT NULL,
  `phone` varchar(20) DEFAULT NULL,
  `defaultCId` mediumint(8) unsigned DEFAULT NULL,
  `isPrimeUser` tinyint(1) NOT NULL DEFAULT 0,
  `isActive` tinyint(1) NOT NULL DEFAULT 1,
  `lastLogin` timestamp NULL DEFAULT NULL,
  `crdByUserId` mediumint(8) unsigned NOT NULL DEFAULT 0,
  `crdDate` timestamp NULL DEFAULT NULL,
  `updDate` timestamp NOT NULL DEFAULT current_timestamp() ON UPDATE current_timestamp(),
  `activation` varchar(64) DEFAULT NULL,
  `licCnt` tinyint(3) NOT NULL DEFAULT 0,
  `invsign` varchar(64) DEFAULT NULL,
  `conId` mediumint(8) unsigned NOT NULL DEFAULT 0,
  `defaultbId` mediumint(8) unsigned NOT NULL DEFAULT 0,
  `mIdread` int(10) unsigned NOT NULL DEFAULT 0,
  PRIMARY KEY (`id`),
  UNIQUE KEY `loginName` (`loginName`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ob_users_auth_tokens`;
CREATE TABLE `ob_users_auth_tokens` (
  `id` mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
  `uId` mediumint(8) unsigned NOT NULL,
  `authTkn` varchar(250) NOT NULL,
  `expDate` datetime NOT NULL,
  `deviceId` mediumint(8) unsigned NOT NULL,
  PRIMARY KEY (`id`),
  KEY `ix__auth_token` (`authTkn`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- 2023-03-18 06:48:05
ALTER TABLE `ob_price_list_apply` ADD `applyType` VARCHAR(1) NOT NULL DEFAULT 'B' AFTER `ctype`;
update `ob_price_list_apply` set applyType='A' where ctype not in ('B','F');

CREATE TABLE `ob_storage` (
  `id` int(10) UNSIGNED NOT NULL,
  `cId` int(10) UNSIGNED NOT NULL,
  `bId` int(10) UNSIGNED NOT NULL,
  `stoCode` varchar(12) NOT NULL,
  `stoName` varchar(200) NOT NULL,
  `numRange` varchar(1000) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

ALTER TABLE `ob_storage` ADD PRIMARY KEY (`id`), ADD KEY `stoCode` (`stoCode`);
ALTER TABLE `ob_storage` MODIFY `id` int(10) UNSIGNED NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=1;

CREATE TABLE `ob_storage_ts` (
  `tsId` int(11) NOT NULL,
  `tsType` char(1) NOT NULL COMMENT ' T-Transaction, S-Stock',
  `tstItemId` int(11) NOT NULL,
  `stoId` int(10) UNSIGNED NOT NULL,
  `stoNo` int(11) NOT NULL,
  `bags` int(11) NOT NULL,
  `qty` decimal(9,3) NOT NULL,
  `uom` varchar(10) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

ALTER TABLE `ob_storage_ts` ADD KEY `tsId` (`tsId`);

CREATE TABLE `ob_storage_cur` (
  `itemId` int(11) NOT NULL,
  `itemAttrId` int(11) NOT NULL,
  `stoId` int(11) NOT NULL,
  `stoNo` int(10) UNSIGNED NOT NULL,
  `bags` int(11) NOT NULL,
  `stkLevel` decimal(10,0) NOT NULL,
  `uom` varchar(10) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

ALTER TABLE `ob_storage_cur` ADD KEY `itemId` (`itemId`), ADD KEY `stoId` (`stoId`);

INSERT INTO ob_sys_role_modules(modCode, modName, actionOption, orderIndex, roleCode, oldModCode) VALUES ('MNPHY','Physical Stock','4','6','C,K','');

ALTER TABLE `ob_trans_log` ADD `updatedLog` TEXT NOT NULL AFTER `deviceId`;

-- Workflow queries

CREATE TABLE IF NOT EXISTS `ob_workflow` (
	`id` int(10) UNSIGNED NOT NULL,
	`cId` int(10) UNSIGNED NOT NULL,
	`bId` int(10) NOT NULL DEFAULT 0,
	`name` varchar(60) NOT NULL,
	`typeCode` char(2) NOT NULL,
	`stypeCode` varchar(3) NOT NULL,
	`event` char(1) NOT NULL COMMENT 'A/E/D/Z (default: Z - All)',
	`actions` varchar(5000) NOT NULL,
	`conditions` varchar(5000) NOT NULL,
	`condformat` varchar(2000) NOT NULL,
	`isActive` tinyint(1) NOT NULL,
	`sortOrd` int(10) NOT NULL DEFAULT 0,
	`createdBy` varchar(60) NOT NULL,
	`updatedBy` varchar(60) NOT NULL,
	`updatedOn` timestamp NOT NULL DEFAULT current_timestamp() ON UPDATE current_timestamp()
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

ALTER TABLE `ob_workflow` ADD PRIMARY KEY (`id`);

ALTER TABLE `ob_workflow` MODIFY `id` int(10) UNSIGNED NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=11;

ALTER TABLE `ob_messages` ADD `rType` CHAR(1) NOT NULL COMMENT 'S/T/C/I/A' AFTER `priority`, ADD `rId` INT(10) UNSIGNED NOT NULL AFTER `rType`;

CREATE TABLE `ob_approval` (
	`rType` CHAR(1) NOT NULL COMMENT 'S/T/C/I/A',
	`rId` INT(10) NOT NULL,
	`approvedUserId` INT(11) NOT NULL,
	`updatedOn` TIMESTAMP on update CURRENT_TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP
) ENGINE = InnoDB;

CREATE TABLE `ob_approval_pending` (
	`rType` CHAR(1) NOT NULL COMMENT 'S/T/C/I/A',
	`rId` INT(10) UNSIGNED NOT NULL,
	`urId` INT(11) UNSIGNED NOT NULL,
	`urtype` CHAR(1) NOT NULL COMMENT 'U/R',
	`apvLevel` INT(1) UNSIGNED NOT NULL,
	`updatedOn` TIMESTAMP on update CURRENT_TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP
) ENGINE = InnoDB;
ALTER TABLE `ob_companies` ADD `mainbId` INT(11) NOT NULL DEFAULT "0" AFTER `addInfo`;
ALTER TABLE `ob_credit_limit` DROP PRIMARY KEY, ADD PRIMARY KEY (`conTId`, `ctType`, `cId`) USING BTREE;
ALTER TABLE `ob_bom` ADD `dispPrint` CHAR(1) NOT NULL COMMENT '\'R\' -> Name WIth Rate, \'N\' - Name only, Q - Name With Quantity' AFTER `bomType`;
CREATE TABLE `ob_trans_items_rel` (
  `transItemId` int(11) NOT NULL,
  `ptitemId` int(10) NOT NULL,
  `subCode` char(2) NOT NULL COMMENT 'AL-Alternate Item, CO-Content Item, OA - Optional Add-on',
  `sortNo` int(10) NOT NULL,
  `isHide` tinyint(1) NOT NULL,
  `info` text NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;
ALTER TABLE `ob_trans_export` ADD `conId` INT(11) NOT NULL;
ALTER TABLE `ob_trans_export` DROP INDEX `transId`, ADD UNIQUE `transId` (`transId`, `cId`, `conId`) USING BTREE;
ALTER TABLE `ob_trans_log` ADD INDEX `ix_tId` (`tId`);
ALTER TABLE ob_account CHANGE bId bId MEDIUMINT(8) UNSIGNED NOT NULL DEFAULT "0";
ALTER TABLE ob_account_loc CHANGE locId locId MEDIUMINT(8) UNSIGNED NOT NULL DEFAULT "0";
ALTER TABLE ob_api_keys CHANGE bId bId MEDIUMINT(8) UNSIGNED NOT NULL DEFAULT "0";
ALTER TABLE ob_attachment CHANGE bId bId MEDIUMINT(8) UNSIGNED NOT NULL DEFAULT "0";
ALTER TABLE ob_bom_items CHANGE locId locId MEDIUMINT(8) UNSIGNED NOT NULL DEFAULT "0";
ALTER TABLE ob_budget CHANGE bId bId MEDIUMINT(8) UNSIGNED NOT NULL DEFAULT "0";
ALTER TABLE ob_compsmtp CHANGE bId bId MEDIUMINT(8) UNSIGNED NOT NULL DEFAULT "0";
ALTER TABLE ob_compusers_location CHANGE locId locId MEDIUMINT(8) UNSIGNED NOT NULL DEFAULT "0";
ALTER TABLE ob_contacts CHANGE bId bId MEDIUMINT(8) UNSIGNED NOT NULL DEFAULT "0";
-- ALTER TABLE ob_ec_orders CHANGE bId bId MEDIUMINT(8) UNSIGNED NOT NULL DEFAULT "0";
-- ALTER TABLE ob_ec_shipay CHANGE bId bId MEDIUMINT(8) UNSIGNED NOT NULL DEFAULT "0";
ALTER TABLE ob_item_attr_serial_cur CHANGE bId bId MEDIUMINT(8) UNSIGNED NOT NULL DEFAULT "0";
ALTER TABLE ob_items_cur CHANGE bId bId MEDIUMINT(8) UNSIGNED NOT NULL DEFAULT "0";
ALTER TABLE ob_obojobs CHANGE bId bId MEDIUMINT(8) UNSIGNED NOT NULL DEFAULT "0";
ALTER TABLE ob_printers CHANGE bId bId MEDIUMINT(8) UNSIGNED NOT NULL DEFAULT "0";
ALTER TABLE ob_printsettings CHANGE bId bId MEDIUMINT(8) UNSIGNED NOT NULL DEFAULT "0";
ALTER TABLE ob_series CHANGE bId bId MEDIUMINT(8) UNSIGNED NOT NULL DEFAULT "0";
ALTER TABLE ob_skvalue CHANGE bId bId MEDIUMINT(8) UNSIGNED NOT NULL DEFAULT "0";
ALTER TABLE ob_stock_entries CHANGE locId locId MEDIUMINT(8) UNSIGNED NOT NULL DEFAULT "0";
ALTER TABLE ob_stock_items CHANGE fromlocId fromlocId MEDIUMINT(8) UNSIGNED NOT NULL DEFAULT "0";
ALTER TABLE ob_stock_items CHANGE tolocId tolocId MEDIUMINT(8) UNSIGNED NOT NULL DEFAULT "0";
ALTER TABLE ob_stock_physical CHANGE bId bId MEDIUMINT(8) UNSIGNED NOT NULL DEFAULT "0";
ALTER TABLE ob_trans CHANGE bId bId MEDIUMINT(8) UNSIGNED NOT NULL DEFAULT "0";
ALTER TABLE ob_trans_items CHANGE locId locId MEDIUMINT(8) UNSIGNED NOT NULL DEFAULT "0";
ALTER TABLE ob_workflow CHANGE bId bId MEDIUMINT(8) UNSIGNED NOT NULL DEFAULT "0";
INSERT INTO `ob_sys_role_modules` (`modCode`, `modName`, `actionOption`, `orderIndex`, `roleCode`, `oldModCode`) VALUES ('TBBDE', 'Block backed dated entries', '0', '83', 'R,S,I,F,C,K', '');
insert into ob_compconfig (cId,code,value) select c.id as cId,'timeZone' as code, cu.timeZone as value from ob_companies as c join ob_countries as cu on cu.countryCode=c.countryCode ON DUPLICATE KEY UPDATE value=value;
ALTER TABLE `ob_account` ADD `userAccess` VARCHAR(1000) NOT NULL AFTER `sortNo`;
INSERT INTO `ob_role_permissions` (`roleId`, `cId`, `modCode`, `actionRights`) SELECT roleId,cId,'TLSHL',1 from ob_role where roleCode IN ('S', 'R');
ALTER TABLE `ob_trans_items_rel` ADD PRIMARY KEY( `transItemId`);
INSERT INTO `ob_cities` (`name`, `stateCode`, `location`) VALUES ('Deuli', 'WB', '22.077600,87.328700');
INSERT INTO `ob_account` (`cId`, `name`, `groupId`, `groupCode`, `accCode`, `descr`, `taxId`, `itc`, `taxTypeCode`, `isActive`, `systemRec`, `balance`,`bid`) SELECT ag.cId,'Advance to Suppliers',ag.id,ag.groupCode,'AS','',0,0,'',1,1,0,0 FROM ob_accountgroup ag  WHERE ag.groupCode='CA' and ag.systemRec=1;
INSERT INTO `ob_account` (`cId`, `name`, `groupId`, `groupCode`, `accCode`, `descr`, `taxId`, `itc`, `taxTypeCode`, `isActive`, `systemRec`, `balance`,`bid`) SELECT ag.cId,'Advance from Customers',ag.id,ag.groupCode,'AC','',0,0,'',1,1,0,0 FROM ob_accountgroup ag  WHERE ag.groupCode='CL' and ag.systemRec=1;
ALTER TABLE `ob_bank` CHANGE `accNumber` `accNumber` VARCHAR(30) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL;
ALTER TABLE `ob_items_cur` CHANGE `curStk` `curStk` DECIMAL(9,3) NOT NULL DEFAULT '0.000';
ALTER TABLE `ob_items` ADD `bId` MEDIUMINT(8) UNSIGNED NOT NULL DEFAULT '0' AFTER `printName`;
ALTER TABLE `ob_items` CHANGE `isActive` `isActive` TINYINT(1) NOT NULL DEFAULT '1' COMMENT 'Negative value allowed';
ALTER TABLE `ob_contacts` CHANGE `plId` `plId` INT(11) NOT NULL DEFAULT '-1' COMMENT 'Negative value allowed';
ALTER TABLE `ob_contacts` CHANGE `isActive` `isActive` TINYINT(1) NOT NULL DEFAULT '1' COMMENT 'Negative value allowed';
ALTER TABLE `ob_bom_items` CHANGE `qty` `qty` DECIMAL(9,3) NOT NULL COMMENT 'Negative value allowed';
ALTER TABLE `ob_stock_items` CHANGE `qty` `qty` DECIMAL(11,3) NOT NULL COMMENT 'Negative value allowed';
ALTER TABLE `ob_trans` CHANGE `plId` `plId` INT(11) NOT NULL DEFAULT '-1' COMMENT 'Negative value allowed';
ALTER TABLE `ob_trans_items` CHANGE `qty` `qty` DECIMAL(9,3) NOT NULL COMMENT 'Negative value allowed';
ALTER TABLE `ob_category` ADD `hideInPos` CHAR(1) NOT NULL AFTER `imgFileExt`;
ALTER TABLE ob_price_item ADD freeQty decimal(8,3) not null default 0 AFTER unit;
INSERT INTO ob_role_permissions (roleId,cId,modCode,actionRights) SELECT roleId,cId, 'ALWIR' as roleCode,1 as actionRights from (select r.roleId,r.cId,GROUP_CONCAT(rp.modCode) as mcode from ob_role as r join ob_role_permissions as rp on rp.roleId=r.roleId where r.is_system=1 and r.roleCode in ('C','I','S') group by r.roleId) src where find_in_set('ALWIR',mCode)=0;
ALTER TABLE `ob_licensekey` ADD `isIdleDeviceLock` TINYINT(1) NOT NULL DEFAULT '0' AFTER `isApprovePin`;
DROP TABLE IF EXISTS `ob_ec_rating`;
CREATE TABLE `ob_ec_rating` ( `id` int(10) NOT NULL,`reviewId` int(10) NOT NULL,`rating` int(1) NOT NULL) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;
ALTER TABLE `ob_ec_rating` ADD PRIMARY KEY (`id`);
DROP TABLE IF EXISTS `ob_ec_reviews`;
CREATE TABLE `ob_ec_reviews` (`reviewId` int(10) UNSIGNED NOT NULL,`itemId` int(10) UNSIGNED NOT NULL,`userId` int(10) NOT NULL,`userName` varchar(100) NOT NULL,`userEmail` varchar(255) NOT NULL,`deviceIP` varchar(40) NOT NULL,`reviewDate` timestamp NOT NULL DEFAULT current_timestamp(), `reviewContent` text NOT NULL,`isApprove` varchar(1) NOT NULL,`device_user_agent` varchar(500) NOT NULL, `approved_by` int(10) NOT NULL) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;
ALTER TABLE `ob_ec_reviews` ADD PRIMARY KEY (`reviewId`);
INSERT INTO ob_role_permissions (roleId,cId,modCode,actionRights)  SELECT r.roleId,r.cId,sr.modCode,sr.actionOption as actionRights from ob_sys_role_modules as sr join ob_role as r on FIND_IN_SET(r.roleCode,sr.roleCode) >0  left join `ob_role_permissions` as rp on rp.roleId=r.roleId and rp.modCode=sr.modCode where rp.roleId is null;
ALTER TABLE `ob_ec_rating` CHANGE `id` `id` INT(10) NOT NULL AUTO_INCREMENT;
ALTER TABLE `ob_ec_reviews` CHANGE `reviewId` `reviewId` INT(10) UNSIGNED NOT NULL AUTO_INCREMENT;
ALTER TABLE `ob_pointsdetail` CHANGE `points` `points` DECIMAL(9,3) NOT NULL;
ALTER TABLE `ob_items` ADD `margin` DECIMAL(5,2) NOT NULL DEFAULT '0.00' AFTER `bId`;
ALTER TABLE `ob_trans_items_rel` ADD `cPrice` DECIMAL(11,3) NOT NULL AFTER `info`;
INSERT INTO `ob_oboactions` (`id`, `name`, `actCode`, `sdesc`, `dirName`, `version`, `isActive`) VALUES (NULL, 'Obo Image Identifier', 'OII', '', 'Maintenance', '1', '1');
UPDATE `ob_sys_role_modules` SET `roleCode` = 'I,C,K,R' WHERE `ob_sys_role_modules`.`modCode` = 'PUPUG';
update ob_series set classCode='REG' where tType='SO' and classCode='';
UPDATE `ob_sys_role_modules` SET `roleCode` = 'C,R' WHERE `ob_sys_role_modules`.`modCode` = 'RITRG';
ALTER TABLE `ob_contacts_config` CHANGE `value` `value` TEXT CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL;
ALTER TABLE `ob_trans_payment` ADD `allotTaId` INT(11) NOT NULL DEFAULT '0';
ALTER TABLE `ob_companies` ADD `pId` INT NOT NULL AFTER `mainbId`;